/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: led-api.h,v 1.1 2002/09/22 00:23:19 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/9/02
 *
 *-----------------------------------------------------------------
 */


#ifndef _LED_API_H
#define _LED_API_H

#define LED_OK_ON           0x1
#define LED_OK_OFF          0x2
#define LED_FAULT_ON        0x3
#define LED_FAULT_OFF       0x4
#define LED_FAN_GREEN		0x5
#define LED_FAN_RED			0x6

#define LED_OK_AMBER        0xa
#define LED_OK_RED          0xb
#define LED_FAULT_AMBER     0xc
#define LED_FAULT_GREEN     0xd

#if defined (DIAG_R9000) || defined (DIAG_SIBYTE)
#define LED_OK_RED         0x7
#define LED_FAULT_GREEN    0x8
#define LED_FAN_OFF        0x9
#endif


#define LED_DIAG_00         0x8000
#define LED_DIAG_01         0x8001
#define LED_DIAG_02         0x8002
#define LED_DIAG_03         0x8003
#define LED_DIAG_04         0x8004
#define LED_DIAG_05         0x8005
#define LED_DIAG_06         0x8006
#define LED_DIAG_07         0x8007
#define LED_DIAG_08         0x8008
#define LED_DIAG_0F         0x800F
#define LED_DIAG_10         0x8010
#define LED_DIAG_11         0x8011
#define LED_DIAG_12         0x8012
#define LED_DIAG_13         0x8013
#define LED_DIAG_14         0x8014
#define LED_DIAG_15         0x8015
#define LED_DIAG_16         0x8016
#define LED_DIAG_17         0x8017
#define LED_DIAG_18         0x8018
#define LED_DIAG_1F         0x801F

#ifdef USE_DIAG_LED
#define DIAG_LED(_xx)       led_set(_xx)
#else
#define DIAG_LED(_xx)
#endif

extern void led_set(int led_state);	/* one of the states defined above */

#endif /* _LED_API_H */
