#!/usr/bin/perl
#
#-----------------------------------------------------------------
#
# Name:	create_version.pl
#
# RCS:  $Id: create_version.pl,v 1.5 2002/05/18 01:02:43 rick Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:	creates ImageVer string
#
#				usage: "create_version.pl BUILD_TARGET HOST_PLATFORM
#														IMAGE_VERSION_C_FILE"
#
# Created by:	Rick Lund
#
# Date Created:	4/14/01
#
#-----------------------------------------------------------------
#

$exe = $0;

if (@ARGV != 4 && @ARGV != 3)
{
	print "Invalid $exe usage\n";
	exit -1;
}

$tgt = shift;
$platform = shift;
$version_file = shift;
$txt_version_file = shift;

#print "create_version for $tgt in $version_file\n";

$header = "
/*
 *-----------------------------------------------------------------
 *
 * Image Version String file
 *
 * Automatically created by top-level Makefile calling
 * PERL script, $0
 *
 *-----------------------------------------------------------------
 */
";

open VER, ">$version_file"
		or die "Cannot create version file: $!";

print VER $header;
print VER "#include <nfx-incl.h>\n\n";

open(TREENAMEFILE, "tree-name") or die "Can't open tree-name: $!\n";
PROC_LINES:
while ($line = <TREENAMEFILE>) {
	$_ = $line;
    if (/^\#/) {next PROC_LINES;}
	if (/^$/) {next PROC_LINES;}
	($key,$treename) = split(/:/,$_);
	($treename,$junk) = split(/\n/,$treename);
}

#print VER "uchar8 ImageVerString[80] = \"$tgt : $platform : ";

$str = sprintf("%s : %s : %s", $tgt, $treename, scalar localtime);
print VER "uchar8 ImageVerString[80] = \"$str\";\n";

if (! $txt_version_file eq "") {
	open TXTVER, ">$txt_version_file" or die "Cannot create version file: $!";
	print TXTVER "$str\n";
}
	


