#
#-----------------------------------------------------------------
#
# Name:	defs.mk
#
# RCS:  $Id: defs.mk,v 1.88 2002/11/22 19:19:31 maximk Exp $
#
# Copyright (C) 2001, Agile Storage Inc.
#
# Description:	Make definitions
#
# Created by:	Rick Lund
#
# Date Created:	4/11/01
#
#-----------------------------------------------------------------
#

ifeq (${HOST_PLATFORM}, LINUX_TEST)
CC		= gcc
LD		= ld
AS		= gcc
NM		= nm
AR		= ar
LN		= /bin/ln
RANLIB  = ranlib
CONV	=
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX NFP_FP"))
LARGE_MEMORY = 1
endif

ifeq (${TARGET},$(findstring ${TARGET}, "NFP_TXRX NFP_FP"))
#USE_SMP = 1
endif

ifeq (${HOST_PLATFORM}, $(findstring ${HOST_PLATFORM}, "EVAL_BOARD AGILE_HARDWARE"))
ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX NFP_FP PROM_SIBYTE PROM_SIBYTE_BC DIAG_SIBYTE FCNIM FCNIM_TM"))
CC		= /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/bin/mips64-sb1sim-gcc
LD		= /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/bin/mips64-sb1sim-ld
AS		= /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/bin/mips64-sb1sim-gcc
NM		= /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/bin/mips64-sb1sim-nm
CONV	= /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/bin/mips64-sb1sim-objcopy
PROM_CONV	= /usr/local/sde4/bin/conv
COMPILER_DEF = -Dsibyte_comp

else
ifeq (${TARGET}, $(findstring ${TARGET}, "PROM_R9000 PROM_R7000"))
CC		= /usr/local/sde4/bin/gcc
LD		= /usr/local/sde4/bin/ld
AS		= /usr/local/sde4/bin/gcc
NM		= /usr/local/sde4/bin/nm
CONV	= /usr/local/sde4/bin/objcopy
PROM_CONV	= /usr/local/sde4/bin/conv
AR		= /usr/local/sde4/bin/ar
LN		= /bin/ln
RANLIB	= /usr/local/sde4/bin/ranlib
COMPILER_DEF = -Dalgor_comp
endif
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "FCNIM FCNIM_TM PROM_R7000 DIAG_R7000"))
CPUFLAGS	= -mcpu=r4k -mips3 -DR7000 -DR4000
ADDRESS_SIZE	= 32
ifeq (${TARGET}, $(findstring ${TARGET}, "FCNIM FCNIM_TM"))
CRTBEGIN = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/crtbegin.o
CRTEND = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/crtend.o
endif
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "PROM_R9000"))
CPUFLAGS	= -mcpu=r4k -mips3 -DR9000 -DR7000 -DR4000
ADDRESS_SIZE	= 32
# ********
# N O T E : Need to add crtbegin.o & crtend.o
# ********
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX NFP_FP PROM_SIBYTE DIAG_SIBYTE"))
CPUFLAGS	= -DSIBYTE -mcpu=sb1 -DSB1250 -DR4000
ADDRESS_SIZE	= 64
CRTBEGIN = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/long64/crtbegin.o
CRTEND = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/long64/crtend.o
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "PROM_SIBYTE_BC"))
CPUFLAGS	= -DSIBYTE -mcpu=sb1 -DSB1250 -DR4000 -DSIBYTE_BC
ADDRESS_SIZE	= 64
CRTBEGIN = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/long64/crtbegin.o
CRTEND = /usr/local/sbtools/x86-linux-rh6.0/mips64-sb1sim-2.3.1/lib/gcc-lib/mips64-sb1sim/3.0.4/el/mips4/long64/crtend.o
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "PROM_SSC_MGMT SSC_MGMT"))
CPUFLAGS	= -mcpu=r3k -mips1 -DTX3927
ADDRESS_SIZE	= 32
endif

endif

ifeq (${HOST_PLATFORM}, SSC_mips)
CC 		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/cc
LD		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/ld
AS		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/cc
NM		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/nm
CPP		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/cc -E
AR		= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/ar
LN		= /bin/ln
RANLIB	= $(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/bin/ranlib
CONV	=
endif

ifeq (${HOST_PLATFORM}, SSC_x86)
CC	    = /usr/bin/cc
LD		= /usr/bin/ld
AS		= /usr/bin/cc
NM		= /usr/bin/nm
CPP		= /usr/bin/cc -E
AR		= /usr/bin/ar
LN		= /bin/ln
RANLIB	= /usr/bin/ranlib
CONV	=
endif

ifneq (${HOST_PLATFORM}, LINUX_TEST)
ENDIAN	= -EL -Aendian\(little\)
endif

ifeq (${HOST_PLATFORM}, SSC_mips)
ENDIAN = -EL
endif

ifeq (${HOST_PLATFORM}, SSC_x86)
ENDIAN = 
endif

SHELL	= /bin/sh
PERL	= /usr/bin/perl
MKESM_TOOL = mkesm.pl

#
# The embedded case has its own rpc/* include directory. In all cases *other* than 
# the embedded case, we want to force inclusion of the *native* rpc/* include directory first.
#
ifeq (${HOST_PLATFORM}, LINUX_TEST)
INCDIRS=-I/usr/include -I${PATH_TO_ROOT}/Includes -I${PATH_TO_ROOT}/Includes/exports/${TARGET}
else
ifeq (${HOST_PLATFORM}, SSC_x86)
INCDIRS=-I/usr/include -I${PATH_TO_ROOT}/Includes -I${PATH_TO_ROOT}/Includes/exports/${TARGET}
else
ifeq (${HOST_PLATFORM}, SSC_mips)
INCDIRS=-I$(BSD_CROSS_TOOLS)/usr/cross/pmonmips/usr/include -I${PATH_TO_ROOT}/Includes -I${PATH_TO_ROOT}/Includes/exports/${TARGET}
else
INCDIRS=-I${PATH_TO_ROOT}/Includes -I${PATH_TO_ROOT}/Includes/exports/${TARGET}
endif
endif
endif

#
# Turn on DEBUG and PROFILING for FCNIM builds
#
ifeq (${TARGET}, FCNIM)
DEBUG		= -DDEBUG -DNFX_PROFILING
override GOPT_FLAGS=
endif

#
# Turn on DEBUG for FCNIM_TM builds
#
ifeq (${TARGET}, FCNIM_TM)
DEBUG		= -DDEBUG
override GOPT_FLAGS=
endif

#
# Turn on DEBUG for FP builds
#
# Remember to define USE_BSS_THREAD_STACKS in Includes/nfx-target.h
# for optimal performance
#
ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_FP"))
DEBUG		= -DDEBUG -DFS_DEBUG -DNFX_PROFILING
override GOPT_FLAGS=
endif

#
# Turn on DEBUG for TXRX builds
#
ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX"))
DEBUG		= -DDEBUG -DNFX_PROFILING
override GOPT_FLAGS=
endif

ifeq (${HOST_PLATFORM}, LINUX_TEST)
CPPFLAGS    += ${INCDIRS} -DLANGUAGE_C ${DEBUG}
CFLAGS		+= ${MODULE_DEFS}
RAM_LDFLAGS += -lpthread 
endif

ifeq (${HOST_PLATFORM}, SSC_x86)
CFLAGS 		+= -malign-double
endif

ifeq ($(findstring SSC, ${HOST_PLATFORM}), SSC)
CPPFLAGS    += ${INCDIRS} -DLANGUAGE_C -DLINUX_TEST ${DEBUG} 
CFLAGS		+= ${MODULE_DEFS} -Wall -Wmissing-prototypes 
RAM_LDFLAGS += -pthread 
endif

COMPILE.c = $(CC) $(CFLAGS) $(CPPFLAGS) $(DEBUG_FLAGS) $(TARGET_FLAGS) -c
COMPILE.s = $(CC) $(ASFLAGS) $(DEBUG_FLAGS) $(TARGET_FLAGS) -c
COMPILE.S = $(CC) $(ASFLAGS) $(CPPFLAGS) $(DEBUG_FLAGS) $(TARGET_FLAGS) -c
LINK = $(CC) $(CFLAGS) $(LDFLAGS)
LINK.ts = $(CC) -pthread $(CFLAGS) $(LDFLAGS)
LINK.so = $(CC) $(CFLAGS) $(LDFLAGS) -shared
LINK.tsso = $(CC) -pthread $(CFLAGS) $(LDFLAGS) -shared


ifeq (${HOST_PLATFORM}, $(findstring ${HOST_PLATFORM}, "EVAL_BOARD AGILE_HARDWARE"))
CFLAGS		= ${INCDIRS} -nostdlib -nostdinc -fno-builtin ${CPUFLAGS} \
				-DLANGUAGE_C ${ENDIAN} ${DEBUG} ${MODULE_DEFS} \
				${GOPT_FLAGS} ${WARN_FLAGS} ${COMPILER_DEF}
ASFLAGS		= ${INCDIRS} -nostdlib -nostdinc -fno-builtin ${CPUFLAGS} \
				-DLANGUAGE_ASSEMBLY ${ENDIAN} ${DEBUG} ${MODULE_DEFS} \
				${GOPT_FLAGS} ${WARN_FLAGS} ${COMPILER_DEF}
ifeq (${TARGET}, SSC_MGMT)
RAM_LDFLAGS = -Ttext 0x80008000 -nostdlib -nostdinc ${ENDIAN}
else
ifeq (${HOST_PLATFORM}, EVAL_BOARD)
RAM_LDFLAGS = -Ttext 0x80140000 -nostdlib -nostdinc ${ENDIAN}
endif
ifeq (${HOST_PLATFORM}, AGILE_HARDWARE)
RAM_LDFLAGS = -Ttext 0x83000000 -nostdlib -nostdinc ${ENDIAN}
RAM_LDFLAGS_WITH_SCRIPT = -nostdinc ${ENDIAN} -T${LINK_SCRIPT}
endif
endif
endif

CFLAGS += -DNETEEE_FRAGMENT
CFLAGS += -DEEE_VALIDATE

INC_LDFLAGS	= -r ${ENDIAN}

ifneq (${HOST_PLATFORM}, LINUX_TEST)
ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX NFP_FP"))
CFLAGS += -G 0
ASFLAGS += -G 0
else
CFLAGS += -G 0
ASFLAGS += -G 0
endif
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "PROM_R7000 PROM_R9000 PROM_SIBYTE PROM_SIBYTE_BC DIAG_R7000 DIAG_SIBYTE"))
DEBUG_FLAGS	= -g 
GOPT_FLAGS	= -O2    
else
ifneq (${TARGET}, $(findstring ${TARGET}, "SSC SSC_MGMT PROM_SSC_MGMT"))
DEBUG_FLAGS	= -g -fno-omit-frame-pointer -mno-sched-prolog
LD_DEBUG_FLAGS = -g
else
DEBUG_FLAGS	= -g
endif
#DEBUG_FLAGS	= 

GOPT_FLAGS	= -O2    
#GOPT_FLAGS	=

endif

WARN_FLAGS	= -Wall

ifeq (${TARGET}, PROM_R9000)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, PROM_R7000)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, DIAG_R7000)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, PROM_SIBYTE)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, PROM_SIBYTE_BC)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, DIAG_SIBYTE)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif
ifeq (${TARGET}, PROM_SSC_MGMT)
CFLAGS		+= -mlong-calls -DPROM
ASFLAGS		+= -mlong-calls -DPROM
endif

ifeq (${ADDRESS_SIZE}, 64)
CFLAGS		+= -mlong64
ASFLAGS		+= -mlong64
endif

ifeq (${LARGE_MEMORY},1)
CFLAGS		+= -DLARGE_MEMORY
ASFLAGS		+= -DLARGE_MEMORY
endif

ifeq (${USE_SMP},1)
CFLAGS += -DNFX_SMP -DNFX_SPINLOCK_DEBUG
ASFLAGS += -DNFX_SMP -DNFX_SPINLOCK_DEBUG
endif

ifeq (${TARGET}, $(findstring ${TARGET}, "NFP_TXRX NFP_FP"))
NFX_MODULE	= NFX_MOD_NFP
endif
ifeq (${TARGET}, $(findstring ${TARGET}, "FCNIM FCNIM_TM"))
NFX_MODULE	= NFX_MOD_FCNIM
endif
ifeq (${TARGET}, $(findstring ${TARGET}, "SSC SSC_MGMT"))
NFX_MODULE	= NFX_MOD_SSC
endif

ifneq (${NFX_MODULE}, )
TARGET_FLAGS	= -D${TARGET} -D${HOST_PLATFORM} -D${NFX_MODULE}
else
TARGET_FLAGS	= -D${TARGET} -D${HOST_PLATFORM}
endif

# Paths used during the build process

OBJECTS_DIR	= ${PATH_TO_TOOLS}/Objects/${TARGET}
DEPENDS_DIR	= ${PATH_TO_TOOLS}/Depends/${TARGET}
INCLUDE_EXPORT_DIR	= ${PATH_TO_ROOT}/Includes/exports/${TARGET}/export
VERSION_DIR	= ${PATH_TO_TOOLS}/Versions/${TARGET}

# Where things go that will, eventually, get installed under 
# /usr/local/agile on the SSC

INSTALL=/usr/bin/install
PATH_TO_INSTALL = ${PATH_TO_ROOT}/Install/${TARGET}
IMAGES_DIR	= ${PATH_TO_INSTALL}/Images
BIN_DIR = ${PATH_TO_INSTALL}/bin
LIB_DIR = ${PATH_TO_INSTALL}/lib
ETC_DIR = ${PATH_TO_INSTALL}/etc
MAN_DIR = ${PATH_TO_INSTALL}/man
SUDO = /usr/bin/sudo
BINOWN ?= root
BINGRP ?= 7
BINMODE ?= 0555

DEP_FILES	= $(patsubst %.c, ${DEPENDS_DIR}/${MODULE}-%.d, ${SRCS_C})	\
				$(patsubst %.c, ${DEPENDS_DIR}/${MODULE}-%.d, ${FAST_SRCS_C})	\
				$(patsubst %.S, ${DEPENDS_DIR}/${MODULE}-%.d, ${SRCS_S})	\
				$(patsubst %.S, ${DEPENDS_DIR}/${MODULE}-%.d, ${FAST_SRCS_S})
OBJS_LIST	= $(patsubst %.c, ${OBJECTS_DIR}/${MODULE}-%.o, ${SRCS_C})	\
				$(patsubst %.S, ${OBJECTS_DIR}/${MODULE}-%.o, ${SRCS_S})
FAST_OBJS_LIST	= $(patsubst %.c, ${OBJECTS_DIR}/${MODULE}-%.o, ${FAST_SRCS_C})	\
				$(patsubst %.S, ${OBJECTS_DIR}/${MODULE}-%.o, ${FAST_SRCS_S})

SM_LIST_C	= $(patsubst %.sm, %.c, ${SRCS_SM})
SM_LIST_H	= $(patsubst %.sm, %.h, ${SRCS_SM})

MODULE_OBJ	= ${OBJECTS_DIR}/${MODULE}.o
FAST_MODULE_OBJ	= ${OBJECTS_DIR}/${MODULE}-fast.o
VERSION_OBJ	= ${VERSION_DIR}/image-ver.o

BUILD_DIR_LIST	=	${PATH_TO_TOOLS}/Objects 			\
					${PATH_TO_TOOLS}/Depends 			\
					${PATH_TO_ROOT}/Includes/exports	\
					${PATH_TO_TOOLS}/Versions			\
					${PATH_TO_ROOT}/Install				\


