
#-----------------------------------------------------------------
#
# Name:	module.mk
#
# RCS:  $Id: module.mk,v 1.11 2002/10/25 21:31:27 rick Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:	Make rules for making submodules
#
# Created by:	Rick Lund
#
# Date Created:	4/11/01
#
#-----------------------------------------------------------------
#

PATH_TO_ROOT		= ../..


all : ${SM_LIST_C} depend_dir ${DEP_FILES} object_dir
ifneq (${FAST_SRCS_C},)
all : ${FAST_OBJS_LIST} ${FAST_MODULE_OBJ}
endif
ifneq (${FAST_SRCS_S},)
all : ${FAST_OBJS_LIST} ${FAST_MODULE_OBJ}
endif
ifneq (${SRCS_C},)
all : ${OBJS_LIST} ${MODULE_OBJ} 
endif
ifneq (${SRCS_S},)
all : ${OBJS_LIST} ${MODULE_OBJ} 
endif

${FAST_MODULE_OBJ} ${MODULE_OBJ} : ${SM_LIST_C} ${DEP_FILES} ${OBJS_LIST} ${FAST_OBJS_LIST}

${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	Makefile			\
								${PATH_TO_ROOT}/Makefile		\
								${PATH_TO_ROOT}/target.mk		\
								${PATH_TO_TOOLS}/defs.mk		\
								${PATH_TO_TOOLS}/module.mk		\
								${PATH_TO_TOOLS}/suffix.mk


ifeq (${TARGET}, NFP_TXRX)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.txrx
endif

ifeq (${TARGET}, NFP_FP)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.fp
endif

ifeq (${TARGET}, FCNIM)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.fc
endif

ifeq (${TARGET}, SSC)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.ssc
endif

ifeq (${TARGET}, SSC_MGMT)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.ssc_mgmt
endif

ifeq (${TARGET}, SHMEM)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.shmem
endif

ifeq (${TARGET}, PROM_R9000)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.prom.r9000
endif

ifeq (${TARGET}, PROM_R7000)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.prom.r7000
endif

ifeq (${TARGET}, PROM_SIBYTE)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.prom.sibyte
endif

ifeq (${TARGET}, PROM_SIBYTE_BC)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.prom.sibyte_bc
endif

ifeq (${TARGET}, PROM_SSC_MGMT)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.prom.ssc_mgmt
endif

ifeq (${TARGET}, DIAG_R7000)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.diag.r7000
endif

ifeq (${TARGET}, DIAG_SIBYTE)
${FAST_MODULE_OBJ} ${MODULE_OBJ} ${OBJS_LIST} ${FAST_OBJS_LIST} ${DEP_FILES}:	${PATH_TO_ROOT}/Makefile.diag.sibyte
endif
#-----------------------------------------------------------------
#
# General build environment targets
#
#-----------------------------------------------------------------

include ${PATH_TO_TOOLS}/export.mk

clean: force
	@[ -z "$(strip ${SM_LIST_C})" ]  || rm -f ${SM_LIST_C}
	@[ -z "$(strip ${SM_LIST_H})" ] || rm -f ${SM_LIST_H}
	@[ -z "$(strip ${DEP_FILES})" ] || rm -f ${DEP_FILES}
	@[ -z "$(strip ${OBJS_LIST})" ] || rm -f ${OBJS_LIST}
	@[ -z "$(strip ${FAST_OBJS_LIST})" ] || rm -f ${FAST_OBJS_LIST}
	@[ -z "$(strip ${MODULE_OBJ})" ] || rm -f ${MODULE_OBJ}
	@[ -z "$(strip ${FAST_MODULE_OBJ})" ] || rm -f ${FAST_MODULE_OBJ}
#	for exp in ${EXPORT_INCLUDES}; 					\
#	do													\
#		if [ -s ${PATH_TO_EXPORTS}/$$exp ];				\
#			then rm ${PATH_TO_EXPORTS}/$$exp;			\
#		else											\
#			echo "exported file ${PATH_TO_EXPORTS}/$$exp not present"; \
#		fi;												\
#	done

depend_dir: force
	@for dir in ${MOD_SUBDIR};	\
	do	\
		if [ ! -d ${PATH_TO_TOOLS}/Depends/${TARGET}/${MODULE}-$$dir ];     \
			then mkdir -p ${PATH_TO_TOOLS}/Depends/${TARGET}/${MODULE}-$$dir;  \
		fi;                                                 \
	done

depend: depend_dir ${DEP_FILES}

object_dir: force
	@for dir in ${MOD_SUBDIR};	\
	do	\
		if [ ! -d ${PATH_TO_TOOLS}/Objects/${TARGET}/${MODULE}-$$dir ];     \
			then mkdir -p ${PATH_TO_TOOLS}/Objects/${TARGET}/${MODULE}-$$dir;  \
		fi;                                                 \
	done

force:

