/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: exception.S,v 1.1.1.1 2001/10/31 01:32:21 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-target.h>

#include <sys/mips.h>
#include "../prom-pmon/pmon.h"
#include <exports/hwMap.h>

#ifdef R4000
#define MFC_NOP nop; nop
#else
#define MFC_NOP nop
#endif

#if __mips >= 3
#define MTC0            dmtc0
#define MFC0            dmfc0
#else
#define MTC0            mtc0
#define MFC0            mfc0
#endif


	.text

	.globl	_exception
	.ent _exception
/*
 * This routine is used to save the state of a client program after
 * an exception is encountered. But it first checks to see if there
 * is a user defined exception handler (via onintr), and then checks
 * to see if it's a floating-point instruction (if PMON has fp emulation
 * enabled.)
 */
_exception:
	.set noat
	
	MFC0	a0,C0_EPC
	MFC0	a1,C0_CAUSE
	move	a2,ra
	MFC0	a3,C0_BADVADDR

	lw	t1,initial_sr
	li	t2,~SR_IMASK
	and	t1,t2
	mtc0	t1,C0_SR
	la	sp,stack+STKSIZE-24
	la	t0,pmexception
	jr	t0

	.end _exception

