/*
 *-----------------------------------------------------------------
 *
 * Name:	gt64240-promio.S
 *
 * RCS:  $Id: gt64240-promio.S,v 1.3 2001/12/08 23:18:27 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/8/01
 *
 *-----------------------------------------------------------------
 */

#ifdef __mips

#if defined(AGILE_HARDWARE) && defined(PROM_R7000) 

#include <exports/hwMap.h>
#include <sys/mips.h>
#include <exports/promio-api.h>

 
	.set	noreorder

	.text

/*-----------------------------------------------------------------
 * Name:	promio_init()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							t2 = TEMP
 *							t3 = TEMP
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_init
	.ent	promio_init
promio_init:


	j		ra
	nop

	.end	promio_init

/*-----------------------------------------------------------------
 * Name:	promio_put_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_put_char
	.ent	promio_put_char
promio_put_char:

	j		ra
	nop

	.end	promio_put_char

/*-----------------------------------------------------------------
 * Name:	promio_get_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							v0 = RET
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_get_char
	.ent	promio_get_char
promio_get_char:

	j		ra
	nop

	.end	promio_get_char

	.globl	promio_get_char_no_echo
	.ent	promio_get_char_no_echo
promio_get_char_no_echo:

	j		ra
	nop

	.end	promio_get_char_no_echo

/*-----------------------------------------------------------------
 * Name:	promio_char_avail()
 *
 * Description:
 *			registers used: t1 = UART
 *							v0 = RET
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_char_avail
	.ent	promio_char_avail
promio_char_avail:

	li		RET,1

	j		ra
	nop

	.end	promio_char_avail

/*-----------------------------------------------------------------
 * Name:	promio_tx_ready()
 *
 * Description:
 *			registers used:	t1 = UART
 *							v0 = RET
 *
 *			RET will be 0 or != 0 (NOT == 1, if transmitter is ready)
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_tx_ready
	.ent	promio_tx_ready
promio_tx_ready:

	li		RET,1

	j		ra
	nop

	.end	promio_tx_ready

	.set	reorder

#endif	/* AGILE_HARDWARE && PROM_R7000 */
#endif	/* __mips */

