/*
 *-----------------------------------------------------------------
 *
 * Name:	promio-api.h
 *
 * RCS:  $Id: promio-api.h,v 1.5 2002/03/26 22:00:55 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/8/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _PROMIO_API_H
#define _PROMIO_API_H

#define BELL	0x7
#define BS		0x8
#define LF		0xA
#define	CR		0xD
#define ESC		0x1B
#define DEL		0x7F
#define EQUAL	0x3D
#define MINUS	0x2D

#define ESC_CODE	0x10
#define BS_CODE		0x11
#define CR_CODE		0x13

#if __mips

#define UART		t1
#define ARG1		a0
#define ARG2		a1
#define RET			v0
#define SAVE_VAL	v1
#define TEMP		t0

#define ADDR		s1
#define LEN			s2
#define WRITE_VAL	s3

#define	JMP_SUB1(addr)	jal		addr	;\
						nop

#define JMP_SUB2(addr)	move	s8,ra	;\
						jal		addr	;\
						nop				;\
						move	ra,s8	

#define JMP_SUB3(addr)	move	s7,ra	;\
						jal		addr	;\
						nop				;\
						move	ra,s7	

#define JMP_SUB4(addr)	move	s6,ra	;\
						jal		addr	;\
						nop				;\
						move	ra,s6

#define JMP_SUB5(addr)	move	s5,ra	;\
						jal		addr	;\
						nop				;\
						move	ra,s5

#define RET_SUB			j		ra		;\
						nop

#ifdef PROM_DEBUG
#if defined(EVAL_BOARD) || defined(PROM_SSC_MGMT)
#define DEBUG_STR(str)		\
	b	99f;				\
	nop;					\
98:	.asciiz	str;			\
	.align 2;				\
99:;						\
	la	ARG1,98b;			\
	JMP_SUB4(promio_prs)
#else
#define DEBUG_STR(str)
#endif
#else
#define DEBUG_STR(str)
#endif

#endif	/* __mips */

#endif	/* _PROMIO_API_H */

