/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: more-commands.c,v 1.13 2002/12/10 00:04:55 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <exports/eee-api.h>

void set_entry_addr(long addr);
void do_cmd (char *p);
void tlb_display(void);
int32 tlb_set(int32 index, uint32 va, uint32 pa, uint32 size, uint32 calg);
int32 compare_mem(uint32 *addr1, uint32 *addr2, uint32 len);
int32 alt_tty_getchar(void);

#if __long64
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/12/02
 *
 *-----------------------------------------------------------------
 */
void
signextend(
	address_t	* addr
)
{
	if ((*addr & 0xFFFFFFFF80000000) == 0x0000000080000000)
		*addr = *addr | 0xFFFFFFFF00000000;
}
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
do_simple_EEE_test(
	int32   argc,
	char8   * argv[]
)
{
	uchar8  cmd[80];
	uint32  cpu, bufsize, len, slot, plane;
	int32   rc;
	uint32  num_pkts, i;

	if (argc != 1)
		return -1;

	printf("   Enter destination slot : ");
	get_input(cmd);
	slot = atoi(cmd);
	
	printf("   Enter destination cpu : ");
	get_input(cmd);
	cpu = atoi(cmd);

	printf("   Enter buffer size : ");
	get_input(cmd);
	bufsize = atoi(cmd);

	printf("   Enter number of bytes to send : ");
	get_input(cmd);
	len = atoi(cmd);

	printf("   Enter number of packets to send : ");
	get_input(cmd);
	num_pkts = atoi(cmd);

	printf("   Enter data plane (0 = data, 1 = mgmt, 2 = control, 3 = sac) : ");
	get_input(cmd);
	plane = atoi(cmd);

	printf("Sending %d test packet(s) to slot %d, cpu %d, len %d, bufsize %d, plane %d\n",
								num_pkts, slot, cpu, len, bufsize, plane);

	for (i=0; i<num_pkts; i++) {
		if ((rc = eee_testCreateSimplePacket(slot, cpu, len, bufsize, plane, i))
														!= NFX_OK) {
			printf("Error returned 0x%x\n", rc);
			break;
		}
	}

	printf("\nNumber packets sent: %d\n\n", i);

	return 0;
}

//WTG remove some code to make more space in SiByte's RProm.
#ifndef SIBYTE_BC
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
load_toshiba(
	int32   argc,
	char8   * argv[]
)
{
#ifdef PROM_R7000
	load_set_toshiba_boot_block();
#endif

/*
	do_cmd("load -a b0008000 10.1.1.189 ssc-mgmt.bin");
	do_cmd("load -a b0008000 10.1.1.125 ssc-mgmt.bin");
*/

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
int32
toshiba_go(
	int32   argc,
	char8   * argv[]
)
{
#ifdef PROM_R7000
	load_set_toshiba_jump_block();
#endif

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
load_ssc_mgmt(
	int32   argc,
	char8   * argv[]
)
{
	do_cmd("load -a 83000000 10.1.1.189 ssc-mgmt.bin");

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
do_toshiba_compare(
	int32   argc,
	char8   * argv[]
)
{
	compare_mem((uint32 *)0x83000000, (uint32 *)0xb0008000, 0x367f0);

	return 0;
}
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
do_fp_copy(
	int32	argc,
	char8	* argv[]
)
{
	printf("Copying 0x%x bytes from %p to %p\n", 0x400000, (void *)0x40000000, (void *)0x83000000);
	memcpy((void *)0x83000000, (void *)0x40000000, 0x400000);

	set_entry_addr((int)0x83000000);

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
do_tty1_test(
	int32	argc,
	char8	* argv[]
)
{
	char	ch;

	printf("calling tty1 get char\n");
	ch = alt_tty_getchar();
	printf("got ch = 0x%x\n", ch);

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
do_compare(
	int32	argc,
	char8	* argv[]
)
{
	uint32	* addr1, * addr2;
	uint32	len;

	if (!get_rsa (&addr1, argv[1]))
      return (-1);
	if (!get_rsa (&addr2, argv[2]))
      return (-1);
	if (!get_rsa (&len, argv[3]))
      return (-1);

	compare_mem(addr1, addr2, len);

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/03/02
 *
 *-----------------------------------------------------------------
 */
int32
compare_mem(
	uint32	*addr1,
	uint32	*addr2,
	uint32	len
)
{
	uint32	i, a, b;

	for (i=0; i<len/sizeof(uint32); i++) {
		a = addr1[i];
		b = addr2[i];
		if (a != b) {
			printf("Compare Error, %p = 0x%x, %p = 0x%x\n",
													addr1+i, a, addr2+i, b);
			break;
		}
	}

	return 0;
}

#ifdef SIBYTE
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
int32
do_lsi(
	int32	argc,
	char8	* argv[]
)
{
	lsi_gmac_uiDiag();

	return 0;
}

#endif

typedef struct reg_spec_struct {
	uchar8	* disp_name;
	uchar8	* reg_name;
	uint32	reg_num;
	uint32	reg_size;
} reg_spec_t;

#ifdef R7000
reg_spec_t	cp0regs[] = {
	{"C0_INX", "index", C0_INX, 4},
	{"C0_RAND", "random", C0_RAND, 4},
	{"C0_TLBLO0", "tlblo0", C0_TLBLO0, 8},
	{"C0_TLBLO1", "tlblo1", C0_TLBLO1, 8},
	{"C0_CTEXT", "context", C0_CTEXT, 8},
	{"C0_PGMASK", "pgmask", C0_PGMASK, 4},
	{"C0_WIRED", "wired", C0_WIRED, 4},
	{"C0_INFO", "info", C0_INFO, 4},
	{"C0_BADVADDR", "badvaddr", C0_BADVADDR, 8},
	{"C0_COUNT", "count", C0_COUNT, 4},
	{"C0_TLBHI", "tlbhi", C0_TLBHI, 8},
	{"C0_COMPARE", "compare", C0_COMPARE, 4},
	{"C0_SR", "sr", C0_SR, 4},
	{"C0_CAUSE", "cause", C0_CAUSE, 4},
	{"C0_EPC", "epc", C0_EPC, 8},
	{"C0_PRID", "prid", C0_PRID, 4},
	{"C0_CONFIG", "config", C0_CONFIG, 4},
	{"C0_LLADDR", "lladdr", C0_LLADDR, 4},
	{"C0_WATCHLO", "watchlo", C0_WATCHLO, 8},
	{"C0_WATCHHI", "watchhi", C0_WATCHHI, 8},
	{"C0_XCONTEXT", "xcontext", C0_XCONTEXT, 8},
	{"C0_WATCHMASK", "watchmask", C0_WATCHMASK, 4},
	{"C0_PERFCOUNT", "perfcount", C0_PERFCOUNT, 4},
	{"C0_ECC", "ecc", C0_ECC, 4},
	{"C0_CACHEERR", "cacheerr", C0_CACHEERR, 4},
	{"C0_TAGLO", "taglo", C0_TAGLO, 4},
	{"C0_TAGHI", "taghi", C0_TAGHI, 4},
	{"C0_ERREPC", "errepc", C0_ERREPC, 8},
	{NULL, NULL, NULL, 0},
};

reg_spec_t	cp0Set1Regs[] = {
	{"C0C_IPLLO", "ipllo", C0C_IPLLO, 4},
	{"C0C_IPLHI", "iplhi", C0C_IPLHI, 4},
	{"C0C_ICR", "icr", C0C_ICR, 4},
	{"C0C_DERRADDR1", "derraddr1", C0C_DERRADDR1, 4},
	{"C0C_DERRADDR2", "derraddr2", C0C_DERRADDR2, 4},
	{NULL, NULL, NULL, 0},
};
#endif

#ifdef SB1250
reg_spec_t	cp0regs[] = {
	{"C0_INX", "index", C0_INX, 4},
	{"C0_RAND", "random", C0_RAND, 4},
	{"C0_TLBLO0", "tlblo0", C0_TLBLO0, 8},
	{"C0_TLBLO1", "tlblo1", C0_TLBLO1, 8},
	{"C0_CTEXT", "context", C0_CTEXT, 8},
	{"C0_PGMASK", "pgmask", C0_PGMASK, 4},
	{"C0_WIRED", "wired", C0_WIRED, 4},
	{"C0_BADVADDR", "badvaddr", C0_BADVADDR, 8},
	{"C0_COUNT", "count", C0_COUNT, 4},
	{"C0_TLBHI", "tlbhi", C0_TLBHI, 8},
	{"C0_COMPARE", "compare", C0_COMPARE, 4},
	{"C0_SR", "sr", C0_SR, 4},
	{"C0_CAUSE", "cause", C0_CAUSE, 4},
	{"C0_EPC", "epc", C0_EPC, 8},
	{"C0_PRID", "prid", C0_PRID, 4},
	{"C0_CONFIG", "config", C0_CONFIG, 4},
	{"C0_LLADDR", "lladdr", C0_LLADDR, 4},
	{"C0_WATCHLO", "watchlo", C0_WATCHLO, 8},
	{"C0_WATCHHI", "watchhi", C0_WATCHHI, 8},
	{"C0_XCONTEXT", "xcontext", C0_XCTEXT, 8},
	{"C0_ECC", "ecc", C0_ECC, 4},
	{"C0_CACHEERR", "cacheerr", C0_CACHEERR, 4},
	{"C0_TAGLO", "taglo", C0_TAGLO, 4},
	{"C0_TAGHI", "taghi", C0_TAGHI, 4},
	{"C0_ERREPC", "errepc", C0_ERREPC, 8},
	{NULL, NULL, NULL, 0},
};

#endif

#ifdef R7000
uint32
get_cp0Set1( int32 reg_num )
{
	uint32	val;

	val = 0;
	switch (reg_num)
	{
		case C0C_IPLLO:
			val = _rm7k_cfc0(C0C_IPLLO);
			break;

		case C0C_IPLHI:
			val = _rm7k_cfc0(C0C_IPLHI);
			break;

		case C0C_ICR:
			val = _rm7k_cfc0(C0C_ICR);
			break;

		case C0C_DERRADDR1:
			val = _rm7k_cfc0(C0C_DERRADDR1);
			break;

		case C0C_DERRADDR2:
			val = _rm7k_cfc0(C0C_DERRADDR2);
			break;
	}
	return val;
}

uint32
set_cp0Set1( int32 reg_num, uint32 val)
{
	switch (reg_num)
	{
		case C0C_IPLLO:
			_rm7k_ctc0(C0C_IPLLO, val);
			break;

		case C0C_IPLHI:
			_rm7k_ctc0(C0C_IPLHI, val);
			break;

		case C0C_ICR:
			_rm7k_ctc0(C0C_ICR, val);
			break;

		case C0C_DERRADDR1:
			_rm7k_ctc0(C0C_DERRADDR1, val);
			break;

		case C0C_DERRADDR2:
			_rm7k_ctc0(C0C_DERRADDR2, val);
			break;
	}
	return 0;
}
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/5/02
 *
 *-----------------------------------------------------------------
 */
int32
do_cp0(
	int32	argc,
	char8	* argv[]
)
{
	reg_spec_t	* ptr;

	if (argc == 1) {
		for (ptr = cp0regs; ptr->disp_name; ptr++) {
			if (ptr->reg_size == 4) {
				uint32	val;
				extern uint32	mfc0();
				val = mfc0(ptr->reg_num);
				printf("%s = 0x%08x\n", ptr->disp_name, val);
			}
			else {
				uint64	val;
				extern uint64	mfc0();
				val = mfc0(ptr->reg_num);
				printf("%s = 0x%016llx\n", ptr->disp_name, val);
			}
		}
#ifdef R7000
		for (ptr = cp0Set1Regs; ptr->disp_name; ptr++) {
			if (ptr->reg_size == 4) {
				uint32	val;

				val = get_cp0Set1(ptr->reg_num);
				printf("%s = 0x%08x\n", ptr->disp_name, val);
			}
		}
#endif
	}
	else if (argc == 2) {
		for (ptr = cp0regs; ptr->disp_name; ptr++) {
			if (strcmp(argv[1], ptr->reg_name) == 0) {
				if (ptr->reg_size == 4) {
					uint32	val;
					extern uint32	mfc0();
					val = mfc0(ptr->reg_num);
					printf("%s = 0x%08x\n", ptr->disp_name, val);
				}
				else {
					uint64	val;
					extern uint64	mfc0();
					val = mfc0(ptr->reg_num);
					printf("%s = 0x%016llx\n", ptr->disp_name, val);
				}
				return 0;
			}
		}
#ifdef R7000
		for (ptr = cp0Set1Regs; ptr->disp_name; ptr++) {
			if (strcmp(argv[1], ptr->reg_name) == 0) {
				if (ptr->reg_size == 4) {
					uint32	val;
	
					val = get_cp0Set1(ptr->reg_num);
					printf("%s = 0x%08x\n", ptr->disp_name, val);
				}
				return 0;
			}
		}
#endif
		printf("Unknown register, %s\n", argv[1]);
	}
	else if (argc == 3) {
		for (ptr = cp0regs; ptr->disp_name; ptr++) {
			if (strcmp(argv[1], ptr->reg_name) == 0) {
				if (ptr->reg_size == 4) {
					uint32 val;
					extern void mtc0(uint32 reg, uint32 val);
					val = atox(argv[2]);
					mtc0(ptr->reg_num, val);
				}
				else {
					printf("Unsupported\n");
				}
				return 0;
			}
		}
#ifdef R7000
		for (ptr = cp0Set1Regs; ptr->disp_name; ptr++) {
			if (strcmp(argv[1], ptr->reg_name) == 0) {
				if (ptr->reg_size == 4) {
					uint32	val;
					val = atox(argv[2]);
					set_cp0Set1(ptr->reg_num, val);
				}
				return 0;
			}
		}
#endif
		printf("Unknown register, %s\n", argv[1]);
	}
	else
		return -1;

	return 0;
}


uint32	readback;
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/26/02
 *
 *-----------------------------------------------------------------
 */
int32
do_ecc_test(
	int32	argc,
	char8	* argv[]
)
{
#if defined(R7000) & !defined(R9000)
	uint32	val, sr, t;
	static uint32 addr = 0xA0000000;;

	printf("clearing existing ECC interrupts\n");
	*(volatile uint32 *)0xb4000490 = 0;

	printf("enabling SR_IE\n");
	sr = _mips_mfc0(C0_SR);
	sr |= (SR_IE | SR_HINT0);
	_mips_mtc0(C0_SR,sr);

	val = 0x11223345;

	printf("disabling ECC interrupt out of GT\n");
	printf("force bad ECC calculation on\n");
	printf("write 0x%x to 0x%x\n", val, addr);
	printf("turn bad ECC calculation off\n");

	*(volatile uint32 *)0xb4000c1c = 0;

	*(volatile uint32 *)0xb4000494 = 0x000101FE;
	t = *(volatile uint32 *)0xb4000494;

	*(volatile uint32 *)addr = val;
	readback = *(volatile uint32 *)addr;

	*(volatile uint32 *)0xb4000494 = 0x00010000;
	t = *(volatile uint32 *)0xb4000494;

	printf("readback 0x%x = 0x%x\n", addr, readback);

	printf("SDRAM Error Data = 0x%x 0x%x\n", *(volatile uint32 *)0xb4000480, *(volatile uint32 *)0xb4000484);
	printf("SDRAM Error Address = %p\n", *(volatile uint32 *)0xb4000490);
	printf("SDRAM ECC Calculated = 0x%x, Received = 0x%x\n", *(volatile uint32 *)0xb400048c, *(volatile uint32 *)0xb4000488);
	printf("SDRAM ECC Control = 0x%x\n", *(volatile uint32 *)0xb4000494);
	printf("SDRAM ECC Counter = 0x%x\n", *(volatile uint32 *)0xb4000498);

	printf("Main Interrupt Cause Low = 0x%x\n", *(volatile uint32 *)0xb4000c18);
	printf("CPU Interrupt Mask Low = 0x%x\n", *(volatile uint32 *)0xb4000c1c);
	printf("CPU Int0 Mask = 0x%x\n", *(volatile uint32 *)0xb4000e60);
	printf("CPU Int1 Mask = 0x%x\n", *(volatile uint32 *)0xb4000e64);
	printf("CPU Int2 Mask = 0x%x\n", *(volatile uint32 *)0xb4000e68);
	printf("CPU Int3 Mask = 0x%x\n", *(volatile uint32 *)0xb4000e6c);

	addr += 4; 

	printf("enabling ECC interrupt out of GT on Int0\n");
	*(volatile uint32 *)0xb4000c1c = 0x00020000;
	t = *(volatile uint32 *)0xb4000c1c;

#endif
	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/23/02
 *
 *-----------------------------------------------------------------
 */
int32
do_tlb(
	int32	argc,
	char8	* argv[]
)
{
	uint32	index, virt, phys, size, calg;

	if (argc == 1)
		tlb_display();
	else {
		if (argc != 6) {
			printf("tlb <index> <virt> <phys> <size> uncached|cached\n");
			return 0;
		}
		index = atoi(argv[1]);
		virt = atox(argv[2]);
		phys = atox(argv[3]);
		size = atox(argv[4]);
		if (*argv[5] == 'u')
			calg = CFG_C_UNCACHED;
		else
			calg = CFG_C_WBACK;


		printf("setting tlb %d, virt = 0x%x, phys = 0x%x, size = 0x%x, %s\n",
				index, virt, phys, size,
				(calg == CFG_C_WBACK) ? "cached" : "uncached");

		tlb_set(index, virt, phys, size, calg);
	}

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/12/02
 *
 *-----------------------------------------------------------------
 */
int32
do_mc(
	int32	argc,
	char8	* argv[]
)
{
#ifdef SIBYTE

	printf("\n");
	printf("Memory Controller 0:\n");
	printf("   Channel Config     = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051100));
	printf("   Clock Config       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051500));
	printf("   DRAM Mode          = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051140));
	printf("   SDRAM Timing       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051160));
	printf("   SDRAM Timing2      = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051180));
	printf("   CS Start           = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100511A0));
	printf("   CS End             = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100511C0));
	printf("   CS Interleave      = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100511E0));
	printf("   CS0 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051200));
	printf("   CS1 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051260));
	printf("   CS2 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100512C0));
	printf("   CS3 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051320));
	printf("   CS0 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051220));
	printf("   CS1 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051280));
	printf("   CS2 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100512E0));
	printf("   CS3 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051340));
	printf("   CS0 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051240));
	printf("   CS1 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100512A0));
	printf("   CS2 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051300));
	printf("   CS3 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051360));
	printf("   CS Attribute       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10051380));

	printf("\n");
	printf("Memory Controller 1:\n");
	printf("   Channel Config     = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052100));
	printf("   Clock Config       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052500));
	printf("   DRAM Mode          = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052140));
	printf("   SDRAM Timing       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052160));
	printf("   SDRAM Timing2      = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052180));
	printf("   CS Start           = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100521A0));
	printf("   CS End             = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100521C0));
	printf("   CS Interleave      = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100521E0));
	printf("   CS0 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052200));
	printf("   CS1 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052260));
	printf("   CS2 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100522C0));
	printf("   CS3 Row Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052320));
	printf("   CS0 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052220));
	printf("   CS1 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052280));
	printf("   CS2 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100522E0));
	printf("   CS3 Col Addr Bits  = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052340));
	printf("   CS0 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052240));
	printf("   CS1 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x100522A0));
	printf("   CS2 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052300));
	printf("   CS3 Bank Addr Bits = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052360));
	printf("   CS Attribute       = 0x%016llx\n", *(uint64 *)PHYS_TO_K1(0x10052380));

#endif
	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/12/02
 *
 *-----------------------------------------------------------------
 */
int32
do_draminit(
	int32	argc,
	char8	* argv[]
)
{
#ifdef SIBYTE

	if (argc == 1)
		draminit(0);
	else if (argc == 3) {
		if (strncmp(argv[1], "show", 4) == 0) {
			if (atoi(argv[2]) == 0)
				draminit_show_mc(0);
			else if (atoi(argv[2]) == 1)
				draminit_show_mc(1);
		}
	}
	else
		return -1;
#endif
	return 0;
}

