/*
 *-----------------------------------------------------------------
 *
 * Name:	sizeram.S
 *
 * RCS:  $Id: sizeram.S,v 1.5 2002/08/02 15:50:35 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/17/01
 *
 *-----------------------------------------------------------------
 */

#ifdef PROM

#include <nfx-target.h>
#include <exports/hwMap.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/promio-api.h>

#if 0
#ifdef AGILE_HARDWARE
#define USE_256MB_SIMM
#else
#define USE_32MB_SIMM
#endif
#endif

	.text


/*------------------------------------------------------------------*/
gt_i2c_reg_write:
	la	a2,0xb4000000
	add	a2,a0
	sw	a1,0(a2)
	j	ra

/*------------------------------------------------------------------*/
gt_i2c_reg_read:
	la	a2,0xb4000000
	add	a2,a0
	lw	v0,0(a2)
	j	ra

/*------------------------------------------------------------------*/
#define I2C_REG_WRITE_IMM(_a0,_a1)	\
	li		a0,_a0;					\
	li		a1,_a1;					\
	jal		gt_i2c_reg_write;

#define I2C_REG_WRITE_REG(_a0,_a1)	\
	li		a0,_a0;					\
	move	a1,_a1;					\
	jal		gt_i2c_reg_write;

#define I2C_REG_READ(_a0)			\
	li		a0,_a0;					\
	jal		gt_i2c_reg_read;

/*------------------------------------------------------------------*/
	.globl	gt_read_spd_byte
	.ent	gt_read_spd_byte
gt_read_spd_byte:
	move	t0,a0		/* i2c addr */
	move	t1,a1		/* byte addr */
	move	v1,ra

	/*
	 * transmit start + device address
	 */
	I2C_REG_WRITE_IMM(I2C_CONTROL,0x60)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

	I2C_REG_WRITE_REG(I2C_DATA,t0)

	I2C_REG_WRITE_IMM(I2C_CONTROL,0x40)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

1:	I2C_REG_READ(I2C_STATUS_BAUDE_RATE)
	beq		v0,0xF8,1b
1:	bne		v0,0x18,1b

	/*
	 * transmit word address
	 */
	I2C_REG_WRITE_REG(I2C_DATA,t1)
	I2C_REG_WRITE_IMM(I2C_CONTROL,0x40)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

1:	I2C_REG_READ(I2C_STATUS_BAUDE_RATE)
	beq		v0,0xF8,1b
1:	bne		v0,0x28,1b

	/*
	 * transmit start + device address
	 */
	I2C_REG_WRITE_IMM(I2C_CONTROL, 0x60)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

	or	t0,1
	I2C_REG_WRITE_REG(I2C_DATA,t0)
	I2C_REG_WRITE_IMM(I2C_CONTROL, 0x40)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

1:	I2C_REG_READ(I2C_STATUS_BAUDE_RATE)
	beq		v0,0xF8,1b
1:	bne		v0,0x40,1b

	/*
	 * read data byte
	 */	
	I2C_REG_WRITE_IMM(I2C_CONTROL, 0x40)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,8
	beqz	v0,1b

1:	I2C_REG_READ(I2C_STATUS_BAUDE_RATE)
	beq		v0,0xF8,1b
1:	beq		v0,0x50,2f
	beq		v0,0x58,2f
	b		1b
2:
	I2C_REG_READ(I2C_DATA)
	move	a3,v0					/* data byte */

	/*
	 * transmit stop
	 */
	I2C_REG_WRITE_IMM(I2C_CONTROL, 0x50)

1:	I2C_REG_READ(I2C_CONTROL)
	and		v0,0x10
	bnez	v0,1b

	move	v0,a3
	move	ra,v1
	j		ra

	.end	gt_read_spd_byte

/*------------------------------------------------------------------*/
	.globl	sizeram
	.ent	sizeram
sizeram:
	
	move	k0,ra

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	li		t0,0
	li		t1,0x7F
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	sw		t1,SCS_0_LOW_DECODE_ADDRESS(a0)
	
	sw		t0,SCS_1_HIGH_DECODE_ADDRESS(a0)
	sw		t1,SCS_1_LOW_DECODE_ADDRESS(a0)

	sw		t0,SCS_2_HIGH_DECODE_ADDRESS(a0)
	sw		t1,SCS_2_LOW_DECODE_ADDRESS(a0)

	sw		t0,SCS_3_HIGH_DECODE_ADDRESS(a0)
	sw		t1,SCS_3_LOW_DECODE_ADDRESS(a0)
do_dimm1:

#if !defined(USE_128MB_SIMM) && !defined(USE_32MB_SIMM) && !defined(USE_256MB_SIMM) && !defined(USE_512MB_SIMM)

	li		a0,0xAC
	li		a1,5
	jal		gt_read_spd_byte		/* num_banks */
	move	t2,v0

	li		a0,0xAC
	li		a1,6
	jal		gt_read_spd_byte		/* module_data_width */
	and		v0,0xF0
	move	t3,v0

	li		a0,0xAC
	li		a1,13
	jal		gt_read_spd_byte		/* sdram_width */
	move	t4,v0

	li		a0,0xAC
	li		a1,17
	jal		gt_read_spd_byte		/* sdram_banks */
	move	t5,v0

	li		a0,0xAC
	li		a1,31
	jal		gt_read_spd_byte		/* module_bank_density */
	move	t6,v0

#else

#ifdef USE_128MB_SIMM
	li		t2,1
	li		t3,64
	li		t4,8
	li		t5,4
	li		t6,32
#endif	/* 128 MB */

#ifdef USE_32MB_SIMM
	li		t2,1
	li		t3,64
	li		t4,16
	li		t5,4
	li		t6,8
#endif	/* 32 MB */

#ifdef USE_256MB_SIMM
	li		t2,1
	li		t3,64
	li		t4,4
	li		t5,4
	li		t6,64
#endif	/* 256 MB */

#ifdef USE_512MB_SIMM
	li		t2,2
	li		t3,64
	li		t4,8
	li		t5,4
	li		t6,64
#endif	/* 512 MB */

#endif

	/*
	 * Get Total Memory on DIMM1
	 */
	mul		s3,t2,t5
	mul		s3,s3,t6

	/*
	 * Get Memory Organization for DIMM1
	 */
	mul		s4,s3,8
	mul		s4,s4,t4
	div		s4,s4,t2
	div		s4,s4,t3

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	beq		s4,16,dimm1_bank_16mbit
	beq		s4,64,dimm1_bank_64mbit
	beq		s4,128,dimm1_bank_128mbit
dimm1_bank_256mbit:
dimm1_bank_512mbit:
	li		t0,0x000FC000
	b		dimm1_bank_cont
dimm1_bank_64mbit:
dimm1_bank_128mbit:
	li		t0,0x000F8000
	b		dimm1_bank_cont
dimm1_bank_16mbit:
	li		t0,0x000F4000
dimm1_bank_cont:
	sw		t0,SDRAM_BANK0PARAMETERS(a0)
	bne		t2,2,1f
	sw		t0,SDRAM_BANK1PARAMETERS(a0)
1:

/*
	la		ARG1,dimm1_size_msg
	JMP_SUB2(promio_prs)

	move	ARG1,s3
	li		ARG2,8
	JMP_SUB2(promio_prx)

	la		ARG1,mb_msg
	JMP_SUB2(promio_prs)

	la		ARG1,nl_msg
	JMP_SUB2(promio_prs)
*/

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	beq		s3,32,dimm1_32
	beq		s3,64,dimm1_64
	beq		s3,128,dimm1_128
	beq		s3,256,dimm1_256
	beq		s3,512,dimm1_512
	beq		s3,1024,dimm1_1024 
dimm1_0:
	b		save_dimm1
	
dimm1_32:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x1FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x01fff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x01fff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

dimm1_64:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x3FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x03fff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x03fff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

dimm1_128:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x7FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

dimm1_256:
	beq		t2,2,do_split_256
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0xFFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

do_split_256:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x7FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

	li		t0,HW_RAM_BASE+0x8000000
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_1_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0xFFFFFFF
	srl		t0,20
	sw		t0,SCS_1_HIGH_DECODE_ADDRESS(a0)

	/* Enable PCI to SCS1 space */
	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)

	/* Enable PCI BAR for SCS1 */
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_ADDRESS, 0x80000010)
	lw		v0,PCI_0CONFIGURATION_DATA_VIRTUAL_REGISTER(a0)
	add		v0,0x08000000
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_ADDRESS, 0x80000014)
	sw		v0,PCI_0CONFIGURATION_DATA_VIRTUAL_REGISTER(a0)

	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_ADDRESS, 0x80000010)
	lw		v0,PCI_1CONFIGURATION_DATA_VIRTUAL_REGISTER(a0)
	add		v0,0x08000000
	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_ADDRESS, 0x80000014)
	sw		v0,PCI_1CONFIGURATION_DATA_VIRTUAL_REGISTER(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

    GT_WRITE_REG_ASS(PCI_0SCS_1_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_0SCS_1_BASE_ADDRESS_REMAP, 0x08000000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BANK_SIZE, 0x07fff000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BASE_ADDRESS_REMAP, 0x08000000)

	b		save_dimm1

dimm1_512:
	beq		t2,2,do_split_512
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x1FFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x1ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x1ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

do_split_512:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0xFFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

	li		t0,0x20000000
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_1_LOW_DECODE_ADDRESS(a0)
	li		t0,0x20000000
	add		t0,0xFFFFFFF
	srl		t0,20
	sw		t0,SCS_1_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

    GT_WRITE_REG_ASS(PCI_0SCS_1_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_1_BASE_ADDRESS_REMAP, 0x20000000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BASE_ADDRESS_REMAP, 0x20000000)

	/* Enable PCI to SCS1 space */
	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)

	/* Enable PCI BAR for SCS1 */
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_ADDRESS, 0x80000014)
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_DATA_VIRTUAL_REGISTER, 0x90000008)
	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_ADDRESS, 0x80000014)
	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_DATA_VIRTUAL_REGISTER, 0x90000008)

/*	li		s3,256 */

	b		save_dimm1

dimm1_1024:
	/*
	 * Right now this code won't work.  
	 * can't use 0 - 0x40000000 for bank0, since that overlaps prom space.
	 */
	beq		t2,2,do_split_1024
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x3FFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x3ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x3ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

	b		save_dimm1

do_split_1024:
	/*
	 * Right now this code won't work.  Since each bank is 512 MB, and we
	 * can't use 0 - 0x20000000 for bank0, since that overlaps prom space.
	 */
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x1FFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)

	li		t0,0x20000000
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_1_LOW_DECODE_ADDRESS(a0)
	li		t0,0x20000000
	add		t0,0x1FFFFFFF
	srl		t0,20
	sw		t0,SCS_1_HIGH_DECODE_ADDRESS(a0)

    /* Set up PCI accesses to GT memory */
    GT_WRITE_REG_ASS(PCI_0SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_0_BASE_ADDRESS_REMAP, 0x0)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_0_BASE_ADDRESS_REMAP, 0x0)

    GT_WRITE_REG_ASS(PCI_0SCS_1_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_0SCS_1_BASE_ADDRESS_REMAP, 0x20000000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BANK_SIZE, 0x0ffff000)
    GT_WRITE_REG_ASS(PCI_1SCS_1_BASE_ADDRESS_REMAP, 0x20000000)

	/* Enable PCI to SCS1 space */
	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_0BASE_ADDRESS_REGISTERS_ENABLE(a0)

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	lw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)
	and		t0,~0x2
	sw		t0,PCI_1BASE_ADDRESS_REGISTERS_ENABLE(a0)

	/* Enable PCI BAR for SCS1 */
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_ADDRESS, 0x80000014)
	GT_WRITE_REG_ASS(PCI_0CONFIGURATION_DATA_VIRTUAL_REGISTER, 0x90000008)
	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_ADDRESS, 0x80000014)
	GT_WRITE_REG_ASS(PCI_1CONFIGURATION_DATA_VIRTUAL_REGISTER, 0x90000008)

	li		s3,256

	b		save_dimm1

save_dimm1:
	move	s4,s3


	move	ra,k0
	j		ra

	.end	sizeram

/*------------------------------------------------------------------*/

spd_err_msg:
	.asciiz	"Error reading SPD\r\n"
nl_msg:
	.asciiz "\r\n"
dimm1_size_msg:
	.asciiz	"DIMM1 size = "
dimm2_size_msg:
	.asciiz	"DIMM2 size = "
mb_msg:
	.asciiz	"MB"

#endif	/* PROM */

