/*
 *-----------------------------------------------------------------
 *
 * Name:	meminit.S
 *
 * RCS:  $Id: mem-init.S,v 1.2 2002/03/23 18:37:05 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	Initiliaze memory sections
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */

#ifdef PROM

#include <nfx-target.h>
#include <sys/mips.h>

	.text

	.globl	meminit_data
	.globl	meminit_bss
	.globl	meminit_decompression_data
	.globl	meminit_decompression_bss

/*-----------------------------------------------------------------
 * Name:	meminit_data()
 *
 * Description:	Initialize the data section of the PROM in memory
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_data
meminit_data:
	la		t0,etext
	addu	t0,15
	and		t0,~15
	la		t1,_fdata
	la		t2,edata

	.set noreorder
1:
	ld		t3,0(t0)
	sd		t3,0(t1)
	addu	t0,8
	addu	t1,8
	bltu	t1,t2,1b
	nop

	j		ra
	nop

	.set reorder

	.end	meminit_data

#if defined(USE_DECOMPRESS) && !defined(SB1250_SIMULATOR)
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	12/29/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_decompression_data
meminit_decompression_data:
	la		t0,etext
	addu	t0,15
	and		t0,~15
	la		t1,_decompression_text_start
	la		t2,_decompression_text_end

	.set noreorder
1:
	ld		t3,0(t0)
	sd		t3,0(t1)
	addu	t0,8
	addu	t1,8
	bltu	t1,t2,1b
	nop

	j		ra
	nop

	.set reorder

	.end	meminit_decompression_data
#endif

/*-----------------------------------------------------------------
 * Name:	meminit_bss()
 *
 * Description:	Initialize the bss section of the PROM in memory
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_bss
meminit_bss:
	la		v0,_fbss
	la		v1,end

    .set noreorder
1:
	sd		zero,0(v0)
    sd		zero,8(v0)
    sd		zero,16(v0)
	addu	v0,32
	bltu	v0,v1,1b
    sd		zero,-8(v0)			# BDSLOT

	j		ra
	nop

	.set	reorder

	.end	meminit_bss

#if defined(USE_DECOMPRESS) && !defined(SB1250_SIMULATOR)
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	12/29/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_decompression_bss
meminit_decompression_bss:
	la		v0,_decompression_bss_start
	la		v1,_decompression_bss_end

    .set noreorder
1:
	sd		zero,0(v0)
    sd		zero,8(v0)
    sd		zero,16(v0)
	addu	v0,32
	bltu	v0,v1,1b
    sd		zero,-8(v0)			# BDSLOT

	j		ra
	nop

	.set	reorder

	.end	meminit_decompression_bss
#endif

#endif	/* PROM */

