/*
 *-----------------------------------------------------------------
 *
 * Name:	nfx-init.S
 *
 * RCS:  $Id: nfx-init.S,v 1.2 2002/03/26 22:04:58 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	low level board initialization - PROM code
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/13/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-target.h>
#include <sys/mips.h>
#include <sys/tx3927.h>

	.text

	.globl	nfx_init

	.extern	nfx_init_done

	.set	noreorder

/*-----------------------------------------------------------------
 * Name:	nfx_init
 *
 * Description:
 *				minimal galileo init
 *				uart init
 *				nsdb
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/13/01
 *
 *-----------------------------------------------------------------
 */
	.ent	nfx_init
nfx_init:

	la	t0,TX3927_PCFG
	li	t1,0x0FC03000
	sw	t1,0(t0)

	/*
	 * Memory initialization
	 */
	la	t0,TX3927_SDCTR1
#	li	t1,0x00080300
	li	t1,0x01080300
	sw	t1,0(t0)

	la	t0,TX3927_SDCCR0
	li	t1,0x000101ea
	sw	t1,0(t0)

	la	t0,TX3927_SDCCR1
	li	t1,0x020101ea
	sw	t1,0(t0)

	la	t0,TX3927_SDCCMD
	li	t1,0x20100033
	sw	t1,0(t0)

	la	t0,TX3927_SDCCR0
	li	t1,0x000301ea
	sw	t1,0(t0)

	la	t0,TX3927_SDCCR1
	li	t1,0x020301ea
	sw	t1,0(t0)

	la	t0,TX3927_SDCCMD
	li	t1,0x20100031
	sw	t1,0(t0)

	la	t0,TX3927_SDCCMD
	li	t1,0x20100030
	sw	t1,0(t0)

	/*
	 * PCI window init for memory accesses
	 */
	la	t0,TX3927_PCISTAT
	li	t1,0x02100147		/* cfg command reg */
	sw	t1,0(t0)

	la	t0,TX3927_MBAS
	li	t1,0xFC000000		/* target window = 64 MB */
	sw	t1,0(t0)

	la	t0,TX3927_MBA
	li	t1,0x10000008		/* target window = 0x10000000 */
	sw	t1,0(t0)

	/*
	 * enable PCI cfg accesses
	 */
	la	t0,TX3927_LBC
	li	t1,0x80
	sw	t1,0(t0)

	la	sp,stack+STKSIZE-24


	li		t0,0x400
1:
	bne		t0,zero,1b
	subu	t0,1

	j		nfx_init_done
	nop

	.end	nfx_init

