/*
 *-----------------------------------------------------------------
 *
 * Name:	sbdreset-r3k.S
 *
 * RCS:  $Id: sbdreset-r3k.S,v 1.6 2002/10/17 21:32:42 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	low level code for GT 64240 board
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/21/01
 *
 *-----------------------------------------------------------------
 */

#ifdef TX3927

#include <nfx-target.h>
#include <sys/mips.h>
#include <exports/promio-api.h>

	.globl	nfx_init_done
	.globl	nsdb_done

#define msize		s4

LEAF(sbdreset)
	
	mfc0	t1,C0_CONFIG
	or		t1,0x000060A8			/* CWFON | WBON | ICE | DCE | IRSIZE=16 */
	mtc0	t1,C0_CONFIG

	mtc0	zero,C0_INX
	mtc0	zero,C0_RAND
	mtc0	zero,C0_TLBLO
	mtc0	zero,C0_CTEXT
	mtc0	zero,C0_PGMASK
	mtc0	zero,C0_WIRED
	mtc0	zero,C0_CACHE
	mtc0	zero,C0_TLBHI
	mtc0	zero,C0_CAUSE
	mtc0	zero,C0_DEBUG
	mtc0	zero,C0_DEPC
	mtc0	zero,C0_TAGLO

	li		t1,0x10400000			/* CU0 | BEV */
	mtc0	t1,C0_SR

	j		nfx_init
nfx_init_done:

	jal		promio_init

	DEBUG_STR("[promio_init] OK\r\n");

	jal		init_tlb

	DEBUG_STR("[tlb_init] OK\r\n");

	jal		get_boot_block			/* reads boot block from offset 0 */
									/* boot block specifies memory config */
									/* and jump block address */

	move	s0,a0		/* save */

	DEBUG_STR("[boot_init] OK\r\n");

	move	a0,s0		/* restore */

	jal		meminit_data
	jal		meminit_bss

	move	s0,a0		/* save */
	DEBUG_STR("\r\n\r\n");
	la		a0,ImageVerString
	JMP_SUB4(promio_prs)
	DEBUG_STR("\r\n\r\n");
	move	a0,s0		/* restore */

	/* a0 = jump_block_addr */
	jal		get_jump_block			/* reads jump block from jump block addr */
									/* jump block specifies entry offset */
									/* and memory sizes */

	move	s0,a0		/* save */
	move	s1,v0		/* save */

	DEBUG_STR("[context switch] READY\r\n");

	move	a0,s0		/* restore */
	move	v0,s1		/* restore */

	/* v0 = entry addr, a0 = jump_block_addr */
	j		v0

#ifdef USE_NSDB
	jal		nsdb
nsdb_done:
	DEBUG_STR("back from nsdb")
#endif /* USE_NSDB */

END(sbdreset)

#endif	/* TX3927 */

