
#include <sys/types.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <neteee/eee.h>
#include <neteee/eee_if.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>

static int
do_ioctl(int cmd, struct eee_attachreq *req)
{
	int rc = -1;
	int s = socket(PF_EEE, SOCK_DGRAM, 0);
	errno = 0;
	if (s >= 0) {
		rc = ioctl(s, cmd, req);
		close(s);
	}
	return rc;
}


/*
 * ethereee_ifattach - attach an interface with the given parameters
 */
int ethereee_ifattach(struct eee_attachreq *req)
{
	return do_ioctl(SIOCETHEEEATTACH, req);
}


/*
 * ethereee_ifdetach - detach the interface
 */
int ethereee_ifdetach(struct eee_attachreq *req)
{
	return do_ioctl(SIOCETHEEEDETACH, req);
}


/*
 * ethereee_ifset - set the interface for the eee address
 */
int ethereee_ifset(struct eee_attachreq *req)
{
	return do_ioctl(SIOCETHEEESET, req);
}
