/*
 *-----------------------------------------------------------------
 *
 * Name:	bp_init_fc.c
 *
 * RCS:  $Id: bp_init_fc.c,v 1.19 2002/11/07 01:23:36 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:		Tony Wong
 *
 * Date Created:	01/04/02
 *
 *-----------------------------------------------------------------
 */
#ifdef AGILE_HARDWARE

#ifndef SIBYTE
#include <nfx-incl.h>
#include <exports/backplane-api.h>
#include <sys/mips.h>
#include <exports/hwMap.h>
#include <exports/cm-api.h>
typedef int *common_func_mii(uint32, uint32, uint32, uint32);
#endif

void
bp_init_fc()
{
#ifndef SIBYTE
#ifndef SSC_MGMT

#ifdef PROM

	/* shaun 04/18/04
	 * gt init module is done in bp_init_ssc 
	 * for Bobcat (R9000).
	 */
#ifndef PROM_R9000
    uint32 i, data;
	extern void gt_mii_writeSMI_common(uint32, uint32, uint32, uint32);
	extern int gt64240mii_initModule(void);
	extern int gt_mii_writeSMI(uint32, uint32, uint32, uint32);
	extern int gt_mii_readSMI(uint32, uint32, uint32 *);
    extern void common_init_phy8353(common_func_mii *, uint32, uint32);
    extern void common_init_phy8354(common_func_mii *, uint32, uint32);
	extern void common_init_phy5228(common_func_mii *, uint32, uint32);
	extern int bcm_init_5600(int);

	/* initialize Galileo MII ports */
    gt64240mii_initModule();
#ifdef DIAG_R7000	
    dp83820_initModule();
#endif    

    /* only initialize devices if this is slice 0 of FCNIM */
    if (cmGetMyCPUId() != NFX_FCNIM_CTRL_CPU)
        return;

    /* initialize National's 8353/8354 phy to control/data plane */
    /* phy addr: 0x18, 0x19, 0x1a, 0x1b */
    for (i = 0; i < 4; i++) {
        if (gt_mii_readSMI(0x18+i, 0x03, &data) == NFX_OK) {
            if (((data & 0x0000ffff) == 0x8050) || 
                ((data & 0x0000ffff) == 0x8051)) 
            {
	            common_init_phy8354((common_func_mii *)gt_mii_writeSMI_common, 
                                    0xff, 0x18+i);
            }
            else {
	            common_init_phy8353((common_func_mii *)gt_mii_writeSMI_common, 
                                    0xff, 0x18+i);
            }
        }
    }

    /* initialize 5600's 8353/8354 phy to control/data plane */
    /* phy addr: 0x0a, 0x0b */
    for (i = 0; i < 2; i++) {
        if (gt_mii_readSMI(0x0a+i, 0x03, &data) == NFX_OK) {
            if (((data & 0x0000ffff) == 0x8050) || 
                ((data & 0x0000ffff) == 0x8051)) 
            {
	            common_init_phy8354((common_func_mii *)gt_mii_writeSMI_common, 
                                    0xff, 0x0a+i);
            }
            else {
	            common_init_phy8353((common_func_mii *)gt_mii_writeSMI_common, 
                                    0xff, 0x0a+i);
            }
        }
    }

    /* initialize Galileo's 5228 phy to management plane */
    /* phy addr: 0x10, 0x11, 0x12, 0x13 */
	common_init_phy5228((common_func_mii *)gt_mii_writeSMI_common, 0, 0x10);
	common_init_phy5228((common_func_mii *)gt_mii_writeSMI_common, 0, 0x11);
	common_init_phy5228((common_func_mii *)gt_mii_writeSMI_common, 0, 0x12);
	common_init_phy5228((common_func_mii *)gt_mii_writeSMI_common, 0, 0x13);

    /* isolate unused secondary ports */
    /* phy addr: 0x14, 0x15, 0x16, 0x17 */
    gt_mii_writeSMI(0x14, 0x00, 0x0400, 0xffff);
    gt_mii_writeSMI(0x15, 0x00, 0x0400, 0xffff);
    gt_mii_writeSMI(0x16, 0x00, 0x0400, 0xffff);
    gt_mii_writeSMI(0x17, 0x00, 0x0400, 0xffff);

	bcm_init_5600(0);
#endif
#else
extern int dp83820_initModule(void);
extern int gt64240mii_initModule(void);
extern void bcm5600_port_disable(int, int);
extern void gt_mii_writeSMI_common(uint32, uint32, uint32, uint32);

	/* initialize National MACs */
    dp83820_initModule();
	/* initialize Galileo MII ports */
    gt64240mii_initModule();

    if (cmGetMyCPUId() == NFX_FCNIM_CTRL_CPU)
    {
        gt_mii_writeSMI_common(0xffff, 0x18, 0x0, 0x0140);
        gt_mii_writeSMI_common(0xffff, 0x19, 0x0, 0x0140);
        gt_mii_writeSMI_common(0xffff, 0x1a, 0x0, 0x0140);
        gt_mii_writeSMI_common(0xffff, 0x1b, 0x0, 0x0140);
    }
    
	/* disable debug switch port for runtime - done from slice 0 only */
    if (cmGetMyCPUId() == NFX_FCNIM_CTRL_CPU)
		bcm5600_port_disable(0, 15);
#endif
#endif /* SSC_MGMT */
#endif /* SIBYTE */
}
#endif	/* AGILE_HARDWARE */
