/* vi:ts=4  
 *-----------------------------------------------------------------
 *
 * Name: bsd-arpsniff.h
 *
 * RCS:  $Id: bsd-arpsniff.h,v 1.2 2002/08/01 17:55:53 sandrineb Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: arp sniffing to build layer2 connectivity 
 *
 * Created by:	Su Wang
 *
 * Date Created: 05/24/02
 *
 *-----------------------------------------------------------------
 */
#ifndef BSD_ARPSNIFF_H
#define BSD_ARPSNIFF

#if !defined(PROM)
#define ARP_SNIFFING
#endif /* PROM */

/* 20 seconds more than node timeouts */
#define ARPS_TIME_LIVE	((CLUST_NODE_FAIL_TIMEOUT/10) + 2)
#define ARPS_STR_SIZE   16

/* lay2 connection table entry */
typedef struct l2conn_ent
{
	uint32				l2ConnEnt_ip;
	uchar8				l2ConnEnt_ifname[ARPS_STR_SIZE];
	uint32				l2ConnEnt_expire;
	struct l2conn_ent	*l2ConnEnt_next;
} l2conn_ent_t;

/* arp sniffing related stats */
typedef struct 
{
	uint32	alloc;
	uint32  allocFail;
	uint32  dealloc;
} arps_stat_t;

/* configuration block for arp sniffing */
typedef struct
{
	arps_stat_t		stat;
	l2conn_ent_t	*l2ConnTblHead;
	uint32			count;
	int				enable;
} arps_cfg_t;

extern arps_cfg_t	arpsCfg;
extern arps_cfg_t	*arpsCfgPtr;

/* function declarations */
void			arpS_Init(void);
l2conn_ent_t*	arpS_FindEntry(uint32);
int32			arpS_AddEntry(void*, void*);
void			arpS_Timer(void);
void			arpS_ShowL2ConnTbl(void);

#endif /* BSD_ARPSNIFF_H */
