/* agilepost.h */



/* the GET or POST request URI start with this string will  */
/* be treated as a Agile GET/POST request                   */

#define PREFIX_AGILEGET	"/agilerequestprefix"

/* set the maximum agile template size here                 */
/* the processing routine will read the whole template file */
/* into memory to ease the process                          */

#define MAX_AGILETEMPLATE_SIZE	20480

/* set the maximum parameter size here                      */
/* MAX_NUM_PARAMS - max number of args for GET/POST request */
/* MAX_PNAME_SIZE - max parameter name/value string size    */
/* MAX_PARAM_BUFSIZE - max req body buffer size (for POST)  */

#define MAX_NUM_PARAMS			32
#define MAX_PARAMNAME_SIZE		32
#define MAX_PARAMVAL_SIZE		128
#define MAX_PARAM_BUFSIZE		40960

/* the maximum size of a value string which is used to      */
/* replace the tag in Agile's HTML template                 */

#define MAX_REPLACESTR_LEN		40960


#define MAX_TAGNAME_SIZE	64
typedef struct _tagNameTable {
	int	tagType;
	char tagName[MAX_TAGNAME_SIZE];
} tagNameTable_t;

typedef struct _tagCallbackParams {
	void *req;
	char *tag;
	int valueSize;
	char *value;
	int bytesAlreadyDumped;
} tagCallbackParams_t;

typedef int (*tagCallbackFunc_t)(tagCallbackParams_t *);

/* in agilepost.c */
int prepare_agile_template(void *, char *);
int process_agile_getpost(void *, char *);
int dump_to_client(void *, char *, int);
int agile_scan_and_send(void *, tagCallbackFunc_t);
int GetUserPrivilege(void);
void GetSystemHostInfo(void *req, char *ip, char *host);
u_int32_t GetHttpClientIP(void *req);

/* in agileifmain.c */
int actionInterfaceMain(void *r, int count, char **argname, char **argval);

/* in agileifdetail.c */
int actionInterfaceDetail(void *r, int count, char **argname, char **argval);

/* in agileifadd.c */
int actionInterfaceAdd(void *r, int count, char **argname, char **argval);

/* in agileifdel.c */
int actionInterfaceDel(void *r, int count, char **argname, char **argval);

/* in agileifmod.c */
int actionInterfaceMod(void *r, int count, char **argname, char **argval);

/* in agileifstat.c */
/*int actionInterfaceStat(void *r, int count, char **argname, char **argval);*/

/* in agileroutemain.c */
int actionRouteMain(void *r, int count, char **argname, char **argval);

/* in agilerouteadd.c */
int actionRouteAdd(void *r, int count, char **argname, char **argval);

/* in agileroutedel.c */
int actionRouteDel(void *r, int count, char **argname, char **argval);

/* in agilelunmain.c */
int actionLunMain(void *r, int count, char **argname, char **argval);

/* in agilelundetail.c */
int actionLunDetail(void *r, int count, char **argname, char **argval);

/* in agilelunstat.c */
int actionLunStat(void *r, int count, char **argname, char **argval);

/* in agilelunlabel.c */
int actionLunLabel(void *r, int count, char **argname, char **argval);

/* in agilelunreset.c */
int actionLunReset(void *r, int count, char **argname, char **argval);

/* in agilediskmain.c */
int actionDiskMain(void *r, int count, char **argname, char **argval);

/* in agilediskluns.c */
int actionDiskLuns(void *r, int count, char **argname, char **argval);

/* in agilediskaddvol.c */
int actionDiskAddVol(void *r, int count, char **argname, char **argval);

/* in agilediskaddvolact.c */
int actionDiskAddVolAct(void *r, int count, char **argname, char **argval);

/* in agileportmain.c */
int actionPortMain(void *r, int count, char **argname, char **argval);

/* in agileportdetail.c */
int actionPortDetail(void *r, int count, char **argname, char **argval);

/* in agileportstat.c */
int actionPortStat(void *r, int count, char **argname, char **argval);

/* in agileportreset.c */
int actionPortReset(void *r, int count, char **argname, char **argval);

/* in agileportenable.c */
int actionPortEnable(void *r, int count, char **argname, char **argval);

/* in agileportdisable.c */
int actionPortDisable(void *r, int count, char **argname, char **argval);

/* in agilenwstat.c */
int actionNwStat(void *r);

/* in agilenwconnssc.c */
int actionNwConnSsc(void *r, int count, char **argname, char **argval);

/* in agilenwconnfp.c */
int actionNwConnFp(void *r, int count, char **argname, char **argval);

/* in agilevolmain.c */
int actionVolMain(void *r, int count, char **argname, char **argval);

/* in agilevoldetail.c */
int actionVolDetail(void *r, int count, char **argname, char **argval);

/* in agilevoladd.c */
int actionVolAdd(void *r);

/* in agilevoldel.c */
int actionVolDelete(void *r, int count, char **argname, char **argval);

/* in agilevolmod.c */
int actionVolModify(void *r, int count, char **argname, char **argval);

/* in agilesshotmain.c */
int actionSshotMain(void *r, int count, char **argname, char **argval);

/* in agilesshotadd.c */
int actionSshotAdd(void *r, int count, char **argname, char **argval);

/* in agilesshotdel.c */
int actionSshotDel(void *r, int count, char **argname, char **argval);

/* in agilenfsmain.c */
int actionNfsMain(void *r, int count, char **argname, char **argval);

/* in agilenfsdel.c */
int actionNfsDel(void *r, int count, char **argname, char **argval);

/* in agilenfsadd.c */
int actionNfsAdd(void *r, int count, char **argname, char **argval);

/* in agilenfsaddhost.c */
int actionNfsAddHost(void *r, int count, char **argname, char **argval);

/* in agilenfsdelhost.c */
int actionNfsDelHost(void *r, int count, char **argname, char **argval);

/* in agilenfsmodhost.c */
int actionNfsModHost(void *r, int count, char **argname, char **argval);

/* in agilefsetmain.c */
int actionFsetMain(void *r, int count, char **argname, char **argval);

/* in agilefsetadd.c */
int actionFsetAdd(void *r, int count, char **argname, char **argval);

/* in agilefsetdel.c */
int actionFsetDel(void *r, int count, char **argname, char **argval);

/* in agilefsetmod.c */
int actionFsetMod(void *r, int count, char **argname, char **argval);

/* in agilefsetfusg.c */
int actionFsetFUsg(void *r, int count, char **argname, char **argval);

/* in agilefsetugusg.c */
int actionFsetUGUsg(void *r, int count, char **argname, char **argval);

/* in agilefsetfquo.c */
int actionFsetFQuo(void *r, int count, char **argname, char **argval);

/* in agilefsetugquo.c */
int actionFsetUGQuo(void *r, int count, char **argname, char **argval);

/* in agilefsetdquo.c */
int actionFsetDQuo(void *r, int count, char **argname, char **argval);

/* in agilefsetfquomod.c */
int actionFsetFQuoMod(void *r, int count, char **argname, char **argval);

/* in agilefsetugquomod.c */
int actionFsetUGQuoMod(void *r, int count, char **argname, char **argval);

/* in agilefsetdquomod.c */
int actionFsetDQuoMod(void *r, int count, char **argname, char **argval);

/* in agilensmain.c */
int actionNsMain(void *r, int count, char **argname, char **argval);

/* in agilensadd.c */
int actionNsAdd(void *r, int count, char **argname, char **argval);

/* in agilensmod.c */
int actionNsMod(void *r, int count, char **argname, char **argval);

/* in agilensdel.c */
int actionNsDel(void *r, int count, char **argname, char **argval);

/* in agilendmpasess.c */
int actionNdmpActSess(void *r, int count, char **argname, char **argval);

/* in agilendmpsessdetail.c */
int actionNdmpSessDetail(void *r, int count, char **argname, char **argval);

/* in agilendmpsessstatus.c */
int actionNdmpSessStatus(void *r, int count, char **argname, char **argval);

/* in agilendmpsessdel.c */
int actionNdmpSessDel(void *r, int count, char **argname, char **argval);

/* in agilendmpenable.c */
int actionNdmpEnable(void *r);

/* in agilesyswz1.c */
int actionSysWizard1(void *r, int count, char **argname, char **argval);

/* in agilesyswz2.c */
int actionSysWizard2(void *r, int count, char **argname, char **argval);

/* in agilesyswz3.c */
int actionSysWizard3(void *r, int count, char **argname, char **argval);

/* in agilesyswz4.c */
int actionSysWizard4(void *r, int count, char **argname, char **argval);

/* in agilesyswz5.c */
int actionSysWizard5(void *r, int count, char **argname, char **argval);

/* in agilesyswztime.c */
int actionSysWizardSetTime(void *r, int count, char **argname, char **argval);

/* in agilesyswzsave.c */
int actionSysWizardSaveRes(void *r);

/* in agilefilermain.c */
int actionFilerMain(void *r, int count, char **argname, char **argval);

/* in agilefilersreboot.c */
int actionFilerSlotReboot(void *r, int count, char **argname, char **argval);

/* in agilefilerslot.c */
int actionFilerSlot(void *r, int count, char **argname, char **argval);

/* in agilefilercreboot.c */
int actionFilerCpuReboot(void *r, int count, char **argname, char **argval);

/* in agilefilersysop.c */
int actionFilerSysOp(void *r, int count, char **argname, char **argval);

/* in agileadmmain.c */
int actionAdminMain(void *r, int count, char **argname, char **argval);

/* in agilebanner.c */
int actionBanner(void *r);

/* in agilemenu.c */
int actionMenu(void *r);

/* in agilelogin.c */
int actionLogin(void *r, int count, char **argname, char **argval);


/*--------------------------- unused used functions ------------------------*/
/* in agilenetworkarp.c */
int actionNetworkARP(void *r);

/* in agilenwmanarp.c */
int actionNwManARP(void *r, int count, char **argname, char **argval);

/* in agilenwaddarp.c */
int actionNwAddARP(void *r, int count, char **argname, char **argval);

/* in agilenwdelarp.c */
int actionNwDelARP(void *r, int count, char **argname, char **argval);

