/* vi:ts=4 
 *-----------------------------------------------------------------
 *
 * Name: ip_stats.h
 *
 * RCS:  $Id: ip_stats.h,v 1.2 2002/03/09 00:07:25 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: separated from ip_var.h
 *
 * Created by:	Su Wang
 *
 * Date Created: 03/07/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _NETINET_IP_STATS_H_
#define	_NETINET_IP_TATS_H_

struct	ipstat {
	u_long	ips_total;		/* total packets received */
	u_long	ips_badsum;		/* checksum bad */
	u_long	ips_tooshort;		/* packet too short */
	u_long	ips_toosmall;		/* not enough data */
	u_long	ips_badhlen;		/* ip header length < data size */
	u_long	ips_badlen;		/* ip length < ip header length */
	u_long	ips_fragments;		/* fragments received */
	u_long	ips_fragdropped;	/* frags dropped (dups, out of space) */
	u_long	ips_fragtimeout;	/* fragments timed out */
	u_long	ips_forward;		/* packets forwarded */
	u_long	ips_fastforward;	/* packets fast forwarded */
	u_long	ips_cantforward;	/* packets rcvd for unreachable dest */
	u_long	ips_redirectsent;	/* packets forwarded on same net */
	u_long	ips_noproto;		/* unknown or unsupported protocol */
	u_long	ips_delivered;		/* datagrams delivered to upper level*/
	u_long	ips_localout;		/* total ip packets generated here */
	u_long	ips_odropped;		/* lost packets due to nobufs, etc. */
	u_long	ips_reassembled;	/* total packets reassembled ok */
	u_long	ips_fragmented;		/* datagrams successfully fragmented */
	u_long	ips_ofragments;		/* output fragments created */
	u_long	ips_cantfrag;		/* don't fragment flag was set, etc. */
	u_long	ips_badoptions;		/* error in option processing */
	u_long	ips_noroute;		/* packets discarded due to no route */
	u_long	ips_badvers;		/* ip version != 4 */
	u_long	ips_rawout;		/* total raw ip packets generated */
#if defined(AG_EXTENSIONS)
    u_long	ips_rawin;

								/* relay stats */
	u_long	rl_arpfwd;
	u_long  rl_arprcv;
    u_long  rl_ipfwd;
    u_long  rl_iprcv;

	u_long	rl_arpfwderr;
    u_long  rl_arprcverr;
    u_long  rl_ipfwderr;
    u_long	rl_iprcverr;		
    u_long	rl_noproto;			/* unrecognized protocol */

    u_long  rl_fragsfwd;		/* # of fragments sent out */
    u_long  rl_fragedfwd;		/* # of ip has been fragmented */
    u_long  rl_fragsfwderr;		/* # of errs during fragmentation */
    u_long  rl_reasrcv;			/* # of ip reassembled */
    u_long  rl_fragsrcv;		/* # of fragments received */
    u_long  rl_fragsrcverr;		/* # of errs during reassemble */
#endif /* AG_EXTENSIONS */
	u_long	ips_toolong;		/* ip length > max ip packet size */
	u_long	ips_notmember;		/* multicasts for unregistered grps */
};

extern struct	ipstat	ipstat;

#endif /* !_NETINET_IP_STATS_H_ */
