/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"

#include <sys/time.h>

#include <anpssc-api.h>

#include <nfx-defs.h>
#include <nfx-types.h>
#include <hal.h>
#include <eee-desc.h>
//#include <cm-api.h>
#include <sdm-api.h>


#include "asiFibreChannel.h"


/* hard-coded number of fibre channel slot/port */
#define NUM_OF_FC_PORTS		4
#define FCNIM_SLOT_NUM		2

static int total_fc_ports = 0;
static hal_adapter_info_t portInfo[NUM_OF_FC_PORTS];
static hal_fc_link_stats_t portStat[NUM_OF_FC_PORTS];
static int port_valid[NUM_OF_FC_PORTS];

#define PORT_STATE_UNKNOWN		1
#define PORT_STATE_UP			2
#define PORT_STATE_DOWN			3
#define PORT_STATE_DISABLE		4

/* where is the index located (MIB object ID) */
#define FCPORTINDEX_POS		13

#define FCPORTINFO_CACHE_TIMEOUT	1800	/* seconds, that's 30 minutes */
#define FCPORTSTAT_CACHE_TIMEOUT	3		/* seconds */
marker_t fcportinfo_cache_marker = NULL;
marker_t fcportstat_cache_marker = NULL;


/* 
 * asiFibreChannel_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid asiFibreChannel_variables_oid[] = { 1,3,6,1,4,1,10110,1,2,10 };


/* 
 * variable4 asiFibreChannel_variables:
 *   this variable defines function callbacks and type return information 
 *   for the asiFibreChannel mib section 
 */


struct variable4 asiFibreChannel_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   ASIFCPORTNUMBER       1
  { ASIFCPORTNUMBER     , ASN_INTEGER   , RONLY , var_asiFibreChannel, 1, { 1 } },
#define   ASIFCPORTINDEX        4
  { ASIFCPORTINDEX      , ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,1 } },
#define   ASIFCPORTNAME         5
  { ASIFCPORTNAME       , ASN_OCTET_STR , RONLY , var_asiFcPortTable, 3, { 2,1,2 } },
#define   ASIFCPORTADAPTERBRAND  6
  { ASIFCPORTADAPTERBRAND, ASN_OCTET_STR , RONLY , var_asiFcPortTable, 3, { 2,1,3 } },
#define   ASIFCPORTIFTYPE       7
  { ASIFCPORTIFTYPE     , ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,4 } },
#define   ASIFCPORTSPEED        8
  { ASIFCPORTSPEED      , ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,5 } },
#define   ASIFCPORTMAXSCSITAG   9
  { ASIFCPORTMAXSCSITAG , ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,6 } },
#define   ASIFCPORTWWN          10
  { ASIFCPORTWWN        , ASN_OCTET_STR , RONLY , var_asiFcPortTable, 3, { 2,1,7 } },
#define   ASIFCPORTMAXFRAMESIZE  11
  { ASIFCPORTMAXFRAMESIZE, ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,8 } },
#define   ASIFCPORTSTATE        12
  { ASIFCPORTSTATE      , ASN_INTEGER   , RONLY , var_asiFcPortTable, 3, { 2,1,9 } },
#define   ASIFCPORTINOCTETSHI   13
  { ASIFCPORTINOCTETSHI , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,10 } },
#define   ASIFCPORTINOCTETSLO   14
  { ASIFCPORTINOCTETSLO , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,11 } },
#define   ASIFCPORTOUTOCTETSHI  15
  { ASIFCPORTOUTOCTETSHI, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,12 } },
#define   ASIFCPORTOUTOCTETSLO  16
  { ASIFCPORTOUTOCTETSLO, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,13 } },
#define   ASIFCPORTINFRAMESHI   17
  { ASIFCPORTINFRAMESHI , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,14 } },
#define   ASIFCPORTINFRAMESLO   18
  { ASIFCPORTINFRAMESLO , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,15 } },
#define   ASIFCPORTOUTFRAMESHI  19
  { ASIFCPORTOUTFRAMESHI, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,16 } },
#define   ASIFCPORTOUTFRAMESLO  20
  { ASIFCPORTOUTFRAMESLO, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,17 } },
#define   ASIFCPORTSCSIDISKRDS  21
  { ASIFCPORTSCSIDISKRDS, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,18 } },
#define   ASIFCPORTSCSIDISKWRTS  22
  { ASIFCPORTSCSIDISKWRTS, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,19 } },
#define   ASIFCPORTSCSITAPERDS  23
  { ASIFCPORTSCSITAPERDS, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,20 } },
#define   ASIFCPORTSCSITAPEWRTS  24
  { ASIFCPORTSCSITAPEWRTS, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,21 } },
#define   ASIFCPORTSCSIOTHERS   25
  { ASIFCPORTSCSIOTHERS , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,22 } },
#define   ASIFCPORTLINKFAIL     26
  { ASIFCPORTLINKFAIL   , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,23 } },
#define   ASIFCPORTLOSESYNC     27
  { ASIFCPORTLOSESYNC   , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,24 } },
#define   ASIFCPORTLOSESIGNAL   28
  { ASIFCPORTLOSESIGNAL , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,25 } },
#define   ASIFCPORTINVALIDTXWORD  29
  { ASIFCPORTINVALIDTXWORD, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,26 } },
#define   ASIFCPORTINVALIDCRC   30
  { ASIFCPORTINVALIDCRC , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,27 } },
#define   ASIFCPORTTRANSPORTERR  31
  { ASIFCPORTTRANSPORTERR, ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,28 } },
#define   ASIFCPORTUNDERRUN     32
  { ASIFCPORTUNDERRUN   , ASN_COUNTER   , RONLY , var_asiFcPortTable, 3, { 2,1,29 } },

};
/*    (L = length of the oidsuffix) */

void GetPortInfo(void);
int GetPortState(int slot, int port);
void GetPortStatsData(void);


/*
 * init_asiFibreChannel():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_asiFibreChannel(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("asiFibreChannel", asiFibreChannel_variables, variable4,
               asiFibreChannel_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_asiFibreChannel():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_asiFibreChannel(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
#if 0
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
#endif

  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case ASIFCPORTNUMBER:
		GetPortInfo();
        long_ret = total_fc_ports;
        return (unsigned char *) &long_ret;


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_asiFcPortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_asiFibreChannel above.
 */
unsigned char *
var_asiFcPortTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
/* variables we may use later */
static long long_ret;
static unsigned char string[SPRINT_MAX_LEN];
int i, port, count;

	GetPortInfo();
	if (header_simple_table(vp,name,length,exact,
			var_len,write_method, total_fc_ports) == MATCH_FAILED )
		return NULL;

	port = 0;
	count = 0;
	for (i = 0; i < NUM_OF_FC_PORTS; i++)
	{
		if (port_valid[i])
		{
			count++;
			if (count == name[FCPORTINDEX_POS])
			{
				port = i;
				break;
			}
		}
	}

	switch(vp->magic)
	{
	case ASIFCPORTINDEX:
		long_ret = name[FCPORTINDEX_POS];
		return (unsigned char *) &long_ret;

	case ASIFCPORTNAME:
		sprintf(string, "fc%d.%d", FCNIM_SLOT_NUM, port);
		*var_len = strlen(string);
		return (unsigned char *) string;

	case ASIFCPORTADAPTERBRAND:
		*var_len = strlen(portInfo[port].name);
		return (unsigned char *) portInfo[port].name;

	case ASIFCPORTIFTYPE:
		switch (portInfo[port].interface_type) 
		{
		case HAL_IF_FC_L_PORT:
			long_ret = 2;
			break;
		case HAL_IF_FC_NL_PORT:
			long_ret = 3;
			break;
		case HAL_IF_FC_N_PORT:
			long_ret = 4;
			break;
		case HAL_IF_FC_F_PORT:
			long_ret = 5;
			break;
		case HAL_IF_FC_FL_PORT:
			long_ret = 6;
			break;
		default:
			long_ret = 1;
			break;
		}

		return (unsigned char *) &long_ret;

	case ASIFCPORTSPEED:
		long_ret = portInfo[port].u.fc_data.link_speed;
		return (unsigned char *) &long_ret;

	case ASIFCPORTMAXSCSITAG:
		long_ret = portInfo[port].max_tags_per_device;
		return (unsigned char *) &long_ret;

	case ASIFCPORTWWN:
		{
		unsigned char *p =
			(char *) &(portInfo[port].u.fc_data.fc_node_name.u.wwn);

			*var_len = 8;
			for (i = 0; i < 8; i++)
				string[i] = p[7-i];
			return (unsigned char *) string;
		}

	case ASIFCPORTMAXFRAMESIZE:
		long_ret = portInfo[port].u.fc_data.fc_packet_size;
		return (unsigned char *) &long_ret;

	case ASIFCPORTSTATE:
		long_ret = (long) GetPortState(FCNIM_SLOT_NUM, port);
		return (unsigned char *) &long_ret;

	case ASIFCPORTINOCTETSHI:
		GetPortStatsData();
		long_ret = (long)
			((portStat[port].frames_in*portInfo[port].u.fc_data.fc_packet_size) >> 32);
		return (unsigned char *) &long_ret;

	case ASIFCPORTINOCTETSLO:
		GetPortStatsData();
		long_ret = (long) portStat[port].frames_in*portInfo[port].u.fc_data.fc_packet_size;
		return (unsigned char *) &long_ret;

	case ASIFCPORTOUTOCTETSHI:
		GetPortStatsData();
		long_ret = (long)
			((portStat[port].frames_out*portInfo[port].u.fc_data.fc_packet_size) >> 32);
		return (unsigned char *) &long_ret;

	case ASIFCPORTOUTOCTETSLO:
		GetPortStatsData();
		long_ret = (long) portStat[port].frames_out*portInfo[port].u.fc_data.fc_packet_size;
		return (unsigned char *) &long_ret;

	case ASIFCPORTINFRAMESHI:
		GetPortStatsData();
		long_ret = (long) (portStat[port].frames_in >> 32);
		return (unsigned char *) &long_ret;

	case ASIFCPORTINFRAMESLO:
		GetPortStatsData();
		long_ret = (long) portStat[port].frames_in;
		return (unsigned char *) &long_ret;

	case ASIFCPORTOUTFRAMESHI:
		GetPortStatsData();
		long_ret = (long) (portStat[port].frames_out >> 32);
		return (unsigned char *) &long_ret;

	case ASIFCPORTOUTFRAMESLO:
		GetPortStatsData();
		long_ret = (long) portStat[port].frames_out;
		return (unsigned char *) &long_ret;

    case ASIFCPORTSCSIDISKRDS:
		GetPortStatsData();
		long_ret = portStat[port].read_10_cmd_cnt;
		return (unsigned char *) &long_ret;

    case ASIFCPORTSCSIDISKWRTS:
		GetPortStatsData();
		long_ret = portStat[port].write_10_cmd_cnt;
		return (unsigned char *) &long_ret;

    case ASIFCPORTSCSITAPERDS:
		GetPortStatsData();
		long_ret = portStat[port].read_6_cmd_cnt;
		return (unsigned char *) &long_ret;

    case ASIFCPORTSCSITAPEWRTS:
		long_ret = portStat[port].read_10_cmd_cnt;
		return (unsigned char *) &long_ret;

    case ASIFCPORTSCSIOTHERS:
		long_ret = portStat[port].other_cmd_cnt;
		return (unsigned char *) &long_ret;

	case ASIFCPORTLINKFAIL:
		GetPortStatsData();
		if (portStat[port].link_failure == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].link_failure;
		return (unsigned char *) &long_ret;

	case ASIFCPORTLOSESYNC:
		GetPortStatsData();
		if (portStat[port].loss_of_sync == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].loss_of_sync;
		return (unsigned char *) &long_ret;

	case ASIFCPORTLOSESIGNAL:
		GetPortStatsData();
		if (portStat[port].loss_of_signal == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].loss_of_signal;
		return (unsigned char *) &long_ret;

	case ASIFCPORTINVALIDTXWORD:
		GetPortStatsData();
		if (portStat[port].invalid_xmit_words == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].invalid_xmit_words;
		return (unsigned char *) &long_ret;

	case ASIFCPORTINVALIDCRC:
		GetPortStatsData();
		if (portStat[port].invalid_crc == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].invalid_crc;
		return (unsigned char *) &long_ret;

	case ASIFCPORTTRANSPORTERR:
		GetPortStatsData();
		if (portStat[port].transport_errors == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].transport_errors;
		return (unsigned char *) &long_ret;

	case ASIFCPORTUNDERRUN:
		GetPortStatsData();
		if (portStat[port].underrun_cnt == (uint32) -1)
			long_ret = 0; //return NULL;
		else
			long_ret = portStat[port].underrun_cnt;
		return (unsigned char *) &long_ret;

	default:
		ERROR_MSG("");
	}
	return NULL;
}


/*
 * GetPortInfo() will retrieve all FC port detail info in one shot at
 * the same time, it'll determine the total number of ports on system
 */
void GetPortInfo()
{
char					tmpbuf[2048];
sdm_ioctlReqMsg_t		req;
sdm_ioctlRspMsg_t *		rsp = (sdm_ioctlRspMsg_t *) tmpbuf;
int						i, rc;
//struct timeval			timeout = {1, 0};
struct timeval			timeout = {0, 750000};	/* .75 seconds quick retrieve */

	if (fcportinfo_cache_marker &&
		(!atime_ready(fcportinfo_cache_marker, FCPORTINFO_CACHE_TIMEOUT*1000)))
		return;

	if (fcportinfo_cache_marker)
		atime_setMarker(fcportinfo_cache_marker);
	else
		fcportinfo_cache_marker = atime_newMarker();

	memset(port_valid, 0, sizeof(port_valid));
	memset(portInfo, 0, sizeof(portInfo));

	/* Get PORT/LINK INFO */
	memset(&req, 0, sizeof(sdm_ioctlReqMsg_t));
	req.hdr.mid = SDM_MID_IOCTL_REQ;
	req.code = HAL_IOCTL_COMMON_GET_ADAPTER_INFO;
	req.slot = FCNIM_SLOT_NUM;

	total_fc_ports = 0;
	for (i = 0; i < NUM_OF_FC_PORTS; i++)
	{
		req.port = i;

		rc = sendAgileMsg(-1, &req, sizeof(sdm_ioctlReqMsg_t),
				  "sdm", 0, 0, 0, &timeout, tmpbuf, sizeof(tmpbuf));
		if ((rc <= 0) || (rsp->eCode != SDM_OK))
			port_valid[i] = 0;
		else
		{
			port_valid[i] = 1;
			memcpy(&portInfo[i], rsp->data, sizeof(hal_adapter_info_t));
			total_fc_ports++;
		}
	}
}


int GetPortState(int slot, int port)
{
char				tmpbuf[2048];
sdm_ioctlReqMsg_t	req;
sdm_ioctlRspMsg_t	*rsp = (sdm_ioctlRspMsg_t *) tmpbuf;
int					rc, state;
struct timeval		timeout = {2, 0};

	state = PORT_STATE_UNKNOWN;

	/* Get PORT/LINK CONNECTION STATE */
	memset(&req, 0, sizeof(sdm_ioctlReqMsg_t));
	req.hdr.mid = SDM_MID_IOCTL_REQ;
	req.code = HAL_IOCTL_FC_CONNECTION_STATE;
	req.slot = slot;
	req.port = port;
	
	rc = sendAgileMsg(-1, &req, sizeof(sdm_ioctlReqMsg_t),
			"sdm", 0, 0, 0, &timeout, tmpbuf, sizeof(tmpbuf));

	if ((rc <= 0) || (rsp->eCode != SDM_OK))
		return state;

	switch (*((uint32 *)rsp->data)) 
	{
	case HAL_IOCTL_FC_LINK_STATE_LINK_DOWN:
		state = PORT_STATE_DOWN;
		break;
	case HAL_IOCTL_FC_LINK_STATE_LINK_UP:
		state = PORT_STATE_UP;
		break;
	case HAL_IOCTL_FC_LINK_STATE_LINK_OFFLINE:
		state = PORT_STATE_DISABLE;
		break;
	default:
		break;
	}

	return state;
}


void GetPortStatsData()
{
char				rspbuf[2048];
sdm_ioctlReqMsg_t	req;
sdm_ioctlRspMsg_t	*rsp = (sdm_ioctlRspMsg_t *) rspbuf;
struct timeval		timeout = {2, 0};
int					i, rc;

	if (fcportstat_cache_marker &&
		(!atime_ready(fcportstat_cache_marker, FCPORTSTAT_CACHE_TIMEOUT*1000)))
		return;

	if (fcportstat_cache_marker)
		atime_setMarker(fcportstat_cache_marker);
	else
		fcportstat_cache_marker = atime_newMarker();

	GetPortInfo();

	memset(&req, 0, sizeof(sdm_ioctlReqMsg_t));
	req.hdr.mid = SDM_MID_IOCTL_REQ;
	req.code = HAL_IOCTL_FC_GET_ADAPTER_LINK_STATS;
	req.slot = FCNIM_SLOT_NUM;

	for (i = 0; i < total_fc_ports; i++)
	{
		req.port = i;
	
		rc = sendAgileMsg(-1, &req, sizeof(sdm_ioctlReqMsg_t),
				"sdm", 0, 0, 0, &timeout, rspbuf, sizeof(rspbuf));
		if (rc <= 0)
			return;

		rsp = (sdm_ioctlRspMsg_t *) rspbuf;
	
		if (rsp->hdr.mid != SDM_MID_IOCTL_RSP || rsp->eCode != SDM_OK)
			return;
		else if (rsp->dataLen < sizeof(hal_fc_link_stats_t)) 
			return;

		memcpy(&portStat[i], rsp->data, sizeof(hal_fc_link_stats_t));
	}
}

