/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


/* This should always be included first before anything else */
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"

#include <nfx-incl.h>
//#include <exports/nfs-api.h>
#include <exports/evm-api.h>
#include <exports/anpssc-api.h>
#include <exports/rpc.h>
#include <exports/fs-api.h>
#include <exports/mount.h>

#include <exports/nfs.h>
#include <exports/nfs-ssc-cmd.h>

#include "asiMisc.h"

#define DEBUG
#include "system.h"

#define NFS_STATS_CACHE_TIMEOUT	MIB_STATS_CACHE_TIMEOUT
marker_t nfs_stats_cache_marker = NULL;

static uint64 totalV2PktCount(nfs_pktCounters_t *pc);
static uint64 totalV3PktCount(nfs_pktCounters_t *pc);
static int read_nfs_stats(nfs_infoResp_t *rsp);

/*
 * asiMisc_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid asiMisc_variables_oid[] = { 1,3,6,1,4,1,10110,1,2,2 };


/* 
 * variable2 asiMisc_variables:
 *   this variable defines function callbacks and type return information 
 *   for the asiMisc mib section 
 */


struct variable2 asiMisc_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   ASIMISCHIGHNFSOPS     1
  { ASIMISCHIGHNFSOPS   , ASN_COUNTER   , RONLY , var_asiMisc, 1, { 5 } },
#define   ASIMISCLOWNFSOPS      2
  { ASIMISCLOWNFSOPS    , ASN_COUNTER   , RONLY , var_asiMisc, 1, { 6 } },
#define   ASIMISCHIGHNFSRESOURCEERRS  3
  { ASIMISCHIGHNFSRESOURCEERRS, ASN_COUNTER   , RONLY , var_asiMisc, 1, { 40 } },
#define   ASIMISCLOWNFSRESOURCEERRS  4
  { ASIMISCLOWNFSRESOURCEERRS, ASN_COUNTER   , RONLY , var_asiMisc, 1, { 41 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_asiMisc():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_asiMisc(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("asiMisc", asiMisc_variables, variable2,
               asiMisc_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_asiMisc():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_asiMisc(struct variable *vp, 
                oid     *name,
                size_t  *length,
                int     exact,
                size_t  *var_len,
                WriteMethod **write_method)
{
/* variables we may use later */
static long long_ret;
static nfs_infoResp_t rsp;
uint64 total;
uint32 *p;
#ifdef DEBUG
static nfs_infoResp_t prev_rsp;
static uint64 prev_total = 0;
static struct timeval prev_time;
struct timeval now;
#endif

	if (header_generic(vp,name,length,exact,var_len,write_method)
													== MATCH_FAILED )
		return NULL;

	if (read_nfs_stats(&rsp) < 0)
		return NULL;

	/*
	* this is where we do the value assignments for the mib results.
	*/
	switch(vp->magic)
	{
	case ASIMISCHIGHNFSOPS:
		total = totalV2PktCount(&(rsp.msg.stat.nfs_v2RxPktCounters))
				+ totalV3PktCount(&(rsp.msg.stat.nfs_v3RxPktCounters));
		p = (uint32 *) &total;
		long_ret = p[1];
        return (unsigned char *) &long_ret;

	case ASIMISCLOWNFSOPS:
		total = totalV2PktCount(&(rsp.msg.stat.nfs_v2RxPktCounters))
				+ totalV3PktCount(&(rsp.msg.stat.nfs_v3RxPktCounters));
#ifdef DEBUG
		if (prev_total > 0)
		{
			uint64 total_diff;
			nfs_pktCounters_t *pc1, *pc2;

			total_diff = total - prev_total;
			gettimeofday(&now, NULL);

			if ((total_diff/calculate_time_diff(&now, &prev_time) ) > 300)
			{
			snmp_log(LOG_ERR, "Suspecious big counter jump - diff=%lld\n", total_diff);
			pc1 = &(prev_rsp.msg.stat.nfs_v2RxPktCounters);
			pc2 = &(rsp.msg.stat.nfs_v2RxPktCounters);
			snmp_log(LOG_ERR, "v2 counters\n");
			snmp_log(LOG_ERR, "  null old=%lld new=%lld\n", pc1->null, pc2->null);
			snmp_log(LOG_ERR, "  getAttr old=%lld new=%lld\n", pc1->getAttr, pc2->getAttr);
			snmp_log(LOG_ERR, "  setAttr old=%lld new=%lld\n", pc1->setAttr, pc2->setAttr);
			snmp_log(LOG_ERR, "  lookUp old=%lld new=%lld\n", pc1->lookUp, pc2->lookUp);
			snmp_log(LOG_ERR, "  readLink old=%lld new=%lld\n", pc1->readLink, pc2->readLink);
			snmp_log(LOG_ERR, "  read old=%lld new=%lld\n", pc1->read, pc2->read);
			snmp_log(LOG_ERR, "  write old=%lld new=%lld\n", pc1->write, pc2->write);
			snmp_log(LOG_ERR, "  create old=%lld new=%lld\n", pc1->create, pc2->create);
			snmp_log(LOG_ERR, "  mkdir old=%lld new=%lld\n", pc1->mkdir, pc2->mkdir);
			snmp_log(LOG_ERR, "  symlink old=%lld new=%lld\n", pc1->symlink, pc2->symlink);
			snmp_log(LOG_ERR, "  remove old=%lld new=%lld\n", pc1->remove, pc2->remove);
			snmp_log(LOG_ERR, "  rmdir old=%lld new=%lld\n", pc1->rmdir, pc2->rmdir);
			snmp_log(LOG_ERR, "  rename old=%lld new=%lld\n", pc1->rename, pc2->rename);
			snmp_log(LOG_ERR, "  link old=%lld new=%lld\n", pc1->link, pc2->link);
			snmp_log(LOG_ERR, "  readdir old=%lld new=%lld\n", pc1->readdir, pc2->readdir);
			snmp_log(LOG_ERR, "  statfs old=%lld new=%lld\n", pc1->statfs, pc2->statfs);
			pc1 = &(prev_rsp.msg.stat.nfs_v3RxPktCounters);
			pc2 = &(rsp.msg.stat.nfs_v3RxPktCounters);
			snmp_log(LOG_ERR, "v3 counters\n");
			snmp_log(LOG_ERR, "  null old=%lld new=%lld\n", pc1->null, pc2->null);
			snmp_log(LOG_ERR, "  getAttr old=%lld new=%lld\n", pc1->getAttr, pc2->getAttr);
			snmp_log(LOG_ERR, "  setAttr old=%lld new=%lld\n", pc1->setAttr, pc2->setAttr);
			snmp_log(LOG_ERR, "  lookUp old=%lld new=%lld\n", pc1->lookUp, pc2->lookUp);
			snmp_log(LOG_ERR, "  access old=%lld new=%lld\n", pc1->access, pc2->access);
			snmp_log(LOG_ERR, "  readLink old=%lld new=%lld\n", pc1->readLink, pc2->readLink);
			snmp_log(LOG_ERR, "  read old=%lld new=%lld\n", pc1->read, pc2->read);
			snmp_log(LOG_ERR, "  write old=%lld new=%lld\n", pc1->write, pc2->write);
			snmp_log(LOG_ERR, "  create old=%lld new=%lld\n", pc1->create, pc2->create);
			snmp_log(LOG_ERR, "  mkdir old=%lld new=%lld\n", pc1->mkdir, pc2->mkdir);
			snmp_log(LOG_ERR, "  symlink old=%lld new=%lld\n", pc1->symlink, pc2->symlink);
			snmp_log(LOG_ERR, "  mknod old=%lld new=%lld\n", pc1->mknod, pc2->mknod);
			snmp_log(LOG_ERR, "  remove old=%lld new=%lld\n", pc1->remove, pc2->remove);
			snmp_log(LOG_ERR, "  rmdir old=%lld new=%lld\n", pc1->rmdir, pc2->rmdir);
			snmp_log(LOG_ERR, "  rename old=%lld new=%lld\n", pc1->rename, pc2->rename);
			snmp_log(LOG_ERR, "  link old=%lld new=%lld\n", pc1->link, pc2->link);
			snmp_log(LOG_ERR, "  readdir old=%lld new=%lld\n", pc1->readdir, pc2->readdir);
			snmp_log(LOG_ERR, "  readdirplus old=%lld new=%lld\n", pc1->readdirplus, pc2->readdirplus);
			snmp_log(LOG_ERR, "  fsstat old=%lld new=%lld\n", pc1->fsstat, pc2->fsstat);
			snmp_log(LOG_ERR, "  fsinfo old=%lld new=%lld\n", pc1->fsinfo, pc2->fsinfo);
			snmp_log(LOG_ERR, "  pathconf old=%lld new=%lld\n", pc1->pathconf, pc2->pathconf);
			snmp_log(LOG_ERR, "  commit old=%lld new=%lld\n", pc1->commit, pc2->commit);
			}
		}

		prev_total = total;
		memcpy(&prev_rsp, &rsp, sizeof(nfs_infoResp_t));
		memcpy(&prev_time, &now, sizeof(struct timeval));
#endif
		p = (uint32 *) &total;
		long_ret = p[0];
        return (unsigned char *) &long_ret;

	case ASIMISCHIGHNFSRESOURCEERRS:
		total = rsp.msg.stat.nfs_v2XmtPktCounters.nfs_fsResourceErr +
				rsp.msg.stat.nfs_v3XmtPktCounters.nfs_fsResourceErr;
		p = (uint32 *) &total;
		long_ret = p[1];
		return (unsigned char *) &long_ret;

	case ASIMISCLOWNFSRESOURCEERRS:
		total = rsp.msg.stat.nfs_v2XmtPktCounters.nfs_fsResourceErr +
				rsp.msg.stat.nfs_v3XmtPktCounters.nfs_fsResourceErr;
		p = (uint32 *) &total;
		long_ret = p[0];
		return (unsigned char *) &long_ret;

	default:
		ERROR_MSG("");
	}

	return NULL;
}


static uint64 totalV2PktCount(nfs_pktCounters_t *pc)
{
	return (pc->null + pc->getAttr + pc->setAttr + pc->lookUp
			+ pc->readLink + pc->read + pc->write + pc->create
			+ pc->mkdir + pc->symlink + pc->remove + pc->rmdir
			+ pc->rename + pc->link + pc->readdir + pc->statfs);
}

static uint64 totalV3PktCount(nfs_pktCounters_t *pc)
{
	return (pc->null + pc->getAttr + pc->setAttr + pc->lookUp
			+ pc->access + pc->readLink + pc->read + pc->write
			+ pc->create + pc->mkdir + pc->symlink + pc->mknod
			+ pc->remove + pc->rmdir + pc->rename + pc->link
			+ pc->readdir + pc->readdirplus + pc->fsstat + pc->fsinfo
			+ pc->pathconf + pc->commit);
}



static int read_nfs_stats(nfs_infoResp_t *rsp)
{
int stat;
nfs_infoReq_t req;
struct timeval timeout = {20, 0};

	if (nfs_stats_cache_marker &&
		(!atime_ready(nfs_stats_cache_marker, NFS_STATS_CACHE_TIMEOUT*1000)))
		return 0;

	if (nfs_stats_cache_marker)
		atime_setMarker(nfs_stats_cache_marker);
	else
		nfs_stats_cache_marker = atime_newMarker();

	memset(rsp, 0, sizeof(nfs_infoResp_t));
	memset(&req, 0, sizeof(nfs_infoReq_t));

	req.msgHdr.private = 0;
	req.msgHdr.msgType = NFS_REQ_STAT_MSG;

	//TXRX CPU: NFX_NFP_RX
	//TXRX Slot: 1

	stat = sendAgileMsg (-1, &req, sizeof(nfs_infoReq_t),
                "nfs_cmd", NFX_NFP_TXRX1, 1, MGMTPLANE,
                &timeout, rsp, sizeof(nfs_infoResp_t));
	if (stat < sizeof(nfs_infoResp_t))
	{
		if (nfs_stats_cache_marker)
		{
			free(nfs_stats_cache_marker);
			nfs_stats_cache_marker = NULL;
		}
		return -1;
	}
	else
		return 1;
}
