/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


/* This should always be included first before anything else */
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"

#define SSC
#include "nfx-incl.h"
#include "exports/stats-api.h"
#include "csiDev.h"
#include "csiDevErr.h"


uint64 getTxrxNetErrors(void);
uint64 getTxrxBkplErrors(void);
uint64 getFpErrors(void);
uint64 getFcErrors(void);
uint64 getSscMgmtErrors(void);
uint64 getErrorSum(void);


/* 
 * csiDevErr_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid csiDevErr_variables_oid[] = { 1,3,6,1,4,1,10110,1,2,1,1 };


/* 
 * variable2 csiDevErr_variables:
 *   this variable defines function callbacks and type return information 
 *   for the csiDevErr mib section 
 */


struct variable2 csiDevErr_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   CSIDEVERRSUMHIGH      1
  { CSIDEVERRSUMHIGH    , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 1 } },
#define   CSIDEVERRSUMLOW       2
  { CSIDEVERRSUMLOW     , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 2 } },
#define   CSIDEVERRTXRXNETHIGH  3
  { CSIDEVERRTXRXNETHIGH, ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 3 } },
#define   CSIDEVERRTXRXNETLOW   4
  { CSIDEVERRTXRXNETLOW , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 4 } },
#define   CSIDEVERRTXRXBKPLHIGH  5
  { CSIDEVERRTXRXBKPLHIGH, ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 5 } },
#define   CSIDEVERRTXRXBKPLLOW  6
  { CSIDEVERRTXRXBKPLLOW, ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 6 } },
#define   CSIDEVERRFPHIGH       7
  { CSIDEVERRFPHIGH     , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 7 } },
#define   CSIDEVERRFPLOW        8
  { CSIDEVERRFPLOW      , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 8 } },
#define   CSIDEVERRFCHIGH       9
  { CSIDEVERRFCHIGH     , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 9 } },
#define   CSIDEVERRFCLOW        10
  { CSIDEVERRFCLOW      , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 10 } },
#define   CSIDEVERRSSCMGMTHIGH  11
  { CSIDEVERRSSCMGMTHIGH, ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 11 } },
#define   CSIDEVERRSSCMGMTLOW   12
  { CSIDEVERRSSCMGMTLOW , ASN_COUNTER   , RONLY , var_csiDevErr, 1, { 12 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_csiDevErr():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_csiDevErr(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("csiDevErr", csiDevErr_variables, variable2,
               csiDevErr_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_csiDevErr():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_csiDevErr(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
static long long_ret;

	if (header_generic(vp, name, length, exact, var_len, write_method)
						  == MATCH_FAILED )
		return NULL;

	/* 
	* this is where we do the value assignments for the mib results.
	*/
	switch(vp->magic)
	{
	case CSIDEVERRSUMHIGH:
		long_ret = (long) (getErrorSum() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRSUMLOW:
		long_ret = (long) (getErrorSum());
		return (unsigned char *) &long_ret;

	case CSIDEVERRTXRXNETHIGH:
		long_ret = (long) (getTxrxNetErrors() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRTXRXNETLOW:
		long_ret = (long) (getTxrxNetErrors());
		return (unsigned char *) &long_ret;

	case CSIDEVERRTXRXBKPLHIGH:
		long_ret = (long) (getTxrxBkplErrors() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRTXRXBKPLLOW:
		long_ret = (long) (getTxrxBkplErrors());
		return (unsigned char *) &long_ret;

	case CSIDEVERRFPHIGH:
		long_ret = (long) (getFpErrors() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRFPLOW:
		long_ret = (long) (getFpErrors());
		return (unsigned char *) &long_ret;

	case CSIDEVERRFCHIGH:
		long_ret = (long) (getFcErrors() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRFCLOW:
		long_ret = (long) (getFcErrors());
		return (unsigned char *) &long_ret;

	case CSIDEVERRSSCMGMTHIGH:
		long_ret = (long) (getSscMgmtErrors() >> 32);
		return (unsigned char *) &long_ret;

	case CSIDEVERRSSCMGMTLOW:
		long_ret = (long) (getSscMgmtErrors());
		return (unsigned char *) &long_ret;

	default:
		ERROR_MSG("");
	}

	return NULL;
}




uint64 getTxrxNetErrors(void)
{
stats_txrxBmc12500Stats_t *pBmcStats;
stats_txrxLsiStats_t *pLsiStats;
int port;
uint64 total = 0;

	pBmcStats = stats_txrx_bmc12500();
	if (pBmcStats)
	{
		total += (pBmcStats->rxBadPkts + pBmcStats->rxNoBufErrs +
				pBmcStats->rxNoSysDescErrs + pBmcStats->txQFullDrops);
	}

	for (port = 0; port < 4; port++)
	{
		pLsiStats = stats_txrx_lsi(port);
		if (pLsiStats)
		{
			total += (pLsiStats->rxDrops + pLsiStats->rxCrcErrs +
					pLsiStats->rxUndersize + pLsiStats->rxSymbolErrs +
					pLsiStats->txUnderflows + pLsiStats->txErrors);
		}
	}

	return total;
}


uint64 getTxrxBkplErrors(void)
{
stats_txrxDp83820Stats_t *pStats;
uint64 total = 0;

	pStats = stats_txrx_dp83820();
	if (pStats)
	{
		total += (pStats->rxErrors + pStats->rxFcsErrs +
				pStats->rxOverruns + pStats->rxAlignErrs +
				pStats->rxSymbolErrs + pStats->rxLenErrs +
				pStats->rxAborts + pStats->rxNoBufErrs +
				pStats->rxNoSysDescs + pStats->rxRuntPkts +
				pStats->rxCrcErrs + pStats->txQFullDrops +
				pStats->txAborts + pStats->txUnderruns);
	}

	return total;
}


uint64 getFpErrors(void)
{
stats_fpBmc12500Stats_t	*pBmcStats;
stats_fpLsiStats_t *pLsiStats;
int port;
uint64 total = 0;

	pBmcStats = stats_fp_bmc12500();
	if (pBmcStats)
	{
		total += (pBmcStats->rxBadPkts + pBmcStats->rxNoBufErrs +
				pBmcStats->rxNoSysDescErrs + pBmcStats->txQFullDrops);
	}

	for (port = 0; port < 4; port++)
	{
		pLsiStats = stats_fp_lsi(port);
		if (pLsiStats)
		{
			total += (pLsiStats->rxDrops + pLsiStats->rxCrcErrs +
					pLsiStats->rxUndersize + pLsiStats->rxSymbolErrs +
					pLsiStats->txUnderflows + pLsiStats->txErrors);
		}
	}

	return total;
}


uint64 getFcErrors(void)
{
stats_fcDp83820Stats_t *pDpStats;
stats_fcGt64240Stats_t *pGtStats;
uint32_t cpuid;
uint64 total = 0;

	for (cpuid = 0; cpuid < 4; cpuid++)
	{
		pDpStats = stats_fc_dp83820(cpuid);
		total += (pDpStats->rxErrors + pDpStats->rxFcsErrs +
			pDpStats->rxOverruns + pDpStats->rxAlignErrs +
			pDpStats->rxSymbolErrs + pDpStats->rxLenErrs +
			pDpStats->rxAborts + pDpStats->rxNoBufErrs +
			pDpStats->rxNoSysDescs + pDpStats->rxRuntPkts +
			pDpStats->rxCrcErrs + pDpStats->txQFullDrops +
			pDpStats->txAborts + pDpStats->txUnderruns);

		pGtStats = stats_fc_gt64240mii(cpuid);
		total += (pGtStats->rxCrcErrs + pGtStats->rxFragments +
			pGtStats->rxJabbers + pGtStats->rxCollisions +
			pGtStats->rxLateCollis + pGtStats->rxErrors +
			pGtStats->rxUndersized + pGtStats->rxNoSysDescs +
			pGtStats->rxNoBufErrs + pGtStats->txQFullDrops +
			pGtStats->txUnderruns);
	}

	return total;
}


uint64 getSscMgmtErrors(void)
{
stats_sscmgmtBcm5600Stats_t *pStats;
int index;
uint64 total = 0;

	for (index = 0; index < 6; index++)
	{
		pStats = stats_sscmgmt_bcm5600(index);
		total += (pStats->rxFcsErrs + pStats->rxAlignErrs +
			pStats->rxSymbolErrs + pStats->rxFalseCarrs +
			pStats->rxUndersized + pStats->rxFragments +
			pStats->rxJabbers + pStats->rxDiscards +
			pStats->txFcsErrs + pStats->txAborts +
			pStats->txFragments + pStats->txJabbers);
	}

	return total;
}


uint64 getErrorSum(void)
{
	return (getTxrxNetErrors() + getTxrxBkplErrors() +
				getFpErrors() + getFcErrors() + getSscMgmtErrors());
}

