/* vi:ts=4  
 *-----------------------------------------------------------------
 *
 * Name: macros.h
 *
 * RCS:  $Id: macros.h,v 1.4 2002/02/05 23:03:34 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Su Wang
 *
 * Date Created: 08/09/01
 *
 *-----------------------------------------------------------------
 */

#ifndef	_MACROS_H
#define _MACROS_H

#define roundup(x, y)   ((((x)+((y)-1))/(y))*(y))  /* to any y */
#define powerof2(x)     ((((x)-1)&(x))==0)
#define min(a,b) 	(((a)<(b))?(a):(b))
#define max(a,b) 	(((a)>(b))?(a):(b))

#define imin(a,b) 	((((int)a)<((int)b))?(a):(b))
#define imax(a,b) 	((((int)a)>((int)b))?(a):(b))

#define lmin(a,b) 	((((long)a)<((long)b))?(a):(b))
#define lmax(a,b) 	((((long)a)>((long)b))?(a):(b))

#define ulmin(a,b) 	((((u_long)a)<((u_long)b))?(a):(b))
#define ulmax(a,b) 	((((u_long)a)>((u_long)b))?(a):(b))

#if BYTE_ORDER == LITTLE_ENDIAN 
#define ntohl(a)        ((((a) >> 24 ) & 0x000000ff) | \
			 (((a) >> 8  ) & 0x0000ff00) | \
			 (((a) << 8  ) & 0x00ff0000)  | \
			 (((a) << 24 ) & 0xff000000))  \

#define ntohs(a)        ((((a) >> 8) & 0x00ff) | (((a) << 8) & 0xff00))
#endif 

#if BYTE_ORDER == BIG_ENDIAN 
#define ntohl(a)         (a)
#define ntohs(a)         (a)
#endif 

#define htonl(a)         ntohl(a)
#define htons(a)         htons(a)

#endif
