/*
 *-----------------------------------------------------------------
 *
 * Name: cm-fan.h
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description: Maxim max6550 fan controller register definitions.
 *
 * Created by:  Shaun Hui
 *
 * Date Created:    6/18/04
 *
 *-----------------------------------------------------------------
 */
                                                                                
#ifndef _CM_FAN_H
#define _CM_FAN_H

#define FAN_REG_OFFSET		2
#define FAN_MAX_CTRL		2
#define FAN_MAX_FAIL_COUNT	3
#define FAN_MAX_CHASSIS_TEMP	0x32
#define FAN_0_MAX_TACH_REG	2
#define FAN_1_MAX_TACH_REG	3
#define FAN_LOW_MIN_REV_COUNT	0x68
#define FAN_LOW_MAX_REV_COUNT	0x90
#define FAN_HIGH_MIN_REV_COUNT	0x98
#define FAN_HIGH_MAX_REV_COUNT	0xB0

#define FAN_TIMER_INTERVAL	(15*1000)	// 15 seconds

// MAXIM MAX6650 FAN registers map 
#define FAN_SPEED_REG		0x00
#define FAN_CONFIG_REG		0x02
#define FAN_GPIO_DEF_REG	0x04
#define FAN_DAC_REG			0x06
#define FAN_ALARM_EN_REG	0x08
#define FAN_ALARM_REG		0x0a
#define FAN_TACH0_REG		0x0c
#define FAN_TACH1_REG		0x0e
#define FAN_TACH2_REG		0x10
#define FAN_TACH3_REG		0x12
#define FAN_GPIO_STAT_REG	0x14
#define FAN_COUNT_REG		0x16

// FAN CONFIG register bits definitions
#define FAN_CONFIG_OPEN_LOOP	0x30
#define FAN_CONFIG_CLOSE_LOOP	0x20
#define FAN_CONFIG_SW_OFF		0x10
#define FAN_CONFIG_SW_ON		0x00
#define FAN_CONFIG_12VOLT		0x08
#define FAN_CONFIG_DIV_BY_16	0x04
#define FAN_CONFIG_DIV_BY_8		0x03
#define FAN_CONFIG_DIV_BY_4		0x02
#define FAN_CONFIG_DIV_BY_2		0x01
#define FAN_CONFIG_DIV_BY_1		0x00

// FAN ALARM ENABLE register bits definitions
#define FAN_ALARM_ENABLE_MAX	0x01
#define FAN_ALARM_ENABLE_MIN	0x02
#define FAN_ALARM_ENABLE_TACH	0x04
#define FAN_ALARM_ENABLE_GPIO1	0x08
#define FAN_ALARM_ENABLE_GPIO2	0x10

// FAN ALARM STATUS register bits definitions
#define FAN_ALARM_STATUS_MAX	0x01
#define FAN_ALARM_STATUS_MIN	0x02
#define FAN_ALARM_STATUS_TACH	0x04
#define FAN_ALARM_STATUS_GPIO1	0x08
#define FAN_ALARM_STATUS_GPIO2	0x10

// FAN GPIO DEF register bits definitions
#define FAN_GPIO_DEF_0_ALERT	0x01
#define FAN_GPIO_DEF_1_LOGIC_LO	0x04
#define FAN_GPIO_DEF_2_LOGIC_HI	0x30
#define FAN_GPIO_DEF_3_LOGIC_HI	0x40
#define FAN_GPIO_DEF_4_LOGIC_HI	0x80

#endif
