/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2002, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-rpc-ed-lsarpc.h,v 1.1.1.1 2002/04/23 17:47:36 laurentb Exp $
 *
 * Name			: cifs-rpc-ed-lsarpc.h
 *
 * Description	: CIFS DCE/RPC LSA services encode & decode functions. 
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 04/19/2002
 *
 *-----------------------------------------------------------------
 */

#ifndef _CIFS_RPC_ED_LSARPC_H
#define _CIFS_RPC_ED_LSARPC_H

int32	//NFX_OK or NFX_ERR
cifsrpcEDlsaOpenPolicyCall(cifsrpc_ed *edp, lsaOpenPolicyCall *p, uchar8 lv);


int32   //NFX_OK or NFX_ERR
cifsrpcEDlsaOpenPolicyResp(cifsrpc_ed *edp, lsaOpenPolicy2Resp *p, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDlsaOpenPolicy2Call(cifsrpc_ed *edp, lsaOpenPolicy2Call *p, uchar8 lv);


#define	cifsrpcEDlsaOpenPolicy2Resp	cifsrpcEDlsaOpenPolicyResp


int32   //NFX_OK or NFX_ERR
cifsrpcEDlsaQueryInfoPolicyCall(cifsrpc_ed *edp,
								lsaQueryInfoPolicyCall *p,
								uchar8 lv);

int32   //NFX_OK or NFX_ERR
cifsrpcEDlsaQueryInfoPolicyResp(cifsrpc_ed *edp,
								lsaQueryInfoPolicyResp *p,
								uchar8 lv);


int32   //NFX_OK or NFX_ERR
cifsrpcEDlsaCloseCall(cifsrpc_ed *edp, lsaCloseCall *p, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDlsaCloseResp(cifsrpc_ed *edp, lsaCloseResp *p, uchar8 lv);



#endif	//#ifndef _CIFS_RPC_ED_LSARPC_H


