/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * RCS:  $Id: cifs-intmsg.h,v 1.1.1.1 2002/04/23 17:41:16 laurentb Exp $
 *
 * Name			: cifs-intmsg.h
 *
 * Description	: Contains definitions for internal message processing.
 *
 * Created by	: Xiaobing Zhang
 *
 * Date Created	: 03/08/2002
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_INTMSG_H
#define _CIFS_INTMSG_H

#define CIFS_INTMSG_TO_FS		0
#define CIFS_INTMSG_TO_FSSF		1
#define CIFS_INTMSG_TO_EVM		2
#define CIFS_INTMSG_TO_AUTH		3

// Timeout while waiting for response from FS, FSSF, CIFSAUTH, EVM
// or for available buffers for outgoing message from CIFS
#define CIFS_INTMSG_TIMEOUT_FS			2 /*TODO 10*/
#define CIFS_INTMSG_TIMEOUT_FSSF		2 /*TODO 10*/
#define CIFS_INTMSG_TIMEOUT_CIFSAUTH	30
#define CIFS_INTMSG_TIMEOUT_EVM			10
#define CIFS_INTMSG_TIMEOUT_WAITBUF		10

void cifs_msgBuildFSHdr(fs_MsgReqHdr	*fsMsgReqHdrp,
						uint32			reqType,
						fs_AttrType		attrType,
						boolean			caseInsens,
						uint64			userInfo);

void cifs_msgBuildFssfHdr(fssf_msgHdr_t	*fssfMsgHdrp,
						fssf_msgType_t	reqType,
						cifs_operation	*opp);


int32           // NFX_OK or NFX_ERR
cifs_msgSend(uint32     dest,           //Destination module
             uchar8     *msgp,          //Message buffer
             uint32     msgLen,         //Message length
             boolean    freebuf);       //Free message buffer or not


void cifs_msgRcv(eee_desc_t *eDescP);

int32 cifs_msgXmtCmpToFs(cifs_operation *opp);

#endif /* _CIFS_INTMSG_H */
