/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-transport.h,v 1.1.1.1 2002/04/23 17:41:16 laurentb Exp $
 *
 * Name			: cifs-transport.h
 *
 * Description	: CIFS transport interface
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 11/10/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_TRANSPORT_H
#define _CIFS_TRANSPORT_H

	


int32	//NFX_OK or NFX_ERR
cifs_initTransportLayer(void);


int32	//NFX_OK or NFX_ERR
cifs_initServerTransportLayer(cifs_server *svp);


pkt_desc_t *	//NULL if no buffer available
cifs_getDatagBuf(cifs_server *svp);

		
pkt_desc_t *	//NULL if no buffer available
cifs_getClientBuf(cifs_client *clp, uchar8 **smbp);


int32   //NFX_OK or NFX_ERR
cifs_sendClientMsg(cifs_client *clp, cifs_operation *opp);
		
int32   //NFX_OK or NFX_ERR
cifs_sendClientMsgWithoutOp(cifs_client *clp, pkt_desc_t *pktp, uint32 length);

void
cifs_freeInBuf(cifs_client *clp, pkt_desc_t **pktpp);


void
cifs_freeClientOutBuf(cifs_client *clp, pkt_desc_t **pktpp);
	

void
cifs_closeSessionLayer(cifs_client *clp);
		
int32   //NFX_OK or NFX_ERR
cifs_testServerInitCompletion(cifs_server *svp);


		
#endif	//_CIFS_TRANSPORT_H

