//=============================================================================
// File Name	: bmc12500-eth-api.h
//
//  Description	:    
//
//  Created		: 12 March 2002
//
//  Author		: Frank Salzmann
//
//  RCS			: $Id: bmc12500-eth-api.h,v 1.4 2002/10/23 01:27:03 tonyw Exp $
//
//  Copyright(c)  Agile Storage, Inc. 2001, 2002
//=============================================================================


//-- Message Types.
typedef enum {
	ETH_MID_LINK_STATUS_REQ = BCETH_MSG_BASE,
	ETH_MID_LINK_STATUS_RSP 
} bc1250Eth_msgType_t;



typedef enum { 
	speed_10, 
	speed_100, 
	speed_1000,
   	speed_unknown,	
} speed_t;

typedef enum { 
	half_duplex,
	full_duplex,
	unknown_duplex,
} duplex_t;

typedef enum { 
	fc_disabled, 
	fc_frame,
	fc_collision, 
	fc_carrier,
   	fc_unknown,	
} fc_t;

typedef enum { 
	lb_none, 
	lb_int,
	lb_phy,
	lb_ext
} loop_t;

//
//-- Ethernet Link Status Messages.
//
typedef struct _bc1250eth_link_status_req {
	uint32   mid;   			// ETH_MID_LINK_STATUS_REQ
	uint32   link;				// Ethernet link #: 0, 1, 2, 3
} bc1250Eth_ls_reqMsg_t;

typedef struct _bc1250eth_link_status_rsp {
	uint32   mid;   			// ETH_MID_LINK_STATUS_RSP
	uint32   link;				// Ethernet link #: 0, 1, 2, 3
	speed_t  speed;
    duplex_t duplex;	
	uint32   status;
#define ETH_LINK_STATUS_DOWN	0
#define ETH_LINK_STATUS_UP	    1
} bc1250Eth_ls_rspMsg_t;

int bmc12500Eth_set_maxPktSize(uint16 port, uint16 size);
/* port = (0,1,...) size = (16-bit value) */

int bmc12500Eth_get_maxPktSize(uint16 port);
/* port = (0,1,...) returns max packet size */

int bmc12500Eth_set_autoneg(uint16 port, uint16 mode);
/* port = (0,1,...) mode = (0-off, 1-on) */ 

int bmc12500Eth_get_autoneg(uint16 port);
/* port = (0,1,...) returns 1 for ON, returns 0 for OFF */

int bmc12500Eth_get_linkstatus(uint16 port);
/* port = (0,1,...) returns 1 for link up, returns 0 for link down */

void bmc12500Eth_get_stats(int port, uint32 *stat_buf);
/* port = 0 and 2 for Cheetah, 0 and 1 for Garfield, returns 4 32-bit values */
