/*
 *-----------------------------------------------------------------
 *
 * Name:	eee-app.h
 *
 * RCS:  $Id: eee-app.h,v 1.10 2002/11/07 01:20:03 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	EEE layer application interface prototypes
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/10/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _EEE_APP_H
#define _EEE_APP_H


int32
eee_allocateApplicationId(
	uchar8	* appName
);

int32
eee_deallocateApplicationId(
	int32	appId
);

int32
eee_registerReceiveFunc(
	int32	appId,
	void	(*app_rcv_func)(
				eee_descPtr_t	edesc
			),
	void	(*app_mcast_rcv_func)(
				eee_descPtr_t	edesc
			)
);

void
eee_unregisterReceiveFunc(
	int32	appId
);

int32
eee_getApplicationId(
	uchar8	* appName
);

uchar8 *
eee_getNameFromAppId(
	int32	appId
);

/*------------------------------------------------------------------
 *
 *                      Forwarder Interface
 *
 *------------------------------------------------------------------*/
int32
eee_sendMessage(
	void	* src,
	uint32	num_bytes,
	uint32	dest_port,
	uint32	source_port
);

void
eee_receivePacket(
	eee_descPtr_t	edesc
);

int32
eee_forwardPacket(
	eee_descPtr_t	edesc
);

uchar8 *
eee_getAppNameFromId(
	int32 app_id
);

/*------------------------------------------------------------------
 *
 *                      Cleanup Interface
 *
 *------------------------------------------------------------------*/

#define EEE_MAX_FREE_ROUTINES	8	

#if !defined(_KERNEL)
int32
eee_registerCleanupRoutine(
	void	(*function_name)(eee_descPtr_t	edesc));
#endif

#endif	/* _EEE_APP_H */
