/*
 *-----------------------------------------------------------------
 *
 * Name:	eee-validate.h
 *
 * RCS:  $Id: eee-validate.h,v 1.3 2002/09/26 17:23:58 maximk Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/24/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _EEE_VALIDATE_H
#define _EEE_VALIDATE_H

typedef struct eee_val {
	address_t	alloc;
	address_t	free;
} eee_validate_t;

extern eee_validate_t	* eee_desc_validate[2];
extern eee_validate_t	* eee_buf_validate[2][EEE_NUM_BUF_SIZES];

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
#define EEE_VALIDATE_ALLOC_DESC(_desc, _pool, _ra) {				\
	uint32	_index, _vpool;											\
																	\
	if (_pool == 0)													\
		_vpool = 0;													\
	else															\
		_vpool = 1;													\
																	\
	_index = ((address_t)_desc - (address_t)eee.desc_base[_pool]) /		\
											 sizeof(eee_desc_t);	\
	if (eee_desc_validate[_vpool][_index].alloc)					\
		panic("Alloc desc validate error, desc = %p, ra = %p, prev_alloc = %p\n",	\
					_desc, _ra, eee_desc_validate[_vpool][_index].alloc);	\
																	\
	eee_desc_validate[_vpool][_index].alloc = _ra;					\
	eee_desc_validate[_vpool][_index].free = 0;						\
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
#define EEE_VALIDATE_FREE_DESC(_desc, _pool, _ra) {					\
	uint32	_index, _vpool;											\
																	\
	if (_pool == 0)													\
		_vpool = 0;													\
	else															\
		_vpool = 1;													\
																	\
	_index = ((address_t)_desc - (address_t)eee.desc_base[_pool]) /		\
											 sizeof(eee_desc_t);	\
	if (eee_desc_validate[_vpool][_index].free)						\
		panic("Free desc validate error, desc = %p, ra = %p, prev_free = %p\n",	\
					_desc, _ra, eee_desc_validate[_vpool][_index].free);	\
																	\
	eee_desc_validate[_vpool][_index].alloc = 0;					\
	eee_desc_validate[_vpool][_index].free = _ra;					\
}


/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
#define EEE_VALIDATE_ALLOC_BUF(_buf, _pool, _size, _ra) {			\
	uint32	_index, _vpool;											\
																	\
	if (_pool == 0)													\
		_vpool = 0;													\
	else															\
		_vpool = 1;													\
																	\
	_index = ((uint32)_buf - (uint32)(address_t)eee.buf_base[_pool][_size]) /	\
											eee.buf_size[_size];	\
	if (eee_buf_validate[_vpool][_size][_index].alloc)				\
		panic("Alloc buf validate error, buf = %x, ra = %x, prev_alloc = %x\n",	\
				_buf, _ra, eee_buf_validate[_vpool][_size][_index].alloc);	\
																	\
	eee_buf_validate[_vpool][_size][_index].alloc = _ra;			\
	eee_buf_validate[_vpool][_size][_index].free = 0;				\
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
#define EEE_VALIDATE_FREE_BUF(_buf, _pool, _size, _ra) {			\
	uint32	_index, _vpool;											\
																	\
	if (_pool == 0)													\
		_vpool = 0;													\
	else															\
		_vpool = 1;													\
																	\
	_index = ((address_t)_buf - (address_t)eee.buf_base[_pool][_size]) /	\
											eee.buf_size[_size];	\
	if (eee_buf_validate[_vpool][_size][_index].free)					\
		panic("Free buf validate error, buf = %p, ra = %p, prev_free = %p\n",	\
				_buf, _ra, eee_buf_validate[_vpool][_size][_index].free);	\
																	\
	eee_buf_validate[_vpool][_size][_index].alloc = 0;				\
	eee_buf_validate[_vpool][_size][_index].free = _ra;			\
}

#endif	/* _EEE_VALIDATE_H */

