/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : event-as.h
 *
 * Description  : Header file for auto support
 *
 * Created by   : Isabelle Cnudde
 *				  Pankaj Gupta
 *
 * Date Created : 11-SEP-2001
 *
 *------------------------------------------------------------------------------
 */
#ifndef _EVENT_AS_H_
#define _EVENT_AS_H_

/*------------------------------------------------------------------------------
 * Include files
 *------------------------------------------------------------------------------
 */

#include <stdio.h>      // fprintf(), stderr
#include <stdlib.h>     // exit()
#include <string.h>     // memset()
#include <time.h>       //

#include "nfx-incl.h"
#include "exports/opt-api.h"
//#include "exports/ems-def.h"
#include "exports/event-api.h"

/*------------------------------------------------------------------------------
 * Constants and macros.
 *------------------------------------------------------------------------------
 */

/*------------------------------------------------------------------------------
 * Type definitions.
 *------------------------------------------------------------------------------
 */

/* Basic message structure.
 */
typedef struct
{
    char    buf[4096];
    uint32  len;
} ems_msg_t;

/* EMS and autosupport configuration.
 */
typedef struct
{
	boolean		enable;
	char		to[256];
	char		noteto[256];

	uint64		minBitMap;		// frequency of mirroring
	uint32		hourBitMap;
	uint32		dateBitMap;
	uint32		monthBitMap;  
	uint32		dayBitMap;

#define SET_BIT(var, bit) (var |= (1ull << bit))
#define GET_BIT(var, bit) (var & (1ull << bit))

} as_config_t;

/*------------------------------------------------------------------------------
 * Prototypes of global functions.
 *------------------------------------------------------------------------------
 */

void appAddDetails(FILE* fd, nfx_eventMsg_t *evt);
int ems_sendAlarmMail(nfx_eventMsg_t *evt, char *app);
void ems_sendTrap(nfx_eventMsg_t *evt);
void ems_logEvent(nfx_eventMsg_t *evt);

/*----------------------------------------------------------------------------*/

#endif // _EVENT_AS_H_
