/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : evm-debug.h
 *
 * Description  : Volume Manager (EVM) - 
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 19-DEC-2001
 *
 *------------------------------------------------------------------------------
 */

#ifndef _EVM_DEBUG_H_
#define _EVM_DEBUG_H_

#include "evm-srvr-includes.h"
#include "nfx-incl.h"

/*------------------------------------------------------------------------------
 * Global variables.
 *------------------------------------------------------------------------------
 */

extern nfx_spinlock_t  evmStatLock;
extern nfx_spinlock_t  evmQueueLock;

/*------------------------------------------------------------------------------
 * Function prototypes.
 *------------------------------------------------------------------------------
 */

void
evm_trace(int32     level,
          char *    fmt,
          ...);

int32
evm_admin(int32     argc,
          char8 *   argv[]);

void
evm_displayStats(void);

/*----------------------------------------------------------------------------*/

#endif // _EVM_DEBUG_H_
