/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : evm-msg.h
 *
 * Description  : Volume Manager (EVM) - I/O management
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 19-DEC-2001
 *
 *------------------------------------------------------------------------------
 */

#ifndef _EVM_MSG_H_
#define _EVM_MSG_H_

#include "evm-srvr-includes.h"
#include "evm-io.h"
#include "nfx-incl.h"

/*------------------------------------------------------------------------------
 * Function prototypes.
 *------------------------------------------------------------------------------
 */

int32
evm_sendScsiMsg(evm_lioCb_t *   lcb,
                evm_pioCb_t *   pcb);

int32
evm_sendSbmScsiReadMsg(evm_lioCb_t *    lcb,
                       evm_pioCb_t *    pcb);

int32
evm_sendSbmScsiWriteMsg(evm_lioCb_t *   lcb,
                        evm_pioCb_t *   pcb);


int32
evm_sendCreateCodMsg(nfx_cod_t *    codp,
                     uint32         key,
                     uint32         size,
                     uint32         fill);

int32
evm_sendFreeCodMsg(nfx_cod_t cod);

int32
evm_sendRetrieveSacData(nfx_cod_t   cod,
                        uint32      length,
                        uint32      offset,
                        uint32      key,
                        uint32      dest_addr);

/*----------------------------------------------------------------------------*/

#endif // _EVM_MSG_H_
