/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: crashdump-api.h,v 1.4 2002/10/16 03:03:14 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _CRASHDUMP_API_H
#define _CRASHDUMP_API_H

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */
void exc_crashdump_set_stacktop();

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: returns non-zero, if a crashdump is present in the prom
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */
int32 exc_crashdump_is_present();

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: save a crashdump from a CPU exception
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */
void exc_crashdump_except_save(uchar8 * str);

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: save a crashdump from a software panic
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */
void exc_crashdump_panic_save(uchar8 * str);

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: save a crashdump from a watchdog timeout - NMI
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */
void exc_crashdump_nmi_save();

/*-----------------------------------------------------------------
 * Name: exc_crashdump_store
 *
 * Description: store off the crashdump to SSC fs 
 *
 * Created by:	John Hahn
 *
 * Date Created:	6/4/02
 *
 *-----------------------------------------------------------------
 */
int32 exc_crashdump_store(uint32 which);

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: view a crashdump and stacktrace
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/7/02
 *
 *-----------------------------------------------------------------
 */
int32 exc_crashdump_view(uint32 which);

void exc_crashdump_remove();

/*-----------------------------------------------------------------
 * Name: exc_fblen
 *
 * Description: space left in crashdump format storage buffer
 *
 * Created by:    John Hahn
 *
 * Date Created:    6/4/02
 *
 *-----------------------------------------------------------------
 */
uint32 exc_fblen(uint8 * bp);

#define EXC_CD_SAVED	                1
#define EXC_CD_PENDING	                2

#define EXE_CD_FORMAT_BUF_ALLOC_SIZE    (21 * 1024)
#define EXE_CD_FORMAT_BUF_SIZE          (20 * 1024)


#endif	/* _CRASHDUMP_API_H */

