/*
 *-----------------------------------------------------------------
 *
 * Name:	except-api.h
 *
 * RCS:  $Id: except-api.h,v 1.8 2002/11/07 01:19:15 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/21/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _EXCEPT_API_H
#define _EXCEPT_API_H

#define NUM_EXCEPT	32

#define R_ZERO      0
#define R_AT        1
#define R_V0        2
#define R_V1        3
#define R_A0        4
#define R_A1        5
#define R_A2        6
#define R_A3        7
#define R_T0        8
#define R_T1        9
#define R_T2        10
#define R_T3        11
#define R_T4        12
#define R_T5        13
#define R_T6        14
#define R_T7        15
#define R_S0        16
#define R_S1        17
#define R_S2        18
#define R_S3        19
#define R_S4        20
#define R_S5        21
#define R_S6        22
#define R_S7        23
#define R_T8        24
#define R_T9        25
#define R_K0        26
#define R_K1        27
#define R_GP        28
#define R_SP        29
#define R_FP        30
#define R_RA        31
#define R_HI        32
#define R_LO        33

#define R_ENTRYHI   34
#define R_ENTRYLO   35
#define R_ENTRYLO0  35
#define R_INDEX     36
#define R_RANDOM    37

#define R_STATUS    38
#define R_CAUSE     39
#define R_EPC       40
#define R_CONTEXT   41
#define R_BADVA     42
#define R_PRID      43
#define R_K1TMP     44

#if defined(R4000)
#define R_ENTRYLO1  45
#define R_PGMASK    46
#define R_WIRED     47
#define R_CONFIG    48
#define R_LLADDR    49
#define R_WATCHLO   50
#define R_WATCHHI   51
#define R_ECC       52
#define R_CACHERR   53
#define R_TAGLO     54
#define R_TAGHI     55
#define R_ERREPC    56
#define R_XCONTEXT  57
#define R_WATCHMASK 58
#define R_ICR       59
#define R_IPLLO     60
#define R_IPLHI     61
#define R_INFO      62
#define NONFPREGS   63
#endif

#ifdef TX3927
#define R_ERREPC	R_EPC
#define R_CONFIG    45
#define R_PGMASK    46
#define R_WIRED     47
#define R_CACHE     48
#define R_DEBUG     49
#define R_DEPC      50
#define R_TAGLO     51
#define NONFPREGS   52
#endif

#ifdef R7000
#define EXCEPT_INT    0     /* External interrupt */
#define EXCEPT_MOD    1     /* TLB modification */
#define EXCEPT_TLBL   2     /* TLB miss (Load or Ifetch) */
#define EXCEPT_TLBS   3     /* TLB miss (Save) */
#define EXCEPT_ADEL   4     /* Address error (Load or Ifetch) */
#define EXCEPT_ADES   5     /* Address error (Save) */
#define EXCEPT_IBE    6     /* Bus error (Ifetch) */
#define EXCEPT_DBE    7     /* Bus error (data load or store) */
#define EXCEPT_SYS    8     /* System call */
#define EXCEPT_BP     9     /* Break point */
#define EXCEPT_RI     10    /* Reserved instruction */
#define EXCEPT_CPU    11    /* Coprocessor unusable */
#define EXCEPT_OVF    12    /* Arithmetic overflow */
#define EXCEPT_TRAP   13    /* Trap exception */
#define EXCEPT_FPE    15    /* Floating Point Exception */
#define EXCEPT_IWATCH 16    /* Inst Watchpoint exception */
#define EXCEPT_DWATCH 23    /* Data Watchpoint exception */
#define EXCEPT_CACHE  30    /* Fake Cache Error */
#endif

#ifdef TX3927
#define EXCEPT_INT    0     /* External interrupt */
#define EXCEPT_MOD    1     /* TLB modification */
#define EXCEPT_TLBL   2     /* TLB miss (Load or Ifetch) */
#define EXCEPT_TLBS   3     /* TLB miss (Save) */
#define EXCEPT_ADEL   4     /* Address error (Load or Ifetch) */
#define EXCEPT_ADES   5     /* Address error (Save) */
#define EXCEPT_IBE    6     /* Bus error (Ifetch) */
#define EXCEPT_DBE    7     /* Bus error (data load or store) */
#define EXCEPT_SYS    8     /* System call */
#define EXCEPT_BP     9     /* Break point */
#define EXCEPT_RI     10    /* Reserved instruction */
#define EXCEPT_CPU    11    /* Coprocessor unusable */
#define EXCEPT_OVF    12    /* Arithmetic overflow */
#endif

#ifdef SB1250
#define EXCEPT_INT    0     /* External interrupt */
#define EXCEPT_MOD    1     /* TLB modification */
#define EXCEPT_TLBL   2     /* TLB miss (Load or Ifetch) */
#define EXCEPT_TLBS   3     /* TLB miss (Save) */
#define EXCEPT_ADEL   4     /* Address error (Load or Ifetch) */
#define EXCEPT_ADES   5     /* Address error (Save) */
#define EXCEPT_IBE    6     /* Bus error (Ifetch) */
#define EXCEPT_DBE    7     /* Bus error (data load or store) */
#define EXCEPT_SYS    8     /* System call */
#define EXCEPT_BP     9     /* Break point */
#define EXCEPT_RI     10    /* Reserved instruction */
#define EXCEPT_CPU    11    /* Coprocessor unusable */
#define EXCEPT_OVF    12    /* Arithmetic overflow */
#define EXCEPT_TRAP   13    /* Trap exception */
#define EXCEPT_VCEI   14    /* Virtual Coherency Exception (I) */
#define EXCEPT_FPE    15    /* Floating Point Exception */
#define EXCEPT_CP2    16    /* Cp2 exception */
#define EXCEPT_WATCH  23    /* Watchpoint exception */
#define EXCEPT_CACHE  30    /* Fake Cache Error */
#define EXCEPT_VCED   31    /* Virtual Coherency Exception (D) */
#endif

#ifdef LANGUAGE_C

#ifdef SSC
typedef uint32     cpureg_t;
#else
typedef sreg_t     cpureg_t;
#endif

int32
intr_registerHandler(
	uint32	ipl,
    void	(*func)(uint32 sr, uint32 cause, address_t epc)
);


int32
intr_unregisterHandler(
    uint32  ipl
);

void exception_panic(uchar8 * str);

#if defined(FCNIM) || defined(NFP_TXRX) || defined(NFP_FP)
void ecc_exception_init(void);
#endif

#endif

#endif	/* _EXCEPT_API_H */

