/*
 *-----------------------------------------------------------------
 *
 * Name:    mcount.S
 *
 * RCS:  $Id: mcount.S,v 1.5 2002/10/17 00:03:29 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:   mcount trampoline code
 *
 * Created by:  Byron Rakitzis
 *
 * Date Created:    11/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-target.h>

#if defined(NFX_PROFILING)

#if !defined(LINUX_TEST)

#include <nfx-incl.h>
#include <sys/mips.h>

#if defined(FCNIM) || defined(FCNIM_TM)
#define NOP nop
#else
#define NOP ssnop
#endif

.set noreorder
.set noat

.globl _runtimeTlbExcept
.ent _runtimeTlbExcept
_runtimeTlbExcept:

    la  k0, 0xbfc00200
    jr  k0
    nop

.end _runtimeTlbExcept

.globl _runtimeCacheErrExcept
.ent _runtimeCacheErrExcept
_runtimeCacheErrExcept:

    la  k0, 0xbfc00300
    jr  k0
    nop

.end _runtimeCacheErrExcept

.globl _runtimeOtherExcept
.ent _runtimeOtherExcept
_runtimeOtherExcept:

    la  k0, 0xbfc00380
    jr  k0
    nop

.end _runtimeOtherExcept

.globl _profSample1
.ent _profSample1
_profSample1:

    la  k0, _profSample2
    jr  k0
    nop

.end _profSample1


.globl _profSample2
.ent _profSample2
_profSample2:
    subu   sp, (34*8)+128
    sd  $0,  1*8(sp)
    sd  $1,  2*8(sp)
    sd  $2,  3*8(sp)
    sd  $3,  4*8(sp)
    sd  $4,  5*8(sp)
    sd  $5,  6*8(sp)
    sd  $6,  7*8(sp)
    sd  $7,  8*8(sp)
    sd  $8,  9*8(sp)
    sd  $9, 10*8(sp)
    sd $10, 11*8(sp)
    sd $11, 12*8(sp)
    sd $12, 13*8(sp)
    sd $13, 14*8(sp)
    sd $14, 15*8(sp)
    sd $15, 16*8(sp)
    sd $16, 17*8(sp)
    sd $17, 18*8(sp)
    sd $18, 19*8(sp)
    sd $19, 20*8(sp)
    sd $20, 21*8(sp)
    sd $21, 22*8(sp)
    sd $22, 23*8(sp)
    sd $23, 24*8(sp)
    sd $24, 25*8(sp)
    sd $25, 26*8(sp)
    sd $26, 27*8(sp)
    sd $27, 28*8(sp)
    sd $28, 29*8(sp)
#   sd $29, 30*8(sp)
    sd $30, 31*8(sp)
    sd $31, 32*8(sp)
    mfhi    t0
    sd      t0,33*8(sp)
    mflo    t0
    sd      t0,34*8(sp)

	mfc0	a0,C0_EPC
	nop
	nop
	nop
	jal	prof_sample
	nop

    li  t0, 1
    la  t1, 0xb0020098 
    sd  t0, 0(t1)       # write timer1 cfg reg to clear intr
    ld  t0, 0(t1)

    ld  $0,  1*8(sp)
    ld  $1,  2*8(sp)
    ld  $2,  3*8(sp)
    ld  $3,  4*8(sp)
    ld  $4,  5*8(sp)
    ld  $5,  6*8(sp)
    ld  $6,  7*8(sp)
    ld  $7,  8*8(sp)
#if 0
    ld  $8,  9*8(sp)            /* t0 */
    ld  $9, 10*8(sp)            /* t1 */
#endif
    ld $10, 11*8(sp)
    ld $11, 12*8(sp)
    ld $12, 13*8(sp)
    ld $13, 14*8(sp)
    ld $14, 15*8(sp)
    ld $15, 16*8(sp)
    ld $16, 17*8(sp)
    ld $17, 18*8(sp)
    ld $18, 19*8(sp)
    ld $19, 20*8(sp)
    ld $20, 21*8(sp)
    ld $21, 22*8(sp)
    ld $22, 23*8(sp)
    ld $23, 24*8(sp)
    ld $24, 25*8(sp)
    ld $25, 26*8(sp)
    ld $26, 27*8(sp)
    ld $27, 28*8(sp)
    ld $28, 29*8(sp)
#   ld $29, 30*8(sp)
    ld $30, 31*8(sp)
    ld $31, 32*8(sp)
    ld  t0,33*8(sp)
    mthi    t0
    ld  t0,34*8(sp)
    mtlo    t0
    ld  $8,  9*8(sp)            /* t0 */
    ld  $9, 10*8(sp)            /* t1 */

    addiu   sp, (34*8)+128

    NOP
    NOP
    NOP
    NOP
    NOP

    sync
    NOP
    NOP
    NOP
    NOP
    NOP

	eret
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP

.end _profSample2


#else /* LINUX_TEST */

.text
        .align 4
.globl mcount
        .type    mcount,@function
mcount:
        pushl   %ebp
        movl    %esp, %ebp
        subl    $8, %esp

        movl 4(%ebp),%eax
        movl (%ebp),%edx;movl 4(%edx),%edx

        subl    $8, %esp
        pushl   %eax
        pushl   %edx
        call    ___mcount
        leave
        ret

#endif /* LINUX_TEST */

/*
 * Somewhat-tested MP-safe mcount using load-linked/store-conditional
 */
#if 0
// void mcount(frompc, selfpc)
// {
// 
//       int hash = (frompc ^ selfpc) % TABLE_SIZE;
//       int i = hash;
// 
//       do {
//               volatile Arc *arc = &table[i];
// 
//               if (arc->frompc == 0) {
//                       int old = loadLinked(&arc->frompc);
//                       if (old == 0
//                           && storeConditional(&arc->frompc, frompc)) {
//                               arc->count = 1;
//                               arc->selfpc = selfpc;
//                               return;
//                       }
//                       assert(arc->frompc != 0);
//               }
// 
//               if (arc->frompc == frompc && arc->selfpc == selfpc) {
//                       while (TRUE) {
//                               int count = loadLinked(&arc->count);
//                               if (storeConditional
//                                   (&arc->count, count + 1)) return;
//                       }
//               }
// 
//               i = (i + 1) % TABLE_SIZE;
//       } while (i != hash);
// 
//       // table was full
// }

#include <nfx-incl.h>
#include <sys/mips.h>

.abicalls

.set noreorder
.set noat

.text
.align 4
.globl _mcount
.type    _mcount,@function
_mcount:
        xor t0,$at,ra            # hash = frompc ^ selfpc

	####################
	#
	# Hand-crafted code to compute a table size of 12*65536.
	#
	# This is slightly bogus, should be keyed of a CPP constant.

	srl t0,2
        andi t0,0xffff		# hash is multiple of 4 (instructions
	sll t0,2		# on mips are 4-byte aligned)

	addu t1,t0,t0		# hash *= 3
	addu t0,t0,t1

	li t5,12*0xffff

	#
	#
	####################


        move t1,t0              # i = hash
        la t2,mcount_table
        addu t3,t2,t1           # arc = &table[i]

loop:

#
#       Possible optimization: try a regular load before an ll assuming
#       you will hit an arc.
#
        lw t4,0(t3)             # if arc->frompc != 0
        bnez t4,check_arc
	nop

        ll t4,0(t3)             # if arc->frompc != 0
        bnez t4,check_arc
	nop

        move t4,$at             # or if sc(&arc->frompc, frompc) == 0
        sc t4,0(t3)
        beqz t4,check_arc
        lw t4,0(t3)             # hoisted from check_arc

        sw ra,4(t3)             # arc->selfpc = selfpc
        b incr_count
        nop

check_arc:
        # lw t4,0(t3)           # frompc == arc->frompc
        bne t4,$at,next_iter
                                # next instruction ok to mispredict

        lw t4,4(t3)             # selfpc == arc->selfpc
        bne t4,ra,next_iter
	nop

incr_count:
        ll t4,8(t3)
        addiu t4,1
        sc t4,8(t3)
        beqz t4,incr_count
        nop

	addu sp,sp,8
	j ra
	move ra,$at

next_iter:
        addiu t1,12              # i = (i + 1) % TABLE_SIZE;
	beq t1,t5,no_wrap
	nop
	move t1,zero

no_wrap:
        bne t0,t1,loop          # while (i != hash);
        addu t3,t2,t1           # hoisted from top of loop

	addu sp,sp,8
	j ra
	move ra,$at
#endif
#endif // NFX_PROFILING
