/*
 * Name		: fs-am.h
 * RCS		: $ID$
 * Description	: FS-Agile Mirror interface
 * Created by	: Rahul Khona
 * Date Created	: 18/1/2002
 */
#ifndef _FS_AM_H_
#define _FS_AM_H_

typedef struct fs_AmSnapInfo {
	char 	name[FS_SNAPNAME_MAX];
	int		id;
	int		snapTime;
} fs_AmSnapInfo;

typedef struct fs_AmSourceSession {
    fs_FileSystem   *fs;    // back pointer to fs
    uint64          cookie; // AM session Cookie;
    char            *oldName;   // name of old snapshot
    char            *newName;   // name of new snapshot
    int             oldSnapNum; // snapshot num of oldsnapshot -1 if nothing
                                // exists
    int             newSnapNum; // snapshot num of new snapshot
    int             copiedSnode; // copied super node

	int				numMaxSets;
	int				numCurSet;
	int				setIdx;
	fs_AmSnapInfo	snapInfo[FS_MAX_SNAPSHOTS]; 
								// list of snap shot info
								// that should be included in current session
								// transfer based on oldName snap generation
								// time
    boolean         done;
} fs_AmSourceSession_t;

typedef struct fs_AmTargetSession {
    fs_FileSystem   *fs;    // back pointer to fs
    uint64          cookie; // AM session Cookie;
    uint32          snapNum;    // snapnum of target snapshot
    char            *newName;   // name of new snapshot
} fs_AmTargetSession_t;
#endif  /* _FS_AM_H_ */
