#ifndef __SSC_STDIO_H
#define __SSC_STDIO_H

typedef struct ssc_file
{
	uint32 fd;
} ssc_FILE;

#define SSC_STDIO_MSG_BASE 1000

enum {
	SSC_STDIO_OPEN = SSC_STDIO_MSG_BASE,
	SSC_STDIO_READ,
	SSC_STDIO_WRITE,
	SSC_STDIO_SEEK,
	SSC_STDIO_CLOSE
};

struct ssc_stdio_msg_hdr
{
	uint32 type;
	uint32 handle;
};


struct ssc_stdio_open_msg
{
	uint32 type;
	uint32 handle;
	uint32 namelen;
	uint32 modelen;
	char data[1];
};


struct ssc_stdio_open_rsp
{
	uint32 type;
	uint32 handle;
	uint32 fd;
};

struct ssc_stdio_read_msg
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 sz;
	uint32 nelm;
};


struct ssc_stdio_read_rsp
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 nelm;
};


struct ssc_stdio_write_msg
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 sz;
	uint32 nelm;
};


struct ssc_stdio_write_rsp
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 nelm;
};


struct ssc_stdio_seek_msg
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 offset;
	uint32 whence;
};

struct ssc_stdio_seek_rsp
{
	uint32 type;
	uint32 handle;
	uint32 fd;
	uint32 offset;
};


struct ssc_stdio_close_msg
{
	uint32 type;
	uint32 handle;
	uint32 fd;
};


struct ssc_stdio_close_rsp
{
	uint32 type;
	uint32 handle;
	uint32 fd;
};


ssc_FILE *ssc_fopen(char *name, char *mode);
int ssc_fread(char *buf, uint32 sz, uint32 nelm, ssc_FILE *file);
int ssc_fwrite(char *buf, uint32 sz, uint32 nelm, ssc_FILE *file);
int ssc_fclose(ssc_FILE *file);
int ssc_fseek(ssc_FILE *file, uint32 off, uint32 whence);

#endif
