/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: ecc.c,v 1.8 2002/11/07 01:18:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/26/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/except-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/26/02
 *
 *-----------------------------------------------------------------
 */
void
ecc_error_exc(
	uint32	sr,
	uint32	cause,
	address_t	epc
)
{
	uint32	errdatahigh, errdatalow, eccrx, ecccalc, erraddr, ecccount;

	printf("\nECC Error Exception, SR = 0x%x, EPC = %p\n\n", sr, (void *)epc);

	errdatahigh = *(volatile uint32 *)0xb4000480;
	errdatalow = *(volatile uint32 *)0xb4000484;
	eccrx = *(volatile uint32 *)0xb4000488;
	ecccalc = *(volatile uint32 *)0xb400048c;
	erraddr =  *(volatile uint32 *)0xb4000490;
	ecccount =  *(volatile uint32 *)0xb4000498;

#if 0
    printf("SDRAM Error Data = 0x%x 0x%x\n", *(volatile uint32 *)0xb4000480, *(volatile uint32 *)0xb4000484);
    printf("SDRAM Error Address = %p\n", erraddr);
    printf("SDRAM ECC Calculated = 0x%x, Received = 0x%x\n", errcalc, errrx);
    printf("SDRAM ECC Control = 0x%x\n", *(volatile uint32 *)0xb4000494);
    printf("SDRAM ECC Counter = 0x%x\n", *(volatile uint32 *)0xb4000498);

    printf("Main Interrupt Cause Low = 0x%x\n", *(volatile uint32 *)0xb4000c18);
    printf("CPU Interrupt Mask Low = 0x%x\n", *(volatile uint32 *)0xb4000c1c);
#endif

	*(volatile uint32 *)0xb4000494 = 0;
	*(volatile uint32 *)0xb4000490 = 0;

	panic("ECC EXC, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n", errdatahigh, errdatalow, eccrx, ecccalc, erraddr, ecccount);
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/26/02
 *
 *-----------------------------------------------------------------
 */
void
ecc_exception_init()
{
	uint32	t;

	printf("ECC exception handler Initialized\n");

	/* clear exisiting ECC error interrupts */
	*(volatile uint32 *)PHYS_TO_K1(
						HW_GALILEO_BASE + SDRAM_AND_DEVICE_ERROR_ADDRESS) = 0;
	*(volatile uint32 *)PHYS_TO_K1(
						HW_GALILEO_BASE + CPU_INTERRUPT_MASK_REGISTER_LOW) = 0;

#if 0
	/* enable ECC interrupt */
	sr = _mips_mfc0(C0_SR);
	sr |= (SR_IE | SR_HINT0);		/* Int0 is from galileo */
	_mips_mtc0(C0_SR, sr);
#endif

	*(volatile uint32 *)PHYS_TO_K1(
						HW_GALILEO_BASE + SDRAM_ECC_ERROR_COUNTER) = 0;
	*(volatile uint32 *)PHYS_TO_K1(
		HW_GALILEO_BASE + CPU_INTERRUPT_MASK_REGISTER_LOW) = 0x20000;	/* ECC */
	*(volatile uint32 *)PHYS_TO_K1(
						HW_GALILEO_BASE + SDRAM_ECC_CONTROL) = 0x00000200;

	t = *(volatile uint32 *)PHYS_TO_K1(
						HW_GALILEO_BASE + SDRAM_AND_DEVICE_ERROR_ADDRESS);

#if 0
	gtint_intr_registerHandler(2, ecc_error_exc);
#endif
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description: stub for command ui to ecc test
 *
 * Created by:	John Hahn
 *
 * Date Created:	9/07/02
 *
 *-----------------------------------------------------------------
 */

int32
do_ecc(
	int32	ac,
	char8 * av[]
)
{
    printf("not implemented\n");
	return NFX_ERR;
}
