/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: gpp-defs.h,v 1.4 2002/10/08 03:16:12 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/1/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _GPP_DEFS_H
#define _GPP_DEFS_H


#ifndef R7000
#error Non-R7000 Target build is including sm-gt64240/gpp-defs.h !!!
#endif
/*
 * following GPP bits are located in the Galileo GPP_VALUE registers
 * for all FC slices
 */

#define GPP_FC_DIAG_LED_ERR_MASK	0x80000000
#define GPP_FC_DIAG_LED_ERR_SHIFT	31
#define GPP_FC_DIAG_LED_2LINK_MASK	0x40000000
#define GPP_FC_DIAG_LED_2LINK_SHIFT	30
#define GPP_FC_DIAG_LED_CLINK_MASK	0x20000000
#define GPP_FC_DIAG_LED_CLINK_SHIFT	29
#define GPP_FC_DIAG_LED_DLINK_MASK	0x10000000
#define GPP_FC_DIAG_LED_DLINK_SHIFT	28

#define GPP_FC_DIAG_LED_OFF         0
#define GPP_FC_DIAG_LED_ON          1

#define GPP_FC_DIAG_LED_CPUOK_MASK	0x08000000
#define GPP_FC_DIAG_LED_CPUOK_SHIFT	27

#define GPP_FC_DIAG_LED_CPUOK_RED   0
#define GPP_FC_DIAG_LED_CPUOK_GREEN 1

#define GPP_FC_DIAG_LED_ALL_MASK  \
   (GPP_FC_DIAG_LED_ERR_MASK	| \
    GPP_FC_DIAG_LED_2LINK_MASK	| \
    GPP_FC_DIAG_LED_CLINK_MASK	| \
    GPP_FC_DIAG_LED_DLINK_MASK  | \
    GPP_FC_DIAG_LED_CPUOK_MASK)

#define GPP_FC_SLICE_MASK	        0x06000000
#define GPP_FC_SLICE_SHIFT	        25
#define GPP_FC_REV_MASK		        0x00800000
#define GPP_FC_REV_SHIFT	        23
#define GPP_FC_REV_PRE_BETA         1
#define GPP_FC_REV_REVA_BETA        0

/*
 * following GPP bits for clock mode, mem type, diag sel, prom sel
 * are for FC slices 1,2,3 and are in Galileo GPP_VALUE register
 */

#define GPP_FC123_CLK_MODE_MASK		    0x00400000
#define GPP_FC123_CLK_MODE_SHIFT		22
#define GPP_FC123_CLK_MODE_100MHz		1
#define GPP_FC123_CLK_MODE_125MHz		0
#define GPP_FC123_MEM_TYPE_MASK		    0x00200000
#define GPP_FC123_MEM_TYPE_SHIFT		21
#define GPP_FC123_MEM_TYPE_UNREG		0
#define GPP_FC123_MEM_TYPE_REG			1
#define GPP_FC123_DIAG_SEL_MASK		    0x00100000
#define GPP_FC123_DIAG_SEL_SHIFT		20
#define GPP_FC123_PROM_SEL_MASK		    0x00080000
#define GPP_FC123_PROM_SEL_SHIFT		19

#define GPP_FC123_SLICE_STATE_SHIFT     15
#define GPP_FC123_SLICE_STATE_MASK      (0xf << GPP_FC123_SLICE_STATE_SHIFT)

/*
 * GPP bits for clock mode, mem type, diag sel, prom sel are for
 * FC slice 0 and are found in the BMFPGA status register defined
 * in sys/bmfpga.h
 */

#endif  /* _GPP_DEFS_H */
