/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: gtint.c,v 1.3 2002/11/07 01:18:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/hwMap.h>
#include <exports/except-api.h>
#include <exports/bsp-api.h>
#ifdef NFX_PROFILING
#include <exports/prof-api.h>
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */
void
gtint_func(
	uint32	sr,
	uint32	cause,
	address_t	epc
)
{
	volatile uint32	* icause = (volatile uint32 *)PHYS_TO_K1(
								HW_GALILEO_BASE + LOW_INTERRUPT_CAUSE_REGISTER);
	uint32			gt_cause;

	gt_cause = *icause;

	if (gt_cause & 0x20000)
		ecc_error_exc(sr, cause, epc);
#ifdef NFX_PROFILING
	if (gt_cause & 0x200)
		prof_int(sr, cause, epc);
#endif
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:	 GT interrupt routes to R7000 on Int0 (IP2)
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */
void
gtint_init()
{
	intr_registerHandler(2, gtint_func);
}

