/*
 *-----------------------------------------------------------------
 *
 * Name: busclock.c
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description: Contains routines to return system bus speed.
 *
 * Created by:	Shaun Hui
 *
 * Date Created:06/14/04
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <exports/cm-api.h>

uint32	busclock = 0;

/*-----------------------------------------------------------------
 * Name: get_busclock
 *
 * Description: Returns clock speed of system bus in MHz.
 *
 *-----------------------------------------------------------------
 */
uint32
get_busclock()
{
	uint32 bmfpga_get_busclock();

	busclock = bmfpga_get_busclock();

	return busclock;
}

#ifndef PROM

/*-----------------------------------------------------------------
 * Name: get_pipefreq
 *
 * Description: Returns pipeline (CPU) frequency in Hz
 *
 *-----------------------------------------------------------------
 */
uint32
get_pipefreq()
{
    return ((get_busclock() * 1000000 * 6);
}

#else

uint32
get_pipefreq()
{
    return (sbdpipefreq());
}

#endif
