/*
 *-----------------------------------------------------------------
 *
 * Name:	vs-hash.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2003, Agile Storage Inc.
 *
 * Description:	Virtual server hash table definitions
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	01/15/03
 *
 *-----------------------------------------------------------------
 */

#ifndef _VS_HASH_H
#define _VS_HASH_H

#include <exports/vs-mem-api.h>

typedef struct vs_ht_item {
	struct vs_ht_item	* next;
	/*TODO: replace the above by: vs_mem_index_t next;*/
	vs_mem_index_t		data;
} vs_ht_item_t;

typedef struct vs_ht {
	vs_ht_item_t	** head;
	uint32			(* hash)(void *key);
	int32			(* compare)(vs_mem_index_t ht_data,
								vs_mem_index_t search_data);
	void			(* release)(vs_mem_index_t data);
	uint32			num_buckets;
	nfx_spinlock_t	ht_spin;
} vs_ht_t;



vs_ht_item_t *	vs_hash_getNode(void);

void	vs_hash_freeNode(	vs_ht_item_t	* htp);

#endif	/* _VS_HASH_H */

