/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: ipmd-kern.h
 *
 * RCS:  $Id: ipmd-kern.h,v 1.7 2002/10/29 01:26:53 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Su Wang
 *
 * Date Created: 10/11/2001
 *
 *-----------------------------------------------------------------
 */

#ifndef _IPMD_KERN_H
#define _IPMD_KERN_H

/* kernel cmds id */
#define TCB_TABLE		0
#define TCP_STAT		1
#define UDB_TABLE		2
#define UDP_STAT		3
#define ICMP_STAT		4
#define IP_STAT			6
#define IF_STAT			5

/* auxiliary interface for GigE */
typedef struct 
{
	ushort16		ipm_auxMtu;
	ushort16		ipm_auxFlags;
} ipm_auxIntf_t;

extern ipm_auxIntf_t	ipmd_auxIntf[];
#define IPM_GET_AUXINTF(cpu, link)  (&ipmd_auxIntf[link])

/* configure kernel interface */
int32 ipmd_AddKernIp(char*, uint32, uint32);
int32 ipmd_DelKernIp(char*, uint32 );
int32 ipmd_AddKernRt(uint32, uint32, uint32);
int32 ipmd_DelKernRt(uint32, uint32, uint32);
int32 ipmd_AddKernArp(uint32, char*);
int32 ipmd_DelKernArp(uint32);
int32 ipmd_EnableKernIntf(char*);
int32 ipmd_DisableKernIntf(char*);

#if defined(SSC_x86) || defined(SSC_mips)
/* func to access kernel mem space */
int32 ipmd_GetKernIfStats(char*, ipm_ifstat_t*, int, int*, int*);
int32 ipmd_GetKernIpStats(void*, int, int*, int*);
int32 ipmd_GetKernIcmpStats(void*, int, int*, int*);
int32 ipmd_GetKernTcpStats(void*, int, int*, int*);
int32 ipmd_GetKernUdpStats(void*, int, int*, int*);
int32 ipmd_GetKernTcpConn(ipm_conn_t*, int, int*, int*);
int32 ipmd_GetKernUdpConn(ipm_conn_t*, int, int*, int*);
#endif /* SSC_x86, SSC_mips */

int32 ipmd_GetKernIpByName(char*, ipm_ip_t*, int, int*, int*);
int32 ipmd_GetKernIfByName(char*, ipm_if_t*, int, int*, int*);
int32 ipmd_GetKernIfByNameTxRx(char*, ipm_if_t*, int, int*, int*);
int32 ipmd_GetKernFindIp(uint32, uint32);
int32 ipmd_GetKernFindIpExact(uint32, uint32, char*);
int32 ipmd_GetKernRtTbl(ipm_rt_t*, int, int*, int*);
int32 ipmd_GetKernArpTbl(ipm_arp_t*, int, int*, int*);
int32 ipmd_GetKernIpByIp(uint32, int, ipm_ip_t*, int, int*, int*);
void  ipmd_ReplaceIp(uint32 ip_addr);
#endif /* _IPMD_KERN_H */
