/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: ipmd-vif.h
 *
 * RCS:  $Id: ipmd-vif.h
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Su Wang
 *
 * Date Created: 10/07/2002
 *
 *-----------------------------------------------------------------
 */

#ifndef _IPMD_VIF_H
#define _IPMD_VIF_H

#if defined(LINK_AGG)

/* misc. flags */
#define IPMD_VIFCONF_RESTORE		0x1

#define IPMD_VIF_PROC_SSC(_mtype) ((_mtype == IPM_MSG_VIF_CREAT)	||	\
									(_mtype == IPM_MSG_VIF_DEL)		||	\
									(_mtype == IPM_MSG_VIF_ADDLNK)	||	\
									(_mtype == IPM_MSG_VIF_RMLNK)	||	\
									(_mtype == IPM_MSG_VIP_ADD)		||	\
									(_mtype == IPM_MSG_VIP_DEL)		||	\
									(_mtype == IPM_MSG_VIF_PREF)	||	\
									(_mtype == IPM_MSG_VIFTBL_REQ))

void		ipmd_ProcessVif(int32 mtype, void* msg, char* app);
void		ipmd_ProcessVifTxrx(int32 mtype, void	*msg);
ipm_vif_t*	ipmd_FindVifByName(char	*vifName);
ipm_vif_t*	ipmd_FindVifByLink(char	*linkName); 
int32		ipmd_AddLinkToVif(char	*linkName, ipm_vif_t *vifp, uint32 flags);
int32		ipmd_RmLinkFromVif(char	*linkName, ipm_vif_t *vifp);
char*		ipmd_VifHasIP(uint32 ip, ipm_vif_t	*vifp);
int32		ipmd_CmpVif(ipm_vif_t	*vifp1,	ipm_vif_t	*vifp2);
int32		ipmd_GetIfFromTxrx(char	*linkName, ipm_if_t	*ipm_ifp);
void		ipmd_SwitchLinkIP(char *srcLink,  char *dstLink);
void		ipmd_InitVif(void);
#endif /* LINK_AGG */

#endif /* _IPMD_VIF_H */
