/*
 *------------------------------------------------------------------------------
 *
 * Name:	ispfc_aen_handler.h
 *
 * RCS:		$Id: ispfc_aen_handler.h,v 1.3 2002/01/12 02:19:41 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	QLogic 2300 FC HAL driver AEN handler definitions
 *
 * Created by:	Radek Aster
 *
 * Date Created: 6/1/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __ISPFC_AEN_HANDLER_H__
#define __ISPFC_AEN_HANDLER_H__

typedef struct {
	uint32 valid;
	uint32 aen_code;
	void (*aen_handler)(ispfc_cb_t *, void *, uint32);
	void * aen_cookie;
	uint32 aen_arg;
} ispfc_aen_handler_t;

void ispfc_register_aen_handler(ispfc_cb_t *, uint32,
				void (*)(ispfc_cb_t *, void *, uint32),
				void *,
				uint32);
void ispfc_deregister_aen_handler(ispfc_cb_t *, uint32);
void ispfc_reset_aen_handlers(ispfc_cb_t *);
void ispfc_aen_handler(ispfc_cb_t *, uint32);

#endif /* __ISPFC_AEN_HANDLER_H__ */
