/*
 *------------------------------------------------------------------------------
 *
 * Name:	ispfc_misc.c
 *
 * RCS:		$Id: ispfc_misc.h,v 1.8 2002/10/10 22:36:33 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	QLogic 2300 FC HAL driver miscellaneous definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 6/6/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __ISPFC_MISC_H__
#define __ISPFC_MISC_H__

#ifdef DEBUG
ushort16 _ispfc_reg_read(ispfc_cb_t *, ushort16);
void	 _ispfc_reg_write(ispfc_cb_t *, ushort16, ushort16);
void	 ispfc_dump_pio_trace(ispfc_cb_t *, int);
#endif

void     ispfc_dump_registers(ispfc_cb_t *);

byte	 ispfc_alpa_to_loopid(byte);
byte	 ispfc_loopid_to_alpa(byte);
char *   ispfc_scsi_cdb_to_string(byte *);
char *   ispfc_scsi_sense_to_string(byte *);

eee_desc_t *  ispfc_edesc_allocate(scsi_desc_t *);
void	      ispfc_edesc_set_len(eee_desc_t *, int32);
void	      ispfc_edesc_offset_buf(eee_desc_t *, int32, int);

void     ispfc_trigger_pci_analyzer(void);

void     ispfc_qlogic_dump(ispfc_cb_t *, void (*)(ispfc_cb_t *, void *, int32), void *);

#endif
