/*
 *-----------------------------------------------------------------
 *
 * Name:	atol.c
 *
 * RCS:  $Id: atol.c,v 1.1 2001/11/09 19:21:22 bob Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	converts p to long
 *
 * Created by:	Bob Fozard
 *
 * Date Created:	11/05/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

long
atol (
	char8	* p
)
{
	int32	digit, isneg;
	long	value;

	isneg = 0;
	value = 0;

	for (; isspace (*p); p++);	/* gobble up leading whitespace */

	/* do I have a sign? */
	if (*p == '-') {
		isneg = 1;
		p++;
	} else if (*p == '+')
		p++;

	for (; *p; p++) {
		value *= 10;
		if (*p >= '0' && *p <= '9')
			digit = *p - '0';
		else
			break;
		value += digit;
	}

	if (isneg)
		value = 0 - value;

	return (value);

}	/* atol() */

