/*
 *-----------------------------------------------------------------
 *
 * Name:	atolx.c
 *
 * RCS:  $Id: atolx.c,v 1.1 2002/03/11 18:43:15 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:	converts p to long
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/27/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

unsigned long
atolx (
	char8	* p
)
{
	int32	digit;
	unsigned long	value;
	uint32	c;

	value = 0;

	for (; isspace (*p); p++);	/* gobble up leading whitespace */

	if ((*p == '0') && (*(p+1) == 'x'))
		p+=2;

	for (; *p; p++) {
		value *= 16;
		c = *p;
		if (c >= '0' && c <= '9')
			digit = c - '0';
		else if (c >= 'a' && c <= 'f')
			digit = c - 'a' + 10;
		else if (c >= 'A' && c <= 'F')
			digit = c - 'A' + 10;
		else
			break;
		value += digit;
	}

	return (value);

}	/* atolx() */

