/*
 *-----------------------------------------------------------------
 *
 * Name:	atox.c
 *
 * RCS:  $Id: atox.c,v 1.2 2001/10/03 18:10:32 maximk Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	converts p to int
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/03/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

uint32
atox (
	char8	* p
)
{
	int32	digit;
	uint32	value, c;

	value = 0;

	for (; isspace (*p); p++);	/* gobble up leading whitespace */

	if ((*p == '0') && (*(p+1) == 'x'))
		p+=2;

	for (; *p; p++) {
		value *= 16;
		c = *p;
		if (c >= '0' && c <= '9')
			digit = c - '0';
		else if (c >= 'a' && c <= 'f')
			digit = c - 'a' + 10;
		else if (c >= 'A' && c <= 'F')
			digit = c - 'A' + 10;
		else
			break;
		value += digit;
	}

	return (value);

}	/* atox() */

