/*
 *-----------------------------------------------------------------
 *
 * Name:	bzero.c
 *
 * RCS:  $Id: bzero.c,v 1.7 2002/10/18 17:52:54 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: clear length bytes in destination
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

void
old_bzero (
	void			* dst,
	__SIZE_TYPE__ 	nbytes
)
{
	register char * addr = dst;
    register uint32 nwords;

    if (nbytes < 8)
    {
        while (nbytes-- > 0)
            *addr++ = 0;
        return;
    }
    
    // the first bytes until 32 bit alignement
    while ((address_t)addr & 0x3)
    {
       *((char *)addr)++ = 0;
       nbytes--;
    }

#ifdef R4000
    // the next 32 bytes
    if ((address_t)addr & 0x7)
    {
       *((uint32 *)addr)++ = 0;
       nbytes -= 4;
    }
    
    nwords = nbytes >> 3;
    while (nwords--)
    {
        *((uint64 *)addr)++ = 0;
    }
    nbytes &= 0x7;

#else
    nwords = nbytes >> 2;
    while (nwords--)
    {
        *((uint32 *)addr)++ = 0;
    }
    nbytes &= 0x3;
#endif

    while (nbytes--)
    {
       *((char *)addr)++ = 0;
    }

}	/* bzero() */


