/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:	libc.h
 *
 * RCS:  $Id: libc.h,v 1.47 2002/11/26 22:48:14 bob Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _LIBC_H
#define _LIBC_H

/*
 * Strings
 */

#define FMT_RJUST		0
#define FMT_LJUST		1
#define FMT_RJUST0		2
#define FMT_CENTER		3

#ifdef LANGUAGE_C


#ifdef sibyte_comp

/* Copyright (C) 1989, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* As a special exception, if you include this header file into source
   files compiled by GCC, this header file does not by itself cause
   the resulting executable to be covered by the GNU General Public
   License.  This exception does not however invalidate any other
   reasons why the executable file might be covered by the GNU General
   Public License.  */

/*
 * ISO C Standard:  7.15  Variable arguments  <stdarg.h>
 */

#ifndef _STDARG_H
#ifndef _ANSI_STDARG_H_
#ifndef __need___va_list
#define _STDARG_H
#define _ANSI_STDARG_H_
#endif /* not __need___va_list */
#undef __need___va_list

/* Define __gnuc_va_list.  */

#ifndef __GNUC_VA_LIST
#define __GNUC_VA_LIST
typedef __builtin_va_list __gnuc_va_list;
#endif

/* Define the standard macros for the user,
   if this invocation was from the user program.  */
#ifdef _STDARG_H

/* Note that the type used in va_arg is supposed to match the
   actual type **after default promotions**.
   Thus, va_arg (..., short) is not valid.  */

#define va_start(v,l)	__builtin_stdarg_start((v),l)
#define va_end		__builtin_va_end
#define va_arg		__builtin_va_arg
#if !defined(__STRICT_ANSI__) || __STDC_VERSION__ + 0 >= 199900L
#define va_copy(d,s)	__builtin_va_copy((d),(s))
#endif
#define __va_copy(d,s)	__builtin_va_copy((d),(s))


/* Define va_list, if desired, from __gnuc_va_list. */
/* We deliberately do not define va_list when called from
   stdio.h, because ANSI C says that stdio.h is not supposed to define
   va_list.  stdio.h needs to have access to that data type, 
   but must not use that name.  It should use the name __gnuc_va_list,
   which is safe because it is reserved for the implementation.  */

#ifdef _HIDDEN_VA_LIST  /* On OSF1, this means varargs.h is "half-loaded".  */
#undef _VA_LIST
#endif

#ifdef _BSD_VA_LIST
#undef _BSD_VA_LIST
#endif

#if defined(__svr4__) || (defined(_SCO_DS) && !defined(__VA_LIST))
/* SVR4.2 uses _VA_LIST for an internal alias for va_list,
   so we must avoid testing it and setting it here.
   SVR4 uses _VA_LIST as a flag in stdarg.h, but we should
   have no conflict with that.  */
#ifndef _VA_LIST_
#define _VA_LIST_
#ifdef __i860__
#ifndef _VA_LIST
#define _VA_LIST va_list
#endif
#endif /* __i860__ */
typedef __gnuc_va_list va_list;
#ifdef _SCO_DS
#define __VA_LIST
#endif
#endif /* _VA_LIST_ */
#else /* not __svr4__ || _SCO_DS */

/* The macro _VA_LIST_ is the same thing used by this file in Ultrix.
   But on BSD NET2 we must not test or define or undef it.
   (Note that the comments in NET 2's ansi.h
   are incorrect for _VA_LIST_--see stdio.h!)  */
#if !defined (_VA_LIST_) || defined (__BSD_NET2__) || defined (____386BSD____) || defined (__bsdi__) || defined (__sequent__) || defined (__FreeBSD__) || defined(WINNT)
/* The macro _VA_LIST_DEFINED is used in Windows NT 3.5  */
#ifndef _VA_LIST_DEFINED
/* The macro _VA_LIST is used in SCO Unix 3.2.  */
#ifndef _VA_LIST
/* The macro _VA_LIST_T_H is used in the Bull dpx2  */
#ifndef _VA_LIST_T_H
/* The macro __va_list__ is used by BeOS.  */
#ifndef __va_list__
typedef __gnuc_va_list va_list;
#endif /* not __va_list__ */
#endif /* not _VA_LIST_T_H */
#endif /* not _VA_LIST */
#endif /* not _VA_LIST_DEFINED */
#if !(defined (__BSD_NET2__) || defined (____386BSD____) || defined (__bsdi__) || defined (__sequent__) || defined (__FreeBSD__))
#define _VA_LIST_
#endif
#ifndef _VA_LIST
#define _VA_LIST
#endif
#ifndef _VA_LIST_DEFINED
#define _VA_LIST_DEFINED
#endif
#ifndef _VA_LIST_T_H
#define _VA_LIST_T_H
#endif
#ifndef __va_list__
#define __va_list__
#endif

#endif /* not _VA_LIST_, except on certain systems */

#endif /* not __svr4__ */

#endif /* _STDARG_H */

#endif /* not _ANSI_STDARG_H_ */
#endif /* not _STDARG_H */



#else		/*  sibyte_comp */

#if !defined(__OpenBSD__) && !defined(linux)

typedef void 	* va_list;

enum {
  __no_type_class = -1,
  __void_type_class,
  __integer_type_class,
  __char_type_class,
  __enumeral_type_class,
  __boolean_type_class,
  __pointer_type_class,
  __reference_type_class,
  __offset_type_class,
  __real_type_class,
  __complex_type_class,
  __function_type_class,
  __method_type_class,
  __record_type_class,
  __union_type_class,
  __array_type_class,
  __string_type_class,
  __set_type_class,
  __file_type_class,
  __lang_type_class
};

#define __va_alignoff(TYPE)                         \
  (((__alignof(TYPE) <= __alignof(int))                \
    ?__alignof(int)                        \
    : __alignof(TYPE)) - 1)

#define __va_real_size(TYPE) \
    ((sizeof(TYPE) <= sizeof(int)                  \
      && __builtin_classify_type(*(TYPE *)0) != __record_type_class \
      && __builtin_classify_type(*(TYPE *)0) != __union_type_class) \
     ? sizeof(TYPE) : __va_rounded_size(TYPE))

#define __va_rounded_size(TYPE)  \
  (((sizeof (TYPE) + sizeof (int) - 1) / sizeof (int))    \
   * sizeof (int))



#define va_start(AP, LASTARG)                       \
 (AP = ((va_list) __builtin_next_arg(LASTARG)))

#define va_end(AP)  ((void)0)

#define va_arg(AP, TYPE)                              \
 (AP =                                        \
   (va_list) (((long)AP + __va_alignoff(TYPE)) & ~__va_alignoff(TYPE))        \
      + __va_rounded_size(TYPE),                          \
   *((TYPE *) (void *) ((char *)AP - __va_real_size(TYPE))))
#endif

#endif



#if !defined (linux)	// Stupid thing is defined in Linux
/* Random number generator stuff */
struct random_data {
	int32 *fptr;	/* Front pointer.  */
	int32 *rptr;	/* Rear pointer.  */
	int32 *state;	/* Array of state values.  */
	int rand_type;	/* Type of random number generator.  */
	int rand_deg;	/* Degree of random number generator.  */
	int rand_sep;	/* Distance between front and rear.  */
	int32 *end_ptr;	/* Pointer behind state table.  */
};
#endif


#if defined(linux) || defined(__OpenBSD__)
/*#include <sys/types.h>*/
#include <stdarg.h>
/*#include <string.h>*/
/*#include <stdio.h>*/
/*#include <ctype.h>*/
#else
#ifndef _STDLIB_H
#define _STDLIB_H
/* Other stdlib stuff that we've implemented */

extern void *   memset(void *s, int c, __SIZE_TYPE__ n);
extern int      memcmp(const char *s1, const char *s2, int len);
extern char *   strcpy(char *dest, const char *src);
extern char *   strstr(const char *str, const char *substr);
extern int32    strlen(const char *s);
extern void *   memcpy(void *dst, const void *src, __SIZE_TYPE__ nbytes);
extern void *	memcpy6(void *dst, const void *src, __SIZE_TYPE__ nbytes);
extern void *	memcpy4(void *dst, const void *src, __SIZE_TYPE__ nbytes);
extern void *	memcpy40(void *dst, const void *src, __SIZE_TYPE__ nbytes);
extern void		ht_memcpy_ass(void *dst, const void  *src, uint32 clines);
extern void		local_memcpy_ass(void *dst, const void *src, uint32 clines);
extern int32    printf (const char *fmt, ...);
extern int32    sprintf(char *buf, const char *fmt, ...);
extern int      snprintf(char *buf, uint32 str_m, const char *fmt, ...);
extern int32    vsprintf(char8 *d, const char8 * s, va_list ap);
extern int      vsnprintf (char *str, uint32 count, const char *fmt, va_list args);
extern int32	scanf (const char *fmt, ...);
extern int32	sscanf (const char8 *buf, const char8 *fmt, ...);
extern void     bzero(void * dst, __SIZE_TYPE__ length);
extern char *   strtok(char * s, const char * delim);
extern char *   strtok_r(char *s, const char *delim, char **ptrptr);
extern int32    toupper (int32	c);
extern int32    tolower (int32	c);
extern int      libc_check_crc  (int argc, char **argv);
extern int      uncompress(char *dst, unsigned long * dlen, const char * src, unsigned long slen);

extern void *   memchr(const void *s, int c, int n);
extern void *   memmove(void *dst, const void *src, __SIZE_TYPE__ length);

extern char *   strncpy(char8 *dest, const char8 *src, int32 n);
extern char8 *  strcat (char8 *dst, const char8 *src);
extern char8 *  strncat (char8 *dst, char8 *src, __SIZE_TYPE__ n);
extern char8 *  strchr (const char8 *str, char8 c);
extern char8 *  strnchr (char8 *str, char8 c, int32 n);
extern char *   strrchr (char *str, char c);
extern char *   strnrchr (char *str, char c, int n);
extern int32    strcmp(const char8 *str1, const char8 *str2);
extern int32    strncmp(const char8 *str1, const char8 *str2, int32 n);
extern uint64   strtoq(const char *nptr, char **endptr, int base);
extern int32    strcasecmp(const char8 *str1, const char8 *str2);
extern int32    strncasecmp(const char8 *str1, const char8 *str2, int32 n);

extern unsigned long atolx (char8 *p);
extern int32    atoi (const char8 *p);
extern long     atol (char8 *p);
extern int32    atob (uint32* vp, char8 *p, int32 base);
extern int32    llatob (uint64* vp, char8 *p, int32 base);
extern char8 *  btoa (char8 *dst, uint32 value, int32 base);
extern char8 *  llbtoa (char8 *dst, uint64 value, int32 base);

#ifndef PROM
extern char     index(char *s, int c);
#endif
extern int32    getIpAddr( char *ipAddrStr, uint32 *addr);
extern int32    isalpha(int32 c);
extern int32    isdigit(int32 c);
extern int32    islower(int32 c);
extern int32    isupper(int32 c);
extern int32    isprint(int32 c);
extern int32    isspace(int32 c);
extern int32    isxdigit(int32 c);

#endif /* _STDLIB_H */

extern int      srandom_r(uint32, struct random_data *);
extern int      initstate_r(uint32, void *, int n, struct random_data *);
extern int      setstate_r(void *, struct random_data *);
extern int      random_r (struct random_data *, int32 *);
/*
 * Non-reentrant interface.
 */
extern int      random(void);
extern void     srandom(uint32 seed);
#endif

extern uint32   crc32_checksum  (void *ptr, uint32 len, uint32 crc);
extern uint32   uint32_checksum (void *ptr, uint32 len, uint32 cksum);
extern uint32   uint32_checksum_add (uint32 cksum1, uint32 cksum2);
extern uint64   uint64_coreHash (void *ptr, uint64 len, uint64 level);
extern uint32   crc32_zlib      (uint32 crc, void *ptr, uint32 len);

#if !defined(_KERNEL)
extern void     panic(char8 *fmt, ...);
#endif
extern char8 *  _getbase(char8 *p, int32 *basep);
extern int32    atob(uint32 *vp, char8 *p, int32 base);
extern char8 *  btoa(char8 *dst, uint32 value, int32 base);
extern int32    gethex(uint32 *vp, char8 *p, int32 n);
extern uint32   atox(char8 *);
extern uint64   atollx(uint64 *value, char8 *p);
extern int32    strbequ(char8 *s1, char8 *s2);
extern char8 *  strdchr(char8 *p);
extern int      strempty(char8 *p);
extern char8 *  strichr(char8 *p, int32 c);
extern void     strtoupper(char8 *p);
extern int32    striequ(char8 *s1, char8 *s2);
extern int32    strpat(char8 *s1, char8 *s2);
extern char8 *  strposn(char8 *p, char8 *q);
extern char8 *  strccat(char8 *dst, char c);
extern int32    strpat(char8 *s1, char8 *s2);
extern char8 *  strbalp(char8 *p);
extern char8 *  strrpset(char8 *str, char8 *set);
extern void     dummy(void);
extern int32    strequ(char8 *str1, char8 *str2);
extern void     stristr(char8 *dst, char8 *p);
extern void		str_fmt(char8 *p, int32 size, int32 fmt);

#if !defined(LINUX_TEST) && !defined(__OpenBSD__)
extern uint32   ntohl( uint32 tmp );
extern uint32   htonl( uint32 tmp );
extern ushort16 ntohs( ushort16 tmp );
extern ushort16 htons( ushort16 tmp );
extern void     bcopy(const void * src, void * dest, int count);
extern void     qsort(void *array, uint32 n, uint32 es, int (*cmp)());
extern int		strcspn(const char *, const char *);
extern int 		vfscanf(int32 *fp, const char *fmt, va_list ap);
extern int		vsscanf(const char *s, const char *fmt, va_list ap);
extern char8* 	fgets(char8	*dst, int32 max, int32	*fp);
extern int		getchar(void);
extern uint64   strtoll(const char *nptr, char **endptr, int base);

#include <sys/mips.h>
extern int      setjmp(jmp_buf env);
extern void     longjmp(jmp_buf env, int val);
#endif

/*
 * some utilities from hist.c
 */
#ifdef PROM
extern int      get_line(char * p, int usehist);
#else
extern int      get_line(uchar8 * p, int32 usehist);
#endif
extern int      get_cmd(char *p);
#if defined(FS_STANDALONE) || defined(SSC)
extern void     get_input(uchar8 *cmd);
#else
extern int      get_input(char * p);
#endif


#endif	/* LANGUAGE_C */

#endif	/* _LIBC_H */


