/*
 *-----------------------------------------------------------------
 *
 * Name:	memset.c
 *
 * RCS:  $Id: memset.c,v 1.5 2002/07/11 20:04:16 shaun Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

void *
memset(
       void	*			dst,
       int				value,
       __SIZE_TYPE__	nbytes
)
{
	char * addr = dst;
    uint32 nwords;
    char val8 = value & 0xff;
    uint32 val32;
#ifdef R4000
    register uint64 val64;
#endif    
	
    if (nbytes < 8)
    {
        while (nbytes-- > 0)
            *addr++ = val8;

        return(dst);
    }
   
    if (value == 0)
    {
        val32 = 0;
    }
    else
    { 
        val32 = value & 0xff;
        val32 =  ((val32 << 24) | 
                  (val32 << 16) | 
                  (val32 << 8) | 
                  val32);
    }
    
    // the first bytes until 32 bit alignement
    while ((address_t)addr & 0x3)
    {
       *((char *)addr)++ = val8;
       nbytes--;
    }

#ifdef R4000

    if (value == 0)
    {
        val64 = 0;
    }
    else
    { 
        val64 = (uint64)val32;
        val64 = (val64 << 32) | val64;
    }
    
    if ((address_t)addr & 0x7)
    {
       *((uint32 *)addr)++ = val32;
       nbytes -= 4;
    }
    
    nwords = nbytes >> 3;
    while (nwords--)
    {
        *((uint64 *)addr)++ = val64;
    }
    nbytes &= 0x7;

#else
    nwords = nbytes >> 2;
    while (nwords--)
    {
        *((uint32 *)addr)++ = val32;
    }
    nbytes &= 0x3;
#endif

    while (nbytes--)
    {
       *((char *)addr)++ = val8;
    }

    return(dst);
}	/* memset() */



