/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: newbzero.S,v 1.4 2002/10/23 20:51:53 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>

#if __mips >= 3
#define ADDIU   daddiu
#else
#define ADDIU   addiu
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */

	/* a0 = address, a1 = nbytes */

	.set	noreorder

	.globl	fastbzero
	.ent	fastbzero

fastbzero:
	andi	v0,a0,7
	beqz	v0,bzero_aligned
	li		t0,8

	slti	t2,a1,8
	bnez	t2,bzero_rest_byte_loop
	move	t1,a1

	subu	v0,t0,v0
	subu	a1,a1,v0

bzero_unaligned:
	sb		zero,0(a0)
	ADDIU	v0,v0,-1
	bne		v0,zero,bzero_unaligned
	ADDIU	a0,a0,1

bzero_aligned:
	srl		t0,a1,5				/* t0 = number of 32 byte lines */

	beqz	t0,bzero_rest_double
	andi	t1,a1,0x1F			/* t1 = number of bytes in remainder */
	
bzero_aligned_loop:
	ADDIU	t0,t0,-1
	sd		zero,0(a0)
	sd		zero,8(a0)
	sd		zero,16(a0)
	sd		zero,24(a0)
	bne		t0,zero,bzero_aligned_loop
	ADDIU	a0,a0,32

bzero_rest_double:
	beqz	t1,bzero_return

	srl		t0,t1,3				/* t0 = number of doublewords in remainder */
	bne		t0,zero,bzero_rest_doubleword_loop
	andi	t1,t1,7				/* t1 = number of bytes left over */
	bne		t1,zero,bzero_rest_byte_loop
	nop

bzero_return:
	j		ra
	nop

bzero_rest_doubleword_loop:
	ADDIU	t0,t0,-1
	sd		zero,0(a0)
	bne		t0,zero,bzero_rest_doubleword_loop
	ADDIU	a0,a0,8

	beqz	t1,bzero_return
	nop

bzero_rest_byte_loop:
	ADDIU	t1,t1,-1
	sb		zero,0(a0)
	bne		t1,zero,bzero_rest_byte_loop
	ADDIU	a0,a0,1

	b		bzero_return
	nop

	.end	fastbzero

