/*
 *-----------------------------------------------------------------
 *
 * Name:	memcpy.c
 *
 * RCS:  $Id: oldmemcpy.c,v 1.3 2002/10/23 20:51:53 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

extern void fastbzero(void *, int);
extern void old_bzero(void *, int);
extern void *ultranew_memcpy(void *, const void *, int);
extern void *ht_memcpy_fast(void *, const void *, int);

void
bzero (
    void            * dst,
    __SIZE_TYPE__   nbytes
)
{
	if (nbytes >= 128)
		fastbzero(dst, nbytes);
	else
		old_bzero(dst, nbytes);
}

void *
memcpy(
       void	*			dst,
       const void	*	src,
       __SIZE_TYPE__	nbytes
)
{
	char8	* ret = ultranew_memcpy(dst, src, nbytes);
	return (ret);
}

#ifdef SIBYTE
void
ht_memcpy_ass(
       void	*			dst,
       const void	*	src,
       uint32		clines
)
{
	ht_memcpy_fast(dst, src, clines);
}
#endif


void *
oldmemcpy(
       void	*			dst,
       const void	*	src,
       __SIZE_TYPE__	nbytes
)
{

	char8	* ret = (char8 *) dst;

	if (((address_t)dst & 0x1) || ((address_t)src & 0x1)) {

		while (nbytes--)
			*((char *)dst)++ = *((char *)src)++;

	} else if (((address_t)dst & 0x2) || ((address_t)src & 0x2)) {
		int32	nshorts;

		nshorts = nbytes >> 1;
		nbytes %= 2;

		while (nshorts-- > 0)
			*((ushort16 *)dst)++ = *((ushort16 *)src)++;

		while (nbytes-- > 0)
			*((char *)dst)++ = *((char *)src)++;
#if __mips >= 3
	} else if (((address_t)dst & 0x4) || ((address_t)src & 0x4)) {

		int32	nwords;

		nwords = nbytes >> 2;
		nbytes %= 4;

		while (nwords-- > 0)
			*((uint32 *)dst)++ = *((uint32 *)src)++;

		while (nbytes-- > 0)
			*((char *)dst)++ = *((char *)src)++;
	} else {

		int32	nlongs;

		nlongs = nbytes >> 3;
		nbytes %= 8;

		while (nlongs-- > 0)
			*((uint64 *)dst)++ = *((uint64 *)src)++;

		while (nbytes-- > 0)
			*((char *)dst)++ = *((char *)src)++;
	}
#else
	} else {

		int32	nwords;

		nwords = nbytes >> 2;
		nbytes %= 4;

		while (nwords-- > 0)
			*((uint32 *)dst)++ = *((uint32 *)src)++;

		while (nbytes-- > 0)
			*((char *)dst)++ = *((char *)src)++;
	}
#endif

	return(ret);

}	/* memcpy() */

