/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:	printf.c
 *
 * RCS:  $Id: printf.c,v 1.8 2002/12/05 06:48:54 tonyw Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/eee-api.h>
#include <exports/cm-api.h>
#include <exports/rcon-api.h>
#include <exports/serio-api.h>

#ifndef EEE_MGMT
#define EEE_MGMT 2
#endif

char8    printf_buff[512] CPU_PRIVATE;

uint32			already_rconned	CPU_PRIVATE;

/*------------------------------------------------------------------*/
int32
printf (const char *fmt, ...)
{
	va_list		ap;
	int32		len;
	int32		i;
	uint32		destport;
	uint32		srcport;
	uchar8		buff[512];
	rconDataMsg_t	*data_snd = (rconDataMsg_t *)buff;

	va_start(ap, fmt);

	len = vsprintf(printf_buff, fmt, ap);

	va_end (ap);

	/*rcon if rcon flag is set*/
	if (rcon && !already_rconned) {
		already_rconned = 1;

		bzero(buff, sizeof(buff));
		/* form rcon data msg */
		data_snd->hdr.msgType = RCON_DATA;
		data_snd->len = len;
		strncpy(data_snd->buf, printf_buff,len);

		destport = PACK_UNICAST_PORT_ADDRESS(NFX_CARDTYPE_SSC, NFX_SSC_UNIX,
														incoming_appid,
														EEE_MGMT, NFX_COS_HIGH, 0);
		srcport = PACK_UNICAST_PORT_ADDRESS(nfxMySlotId, nfxMyCPUId,
														eee_allocateApplicationId("rcon"),
														EEE_MGMT, NFX_COS_HIGH, 0);
		eee_sendMessage(data_snd, sizeof(rconDataMsg_t) + strlen(data_snd->buf),
																	destport, srcport);
	}

#ifdef USE_WATCHDOG
	watchdog_kick();
#endif
	for (i = 0; i < len; ++i)
		putchar(printf_buff[i]);

	already_rconned = 0;

	return (len);

}	/* printf() */

/*------------------------------------------------------------------*/
int32
tty1_printf (const char *fmt, ...)
{
	va_list		ap;
	int32		len;
	int32		i;

	va_start(ap, fmt);

	len = vsprintf(printf_buff, fmt, ap);

	va_end (ap);

	for (i = 0; i < len; ++i)
		alt_tty_putchar(printf_buff[i]);

#ifdef LINUX_TEST
	fflush(0);
#endif

	return (len);

}

