/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: scanf.c,v 1.5 2002/10/18 02:52:42 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

#define MAXLN	256

#define ISSPACE	" \t\n\r\f\v"

#define stdin	0

/*-----------------------------------------------------------------
 * Name:	scanf()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/22/01
 *
 *-----------------------------------------------------------------
 */
int32
scanf (const char *fmt, ...)
{
	int32	count;
	va_list	ap;
	uchar8	cmd[80];
  
	va_start (ap, fmt);

	memset(cmd,0,80);
	get_line(cmd, 1);

	count = vfscanf (stdin, fmt, ap);

	va_end (ap);

	return (count);

}	/* scanf() */

#if 0
/*************************************************************
 *  fscanf(fp,fmt,va_alist)
 */
int 
fscanf (FILE *fp, const char *fmt, ...)
{
    int             count;
    va_list ap;

    va_start (ap, fmt);
    count = vfscanf (fp, fmt, ap);
    va_end (ap);
    return (count);
}
#endif

/*-----------------------------------------------------------------
 * Name:	vfscanf()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/22/01
 *
 *-----------------------------------------------------------------
 */
int32
vfscanf (
	int32	* fp,
	const char8	* fmt,
	va_list	ap
)
{
	int32	count;
	char8	buf[MAXLN + 1];

	if (fgets (buf, MAXLN, fp) == 0)
		return (-1);

	count = vsscanf (buf, fmt, ap);

	return (count);

}	/* vfscanf() */

/*-----------------------------------------------------------------
 * Name:	sscanf()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/22/01
 *
 *-----------------------------------------------------------------
 */
int32 
sscanf (const char8 *buf, const char8 *fmt, ...)
{
	int32	count;
	va_list	ap;
    
	va_start (ap, fmt);
	count = vsscanf (buf, fmt, ap);
	va_end (ap);

	return (count);

}	/* sscanf() */

/*-----------------------------------------------------------------
 * Name:	vsscanf()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/22/01
 *
 *-----------------------------------------------------------------
 */
int32
vsscanf (
	const char8	* buf,
	const char8	* s,
	va_list	ap
)
{
	int32	count, noassign, width, base = 0, lflag;
	char8	*t, tmp[MAXLN];

	count = noassign = width = lflag = 0;
	while (*s && *buf) {
		while (isspace (*s))
			s++;
		if (*s == '%') {
			s++;
			for (; *s; s++) {
				if (strchr ("dibouxcsefg%", *s))
					break;
				if (*s == '*')
					noassign = 1;
				else if (*s == 'l' || *s == 'L')
					lflag = 1;
				else if (*s >= '1' && *s <= '9') {
					for (t = (char *)s; isdigit (*s); s++);
					strncpy (tmp, t, s - t);
					tmp[s - t] = '\0';
					atob (&width, tmp, 10);
					s--;
				}
			}
			if (*s == 's') {
				while (isspace (*buf))
					buf++;
				if (!width)
					width = strcspn (buf, ISSPACE);
				if (!noassign) {
					strncpy (t = va_arg (ap, char *), buf, width);
					t[width] = '\0';
				}
				buf += width;
			} else if (*s == 'c') {
				if (!width)
					width = 1;
				if (!noassign) {
					strncpy (t = va_arg (ap, char *), buf, width);
					t[width] = '\0';
				}
				buf += width;
			} else if (strchr ("dobxu", *s)) {
				while (isspace (*buf))
					buf++;
				if (*s == 'd' || *s == 'u')
					base = 10;
				else if (*s == 'x')
					base = 16;
				else if (*s == 'o')
					base = 8;
				else if (*s == 'b')
					base = 2;
				if (!width) {
					if (isspace (*(s + 1)) || *(s + 1) == 0)
						width = strcspn (buf, ISSPACE);
					else
						width = strchr (buf, *(s + 1)) - buf;
				}
				strncpy (tmp, buf, width);
				tmp[width] = '\0';
				buf += width;
				if (!noassign)
					atob (va_arg (ap, void *), tmp, base);
			}
			if (!noassign)
				count++;
			width = noassign = lflag = 0;
			s++;
		} else {
			while (isspace (*buf))
				buf++;
			if (*s != *buf)
				break;
			else
				s++, buf++;
		}
	}

	return (count);

}	/* vsscanf() */

