/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: str_fmt.c,v 1.1.1.1 2001/07/04 00:17:15 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: format p in a field size in width using fmt
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include "libc.h"

void
str_fmt(
	char8	* p,
	int32	size,
	int32	fmt
)
{
	int32	n, m, len;

	len = strlen (p);
	switch (fmt) {
		case FMT_RJUST:
				for (n = size - len; n > 0; n--)
					strichr (p, ' ');
				break;
		case FMT_LJUST:
				for (m = size - len; m > 0; m--)
					strcat (p, " ");
				break;
		case FMT_RJUST0:
				for (n = size - len; n > 0; n--)
					strichr (p, '0');
				break;
		case FMT_CENTER:
				m = (size - len) / 2;
				n = size - (len + m);
				for (; m > 0; m--)
					strcat (p, " ");
				for (; n > 0; n--)
					strichr (p, ' ');
				break;
	}

}	/* str_fmt() */


