/*
 *-----------------------------------------------------------------
 *
 * Name:	strncpy.c
 *
 * RCS:  $Id: strncpy.c,v 1.2 2002/10/18 02:52:42 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: copy n chars from src to dst
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/7/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

char8 *
strncpy (
	char8	    * dst,
	const char8	* src,
	int32	    n
)
{
	char           *d;

	if (!dst || !src)
		return (dst);

	d = dst;

	for (; *src && n; d++, src++, n--)
		*d = *src;

	while (n--)
		*d++ = '\0';

	return (dst);

}	/* strncpy() */

