/*
 *-----------------------------------------------------------------
 *
 * Name:        load-bobcat.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description: Definitions for Bobcat platform related autoload code.
 *
 * Created by:  Shaun Hui
 *
 * Date Created: 9/21/04
 *
 *-----------------------------------------------------------------
 */
#ifndef _LOAD_BC_H
#define _LOAD_BC_H

#define CNTRL(x)				((x) & 0x1f)

// defines for module names
#define LOAD_BC_SSC_NAME		"SSC"
#define LOAD_BC_TXRX_NAME		"TXRX"
#define LOAD_BC_FP_NAME			"FP"
#define LOAD_BC_FC_NAME			"FC"

// defines for image names
#define LOAD_BC_SSC_IMAGE		"bsd"
#define LOAD_BC_TXRX_IMAGE		"txrx_bc.bin"
#define LOAD_BC_FP_IMAGE		"fp_bc.bin"
#define LOAD_BC_FC_IMAGE		"fc_bc.bin"

// defines for load addresses
#define LOAD_BC_SSC_ADDR		0x83000000
#define LOAD_BC_TXRX_ADDR		0x9a000000
#define LOAD_BC_FP_ADDR			0x9b000000
#define LOAD_BC_FC_ADDR			0x13000000

// defines for module id
#define LOAD_BC_SSC_ID			0
#define LOAD_BC_TXRX_ID			1
#define LOAD_BC_FP_ID			2
#define LOAD_BC_FC_ID			3
#define LOAD_BC_MIN_ID			(LOAD_BC_SSC_ID)
#define LOAD_BC_MAX_ID			(LOAD_BC_FC_ID+1)

// defines for load device id
#define LOAD_BC_DEV_ID_MIN		0				// wd0
#define LOAD_BC_DEV_ID_MAX		1				// wd1

// defines for auto load states
#define LOAD_BC_STATE_PROM_INIT			1		// PROM initialized
#define LOAD_BC_STATE_RT_LOADING		2		// Run time loading
#define LOAD_BC_STATE_RT_LOADED 		3		// Run time load complete
/* WTG these 2 not used */
#define LOAD_BC_STATE_RT_INIT 			4		// Run time initializing
#define LOAD_BC_STATE_RT_UP 			5		// Run time is up

// diag run defines
#define LOAD_BC_STATE_DIAG_INIT 		6		// Diags initializing
#define LOAD_BC_STATE_DIAG_STOPPED 		7		// Diags 
#define LOAD_BC_STATE_DIAG_RUNNING 		8		// Diags 
#define LOAD_BC_STATE_DIAG_PASS 		9		// Diags 
#define LOAD_BC_STATE_DIAG_FAIL 		10		// Diags 
#define LOAD_BC_STATE_DIAG_MENU 		11		// Diags 
#define LOAD_BC_STATE_DIAG_EXECUTE 		12		// Diags 
#define LOAD_BC_STATE_DIAG_TIMEOUT 		13		// Diags 
#define LOAD_BC_STATE_DIAG_PROM_PROMPT 		14		// Diags 
#define LOAD_BC_STATE_DIAG_PROM_CRASHED 	15		// Diags 


#define LOAD_BC_SRAM_OFFSET				0x0200

typedef struct 
{
	uint32		load_addr;
	char		*load_name;
	char		*mod_name;
} load_bc_tbl_t;

typedef struct 
{
	int32	state_ssc[LOAD_BC_MAX_ID];
	int32	state_mod[LOAD_BC_MAX_ID];
} load_cb_t;

#endif	// _LOAD_BC_H
