/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: load-net.c,v 1.7 2002/09/27 22:31:22 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/4/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/tftp-api.h>
#include "load.h"

#ifdef NEW_LOADER

int32	load_busy;
int32	load_ret;

extern void	* binary_addr;

/*-----------------------------------------------------------------
 * Name:	load_net
 *
 * Description: Load file, fname, from ip address, ipAddr
 *
 *				Returns NFX_OK on successful load, or -1 on tftp error
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/11/02
 *
 *-----------------------------------------------------------------
 */
int32
load_net(
	char8	* fname,
	uint32	ipAddr,
	address_t	addr,
	uint32	* nbytes
)
{
	void	* fd;

	printf("loading %s from 0x%x", fname, ipAddr);

	if (addr == EMBEDDED_ADDR) {
		binary_addr = 0;
		printf("\n");
	}
	else {
		binary_addr = (void *)addr;
		printf(" at %p\n", binary_addr);
		set_entry_addr((long)binary_addr); 
	}

	/*
	 * Start tftp session with SSC
	 */
	fd = tftp_open(fname, ipAddr, load_cmdDataInd, load_cmdEventInd);
	if (!fd) {
		printf("Error opening remote file, %s\n", fname);
		return -1;
	}

	load_busy = 1;

	/*
	 * Spin, loading rest of file, until EOF or TIMEOUT, or other tftp ERROR
	 */
	while (1) {
		eee_poll(1);
		if (!load_busy)
			break;
	}

	if (addr != EMBEDDED_ADDR) {
		printf("binary load, %ld bytes (0x%lx)\n",
                (address_t)binary_addr - addr,
                (address_t)binary_addr - addr);
		if (nbytes)
			*nbytes = (address_t)binary_addr - addr;
	}

	return load_ret;
}

#endif
