/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: load.h,v 1.7 2002/09/30 22:56:10 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/11/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _LOAD_H
#define _LOAD_H

#define NEW_LOADER

extern int32 load_cmdDataInd(char8 * pData, int32 size);
extern int load_cmdEventInd(void * tftpCb, int32 event);
int32   load_flash(char * fname, address_t	addr, uint32 * nbytes);
int32   load_net(char8	* fname, uint32	ipAddr, address_t addr, uint32 * nbytes);
void    load_get_fname(uint32 card_type, uint32	slot, uint32 cpu, uchar8 * fname);
int32   load_get_format(uchar8 * line);
void    load_add_line(uchar8 * buf, uint32 size);
uchar8 *load_get_line(void);
int32   load_load_line(uchar8 * lp, int32 format);
void    load_set_toshiba_boot_block(void);
void    load_set_toshiba_jump_block(void);
void    load_set_fp_boot_block(uint32);
void    load_set_fp_jump_block();
void    set_entry_addr(long addr);

#define LOADER_FNAME_TXRX		1
#define LOADER_FNAME_FP			2
#define LOADER_FNAME_SP			3		/* fiber channel */

#define EMBEDDED_ADDR			0xffffffff

#define LOADER_ERR			-1
#define LOADER_BREAK		-2

#define FP_BOOT_BLOCK_SIGNATURE	0x15263748
#define FP_JUMP_BLOCK_SIGNATURE	0x596A7B8D

typedef struct _fp_boot {
	uint32	signature;
	uchar8	* src;
	uchar8	* dest;
	uint32	len;
} load_fp_boot_block_t;

typedef struct _fp_jump {
	uint32		signature;
	address_t	entry_addr;
} load_fp_jump_block_t;

#endif	/* _LOAD_H */

