/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:        lock-mem.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2002, ClariStor Inc.
 *
 * Description: Byte range lock memory management function prototypes.
 *
 * Created by:  Xiaobing Zhang
 *
 * Date Created:    11/09/2002
 *
 *-----------------------------------------------------------------
 */

#ifndef _LOCK_MEM_H
#define _LOCK_MEM_H

/*--------------------
 * Function Prototypes
 *--------------------
 */
lock_cifsLockOwner_t *  
lock_memAllocCifsLockOwner(uint16         tid,
				           uint16         fid,
				           uint16         pid,
						   vs_mem_index_t *lockOwnerIdxp);

int32
lock_memFreeCifsLockOwner(vs_mem_index_t  lockOwnerIdx);

lock_nlmLockClient_t *
lock_memAllocNlmLockClient(ip_index_t		clientIpAddr,
						   int32			state,
						   int32			pid,
						   uint16			callerNameLen,
						   char			*callerName,
						   vs_mem_index_t	*lockClientIdxp);

int32
lock_memFreeNlmLockClient(vs_mem_index_t		lockClientIdx,
                          lock_nlmLockClient_t	*lockClientp);

lock_nlmLockOwner_t *  
lock_memAllocNlmLockOwner(vs_mem_index_t		lockClientIdx,
						  lock_nlmLockClient_t	*lockClientp,
						  int32					pid,
						  uint16				ownerNameLen,
						  char					*ownerName,
						  vs_mem_index_t		fcb,
						  vs_mem_index_t		*lockOwnerIdxp);

int32
lock_memFreeNlmLockOwner(vs_mem_index_t         lockOwnerIdx,
                         lock_nlmLockOwner_t    *lockOwnerp);

lock_dependency_t *
lock_memAllocDependency(vs_mem_index_t  lockOwnerIdx,
                        vs_mem_index_t  *dependencyIdxp);

int32
lock_memFreeDependency(vs_mem_index_t   dependencyIdx);

lock_ownerTimeout_t *
lock_memAllocOwnerTimeout(vs_mem_index_t    ownerClientIdx,
                          vs_mem_index_t    *ownerTimeoutIdxp);

int32
lock_memFreeOwnerTimeout(vs_mem_index_t ownerTimeoutIdx);

lock_cifsLockInfo_t *
lock_memAllocCifsLockInfo(vs_mem_index_t 		cifsLockOwnerIdx,
						  lock_cifsLockOwner_t  *cifsLockOwnerp,
				          uint64     			offset,
						  uint64      			len,
						  vs_mem_index_t 		*cifsLockInfoIdxp);

int32
lock_memFreeCifsLockInfo(vs_mem_index_t			lockInfoIdx,
						 lock_cifsLockInfo_t	*lockInfop);

lock_nlmLockInfo_t *
lock_memAllocNlmLockInfo(vs_mem_index_t			nlmLockOwnerIdx,
						 lock_nlmLockOwner_t	*nlmLockOwnerp,
						 uint64					offset,
						 uint64					len,
						 vs_mem_index_t			fcb,
						 vs_mem_index_t			*nlmLockInfoIdxp);

int32
lock_memFreeNlmLockInfo(vs_mem_index_t		lockInfoIdx,
						lock_nlmLockInfo_t	*lockInfop);

int32
lock_memFreeLockInfo(vs_mem_index_t	lockInfoIdx,
					 void			*lockInfop);

lock_exLock_t *
lock_memAllocExLock(vs_mem_index_t	lockInfoIdx,
					vs_mem_index_t	*exLockIdxp);

int32
lock_memFreeExLock(vs_mem_index_t	exLockIdx,
				   lock_exLock_t	*exLockp);

lock_shLock_t *
lock_memAllocShLock(vs_mem_index_t	lockInfoIdx,
					vs_mem_index_t	*shLockIdxp);

int32
lock_memFreeShLock(vs_mem_index_t	shLockIdx,
				   lock_shLock_t	*shLockp);

lock_shNode_t *
lock_memAllocShNode(vs_mem_index_t	shLockIdx,
					lock_shLock_t	*shLockp,
					vs_mem_index_t	*shNodeIdxp);

int32
lock_memFreeShNode(lock_fileLock_t	*fileLockp,
				   vs_mem_index_t	shNodeIdx,
				   lock_shNode_t	*shNodep,
				   boolean			freeShLock);

lock_pendingLock_t *
lock_memAllocPendingLock(lock_fileLock_t	*fileLockp,
						 vs_mem_index_t		lockInfoIdx,
						 uint8				lockType,
						 eeeRTC_t			timeout,
						 vs_mem_index_t		ulPrivate,
						 vs_mem_index_t		*pendLockIdxp);

int32
lock_memFreePendingLock(vs_mem_index_t	  pendLockIdx,
					   lock_pendingLock_t *pendLockp,
					   boolean			  delLockInfo);

lock_fileLock_t *
lock_memAllocFileLock(vs_mem_index_t	*fileLockIdxp);

int32
lock_memFreeFileLock(vs_mem_index_t		*fileLockIdxp,
					 lock_fileLock_t	*fileLockp);

#endif /* _LOCK_MEM_H */

