/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:        lock-proc.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2002, ClariStor Inc.
 *
 * Description: Lock processing functions prototypes.
 *
 * Created by:  Xiaobing Zhang
 *
 * Date Created:    12/03/2002
 *
 *-----------------------------------------------------------------
 */
#ifndef _LOCK_PROC_H
#define _LOCK_PROC_H

/*--------------------
 * Function prototypes
 *--------------------
 */
int32
lock_addExclLock(lock_fileLock_t	*fileLockp,
				 vs_mem_index_t		newLockInfoIdx,
				 void				*newLockInfop,
				 uint8				newLockOwnerType,
				 vs_mem_index_t		*lockIdxp);

int32
lock_addSharedLock(lock_fileLock_t	*fileLockp,
				   vs_mem_index_t	newLockInfoIdx,
				   void				*newLockInfop,
				   uint8			newLockOwnerType,
				   vs_mem_index_t	*lockIdxp);

int32
lock_addPendingLock(lock_fileLock_t	*fileLockp,
					void			*newLockInfop,
					uint8			newLockOwnerType,
					uint8			newLockType,
					eeeRTC_t		newLockTimeout,
					vs_mem_index_t	newLockUlPrivate);

int32
lock_addGrantedLock(lock_fileLock_t *fileLockp,
					vs_mem_index_t	newLockInfoIdx,
					void			*newLockInfop,
					uint8			newLockOwnerType,
					uint8			newLockType);

int32
lock_procLock(lock_fileLock_t *fileLockp,
			  void            *lockInfop,
			  uint8           lockOwnerType,
			  uint8			  lockType,
			  eeeRTC_t		  timeout,
			  vs_mem_index_t  ulPrivate);

int32
lock_delCifsExclLock(lock_fileLock_t		*fileLockp,
					 lock_cifsLockInfo_t	*lockInfop,
					 lock_exLock_t			*exLockp);

int32
lock_delNlmExclLock(lock_fileLock_t		*fileLockp,
					lock_nlmLockInfo_t	*lockInfop,
					lock_exLock_t		*exLockp);

int32
lock_delExclLock(lock_fileLock_t	*fileLockp,
				 void				*lockInfop,
				 uint8				lockOwnerType,
				 lock_exLock_t		*exLockp);

int32
lock_delCifsSharedLock(lock_fileLock_t	*fileLockp,
					   void				*lockInfop,
					   lock_shLock_t	*shLockp,
					   lock_shNode_t	*shNodep,
					   vs_mem_index_t	prevShLockIdx);

int32
lock_delNlmSharedLock(lock_fileLock_t	*fileLockp,
					 void				*lockInfop,
					 lock_shLock_t		*shLockp,
					 lock_shNode_t		*shNodep,
					 vs_mem_index_t		prevShLockIdx);

int32
lock_delSharedLock(lock_fileLock_t	*fileLockp,
				   void				*lockInfop,
				   uint8			lockOwnerType,
				   lock_shLock_t	*shLockp,
				   lock_shNode_t	*shNodep,
				   vs_mem_index_t	prevShLockIdx);

int32
lock_procUnlockSingle(lock_fileLock_t *fileLockp,
			  		  void            *lockInfop,
			  		  uint8           lockOwnerType,
					  uint8			  lockType);

int32
lock_unlockExclAll(lock_fileLock_t	*fileLockp,
				   uint32			key,
				   uint32			clientIpAddr,
				   uint16			searchMask);

int32
lock_unlockSharedAll(lock_fileLock_t	*fileLockp,
					 uint32				key,
					 uint32				clientIpAddr,
					 uint16				searchMask);

int32
lock_deletePendingAll(lock_fileLock_t	*fileLockp,
					  uint32			key,
					  uint32			clientIpAddr,
					  uint16			searchMask);

int32
lock_procUnlockAll(vs_mem_index_t	fileLockIdx,
				   uint32			key,
				   uint32			clientIpAddr,
				   uint16			searchMask);

#endif /* _LOCK_PROC_H */

