/*  
 *=============================================================================
 * File Name   :    lsi8104.h
 *
 *  Description:    
 *
 *  Created    :    01-02-2002
 *
 *  Author     :    Tony Wong
 *
 *  Copyright(c)  Agile Storage, Inc. 2002
 *=============================================================================
 */

#include <nfx-incl.h>
#include <exports/eee-api.h>
#include <exports/cm-api.h>

#ifndef LSI_8104_H_INCLUDED
#define LSI_8104_H_INCLUDED

#ifdef GARFIELD_LUC_TEST
#define LSI_MAX_NUM_DEVICES		1
#define LSI_GMAC_BASE_ADDR		0xbf100000 
#define LSI_GMAC_RDWR_ADDR		0xbf400010
#else
#define LSI_MAX_NUM_DEVICES		6
#define LSI_NUM_DEVICES_FP		6
#define LSI_NUM_DEVICES_TXRX	4
#define LSI_GMAC_BASE_ADDR0		0xffffffffbe000000ll
#define LSI_GMAC_BASE_ADDR1		0xffffffffbe100000ll
#define LSI_GMAC_BASE_ADDR2		0xffffffffbe200000ll
#define LSI_GMAC_BASE_ADDR3		0xffffffffbe300000ll
#define LSI_GMAC_BASE_ADDR4		0xffffffffbe400000ll
#define LSI_GMAC_BASE_ADDR5		0xffffffffbe500000ll
#endif

#define LSI_GMAC_MAC1			0x00 /* high order */
#define LSI_GMAC_MAC2			0x01
#define LSI_GMAC_MAC3			0x02 /* low order */
#define LSI_GMAC_FILTER1		0x03 /* 0xffff to pass all */
#define LSI_GMAC_FILTER2		0x04 /* 0xffff to pass all */
#define LSI_GMAC_FILTER3		0x05 /* 0xffff to pass all */
#define LSI_GMAC_FILTER4		0x06 /* 0xffff to pass all */
#define LSI_GMAC_CONFIG1		0x07
#define LSI_GMAC_CONFIG2		0x08
#define LSI_GMAC_CONFIG3		0x09
#define LSI_GMAC_CONFIG4		0x0a
#define LSI_GMAC_STATUS			0x0b
#define LSI_GMAC_STATUSMASK		0x0e
#define LSI_GMAC_TX_THRESH		0x11
#define LSI_GMAC_RX_THRESH		0x12
#define LSI_GMAC_FLOWCTRL1		0x13
#define LSI_GMAC_FLOWCTRL2		0x14
#define LSI_GMAC_AN_BASETX		0x15
#define LSI_GMAC_AN_BASERX		0x16
#define LSI_GMAC_AN_NEXTTX		0x17
#define LSI_GMAC_AN_NEXTRX		0x18
#define LSI_GMAC_DEVICEID		0x20

#define LSI_GMAC_HALFFULL1		0x70
#define LSI_GMAC_HALFFULL2		0x71
#define LSI_GMAC_HALFFULL3		0x72
#define LSI_GMAC_HALFFULL4		0x73
#define LSI_GMAC_HF_MASK1		0x78
#define LSI_GMAC_HF_MASK2		0x79
#define LSI_GMAC_HF_MASK3		0x7a
#define LSI_GMAC_HF_MASK4		0x7b

#define LSI_GMAC_RX_DROPS0		0x80
#define LSI_GMAC_RX_DROPS1		0x81
#define LSI_GMAC_OCTETS0		0x82
#define LSI_GMAC_OCTETS1		0x83
#define LSI_GMAC_PKTS0			0x84
#define LSI_GMAC_PKTS1			0x85
#define LSI_GMAC_BCASTPKTS0		0x86
#define LSI_GMAC_BCASTPKTS1		0x87
#define LSI_GMAC_MCASTPKTS0		0x88
#define LSI_GMAC_MCASTPKTS1		0x89
#define LSI_GMAC_CRCALIGN0		0x8a
#define LSI_GMAC_CRCALIGN1		0x8b
#define LSI_GMAC_UNDERSIZE0		0x8c
#define LSI_GMAC_UNDERSIZE1		0x8d
#define LSI_GMAC_OVERSIZE0		0x8e
#define LSI_GMAC_OVERSIZE1		0x8f
#define LSI_GMAC_FRAGMENT0		0x90
#define LSI_GMAC_FRAGMENT1		0x91
#define LSI_GMAC_JABBER0		0x92
#define LSI_GMAC_JABBER1		0x93
#define LSI_GMAC_COLLISION0		0x94
#define LSI_GMAC_COLLISION1		0x95
#define LSI_GMAC_64_RX0			0x96
#define LSI_GMAC_64_RX1			0x97
#define LSI_GMAC_65_127RX0		0x98
#define LSI_GMAC_65_127RX1		0x99
#define LSI_GMAC_128_255RX0		0x9a
#define LSI_GMAC_128_255RX1		0x9b
#define LSI_GMAC_256_511RX0		0x9c
#define LSI_GMAC_256_511RX1		0x9d
#define LSI_GMAC_512_1023RX0	0x9e
#define LSI_GMAC_512_1023RX1	0x9f
#define LSI_GMAC_1024_1518RX0	0xa0
#define LSI_GMAC_1024_1518RX1	0xa1
#define LSI_GMAC_OCTETS_TX0		0xa2
#define LSI_GMAC_OCTETS_TX1		0xa3
#define LSI_GMAC_PKTS_TX0		0xa4
#define LSI_GMAC_PKTS_TX1		0xa5
#define LSI_GMAC_BCAST_TX0		0xa6
#define LSI_GMAC_BCAST_TX1		0xa7
#define LSI_GMAC_MCAST_TX0		0xa8
#define LSI_GMAC_MCAST_TX1		0xa9

#define LSI_GMAC_64_TX0			0xaa
#define LSI_GMAC_64_TX1			0xab
#define LSI_GMAC_65_127TX0		0xac
#define LSI_GMAC_65_127TX1		0xad
#define LSI_GMAC_128_255TX0		0xae
#define LSI_GMAC_128_255TX1		0xaf
#define LSI_GMAC_256_511TX0		0xb0
#define LSI_GMAC_256_511TX1		0xb1
#define LSI_GMAC_512_1023TX0	0xb2
#define LSI_GMAC_512_1023TX1	0xb3
#define LSI_GMAC_1024_1518TX0	0xb4
#define LSI_GMAC_1024_1518TX1	0xb5

#define LSI_GMAC_TX_DISC0       0xc2
#define LSI_GMAC_TX_DISC1       0xc3
#define LSI_GMAC_TX_BAD0        0xc4
#define LSI_GMAC_TX_BAD1        0xc5
#define LSI_GMAC_RX_SYM0        0xe2
#define LSI_GMAC_RX_SYM1        0xe3
#define LSI_GMAC_TX_CTRL0		0xe6
#define LSI_GMAC_TX_CTRL1		0xe7
#define LSI_GMAC_RX_CTRL0		0xe8
#define LSI_GMAC_RX_CTRL1		0xe9

typedef union _lsi_conf1
{
	uint16 wd;
	struct {
#if 0
		uint16 reset:1;		/* 1 to reset controller */
		uint16 rxrst:1; 	/* 1 to reset Rx */
		uint16 txrst:1; 	/* 1 to reset Tx */
		uint16 anrst:1; 	/* 1 to restart auto-neg */
		uint16 cntrst:1; 	/* 1 to reset counters */
		uint16 autopad:1;	/* 1 to auto pad Tx */
		uint16 ipg:3; 		/* interpacket gap */
		uint16 txprmbl:1;	/* 1 to Tx preamble */
		uint16 txcrc:1;		/* 1 to Tx crc */
		uint16 rxprmbl:1;	/* 1 to Rx preamble */
		uint16 rxcrc:1;		/* 1 to Rx crc */
		uint16 rxstatus:2;	/* Rx status word */
		uint16 rxeof:1;		/* Rx EOF position */
#else
		uint16 rxeof:1;		/* Rx EOF position */
		uint16 rxstatus:2;	/* Rx status word */
		uint16 rxcrc:1;		/* 1 to Rx crc */
		uint16 rxprmbl:1;	/* 1 to Rx preamble */
		uint16 txcrc:1;		/* 1 to Tx crc */
		uint16 txprmbl:1;	/* 1 to Tx preamble */
		uint16 ipg:3; 		/* interpacket gap */
		uint16 autopad:1;	/* 1 to auto pad Tx */
		uint16 cntrst:1; 	/* 1 to reset counters */
		uint16 anrst:1; 	/* 1 to restart auto-neg */
		uint16 txrst:1; 	/* 1 to reset Tx */
		uint16 rxrst:1; 	/* 1 to reset Rx */
		uint16 reset:1;		/* 1 to reset controller */
#endif
	} bits;
} lsi_gmac_conf1_t;

typedef union _lsi_conf2
{
	uint16 wd;
	struct {
#if 0
		uint16 rxucast:1;	/* Rx unicast mode */
		uint16 rxmcast:1;	/* Rx multicast mode */
		uint16 rxbcast:1;	/* Rx broadcast mode */
		uint16 rxreject:1;	/* Rx reject mode */
		uint16 rxaccept:1;	/* Rx accept mode */
		uint16 discoflow:1;	/* discard overflow */
		uint16 disccrc:1;	/* discard crc errored */
		uint16 discusize:1;	/* discard undersized */
		uint16 discosize:1;	/* discard oversized */
		uint16 disccode:1;	/* discard code errored */
		uint16 discabort:1;	/* discard Rx aborted */
		uint16 rsvd:5;		/* reserved */
#else
		uint16 rsvd:5;		/* reserved */
		uint16 discabort:1;	/* discard Rx aborted */
		uint16 disccode:1;	/* discard code errored */
		uint16 discosize:1;	/* discard oversized */
		uint16 discusize:1;	/* discard undersized */
		uint16 disccrc:1;	/* discard crc errored */
		uint16 discoflow:1;	/* discard overflow */
		uint16 rxaccept:1;	/* Rx accept mode */
		uint16 rxreject:1;	/* Rx reject mode */
		uint16 rxbcast:1;	/* Rx broadcast mode */
		uint16 rxmcast:1;	/* Rx multicast mode */
		uint16 rxucast:1;	/* Rx unicast mode */
#endif
	} bits;
} lsi_gmac_conf2_t;

typedef union _lsi_conf3
{
	uint16 wd;
	struct {
#if 0
		uint16 rsvd:2;		/* reserved */
		uint16 autoclr:1;	/* auto clear mode */
		uint16 autoabort:1;	/* auto Rx abort */
		uint16 cntreset:1;	/* counter reset on read */
		uint16 cntroll:1;	/* counter rollover enable */
		uint16 ewrap:1;		/* EWRAP pin assert */
		uint16 lckref:1;	/* LCKREFn pin assert */
		uint16 encdet:1;	/* EN_CDET pin assert */
		uint16 anenable:1;	/* auto-neg enable */
		uint16 rxmax:2;		/* Rx MAX packet size */
		uint16 rxabort:1;	/* RXABORT pin assert */
		uint16 sysdis:1;	/* system interface disable */
		uint16 fcntrl:1;	/* FCNTRL pin disable */
		uint16 sdenable:1;	/* SD pin enable */
#else
		uint16 sdenable:1;	/* SD pin enable */
		uint16 fcntrl:1;	/* FCNTRL pin disable */
		uint16 sysdis:1;	/* system interface disable */
		uint16 rxabort:1;	/* RXABORT pin assert */
		uint16 rxmax:2;		/* Rx MAX packet size */
		uint16 anenable:1;	/* auto-neg enable */
		uint16 encdet:1;	/* EN_CDET pin assert */
		uint16 lckref:1;	/* LCKREFn pin assert */
		uint16 ewrap:1;		/* EWRAP pin assert */
		uint16 cntroll:1;	/* counter rollover enable */
		uint16 cntreset:1;	/* counter reset on read */
		uint16 autoabort:1;	/* auto Rx abort */
		uint16 autoclr:1;	/* auto clear mode */
		uint16 rsvd:2;		/* reserved */
#endif
	} bits;
} lsi_gmac_conf3_t;

typedef union _lsi_conf4
{
	uint16 wd;
	struct {
#if 0
		uint16 endian:1;	/* 1=Big */
		uint16 bussize:1;	/* 1=16, 0=32 bits width */
		uint16 rsvd1:1;		/* reserved */
		uint16 loopback:1;	/* 1=loopback */
		uint16 downflush:1;	/* 1=flush FIFO when link down */
		uint16 txdisable:1;	/* 1=Tx disable */
		uint16 rsvd2:2;		/* reserved */
		uint16 cntmaxsize:2;/* counter max packet size */
		uint16 rsvd3:6;		/* reserved */
#else
		uint16 rsvd3:6;		/* reserved */
		uint16 cntmaxsize:2;/* counter max packet size */
		uint16 rsvd2:2;		/* reserved */
		uint16 txdisable:1;	/* 1=Tx disable */
		uint16 downflush:1;	/* 1=flush FIFO when link down */
		uint16 loopback:1;	/* 1=loopback */
		uint16 rsvd1:1;		/* reserved */
		uint16 bussize:1;	/* 1=16, 0=32 bits width */
		uint16 endian:1;	/* 1=Big */
#endif
	} bits;
} lsi_gmac_conf4_t;

typedef union _lsi_status
{
	uint16 wd;
	struct {
#if 0
		uint16 rxsync:1;	/* Rx synchronized */
		uint16 rsvd1:2;		/* reserved */
		uint16 sigdetect:1; /* 1 if SD pin is HIGH */
		uint16 link:1;		/* 1 if link pass */
		uint16 rsvd2:3;		/* reserved */
		uint16 an_np:1;		/* auto-neg next page status */
		uint16 an_txnp:1;	/* auto-neg Tx next page status */
		uint16 an_rxnp:1;	/* auto-neg Rx next page status */
		uint16 an_rxbp:1;	/* auto-neg Rx base page status */
		uint16 an_rmstrt:1;	/* auto-neg remote restart status */
		uint16 rsvd3:3;		/* reserved */
#else
		uint16 rsvd3:3;		/* reserved */
		uint16 an_rmstrt:1;	/* auto-neg remote restart status */
		uint16 an_rxbp:1;	/* auto-neg Rx base page status */
		uint16 an_rxnp:1;	/* auto-neg Rx next page status */
		uint16 an_txnp:1;	/* auto-neg Tx next page status */
		uint16 an_np:1;		/* auto-neg next page status */
		uint16 rsvd2:3;		/* reserved */
		uint16 link:1;		/* 1 if link pass */
		uint16 sigdetect:1; /* 1 if SD pin is HIGH */
		uint16 rsvd1:2;		/* reserved */
		uint16 rxsync:1;	/* Rx synchronized */
#endif
	} bits;
} lsi_gmac_status_t;


typedef union _lsi_status_mask
{
	uint16 wd;
	struct {
#if 0
		uint16 mask_rsync:1;/* mask resync interrupt */
		uint16 rsvd1:3;		/* reserved */
		uint16 mask_link:1;	/* mask link interrupt */
		uint16 rsvd2:3;		/* reserved */
		uint16 mask_an_np:1;/* mast auto-neg next page interrupt */
		uint16 rsvd3:3;		/* reserved */
		uint16 mask_an_rmstrt:1;/* mast auto-neg next page interrupt */
		uint16 rsvd4:3;		/* reserved */
#else
		uint16 rsvd4:3;		/* reserved */
		uint16 mask_an_rmstrt:1;/* mast auto-neg next page interrupt */
		uint16 rsvd3:3;		/* reserved */
		uint16 mask_an_np:1;/* mast auto-neg next page interrupt */
		uint16 rsvd2:3;		/* reserved */
		uint16 mask_link:1;	/* mask link interrupt */
		uint16 rsvd1:3;		/* reserved */
		uint16 mask_rsync:1;/* mask resync interrupt */
#endif
	} bits;
} lsi_gmac_statusmask_t;
#endif /* LSI_8104_H_INCLUDED */
