/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:        luc-utils.h
 *
 * RCS:  $Id: luc-utils.h,v 1.6 2001/12/03 21:59:00 shaun Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description: Function prototypes for luc-utils.c.
 *
 * Created by:	Shaun Hui
 *
 * Date Created: 05/01/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _LUC_UTILS_H
#define _LUC_UTILS_H

#define LUC_TRACE_ALL		0x0000001F
#define LUC_TRACE_PKT		0x00000001
#define LUC_TRACE_TRD		0x00000002
#define LUC_TRACE_TCD		0x00000004
#define LUC_TRACE_RCD		0x00000008
#define LUC_TRACE_FBD		0x00000010

void luc_setTxMode( int32 link, int32 mode);
void luc_setRxMode( int32 link, int32 mode);
void luc_setLbkMode( int32 link, int32 mode);
void luc_setVlanMode( int32 link, int32 mode);
void luc_setDbgMode( int32 mode);
void luc_setRstMode( int32 mode);
void luc_setStatsUpdMode( int32 mode);
void luc_setLinkAggrMode( int32 mode);

void *luc_allocLocalMem( int32 size );
void *luc_allocCtrlMem( int32 size );

int32 luc_showTCR( void );

void luc_logError( int32 err_code );
void luc_abort( int32 err_code );

void luc_trace( char *msg, int32 type, void *pDesc, byte *pData, int32 datalen);

byte *luc_getMacAddr( int32 link );

extern	int32 luc_traceFlag;
#endif
