/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-api.h,v 1.4 2002/08/28 20:46:33 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */

#define MDK_CMD_LINESIZE	80

#define LINE_WIDTH		80

#define PAGE_UP			'+'
#define PAGE_DOWN		'-'

#define BS				0x8
#define DEL				0x7F
#define ESC				0x1B

#define RET_QUIT		1
#define RET_TOP			2
#define RET_NOTHING		3

/* Test result Return values */
#define RET_PASSED		4
#define RET_DEV_UP		5
#define RET_DEV_DOWN		6
#define RET_SKIPPED		7	/* For loopbacks */
#define RET_FAILED		8
#define RET_SKIP_TEST		9
#define RET_TEST_ERR_BASE	10

uint32 mdk_appId;

/*------------------------------------------------------------------*/
#define MDK_MAX_PACKAGES	50	
#define MDK_PACKAGES_PER_PAGE	10

#define MDK_NUM_TEST_PARAMS		20
//#define MDK_NUM_ERROR_PARAMS	200

#define MDK_MAX_TESTS_PER_PACKAGE	10

#define MDK_LOG_SIZE		40	

#define MDK_RESULT_MAX		6
/*------------------------------------------------------------------*/
typedef struct _mdk_option_t {
	uchar8		* str;
	uchar8		* comment;
	uint32		value;
} mdk_option_t;

/*------------------------------------------------------------------*/
typedef struct _mdk_test_t {
	uchar8		* testName;
	uchar8		* testComment;
	uchar8  * testHelp;
	int32		(*test)();
	uint32 		test_complt;
} mdk_test_t;

/*------------------------------------------------------------------*/
typedef struct _res_t {
	uint32	testresult;
        uint32  addr[20];
        uint32  exptd[20];
        uint32  rcvd[20];
} res_t;

/*------------------------------------------------------------------*/
typedef struct _mdk_log_entry_t {
	uint32		loop;
	uchar8		menuName[30];
	uchar8		testName[30];
	int32		testresult;
	res_t 	result[MDK_RESULT_MAX];
	void		(*logfn)(struct _mdk_log_entry_t *);
} mdk_log_entry_t;

typedef struct _mdk_log_t {
	uint32				size;
	mdk_log_entry_t		entry[MDK_LOG_SIZE];
} mdk_log_t;

/*------------------------------------------------------------------*/
typedef struct _mdk_package_t {
	uchar8			* menuName;
	uchar8			* menuComment;
	uchar8                  * menuHelp;
	int32			(*packageInit)();
	int32			(*packageError)(struct _mdk_log_entry_t *);
	mdk_test_t		* basicTests;
	mdk_test_t		* restrictedTests;
	mdk_option_t	* options;
} mdk_package_t;

/*------------------------------------------------------------------*/

typedef struct _test_params_t {
	uint32	loop_num;
	uchar8	* menuName;
	uchar8	* testName;
	uint32	param[MDK_NUM_TEST_PARAMS]; /* options*/
	res_t 	result[MDK_RESULT_MAX];
	int32	testresult;
	uint32		resultCnt;
	uint32 		test_done;
	uchar8	* devName;
} mdk_test_params_t;

/*------------------------------------------------------------------*/
typedef struct _mdk_t {
	uchar8			* title;
	uchar8			* version;
	uchar8			* date;
	uchar8			* time;
	uchar8			* card_type;
	mdk_package_t	* pkg[MDK_MAX_PACKAGES];
	uint32			num_pkgs;
	uint32			loop_cnt;
	uint32			num_loops;
} mdk_t;

/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/

extern mdk_t				mdk, * mdkp;
extern mdk_package_t		** mdk_package_list;
extern int32				pg_num, pg_max;
extern mdk_log_t			mdk_log;
extern mdk_test_params_t	tparam, * tp;

uint32 test_done;
