/*
 *-----------------------------------------------------------------
 *
 * Name:	mdk-log.c
 *
 * RCS:  $Id: mdk-log.c,v 1.3 2002/05/21 17:13:24 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_log_error(
	mdk_package_t		** pkgPtr,
	uint32 i
)
{
	mdk_log_entry_t	* err;
	uchar8 * test;
	test = "MEM";
	if (mdk_log.size < MDK_LOG_SIZE) {
		err = &mdk_log.entry[mdk_log.size];

		err->loop = tp->loop_num;
		strcpy(err->menuName, tp->menuName);
		strcpy(err->testName, tp->testName);
		err->logfn = (*pkgPtr)->packageError;
		
		if (i == 0XFFFF0000) {
			err->testresult = tp->testresult;
			/* check if any single test has copied the results for logging
			 * this is used to log results in mem/register tests
			 */
			memcpy((&err->result[0]), (&tp->result[0]), sizeof(res_t));
			memcpy((&err->result[1]), (&tp->result[1]), sizeof(res_t));
			memcpy((&err->result[2]), (&tp->result[2]), sizeof(res_t));
#if 0
			printf("%02x  ",tp->result[0].addr[0]);
			if(tp->result[0].addr[0]) {
				printf("%02x  ",tp->result[0].addr[0]);
				memcpy((&err->result[0]), (&tp->result[0]), sizeof(res_t));
			}
			else if(tp->result[1].addr[0])
				memcpy((&err->result[1]), (&tp->result[1]), sizeof(res_t));
			else if(tp->result[2].addr[0])
				memcpy((&err->result[2]), (&tp->result[2]), sizeof(res_t));
#endif
			(*err->logfn)(err);
			mdk_log.size++;
		}
		else { 	
			memcpy((&err->result[i]), (&tp->result[i]), sizeof(res_t));
			err->testresult = tp->testresult;
			(*err->logfn)(err);
			mdk_log.size++;
		}	
	}

}



/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_log_zero()
{
	printf("mdk_log_zero, previous size = %d\n", mdk_log.size);

	bzero(&mdk_log, sizeof(mdk_log_t));
	mdk_log.size = 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_log_display()
{
	uint32			i;
	mdk_log_entry_t	* err;

	printf("\n");
	printf("---------------------------------------------------------------\n");
	printf("ERROR LOG (%d entries%s)\n", mdk_log.size,
							mdk_log.size == MDK_LOG_SIZE ? " [FULL]":"");
	err = mdk_log.entry;
	for (i=0; i<mdk_log.size; i++) {
		printf("\n");
		printf("%s: %s: FAILED, loop %d\n",
									err->menuName, err->testName, err->loop);
		(*err->logfn)(err);
		err++;
	}	
	printf("---------------------------------------------------------------\n");
	printf("\n");

	get_continue();
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_results_display()
{
	uint32			i;
	mdk_log_entry_t	* res;

	printf("\n");
	printf("---------------------------------------------------------------\n");
	printf("RESULTS  LOG (%d entries%s)\n", mdk_log.size,
							mdk_log.size == MDK_LOG_SIZE ? " [FULL]":"");
	res = mdk_log.entry;
	for (i=0; i<mdk_log.size; i++) {
		printf("\n");
		printf("%s: %s: PASSED, loop %d\n",
									res->menuName, res->testName, res->loop);
		(*res->logfn)(res);
		res++;
	}
	printf("---------------------------------------------------------------\n");
	printf("\n");

	get_continue();
}

