/*
 *-----------------------------------------------------------------
 *
 * Name:	mdk-main.c
 *
 * RCS:  $Id: mdk-main.c,v 1.1.1.1 2002/03/26 01:43:51 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	Manufacturing Diagnostic Kernel
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/12/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>
#if defined(DIAG_SIBYTE) || defined (DIAG_R7000)
#include <exports/hwMap.h>
#endif

int32	pg_num, pg_max;

mdk_t				mdk, * mdkp;
mdk_package_t		** mdk_package_list;
mdk_log_t			mdk_log;
mdk_test_params_t	tparam, * tp;
uint32 mdk_init_done = 0;

/*-----------------------------------------------------------------
 * Name:	mdk_main()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
#if defined (DIAG_SIBYTE) || defined (DIAG_R7000)
void mdk_main()
#else
main()
#endif	
{
	int32	rc;

	/*serio_init();*/

	/*
	 *  Initialize MDK structures
	 */
	mdkp = mdk_init();

	tp = &tparam;

	mdk_init_packages();

	pg_num = 0;

	while (1) {
		rc = mdk_top_level();
		if (rc)
			break;
	}
	printf("Qutting diagnostic kernel\n");

	mdk_init_done = 1;
}

/*-----------------------------------------------------------------
 * Name:	do_mdk()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
do_mdk()
{
#if defined (DIAG_SIBYTE) || defined (DIAG_R7000)
	int32	rc;

	if(!mdk_init_done)
		mdk_main();

	while (1) {
		rc = mdk_top_level();
		if (rc)
			break;
	}
	printf("Qutting diagnostic kernel\n");
#endif 
}

