/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-options.c,v 1.2 2002/07/08 21:04:24 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_init_params(
	mdk_package_t		** pkgPtr
)
{
	mdk_option_t	* opt;
	int32			i;

	opt = &((*pkgPtr)->options[0]);
	i = 0;
	while (opt->str) {
		tp->param[i] = opt->value;
		i++;
		opt++;
	}

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_display_options(
	mdk_package_t	** pkgPtr,
	uint32			* num_opts
)
{
	mdk_option_t	* opt;
	uint32			i;
	uchar8			str[LINE_WIDTH];

	opt = (*pkgPtr)->options;

	clear_screen();
	sprintf(str, "%s    Tests", (*pkgPtr)->menuName);
	center(str, LINE_WIDTH);

	printf("\nOptions:\n", (*pkgPtr)->menuName);

	i = 0;
	while (opt->str) {
		printf("    %d: %-20s   0x%08x   %-20s\n", i, opt->str, tp->param[i], opt->comment);
		i++;
		opt++;
	}
	* num_opts = i;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_opt_new(
	mdk_package_t	** pkgPtr,
	uint32			opt_num,
	uint32			val
)
{
	mdk_option_t	* opt;

	opt = &((*pkgPtr)->options[opt_num]);
	opt->value = val;
	tp->param[opt_num] = val;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_set_options(
	mdk_package_t	** pkgPtr
)
{
	uchar8	* line;
	uint32	num_opts;
	uint32	opt;
	uint32	val;

	while (1) {
		mdk_display_options(pkgPtr, &num_opts);

		printf("\n");
		printf("Enter option number (RET to go back to prv menu): ");

		line = mdk_get_line(MDK_CMD_LINESIZE);

		if (strlen(line)) {
			if (isdigit(line[0])) {
				opt = atoi(line);
				if (opt >= num_opts) {
					printf("Invalid option, %d\n", opt);
					get_continue();
				}
				else {
					printf("\nEnter new value : ");
					line = mdk_get_line(MDK_CMD_LINESIZE);
					if (strlen(line)) {
						val = atox(line);
						mdk_opt_new(pkgPtr, opt, val);
					}
				}
			}
			else {
				printf("Invalid option, %s\n", line);
				get_continue();
			}
		}
		else
			break;
	}
}

