/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-top.c,v 1.5 2002/08/28 22:17:53 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

#define CNTRL(x)        ((x) & 0x1f)
extern uint32 testPassed;
extern uint32 testFailed;
extern uint32 testTimeout;
uint32 BurnInTest = 0;

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
uint32
mdk_get_req_packages(
	uchar8	* line,
	uchar8	* req,
	int32	min,
	int32	max
)
{
	uint32	cnt = 0;
	uchar8	* str;

	mdkp->num_loops = 1;

	if (str = getToken(line)) {
		do {
			if (isdigit(str[0])) {
				req[cnt] = atoi(str);
				if ((req[cnt] < min) || (req[cnt] > max)) {
					printf("Invalid package number, %d\n", req[cnt]);
					get_continue();
					return 0;
				}
				cnt++;
			}
			else if ((str[0] == 'l') || (str[0] == 'L')) {
				printf("str %c %c %c\n", str[0], str[1], str[2]);
				mdkp->num_loops = atoi(&str[1]);
				if (isdigit(str[2])) {
					req[cnt] = atoi(str[2]);
					if ((req[cnt] < min) || (req[cnt] > max)) {
						printf("Invalid package number, %d\n", req[cnt]);
						get_continue();
					return 0;
				}
				cnt++;
			}
			}
		} while (str = getToken(0));
	}

	return cnt;

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
uint32
mdk_get_all_packages(
	uchar8	* req
)
{
	mdk_package_t	* pkg;
	uint32			cnt = 0;

	while (mdk.pkg[cnt]) {
		req[cnt] = cnt;
		cnt++;
		mdk.num_loops = 0;
	}
	return cnt;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
int32
mdk_top_do_cmd(
	uchar8	* line
)
{
	uchar8			req_packages[MDK_MAX_PACKAGES];
	uint32			num_pkgs_todo;
	mdk_package_t	** pkgPtr;
	int32			pkg_max, pkg_min;
	int32			rc;
	uint32			burnNum = 0;
	
	pkg_min = pg_num * MDK_PACKAGES_PER_PAGE;
	pkg_max = pkg_min + MDK_PACKAGES_PER_PAGE - 1;
	if (pkg_max > mdkp->num_pkgs)
		pkg_max = mdkp->num_pkgs - 1;

	switch(line[0]) {
		case PAGE_UP:
				if (pg_num < pg_max)
					pg_num++;
				break;
		case PAGE_DOWN:
				if (pg_num)
					pg_num--;
				break;
		case 'q':					/* quit the diags */
		case 'Q':
				return (RET_QUIT);
				break;
		case 'z':
		case 'Z':
				mdk_log_zero();
				break;
		case 'r':
		case 'R':
				mdk_results_display();
				break;
		case 'e':
		case 'E':
				mdk_log_display();
				break;
		case 'a':					/* run acceptance test */
		case 'A':
				/* Initialise counters to 0 before test */
				testPassed = 0;
			       	testFailed = 0;
			       	testTimeout = 0;
				num_pkgs_todo = mdk_get_all_packages(req_packages);
				mdk_run_top_accept(req_packages, num_pkgs_todo);
				printf("\n");
				printf("********** Passed %d Timeout %d Failed %d **********\n",testPassed, testTimeout, testFailed);
				get_continue();
				break;
		case 'b':					/* run burn test */
		case 'B':
				/* Initialise counters to 0 before test */
				testPassed = 0;
			       	testFailed = 0;
			       	testTimeout = 0;
				BurnInTest = 1;
				/* run acceptance test till break */
				for (;;) 
				{
					num_pkgs_todo = mdk_get_all_packages(req_packages);
					rc = mdk_run_top_accept(req_packages, num_pkgs_todo);
					if(rc < 0)
						break;	
					if (char_avail()) 
					{
						if (getchar() == CNTRL('e'))
							break;
					}
					printf("******* Ran %d times *******\nTotal Passed %d\nTotal Timeout %d\nTotal Failed %d\n****************************\n",++burnNum, testPassed, testTimeout, testFailed);
					/* reinitialise package counters to 0 */
					//testPassed = 0;
				       	//testFailed = 0;
				       	//testTimeout = 0;
				}
				get_continue();
				BurnInTest = 0;
				break;
		case 'h':					/* help */
		case 'H':
				mdk_help_top(line);
				printf("\n");
				get_continue();
				break;
		case 'o':
		case 'O':
				printf("This is not supported at this level currently.\n");
				get_continue();
				break;		
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
				num_pkgs_todo = mdk_get_req_packages(	line,
														req_packages,
														pkg_min,
														pkg_max);
				if (num_pkgs_todo > 1) {
					/*
					 * Run through selected packages
					 */
					mdk_run_top_accept(req_packages, num_pkgs_todo);
					printf("\n");
					get_continue();
				}
				else if (num_pkgs_todo == 1) {
					/*
					 * Go into selected package submenu
					 */
					pkgPtr = &(mdk_package_list[req_packages[0]]);
					mdk_run_package_init(pkgPtr);
					if (mdk_submenu(pkgPtr) == RET_QUIT) {
						return (RET_QUIT);
					}
				}
				break;
		default:
				printf("Invalid selection\n");
				get_continue();
				break;
	}

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
int32
mdk_top_level()
{
	uchar8	* line;
	int32	rc;

	mdk_show_menu(pg_num);

	line = mdk_get_line(MDK_CMD_LINESIZE);

	rc = mdk_top_do_cmd(line);

	return rc;
}

