/*
 *-----------------------------------------------------------------
 *
 * Name:	mdk-util.c
 *
 * RCS:  $Id: mdk-util.c,v 1.2 2002/07/11 18:26:30 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

uchar8 CLS_VT100[] = {
	ESC,'<',					/* VT100 mode */
	ESC,'[','2','J',			/* clear screen */
	ESC,'[','1',';','1','H',	/* move cursor to 'home' position */
	0,
};

uchar8	*cls[] = {
	CLS_VT100
};

uchar8	input_line[MDK_CMD_LINESIZE];

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
void
center(
	uchar8	* str,
	uint32	width
)
{
	uint32	len, pad
;
	len = strlen(str);

	if (len < width)
		pad = (width - len)/2;
	else
		pad = 0;

	while (pad--)
		printf(" ");
	printf("%s\n", str);
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
void
clear_screen()
{
	printf("%s", cls[0]);

	center(mdkp->title, LINE_WIDTH);

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
void
get_continue()
{
	uchar8	c;
	
	printf("Hit <return> to continue...");
	/* while (getchar() != '\n');*/
	for(;;){
	c = getchar();
	if ((c == '\n') || (c == '\r'))
		return;
	else	
		continue;
	}
}

uchar8	* endLastTok;

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
uchar8 *
getToken(
	uchar8	* str
)
{
	uchar8	* sp, * tp;

	if (str == NULL) {
		if (endLastTok == NULL)
			return NULL;
		sp = endLastTok;
	}
	else
		sp = str;

	while(*sp == ' ' || *sp == '\t') ++sp;

	if (*sp == '\0')  return NULL;

	tp = sp;
	while (*sp != ' ' && *sp != '\t') {
		if (*sp == '\0') {
			endLastTok = sp;
			return tp;
		}
		++sp;
	}

	*sp = '\0';
	endLastTok = sp+1;

	return tp;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
uchar8 *
mdk_get_line(
	uint32	max
)
{
	uchar8	c;
	int32	len = 0;
	uchar8	* buf = input_line;

	while (1) {
		c = getchar();
		if ((c == BS) || (c == DEL)) {
			if (len) {
				len--;
				putchar('\b');
				buf--;
			}
		}
		else if ((c == '\r') || (c == '\n')) {
			*buf = '\0';
			putchar(c);

			break;
		}
		else {
			*buf++ = c;
			len++;
			putchar(c);

		}
	}

	return input_line;
}

