/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-sb-util.c,v 1.6 2002/07/29 20:39:28 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>
#include "mdk-mem.h"
#if defined (DIAG_SIBYTE)

#include <exports/eee-desc.h>
#include <exports/bmc12500-eth.h>
#include <sys/sb1250/sbmips.h>

/* Global Variables */

extern uint32 mdk_loopback;
extern uint32 sb_conflict;
extern uint32 isNextMDKpkt;
extern bc1250EthCfg_t *bcEthCfg[BC1250_MAC_CNT+1];

extern mdk_loopback_t mdk_testState[6];

extern uint32	time_handle_dp83820;
extern uint32	time_handle_port0;
extern uint32	time_handle_port1;
extern uint32	time_handle_port2;
extern uint32	time_handle_port3;
extern uint32	time_handle_port4;
extern uint32	time_handle_port5;

static mdk_bc1250Eth_test_t mdk_bc1250Eth_testControl[6];
extern bmc12500Eth_rx_pkt_trace;
extern bmc12500Eth_tx_pkt_trace;
extern unsigned char bmc12500_lsi_macAddr[6][6];
uint32 sb_test_started[6] = {0,0,0,0,0,0};
uchar8  static_luc_hdr[4][70];
uchar8  static_lmux_hdr[6][20];
uint32  mdk_front_add[4];
uint32  mdk_lmux_add[6];

reginfo_t phys_reg[] = {
	{"w",MII_BMCR, 0x5140, 0x5340,0}, 	/* Basic Mode Control (rw) */
	{"r",MII_BMSR, 0x0149, 0x0149,0}, 	/* Basic Mode Status (ro) */
	{"r", MII_PHYIDR1,0x0027, 0x0027,0},
	{"r", MII_PHYIDR2,0xa831, 0xa831,0},
	{"w",MII_ANAR,0xb1a0, 0xb1a0,0},  	/* Autonegotiation Advertisement */
	{NULL, NULL, NULL,NULL,NULL},
	};
#define PHYS_REG_MAX 	5	

#if 0	
	{"r", MII_ANLPAR,0x0000,0x0000,0},	 /* Autonegotiation Link Partner Ability (rw) */
	{"r", MII_ANER,0x0000,0x0004,0},  	 /* Autonegotiation Expansion */
	{"w", MII_ANNP,0xb7ff,0xb7ff,0},  	/* Autonegotiation Next Page */
	{"r", MII_ANLPNP,0x0000,0x0000,0},	/* (ro) */
	{"r", MII_STEX,0x0000,0x80000,0},
	{"w", MII_PMC1,0xffa4,0xffa4,0},  	/* PMC Control 1 */
	{"w", MII_PMC2,0xffff,0},  	/* PMC Control 2 */
	{"w", MII_IDLE1,0x01ff,0}, 	/* */
	{"w", MII_IDLE2,0x01ff,0}, 	/* */
	{"w", MII_IDLE1A,0x01ff,0},	/* */
	{"w", MII_IDLE2A,0x01ff,0},	/* */
	{"w", MII_LOOPBACK,0xffff,0}, /* Loopback Control */
	{"w", MII_TRUNK,0xf1ff,0},  	/* Trunking Control */
	{"w", MII_AUXCTL,0xf400,0},  	/* PMC Control 3 */
	{"w", MII_PGEN,0xf000,0},  	/* Packet Generator */
	{"w", MII_PCNT,0xffff,0},  	/* Packet Generator Count */
	{"w", MII_RDCT,0x0fff,0},  	/* Redundancy Control */
	{"w", MII_RDCT,0x0fff,0}  	/* Redundancy Control */
	};
#endif

extern uint32 conflict_timeout;

int32 sb_lpbk_timeout(int32 tmr_handle, void * usr_param0, void* usr_param1, void* usr_param2,void* usr_param3);

//char *mdk_loopback_dev[] = {"SB-MAC0", "SB-MAC1", "N-MAC"};

#define CFG_DRAM_SMBUS_CHANNEL	0
#define RLTS  0
#define RRTE  1
#define RLHN  5
#define RLLI  6
#define RRHI  7
#define RRLS  8

/* All these functions have been ported from respective driver code
 * and modified where necessary for diag application
 */

/*
 *------------------------------------------------------------------------------
 * Function Name:	bmc12500Eth_diagLBTest
 *
 * Description: 	Runs loopback test 
 *
 * Created by:		Frank Salzmann
 *
 * Data Created:	April 30, 2001
 * 					
 * Returns: ?????
 *
 *------------------------------------------------------------------------------
 */
int
mdk_12500Eth_diagLBTest(bc1250EthCfg_t *cfg,uint32 testMode, uint32 port)
{
	int32  i, rc;
	int32  pktCnt;
	int32  pktSize, newpktSize;
	uint32 destAddr;
	uint32 dstPort;
	uchar8 *bufptr, *buf;
	uint32 txport;
	uint32 destCpu;
	uint32 val;
	bc1250Eth_regs_t *regs;
	uint32	rct;
	uint32 dtype;

	if(tp->param[TP_LBPKT_CNT])
		pktCnt = tp->param[TP_LBPKT_CNT];
	else
		pktCnt = 1; 

	pktSize = 64;
	if((isTXRX()) && ((testMode == TEST_EXT) || (testMode == TEST_PHY))) {
		if(isCheetah())	{
			if(isTXRX())	
				pktSize = 100;
			if(isFP())	
				pktSize = 64;
		}	
		else {
			pktSize = 66;
			isNextMDKpkt = 0;
		}	
	}
	if (!sb_conflict)
		tp->param[TP_LB_DURATION] = 0; /* Only used for conflict test*/

	sb_test_started[port] = 1;
	if(mdk_bc1250Eth_testControl[port].testState == TEST_INPROGRESS)
	{
		if( mdk_bc1250Eth_testControl[port].testBuffer) 
			eee_ramDealloc(mdk_bc1250Eth_testControl[port].testBuffer);
	}	
	memset(&mdk_bc1250Eth_testControl[port],0,sizeof(mdk_bc1250Eth_testControl));
	memset(&mdk_testState[port],0,sizeof(mdk_loopback_t));
	mdk_bc1250Eth_testControl[port].portUnderTest   = cfg->macId; 
	mdk_bc1250Eth_testControl[port].testState   = TEST_INPROGRESS; 
	mdk_testState[port].state = TEST_INPROGRESS;
	mdk_bc1250Eth_testControl[port].testMode    = testMode;
	mdk_bc1250Eth_testControl[port].testPktCnt  = pktCnt;
	mdk_bc1250Eth_testControl[port].testPktSize = pktSize;
	if(!isCheetah()) 
		mdk_bc1250Eth_testControl[port].fVerify	  = 1;
	/*
	 * Allocate and initialize test data.
	 */
	buf = bufptr = (uchar8 *)eee_ramAlloc(pktSize);
	if(!isCheetah())
		mdk_bc1250Eth_testControl[port].testBuffer = bufptr;
	if( !bufptr ) {
		printf("Test data buffer allocation failed.\n");
		return(NFX_OK);
	}
	if(!isCheetah()) {
		if(port == 0) {
			rct = eee_timerStart(time_handle_port0, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port0;
		}
		else {
			rct = eee_timerStart(time_handle_port1, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port1;
		}
	}
	else {
		if(port == 0) {
			rct = eee_timerStart(time_handle_port0, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port0;
		}
		else if(port == 1){
			rct = eee_timerStart(time_handle_port1, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port1;
		}
		else if(port == 2){
			rct = eee_timerStart(time_handle_port2, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port2;
		}
		else if(port == 3){
			rct = eee_timerStart(time_handle_port3, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port3;
		}
		if(isFP()) {
			if(port == 4){
				rct = eee_timerStart(time_handle_port4, sb_lpbk_timeout,0,0,0,0);
				if(rct != NFX_OK)
					printf("SB Loopback(test Start) Port %d : Could not start timer. 
									Error %08x \n",port, rct);
				else
					mdk_bc1250Eth_testControl[port].timer = time_handle_port4;
			}
			else if(port == 5){
				rct = eee_timerStart(time_handle_port5, sb_lpbk_timeout,0,0,0,0);
				if(rct != NFX_OK)
					printf("SB Loopback(test Start) Port %d : Could not start timer. 
									Error %08x \n",port, rct);
				else
					mdk_bc1250Eth_testControl[port].timer = time_handle_port5;
			}
		}	
	}		
	if(!isCheetah()) {
		//-- Set mac into promis mode.
		regs = &cfg->regs;
		val = bmc12500Eth_readReg(regs->mac_adfilter_cfg);
		val |= 1; // 
		bmc12500Eth_writeReg(regs->mac_adfilter_cfg, val);
	}

	switch(testMode) {

		case TEST_INT:
			/* Ths is not supported now */
			/*
			bmc12500Eth_diagSetLbMode(cfg, BC1250_MAC_LB_ENABLE);
			mdk_bmc12500Eth_diagSetLbMode(cfg, BC1250_MAC_LB_ENABLE);
			*/
			cfg->link.loopback = lb_int;
			dstPort = 0;
			break;

		case TEST_EXT:
			/*dstPort = bmc12500Eth_uiGetInput("Enter Destination Port[0|1]: ");
			if((dstPort != 0) && (dstPort != 1 )) {
				printf("Invalid Dest Port: %d.\n", dstPort); 
				eee_ramDealloc(buf);
				return(NFX_OK);
			}*/
			dstPort = 0; /* Until 2nd CPU is up */
			cfg->link.loopback = lb_ext;
			if(!isCheetah())
				bcEthCfg[port]->link.loopback = lb_ext;
			break;

		case TEST_PHY:
			dstPort = 0;
			cfg->link.loopback = lb_phy;
			break;
	}

	//-- Initialize test packet data.

	/* This marks the test packet so that we can call the 
	 * appropriate receive function
	 */
	if(isCheetah()) {
		   	if(isTXRX()) {
				/* For TXRX pkts going out of the LUC, add LUC header */
				bufptr = mdk_fill_luc_hdr(bufptr, port, pktSize);		
				newpktSize = pktSize - 64;
			}	
			else if(isFP()) {
				bufptr = mdk_fill_lmux_hdr(bufptr, port, pktSize);		
				newpktSize = pktSize - 20;
				//mdk_cheetahFp_loopback_test = 1;	
			}		
	}		
	bufptr[0] = 'm';
	bufptr[1] = 'd';
	bufptr[2] = 'k';
	bufptr[3] = '0' + port;
	bufptr[4] = pktSize;

	for(i=5; i < (newpktSize-5); i++ )
		bufptr[i] = i & 0xFF;
/*
	if( bmc12500Eth_tx_pkt_trace) {
		printf("BMC Tx: bufp: %x, bufLen: %d\n", buf, pktSize);
		bmc12500Eth_printBuf( buf, pktSize, 1);  
	}
*/
	/*
	 * Send first set of loop back packets.
	 */
	dtype = EEE_USER_DATA;
#if defined(PROM)
	if( isFP() ) {
		if( cfg->macId == 0 )
			txport = PROM_PORT_FP0;
		else {
			if(!isCheetah())	
				txport = PROM_PORT_FP1;
			else
				txport = PROM_PORT_FP2;
		}
		if( dstPort == 0 )
			destCpu = NFX_NFP_FP2; // change this when we bring up the 2nd core
		else
			destCpu = NFX_NFP_FP2; 
	}
	else {
		if( cfg->macId == 0 )
			txport = PROM_PORT_TXRX0;
		else {
			if(!isCheetah())	
				txport = PROM_PORT_TXRX1;
			else
				txport = PROM_PORT_TXRX2;
		}
		if( dstPort == 0 )
			destCpu = NFX_NFP_TXRX1;
		else
			destCpu = NFX_NFP_TXRX1; // change this when we bring up the 2nd core
	}

	destAddr = PACK_UNICAST_PORT_ADDRESS(
								 nfxMySlotId,
								 nfxMyCPUId,
								 mdk_appId,
								 dtype, 
								 NFX_COS_HIGH, 
								 txport);
#endif

	cfg->myPortAddr = destAddr;
	if(isCheetah()) {
		   if(isTXRX())
				mdk_front_add[port] = destAddr;
			else if(isFP())
				mdk_lmux_add[port] = destAddr;	
	}		   
	mdk_bc1250Eth_testControl[port].testDestAddr = destAddr;

	if(isCheetah())
		mdk_send_off_pkt(buf,pktSize, destAddr);
	else {
		for(i=0; i < 1; i++)
			rc = eee_sendMessage(buf, pktSize, destAddr, destAddr);
	}
	mdk_bc1250Eth_testControl[port].txPktCnt += 1;
	mdk_bc1250Eth_testControl[port].txByteCnt += (1 * pktSize);

	return(NFX_OK);
} // mdk_12500Eth_diagLBTest 

/*
 *------------------------------------------------------------------------------
 * Function Name:	mdk_sb_RemakePkt(uint32 port)	
 *
 * Description: 	Remakes the missing packet	
 *
 * Created by:		lipika	
 *
 * Data Created:	Jul 19 2002	
 * 					
 * Returns: ?????
 *
 *------------------------------------------------------------------------------
 */
int
mdk_sb_RemakePacket(uint32 port)
{
	int32  i, rc;
	int32  pktCnt;
	int32  pktSize, newpktSize;
	uint32 destAddr;
	uchar8 *bufptr, *buf;
	uint32	rct;

	if(tp->param[TP_LBPKT_CNT])
		pktCnt = tp->param[TP_LBPKT_CNT];
	else
		pktCnt = 1; 

	pktCnt = mdk_bc1250Eth_testControl[port].testPktCnt;
	pktSize = mdk_bc1250Eth_testControl[port].testPktSize;

	if(mdk_bc1250Eth_testControl[port].testState == TEST_INPROGRESS)
	{
		if( mdk_bc1250Eth_testControl[port].testBuffer) 
			eee_ramDealloc(mdk_bc1250Eth_testControl[port].testBuffer);
	}	

	/*
	 * Allocate and initialize test data.
	 */
	buf = bufptr = (uchar8 *)eee_ramAlloc(pktSize);
	if(!isCheetah())
		mdk_bc1250Eth_testControl[port].testBuffer = bufptr;
	if( !bufptr ) {
		printf("Test data buffer allocation failed.\n");
		return(NFX_OK);
	}
	if(!isCheetah()) {
		if(port == 0) {
			rct = eee_timerStart(time_handle_port0, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port0;
		}
		else {
			rct = eee_timerStart(time_handle_port1, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port1;
		}
	}
	else {
		if(port == 0) {
			rct = eee_timerStart(time_handle_port0, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port0;
		}
		else if(port == 1){
			rct = eee_timerStart(time_handle_port1, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port1;
		}
		else if(port == 2){
			rct = eee_timerStart(time_handle_port2, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port2;
		}
		else if(port == 3){
			rct = eee_timerStart(time_handle_port3, sb_lpbk_timeout,0,0,0,0);
			if(rct != NFX_OK)
				printf("SB Loopback(test Start) Port %d : Could not start timer. 
								Error %08x \n",port, rct);
			else
				mdk_bc1250Eth_testControl[port].timer = time_handle_port3;
		}
		if(isFP()) {
			if(port == 4){
				rct = eee_timerStart(time_handle_port4, sb_lpbk_timeout,0,0,0,0);
				if(rct != NFX_OK)
					printf("SB Loopback(test Start) Port %d : Could not start timer. 
									Error %08x \n",port, rct);
				else
					mdk_bc1250Eth_testControl[port].timer = time_handle_port4;
			}
			else if(port == 5){
				rct = eee_timerStart(time_handle_port5, sb_lpbk_timeout,0,0,0,0);
				if(rct != NFX_OK)
					printf("SB Loopback(test Start) Port %d : Could not start timer. 
									Error %08x \n",port, rct);
				else
					mdk_bc1250Eth_testControl[port].timer = time_handle_port5;
			}
		}	
	}		
	
	//-- Initialize test packet data.
	/* This marks the test packet so that we can call the 
	 * appropriate receive function
	 */
	if(isCheetah()) {
		   	if(isTXRX()) {
				/* For TXRX pkts going out of the LUC, add LUC header */
				bufptr = mdk_fill_luc_hdr(bufptr, port, pktSize);		
				newpktSize = pktSize - 64;
			}	
			else if(isFP()) {
				bufptr = mdk_fill_lmux_hdr(bufptr, port, pktSize);		
				newpktSize = pktSize - 20;
				//mdk_cheetahFp_loopback_test = 1;	
			}		
	}		

	bufptr[0] = 'm';
	bufptr[1] = 'd';
	bufptr[2] = 'k';
	bufptr[3] = '0' + port;
	bufptr[4] = pktSize;

	for(i=5; i < (newpktSize-5); i++ )
		bufptr[i] = i & 0xFF;

	destAddr = mdk_bc1250Eth_testControl[port].testDestAddr;

	if(isCheetah())
		mdk_send_off_pkt(buf,pktSize, destAddr);
	else {
		for(i=0; i < 1; i++)
			rc = eee_sendMessage(buf, pktSize, destAddr, destAddr);
	}
	mdk_bc1250Eth_testControl[port].txPktCnt += 1;
	mdk_bc1250Eth_testControl[port].txByteCnt += (1 * pktSize);

	return(NFX_OK);
}


int
mdk_bmc12500Eth_diagShowLbTestResults(mdk_bc1250Eth_test_t *t,uint32 portNo)
{
	//char *mdkTestStates[] = {"","TEST_DONE", "TEST_INPROGRESS", "TEST_VERIFY", 
	//			"TEST_CONTINUE", "TEST_END" };

	char *mdkTestMode[] = {"INT LOOPBACK", "EXT LOOPBACK", "PHY LOOPBACK" };

	printf("\nDIAG BMC12500ETH LOOPBACK TEST PORT %d\n",portNo);
	printf("=============================================\n\n");
	printf("Test Mode         : %s\n", mdkTestMode[t->testMode - 1]);
	printf("Test Packet Cnt   : %d\n", t->testPktCnt);
	printf("Test Packet Size  : %d\n", t->testPktSize);
	printf("Test Verify Flag  : %d\n", t->fVerify);
	printf("Actual Rx Pkt Cnt : %d\n", t->rxPktCnt);
	printf("Actual Rx Byte Cnt: %d\n", t->rxByteCnt);
	printf("Actual Rx Err Cnt : %d\n", t->rxErrPktCnt);
	printf("Actual Tx Pkt Cnt : %d\n", t->txPktCnt);
	printf("Actual Tx Byte Cnt: %d\n", t->txByteCnt);
	printf("\n");
	return(NFX_OK);
} // mdk_bmc12500Eth_diagShowLbTestResults 


/*
 *------------------------------------------------------------------------------
 * Function Name:	bmc12500Eth_diagLbVerifyData
 *
 * Description: 	Verifies the integrety of loop back data 
 *
 * Created by:		Frank Salzmann
 *
 * Data Created:	May 14, 2001
 * 					
 * Returns: ?????
 *
 *------------------------------------------------------------------------------
 */
int
mdk_bmc12500Eth_diagLbVerifyData( uchar8 *bufptr, int32 len, uchar8 *tbufptr,uint32 portNo )
{
	int32  i;

#if 0	
	if( !bufptr || !tbufptr )
		return(NFX_ERR);

	len = 64; /* just check first 64 bytes */
	for(i=0; i < len; i++) {
		if( *bufptr != *tbufptr ) {
			if(portNo == 0) {	
					(int)tp->result[0].addr[i] = bufptr;
					(int)tp->result[0].exptd[i] = *tbufptr;
					(int)tp->result[0].rcvd[i] = *bufptr;	
			}
			else if(portNo == 1) {		
					(int)tp->result[1].addr[i] = bufptr;
					(int)tp->result[1].exptd[i] = *tbufptr;
					(int)tp->result[1].rcvd[i] = *bufptr;	
			}		
			if (tp->param[TP_VERBOSE] == 1) {
				printf("LB Data Error: TestVal=%02x, ActualVal=%02x, Addr=%x\n",
				   *tbufptr, *bufptr, bufptr);
			}
			tp->testresult = ERR_DATA_FAIL;
			return(TEST_END);
		}
		bufptr++;
		tbufptr++;
	}
#endif	
	return(TEST_CONTINUE);
} // mdk_bmc12500Eth_diagLbVerifyData 


int
mdk_bmc12500Eth_diagLbPktReceive( eee_desc_t *edesc )
{
	int32				rc;
	int32 				pktLen;
	int32 				pktSize;
	int32 				bufCnt;
	uint32 				val;
	mdk_bc1250Eth_test_t 	*dptc;
	bc1250EthCfg_t      *cfg;
	bc1250Eth_regs_t *regs;
	//eee_descBuf_t   bd;
	uchar8	*buf;
	uint32 portNo;
	//uint32 rcvd = 0;
	//uint32 i=0;

	buf = edesc->bd[1].buf;
	
	if(buf[0] == 'm' && buf[1] == 'd' && buf[2] == 'k')
	{		
		/* Pattern matches, check pkt is for which Port */
		/*if(!isCheetah()) {	
			if(buf[3] == '0') {
				portNo = 0;
				dptc = &mdk_bc1250Eth_testControl[0]; 
			}
			else if(buf[3] == '1') {
				portNo = 1;
				dptc = &mdk_bc1250Eth_testControl[1]; 
			}
		else {*/
		portNo = buf[3] - '0';	
		//printf("rcvd for port %d\n", portNo);
		pktSize = buf[4];
		dptc = &mdk_bc1250Eth_testControl[portNo]; 
	}
	else {
		if (tp->param[TP_VERBOSE] == 1) {
			printf("PKT destined for mdk_bmc12500 has wrong pattern!!\n");
			printf("%02x %02x %02x %02x\n",buf[0], buf[1], buf[2], buf[3]);
		}
		eee_freePacket(edesc);
		return;
	}

	/* free pkt if we have not started test yet */
	if(!sb_test_started[portNo]) {
		if (tp->param[TP_VERBOSE] == 1) 
			printf("Have not started test yet.\n");	
		eee_freePacket(edesc);
		return;
	}

   /* If packet comes after timeout, does not indicate failure!! */	
	/* Check if packet has come after timeout */
	if(mdk_testState[portNo].timeout)
	{
		if(!sb_conflict)
			dptc->testState = TEST_END;
	}

	if(!isCheetah())
		cfg = bcEthCfg[portNo]; 
	else {
		if(isTXRX()) {
			if((portNo == 0) || (portNo == 1))
				cfg = bcEthCfg[0]; 
			else if((portNo == 2) || (portNo == 3))
				cfg = bcEthCfg[2]; 
		}	
		if(isFP()) {
			if((portNo == 0) || (portNo == 1) || (portNo == 2))
				cfg = bcEthCfg[0]; 
			else if((portNo == 3) || (portNo == 4) || (portNo == 5))
				cfg = bcEthCfg[2]; 
		}	
	}	
	pktLen = edesc->hdr.control & EDESC_TOTAL_LEN;
	bufCnt = ((edesc->hdr.control & EDESC_BUFCNT_MASK) >> EDESC_BUFCNT_SHIFT);

	while(1) {
		switch( dptc->testState )
		{
			case TEST_INPROGRESS:
				dptc->rxPktCnt++; 
				dptc->rxByteCnt += pktLen;

				if( dptc->fVerify )
					dptc->testState = TEST_VERIFY;
				else {
					if(tp->param[TP_LB_DURATION] > 0) {
						if(!conflict_timeout)
							dptc->testState = TEST_CONTINUE;
						else
							dptc->testState = TEST_END;
					}
					else {
						if( dptc->rxPktCnt >= dptc->testPktCnt)
							dptc->testState = TEST_END;
						else
							dptc->testState = TEST_CONTINUE;
					}
				}
				break;

			case TEST_VERIFY:
				rc = mdk_bmc12500Eth_diagLbVerifyData(edesc->bd[1].buf, 
												  edesc->bd[1].len, 
												  dptc->testBuffer,
												  portNo);
				if(tp->param[TP_LB_DURATION] > 0) {
					if(!conflict_timeout)
						dptc->testState = rc;
					else
						dptc->testState = TEST_END;
				}
				else {	
					if( dptc->rxPktCnt >= dptc->testPktCnt)
						dptc->testState = TEST_END;
					else
						dptc->testState = rc;
				}
				break;

			case TEST_CONTINUE:
				dptc->txPktCnt++; 
				dptc->txByteCnt += pktLen;
				eee_timerStop(dptc->timer) ;
				if(!isCheetah()) {
					if((isTXRX()) && ((dptc->testMode == TEST_EXT)
						|| (dptc->testMode == TEST_PHY))) {
						/* Move the bd to point to start of pkt- 
					 	* which has the MAC/EEE header 
					 	*/
						edesc->bd[1].buf-=0x30;
						edesc->bd[1].len+=0x30;
						pktLen += 0x30; 
						edesc->hdr.control |= (pktLen & EDESC_TOTAL_LEN);
					}
				}
				else {
					if((isTXRX()) && ((dptc->testMode == TEST_EXT)
						|| (dptc->testMode == TEST_PHY)))
					{
							uchar8 *tmp;
							uchar8 *newBufp;
							uint32 pktLen;

						pktLen = edesc->hdr.control & EDESC_TOTAL_LEN;
						newBufp = (uchar8 *)eee_ramAlloc(64+pktLen);
						memcpy(newBufp,&static_luc_hdr[portNo],64);
						tmp = newBufp;
						tmp+=64;
						memcpy(tmp,buf,pktLen);
						memcpy(buf,newBufp,pktLen+64);
						if(newBufp) {
							eee_ramDealloc(newBufp);
						}
						edesc->bd[1].len+=64;
				    	pktLen+=64;
				    	edesc->hdr.control |= (pktLen & EDESC_TOTAL_LEN);
						edesc->hdr.dest_port = mdk_front_add[portNo];
						rc = eee_timerStart(dptc->timer, sb_lpbk_timeout,0,0,0,0);
						if(rc != NFX_OK)
							printf("SB Loopback Port %d : Could not start timer. Error %08x \n",portNo, rc);
						//dptc->testBuffer = buf;
						rc = bmc12500Eth_txUnicast( edesc->hdr.dest_port,edesc );
						if(rc !=  EEE_FORWARDED_PACKET)
							printf("ERROR: Port %d Could not forward pkt.\n",portNo);	
						//printf("tx for port %d\n",portNo);
						dptc->testState = TEST_INPROGRESS;
						if(sb_conflict)
							tp->result[portNo].testresult = RET_PASSED;
						return(NFX_OK);
					}
					else if(isFP()) {
						uchar8 *tmp;
						uchar8 *newBufp;
						uint32 pktLen;

						pktLen = edesc->hdr.control & EDESC_TOTAL_LEN;
						if(pktLen > pktSize)
							pktLen = pktSize;
						newBufp = (uchar8 *)eee_ramAlloc(pktLen);
						memcpy(newBufp,&static_lmux_hdr[portNo],20);
						tmp = newBufp;
						tmp+=20;
						memcpy(tmp,buf,pktLen);
						memcpy(buf,newBufp,pktSize);
						if(newBufp) {
							eee_ramDealloc(newBufp);
						}
						//buf -= 20;
						//memcpy(buf,&static_lmux_hdr[portNo],20);
						//edesc->bd[1].len+=20;
						edesc->bd[1].buf = buf;
						edesc->bd[1].len = pktSize;
						pktLen = pktSize;
						edesc->hdr.dest_port = mdk_lmux_add[portNo];
				    	edesc->hdr.control |= (pktLen & EDESC_TOTAL_LEN);
						//dptc->testBuffer = buf;
						rc = eee_timerStart(dptc->timer, sb_lpbk_timeout,0,0,0,0);
						if(rc != NFX_OK)
							printf("SB Loopback Port %d : Could not start timer. Error %08x \n",portNo, rc);
						rc = bmc12500Eth_txUnicast( edesc->hdr.dest_port,edesc );
						if(rc !=  EEE_FORWARDED_PACKET)
							printf("ERROR: Port %d Could not forward pkt.\n",portNo);	
						dptc->testState = TEST_INPROGRESS;
						if(sb_conflict)
							tp->result[portNo].testresult = RET_PASSED;
						return(NFX_OK);
					}		
				}		
							
				edesc->hdr.dest_port = dptc->testDestAddr;
				rc = eee_timerStart(dptc->timer, sb_lpbk_timeout,0,0,0,0);
				if(rc != NFX_OK)
					printf("SB Loopback Port %d : Could not start timer. Error %08x \n",portNo, rc);
				rc = eee_forwardPacket(edesc);
				if(rc !=  EEE_FORWARDED_PACKET)
					printf("ERROR: Port %d Could not forward pkt.\n",portNo);	
				dptc->testState = TEST_INPROGRESS;
				if(sb_conflict)
					tp->result[portNo].testresult = RET_PASSED;
				return(NFX_OK);
				break;
				
			case TEST_END:
				if((isTXRX()) && ((dptc->testMode == TEST_EXT) 
					||(dptc->testMode == TEST_PHY)))
				{
					isNextMDKpkt = 0;
				}
				if(dptc->testMode == TEST_INT)
					bmc12500Eth_diagSetLbMode(bcEthCfg[0], BC1250_MAC_LB_DISABLE);

				//-- Set mac into non-promis mode.
				if(!isCheetah()) {
					regs = &cfg->regs;
					val = bmc12500Eth_readReg(regs->mac_adfilter_cfg);
					val &= ~1;  
					bmc12500Eth_writeReg(regs->mac_adfilter_cfg, val);
				}

				if(dptc->testBuffer) {
					if(!(isCheetah())) 
						eee_ramDealloc(dptc->testBuffer);
				}	
				dptc->testState = TEST_DONE;
				/* reset link so that it can be polled*/
				cfg->link.loopback = lb_none;
				eee_timerStop(dptc->timer) ;
				test_done = 1;
				break;

			case TEST_DONE:
				/* if not timeout */
				if(!(mdk_testState[portNo].timeout)) {
					if(sb_conflict)
						tp->result[portNo].testresult = RET_PASSED;
					else
						tp->testresult = RET_PASSED;
				}
				mdk_testState[portNo].state = TEST_DONE;
				sb_test_started[portNo] = 0;
				//printf("!!!!!!! port %d TEST DONE\n", portNo);
				/*mdk_show_results(tp->testresult);*/
				if (tp->param[TP_VERBOSE] == 1) 
					mdk_bmc12500Eth_diagShowLbTestResults(dptc ,portNo);
#if 0				
				if(dptc->testBuffer) {
					/* Cheetah: TXRX:we've allocated a new buffer in the rx fn of the drv
					 * so we have to call the appropriate deallocate fn here.
					 */ 	
					if(!(isCheetah())) //&& (isTXRX()))
						eee_ramDealloc(dptc->testBuffer);
					/*else {
						eee_deallocateBuffer(dptc->testBuffer);
					}*/	
				}
#endif				
				eee_freePacket(edesc);
				return(NFX_OK);
		}		
	}
	mdk_testState[portNo].state = dptc->testState;
	return(NFX_OK);
} // mdk_bmc12500Eth_diagLbPktReceive

int32
mdk_phy8353_reg_test(bc1250Eth_regs_t *r, uint32 phyAddr)
{
	uint32 i, j=0;
	uint32 sval, rval, val;
	uint32 regAddr;
	uchar8 * test;
	
	test = "r";
	
	for (i=0; i < PHYS_REG_MAX;i++){
		regAddr = phys_reg[i].reg;
		if(!(strcmp((phys_reg[i].rw),test))) {
			if (isCheetah())
				rval = ((uint32)dp83820_readMII_common(phyAddr, regAddr)) & 0xFFFF;
			else 
				rval = bmc12500Eth_mii_read(r,phyAddr,regAddr) & 0xFFFF;
			if(phys_reg[i].expected == rval) {
				phys_reg[i].res = 1;			
			}
			else {
				phys_reg[i].res = 0;
				tp->result[0].addr[j] = regAddr;
				tp->result[0].exptd[j] = phys_reg[i].expected;
				tp->result[0].rcvd[j] = rval;	
				tp->testresult = ERR_DATA_FAIL;
				//return (tp->testresult);
				j++;
			}	
		}
		else /* write */
		{	
			if (isCheetah())
				sval = (uint32)dp83820_readMII_common(phyAddr, regAddr);
			else 
				sval = bmc12500Eth_mii_read(r,phyAddr,regAddr);	
			val = sval;
			val |= phys_reg[i].wbits ;
			if (isCheetah())
				dp83820_writeMII_common(0, phyAddr, regAddr, val);
			else
				bmc12500Eth_mii_write(r,phyAddr,regAddr,val);				
			if (isCheetah())
				rval = (uint32)dp83820_readMII_common(phyAddr, regAddr);
			else 
				rval = bmc12500Eth_mii_read(r,phyAddr,regAddr);
			if(rval == phys_reg[i].expected)
				phys_reg[i].res = 1;
			else {
				phys_reg[i].res = 0;
				tp->result[0].addr[j] = regAddr;
				tp->result[0].exptd[j] = phys_reg[i].expected;
				tp->result[0].rcvd[j] = rval;	
				tp->testresult = ERR_DATA_FAIL;
				//return(tp->testresult);
				j++;
			}	
			/* Store original contents back */
			if (isCheetah())
				dp83820_writeMII_common(0, phyAddr, regAddr, sval);
			else
				bmc12500Eth_mii_write(r,phyAddr,regAddr,sval);				
		}	
		if (tp->param[TP_VERBOSE] == 1) {
		printf("%08x\t %s\t %08x\t %08x\n",phys_reg[i].reg, 
						(phys_reg[i].res == 1)? "PASS":"FAIL", 
						phys_reg[i].expected,rval);}
	}	
	if(tp->testresult != ERR_DATA_FAIL)
		tp->testresult = RET_PASSED;

	return(tp->testresult);
} /* mdk_phy8353_reg_test */

void
mdk_bmc12500Eth_mii_phyLoopback(bc1250EthCfg_t *cfg, int mode, uint32 phyAddr)
{
    uint16 val;
	bc1250Eth_regs_t *r;

	r = &cfg->regs;
	
	if( mode == BC1250_SET ) {
		if (isCheetah())
			val = (uint32)dp83820_readMII_common(phyAddr, MII_BMCR);
		else 
			val = bmc12500Eth_mii_read(r, phyAddr, MII_BMCR);
		val |= 0x4000;
		if (isCheetah())
			dp83820_writeMII_common(0, phyAddr, MII_BMCR, val);
		else
			bmc12500Eth_mii_write(r, phyAddr, MII_BMCR, val);
	}
	else {
		if (isCheetah())
			dp83820_writeMII_common(0, phyAddr, MII_BMCR, 0x8000);
		else
			bmc12500Eth_mii_write(r, phyAddr, MII_BMCR, 0x8000); // Just reset the phy
	}
	if (tp->param[TP_VERBOSE] == 1) {
		if (isCheetah())
			val = (uint32)dp83820_readMII_common(phyAddr, MII_BMCR);
		else 
			val = bmc12500Eth_mii_read(r, phyAddr, MII_BMCR);
		//printf("BMCR %04x",val);
	}
	return;
} // mdk_bmc12500Eth_mii_phyLoopback

int32
sb_lpbk_timeout(int32 tmr_handle,
		 void * usr_param0,
		 void * usr_param1,
		 void * usr_param2,
		 void * usr_param3)
{
	uint32 testresult;
	uint32 port, maxPort;
	mdk_bc1250Eth_test_t 	*dptc;

	/* force the state to done because time's up */
	if(!(isCheetah())) {
		if (tmr_handle == time_handle_port0) {
			port = 0;
		}
		else if(tmr_handle == time_handle_port1) {
			port = 1;
		}
		else if(tmr_handle == time_handle_dp83820) {
			port = 2;
		}
	}
	else {
		if (tmr_handle == time_handle_port0)
				port = 0;
		else if(tmr_handle == time_handle_port1)
				port = 1;
		else if (tmr_handle == time_handle_port2)
				port = 2;
		else if (tmr_handle == time_handle_port3)
				port = 3;
		else if (tmr_handle == time_handle_port4)
				port = 4;
		else if (tmr_handle == time_handle_port5)
				port = 5; /* FP: 6 ext ports */
		else if (tmr_handle == time_handle_dp83820)
				port = 4; /* for TXRX: 4 ext ports + 1 GMAC port */
	}		

	dptc = &mdk_bc1250Eth_testControl[port]; 
	tp->testresult = ERR_TIMEOUT;
	if(sb_conflict)
		tp->result[port].testresult = tp->testresult;
	mdk_testState[port].timeout = 1;
	
	if((sb_conflict) && (!conflict_timeout))
	{
		/* Remake packet till conflict timeout, then end test */
		if(tmr_handle != time_handle_dp83820)	
			mdk_sb_RemakePacket(port);
		else
			mdk_dp83820_diagRemakeLbPkt();
		return(NFX_OK);
	}		
	
	if (tp->param[TP_VERBOSE] == 1) 
	{		
		if(isTXRX())
			maxPort = 3;
		else if(isFP())
			maxPort = 5;
		if(port <= maxPort)
			mdk_bmc12500Eth_diagShowLbTestResults(dptc ,port);
	}	
	/* If we've not rcvd even one pkt */
	if(dptc->rxPktCnt == 0)
		tp->testresult = RET_FAILED;
	if(sb_conflict)
		tp->result[port].testresult = tp->testresult;

	mdk_testState[port].state = TEST_DONE;
	test_done = 1;

	/*
	if(!sb_conflict)
		mdk_show_results(testresult, port);
	*/	
	/* this is used to add eee hdr for pkts looping
	 * through front plane 
	 */
	mdk_loopback = 0;
	return(NFX_OK);
}

char8 *
mdk_fill_lmux_hdr(uchar8 *bufp, uint32 linkid, uint32 pktSize)
{
	uchar8 *junkbuf;
	uchar8 *tmp;
	char *myMacAddr;
	enet_hdr_t *ethHdr;

	junkbuf = bufp;
	junkbuf+=3;
	*junkbuf++ = (linkid%3);
	tmp = junkbuf;
    myMacAddr = (char *)bmc12500_lsi_macAddr[linkid];
	ethHdr = (enet_hdr_t *)tmp;
    memcpy(ethHdr->SA, myMacAddr, 6);
    memcpy(ethHdr->DA, myMacAddr, 6);
    ethHdr->type =  EEE_ETH_TYPE;
	junkbuf +=14;
	*junkbuf++ = 0;
	*junkbuf++ = 0;
    memcpy(&static_lmux_hdr[linkid], bufp, 20);
	return(junkbuf);
}		

char8 *
mdk_fill_luc_hdr(uchar8 *bufp, uint32 linkid, uint32 pktSize)
{
	uchar8 *junkbuf;
	//uchar8 *buf;
	int i;
    luc_tx_hdr_t luc_hdr;
    uint16 udp_len;
    uint16 ip_len;
	//uchar8 tmp;
	
	junkbuf = bufp;
    /* fill LUC header = 20 bytes */
    luc_hdr.field.seq_num = 0;
    luc_hdr.field.pkt_len = 0;
    luc_hdr.field.link_id = linkid;
    luc_hdr.field.control = 3; /* generate both checksums */
    luc_hdr.field.protocol = 0x11;
    luc_hdr.field.tcp_udp_len = pktSize - 20 - 14 - 20;
    luc_hdr.field.src_ip = 0x99999999;
    luc_hdr.field.dest_ip = 0x66666666;
    luc_hdr.field.l3_offset = 14;
    luc_hdr.field.l4_offset = 34;
    luc_hdr.field.tcp_udp_csum = 40;
    luc_hdr.field.tcp_udp_csum = 40;
    luc_hdr.field.ip_csum = 24;

	//memcpy(junkbuf,&luc_hdr.data,20);
    for (i = 19; i >= 0; i--) {
		*junkbuf++ = luc_hdr.data[i];
	}	
    /* fill MAC header = 14 bytes */
    for (i = 0; i < 6; i++)
        *junkbuf++ = 0xff;
    for (i = 6; i < 12; i++)
        *junkbuf++ = 0x00;
    *junkbuf++ = 0x08;
    *junkbuf++ = 0x00;

    ip_len = pktSize - 14 - 20;

    /* fill IP header = 20 bytes */
    *junkbuf++ = 0x45;
    *junkbuf++ = 0x00;
    *junkbuf++ = (ip_len >> 8) & 0xff ; /* length */
    *junkbuf++ = (ip_len & 0xff);
    *junkbuf++ = 0x00; /* id */
    *junkbuf++ = 0x00; /* id */
    *junkbuf++ = 0x40; /* flag */
    *junkbuf++ = 0x00;
    *junkbuf++ = 0xff;
    *junkbuf++ = 0x11;
    *junkbuf++ = 0x00; /* checksum */
    *junkbuf++ = 0x00; /* checksum */
    *junkbuf++ = 0x99; /* src ip */
    *junkbuf++ = 0x99;
    *junkbuf++ = 0x99;
    *junkbuf++ = 0x99;
    *junkbuf++ = 0x66; /* dest ip */
    *junkbuf++ = 0x66;
    *junkbuf++ = 0x66;
    *junkbuf++ = 0x66;

    /* fill UDP header = 8 bytes */
    *junkbuf++ = 0x11; /* src port */
    *junkbuf++ = 0x11;
    *junkbuf++ = 0x22; /* dest port */
    *junkbuf++ = 0x22;
    udp_len = pktSize - 14 - 20 -20 - 8;
    *junkbuf++ = (udp_len >> 8) & 0xff;
    *junkbuf++ = (udp_len & 0xff);
    *junkbuf++ = 0x00; /* checksum */
    *junkbuf++ = 0x00; /* checksum */

    junkbuf++;
    junkbuf++;
    memcpy(&static_luc_hdr[linkid], bufp, 64);
	return(junkbuf);
}

uint32
mdk_send_off_pkt(char8 *buf,uint32 pktSize,uint32 destAddr)
{		
	int32 k;	
	int32  bufCnt;
	int32  bufLen;
	int32  lastBufLen;
	//int32  pktCnt;
	//uchar8 *bufptr;
	eee_desc_t *edesc;
	eee_descHdr_t *hdr;

	if( !(pktSize % 2048) ) {
		bufCnt = (pktSize / 2048);
		lastBufLen = 2048;
	}
	else {
		bufCnt = (pktSize / 2048) + 1;
		lastBufLen = pktSize % 2048;
	}
	edesc = eee_allocateDesc(EEE_SHARED_POOL, NFX_COS_HIGH);
	memset(edesc,0, sizeof(eee_desc_t));
	hdr = (eee_descHdr_t *)edesc;
	hdr->control = (bufCnt << EDESC_BUFCNT_SHIFT) | pktSize;

	for(k=1; k <= bufCnt; k++) {
		if(k == bufCnt)
			bufLen = lastBufLen;
		else
			bufLen = 2048;

		edesc->hdr.src_port = destAddr; 
		edesc->hdr.dest_port = destAddr; 

		edesc->bd[k].buf = buf;
		edesc->bd[k].len = bufLen;
		edesc->bd[k].control = EDESC_BD_CMD_IN_USE | EDESC_BD_LARGE;
	}
	/*
	if( bmc12500Eth_tx_pkt_trace) {
		printf("BMC Tx: bufp: %x, bufLen: %d\n", edesc->bd[1].buf, edesc->bd[1].len);
		bmc12500Eth_printBuf( edesc->bd[1].buf, edesc->bd[1].len, 1);  
	}*/
	bmc12500Eth_txUnicast( edesc->hdr.dest_port,edesc );
}
#endif
