/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : ndmp-auth.h
 *
 * Description  : Main header file of the NDMP authentication library.
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 06-SEP-2001
 *
 *------------------------------------------------------------------------------
 */
#ifndef _NDMP_AUTH_H_
#define _NDMP_AUTH_H_

/*------------------------------------------------------------------------------
 * Include files
 *------------------------------------------------------------------------------
 */

#include <stdio.h>      // fprintf(), stderr
#include <stdlib.h>     // exit()
#include <string.h>     // memset()

#include "nfx-incl.h"
#include "exports/opt-api.h"
#include "exports/anpssc-api.h"
#include "exports/crypt-api.h"

/*------------------------------------------------------------------------------
 * Constants and macros.
 *------------------------------------------------------------------------------
 */

#define NDMP_DBG_PRINT(_p_)  // printf
#define NDMP_FCT_PRINT(_p_)  // printf
#define NDMP_ERR_PRINT(_p_)  // printf

/*------------------------------------------------------------------------------
 * Global variables.
 *------------------------------------------------------------------------------
 */

/* Wait for EVM to respond (10s).
 */
struct timeval waitRegmTo = {10, 0};
    
/*------------------------------------------------------------------------------
 * Type definitions.
 *------------------------------------------------------------------------------
 */

/* Basic message structure.
 */
typedef struct
{
    char    buf[50 * (OPT_MAX_OPTION_LEN + MAX_VALUE_LEN)];
    uint32  len;
} ndmp_msg_t;

/*----------------------------------------------------------------------------*/

#endif // _NDMP_AUTH_H_
