/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * RCS:  $Id: nb-msg.h,v 1.1.1.1 2002/04/23 17:52:14 laurentb Exp $
 *
 * Name			: nb-msg.c
 *
 * Description	: NetBIOS message encoding and decoding deninitions.
 *
 * Created by	: Xiaobing Zhang
 *
 * Date Created	: 11/07/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _NB_MSG_H
#define _NB_MSG_H

void nb_getNameWithType(nb_name_t *name, uchar8 *nameStr);

void nb_displayRsrcMsg(nb_nsResource_t *rsrcP);

void nb_displayDecodedNsMsg(nb_nsPacket_t	*nsPktP);

void nb_displayDecodedSsMsg(uchar8	*buf);

void nb_displayDecodedDsMsg(uchar8	*buf);

void nb_displayEncodedMsg(uchar8 *buf, uint32 length);

uint32			// Buffer length for NetBIOS name
nb_buildNameMsg(uchar8		*buf,	 // Buffer to store compressed NetBIOS name
				nb_name_t	*nbName);// Name

uint32			// Buffer length
nb_buildRsrcMsg(uchar8			*buf,	// Buffer to store resource record
				nb_nsResource_t	*rsrcP,	// Resource record
				boolean			namePointer);	// If TURE, put name pointer
												// instead of name in RR_NAME

uint32			// Length of name service message
nb_buildNsMsg(uchar8		*buf,	 // Buffer for name service msg to be sent
			  nb_nsPacket_t	*nsPktP);// Name service packet structure

uint32			// Return number of bytes taken by the name. 0 if invalid.
nb_parseNameMsg(uchar8		*buf,		// Name service msg received
				int32		offset,		// Offset of compressed name
				uint32		length,		// Length of name service message 
				nb_name_t	*nbNameP);

int32			// offset
nb_parseRsrcMsg(uchar8			*buf,	// Name service msg received
				uint32			offset,	// Offset of resource record
				uint32			length,	// Length of name service message
				nb_nsResource_t	**rsrcP);

int32			// NFX_OK or NFX_ERR
nb_parseNsMsg(uchar8		*buf,		// Name service msg received
			  uint32		length,		// Length of message to be parsed
			  nb_nsPacket_t	*nsPktP);	// Name service packet

uint32			// Length of datagram service message
nb_buildDsMsg(uchar8		*buf,	 // Buffer for datagram msg to be sent
			  nb_dsPacket_t	*dsPktP, // Datagram service packet structure
			  uint16		msgType);// Datagram message type

#endif /* _NB_MSG_H */

