/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * RCS:  $Id: nb-tpl.h,v 1.1.1.1 2002/04/23 17:52:14 laurentb Exp $
 *
 * Name			: nb-tpl.h
 *
 * Description	: Contains NetBIOS initialization and utility deninitions.
 *
 * Created by	: Xiaobing Zhang
 *
 * Date Created	: 11/12/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _NB_TPL_H
#define _NB_TPL_H

int32			// NFX_OK or NFX_ERR
nb_tplNsAddConnInd(tpl_bindCb_t	*bindP,		// Ptr to Bind CB
				   void			*connHdlP,	// Ptr to newly added connection
				   void			**appHdlPP,	// Ptr to correspond app. handle
				   uint32		raddr,		// Remote IP address
				   ushort16		rport);		// Remote port

int32			// NFX_OK or NFX_ERR
nb_tplNsDelConnInd (void *appHdlP, void *connHdlP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplNsRcvPktInd(void *appHdlP, pkt_desc_t *descP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplNsXmtCmpInd (void *appHdlP, pkt_desc_t *descP);

int32			// NFX_OK or NFX_ERR
nb_tplSsAddConnInd(tpl_bindCb_t	*bindP,		// Ptr to Bind CB
				   void			*connHdlP,	// Ptr to newly added connection
				   void			**appHdlPP,	// Ptr to correspond app. handle
				   uint32		raddr,		// Remote IP address
				   ushort16		rport);		// Remote port

int32 			// NFX_OK or NFX_ERR
nb_tplSsDelConnInd (void *appHdlP, void *connHdlP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplSsRcvPktInd(void *appHdlP, pkt_desc_t *descP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplSsXmtCmpInd (void *appHdlP, pkt_desc_t *descP);

int32			// NFX_OK or NFX_ERR
nb_tplDsAddConnInd(tpl_bindCb_t	*bindP,		// Ptr to Bind CB
				   void			*connHdlP,	// Ptr to newly added connection
				   void			**appHdlPP,	// Ptr to correspond app. handle
				   uint32		raddr,		// Remote IP address
				   ushort16		rport);		// Remote port
 
int32			// NFX_OK or NFX_ERR
nb_tplDsDelConnInd (void *appHdlP, void *connHdlP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplDsRcvPktInd(void *appHdlP, pkt_desc_t *descP);

int32			// TPL_FREE_PKT or TPL_HOLD_PKT
nb_tplDsXmtCmpInd (void *appHdlP, pkt_desc_t *descP);

int32			// NFX_OK or TPL error
nb_tplBindReq(nb_srvCB_t	*srvCbP,	// Prt to server control block
			  uint32		raddr,		// Remote IP addr if in client mode
			  uint16		rport,		// Remote port if in client mode
			  uint16		service,	// name, session, or datagram service
			  uint16		protocol,	// Protocol UDP/TCP
			  int32			bindMode);	// TPL_BIND_SERVER or TPL_BIND_CLIENT

void
nb_xmtPktSP(void		*sock,		// Socket to send the message
			pkt_desc_t	*xmtPktP,	// Prt to packet descriptor 
									// containing message to be sent
			uint32		raddr,		// IP address in network byte order
			uint16		rport);		// Port in network byte order

#endif /* _NB_TPL_H */
