/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:        nfs-cache.h
 *
 * RCS:  $Id: nfs-cache.h,v 1.1 2002/10/30 03:54:40 shaun Exp $
 *
 * Copyright (C) 2002, Agile Storage Inc.
 *
 * Description: Contain NFS attribute cache  related prototypes 
 *
 * Created by:	Shaun Hui
 *
 * Date Created: 10/10/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _NFS_CACHE_H
#define _NFS_CACHE_H


void 
nfs_cacheInit( void );

void *
nfs_cacheFindAttr(fs_Handle *fhdlp, int32 *idx);

void *
nfs_cacheAddAttr( fs_Handle *fhdlp, fs_Attr *attrp, int32 hashIdx );

void
nfs_cacheUpdateAttr( fs_Handle *fhdlp, fs_Attr *attrp);

void    *
nfs_cacheFindSymlnk(fs_Handle *fhdlp, int32 *idx);

void *
nfs_cacheAddSymlnk( fs_Handle   *fhdlp,
                    fs_Attr     *attrp,
                    int32       hashIdx,
                    char        *namep,
                    uint32      nameLen );

void    *
nfs_cacheFindFsinfo(fs_Handle *fhdlp, int32 *idx);

void *
nfs_cacheAddFsinfo( fs_Handle   *fhdlp,
                    fs_Attr     *attrp,
                    fs_Fsinfo   *infop,
                    int32       hashIdx);

void
nfs_cacheUpdateSymlnk( void *cachep, fs_Attr *attrp);


int32   
nfs_cacheSendGetAttrResp(nfs_request_t *nfsReqp, void *cachep);

int32   
nfs_cacheSendAccessResp(nfs_request_t 	*nfsReqp, 
						void 			*cachep, 
						uint32 			reqBits);

int32
nfs_cacheSendReadLinkResp(nfs_request_t *nfsReqp,
                        void            *cachep );

int32
nfs_cacheSendFsinfoResp(nfs_request_t *nfsReqp,
                        void          *cachep );

int32
nfs_cacheAgeTmrHandler( int32   timer_handle,
                        void    *param1,
                        void    *param2,
                        void    *param3,
                        void    *param4);

#endif /* NFP_TXRX */
