/* vi:ts=4
 *
 *-----------------------------------------------------------------
 *
 * Name:        nfs-ssc-cmd.h
 *
 * RCS:  $Id: nfs-ssc-cmd.h,v 1.4 2002/10/22 01:30:39 jong Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description: NFS SSC Command definitions.
 *
 * Created by:  Joseph Vu
 *
 * Date Created:        5/18/01
 *
 *-----------------------------------------------------------------
 */
#ifndef _NFS_SSC_CMD_H
#define _NFS_SSC_CMD_H

typedef enum
{
	NFS_REQ_STAT_MSG = NFSSSC_MSG_BASE,
	NFS_RESP_STAT_MSG,
	NFS_NEXT_MSG
} nfs_msgType_t;

typedef struct nfs_msgHdr
{
    nfs_msgType_t   msgType;        /*message type*/
	uint32			pad;
    uint64          private;
    int32           status;         /*message response status*/
    int32           reserved;
} nfs_msgHdr_t;

typedef struct nfs_infoReq
{
    nfs_msgHdr_t    msgHdr;         /*message header*/
    uint32          clientAddr;     /*client IP address*/
} nfs_infoReq_t;

typedef struct nfs_statMsg
{
    nfs_pktCounters_t       nfs_v2XmtPktCounters;   //NFS V2 transmit pkt counters
    nfs_pktCounters_t       nfs_v2RxPktCounters;    //NFS V2 receive rx counters
    nfs_pktCounters_t       nfs_v3XmtPktCounters;   //NFS V2 transmit pkt counters
    nfs_pktCounters_t       nfs_v3RxPktCounters;    //NFS V2 receive rx counters
} nfs_statMsg_t;

typedef struct nfs_infoResp
{   
    nfs_msgHdr_t    msgHdr;
	union
	{
		nfs_statMsg_t		stat;	
		//..next message
	}msg;

#ifdef NFS_USE_TIME_STAMP
	uint64              count_per_usec;
	nfs_procTime_t	procTime[NFS_COMMIT+1];
#endif

} nfs_infoResp_t;

#endif  /*_NFS_SSC_CMD_H*/
