/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:		nlm-test.c
 *
 * RCS:  $Id: nlm-test.c,v 1.3 2002/11/06 03:35:39 joseph Exp $
 *
 * Copyright (C) 2002, Agile Storage Inc.
 *
 * Description: NLM unit test.
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	07/20/2002
 *
 *-----------------------------------------------------------------
 */
#ifdef	NFP_TXRX
#include <nfx-incl.h>
#include <exports/nfs-api.h>
#include "nlm-prototypes.h"

nlm_globalCfg_t	nlmGlobalCfg;
nlm_globalCfg_t	*nlm_globalCfgp;
uint32			nlm_traceEnable;
uint32			nlm_traceDebugEnable;

nfp_clientCB_t	nlmtest_clientCB;
fs_Handle		nlmtest_fileHandle;
nfp_fileCB_t	*nlmtest_fileCBp;

#ifdef	NOTUSED

void
nlm_testLockInit()
{
	nfp_fileCB_t	*fileCBp;
	nfp_lockCB_t	*lockCBp;
	nlm_lockInfo_t	*lockInfop;

	nlm_globalCfgp = &nlmGlobalCfg;
	memset(nlm_globalCfgp, 0, sizeof(nlm_globalCfg_t));

	/*Init file handle*/
	nlmtest_fileHandle.volId.whole_thing = 0x1122334455667788;
	nlmtest_fileHandle.inum = 0x1122334455667788;
	nlmtest_fileHandle.gen = 0x11223344;
	nlmtest_fileHandle.mkfsTime = 0x11223344;
	nlmtest_fileHandle.mntPnt = 0x1122334455667788;

	/*Init file CB*/
	nlmtest_fileCBp = nlm_getFileCB(&nlmtest_fileHandle, &nlmtest_clientCB);
	fileCBp = nlmtest_fileCBp;

	/*Init lock list*/

	/*1st lockCB*/
	lockCBp = nfp_allocLockCB();
	lockCBp->nfp_clientCbp = &nlmtest_clientCB;
	lockCBp->nfp_fileCbp = fileCBp;
	lockInfop = &lockCBp->protocol.nfp_nlmLock;
	lockInfop->nlm_svid = 1;
	lockInfop->lockRec.nlm_l_offset = 100;
	lockInfop->lockRec.nlm_l_end = 120;
	lockInfop->lockRec.nlm_l_len = 21;
	lockInfop->lockRec.nlm_exclusive = TRUE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client1");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner1");

	nlm_addLockCBToCurrList(fileCBp, NULL, lockCBp);

	/*2nd lockCB*/
	lockCBp = nfp_allocLockCB();
	lockCBp->nfp_clientCbp = &nlmtest_clientCB;
	lockCBp->nfp_fileCbp = fileCBp;
	lockInfop = &lockCBp->protocol.nfp_nlmLock;
	lockInfop->nlm_svid = 1;
	lockInfop->lockRec.nlm_l_offset = 200;
	lockInfop->lockRec.nlm_l_end = 230;
	lockInfop->lockRec.nlm_l_len = 31;
	lockInfop->lockRec.nlm_exclusive = FALSE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client2");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner2");

	nlm_addLockCBToCurrList(fileCBp, NULL, lockCBp);

	/*3rd lockCB*/
	lockCBp = nfp_allocLockCB();
	lockCBp->nfp_clientCbp = &nlmtest_clientCB;
	lockCBp->nfp_fileCbp = fileCBp;
	lockInfop = &lockCBp->protocol.nfp_nlmLock;
	lockInfop->nlm_svid = 3;
	lockInfop->lockRec.nlm_l_offset = 300;
	lockInfop->lockRec.nlm_l_end = 340;
	lockInfop->lockRec.nlm_l_len = 41;
	lockInfop->lockRec.nlm_exclusive = TRUE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client3");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner2");

	nlm_addLockCBToCurrList(fileCBp, NULL, lockCBp);

	/*4th lockCB*/
	lockCBp = nfp_allocLockCB();
	lockCBp->nfp_clientCbp = &nlmtest_clientCB;
	lockCBp->nfp_fileCbp = fileCBp;
	lockInfop = &lockCBp->protocol.nfp_nlmLock;
	lockInfop->nlm_svid = 4;
	lockInfop->lockRec.nlm_l_offset = 400;
	lockInfop->lockRec.nlm_l_end = 450;
	lockInfop->lockRec.nlm_l_len = 51;
	lockInfop->lockRec.nlm_exclusive = TRUE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client4");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner4");

	nlm_addLockCBToCurrList(fileCBp, NULL, lockCBp);
}

void
nlm_testAddLockToCurr(uint64 offset, uint64 len)
{
	nfp_lockCB_t	*lockCBp, *addLockCBp;
	nlm_lockInfo_t	*lockInfop;
	nfp_nodePtr_t   nextLockNodep;

	addLockCBp = nfp_allocLockCB();
	addLockCBp->nfp_clientCbp = &nlmtest_clientCB;
	addLockCBp->nfp_fileCbp = nlmtest_fileCBp;
	lockInfop = &addLockCBp->protocol.nfp_nlmLock;

	lockInfop->nlm_svid = 1;
	lockInfop->lockRec.nlm_l_offset = offset;
	lockInfop->lockRec.nlm_l_end = offset + len - 1;
	lockInfop->lockRec.nlm_l_len = len;
	lockInfop->lockRec.nlm_exclusive = TRUE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client3");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner2");

	printf("show addLockCBp\n");
	nlm_showLock(addLockCBp, "\t");

	lockCBp = nlm_getLockCBInList(	nlmtest_fileCBp,
									lockInfop,
									0,
									&nextLockNodep,
									&nlmtest_fileCBp->nfp_lockList);
	if (nextLockNodep)
	{
		nfp_lockCB_t	*nextLockCBp;
		nextLockCBp = (nfp_lockCB_t *)(nextLockNodep->nfp_entryCBp);

		printf("nextLockNodep = %p\n", nextLockNodep);
		printf("show nextLockCBp\n");
		nlm_showLock(nextLockCBp, "\t");
	}
	else
		printf("NULL nextLockNodep\n");

	if (!lockCBp)
	{
		printf("\tAdd to current list\n");
		nlm_addLockCBToCurrList(nlmtest_fileCBp, nextLockNodep, addLockCBp);
	}
	else
	{
		printf("\tAdd to pending list\n");
		nlm_addLockCBToPendList(lockCBp, addLockCBp);
	}
}

void
nlm_testAddLockToPend(uint64 offset, uint64 len)
{
	nfp_lockCB_t	*lockCBp, *addLockCBp;
	nlm_lockInfo_t	*lockInfop;
	nfp_nodePtr_t   nextLockNodep;

	addLockCBp = nfp_allocLockCB();
	addLockCBp->nfp_clientCbp = &nlmtest_clientCB;
	addLockCBp->nfp_fileCbp = nlmtest_fileCBp;
	lockInfop = &addLockCBp->protocol.nfp_nlmLock;

	lockInfop->nlm_svid = 1;
	lockInfop->lockRec.nlm_l_offset = offset;
	lockInfop->lockRec.nlm_l_end = offset + len - 1;
	lockInfop->lockRec.nlm_l_len = len;
	lockInfop->lockRec.nlm_exclusive = TRUE;
	lockInfop->lockRec.nlm_state = 1;
	lockInfop->nlm_callerNameLen = 7;
	lockInfop->nlm_callerName = eee_ramAlloc(lockInfop->nlm_callerNameLen + 1);
	strcpy(lockInfop->nlm_callerName, "client3");
	lockInfop->nlm_ohLen = 6;
	lockInfop->nlm_oh = eee_ramAlloc(lockInfop->nlm_ohLen + 1);
	strcpy(lockInfop->nlm_oh, "owner2");
	
	lockCBp = nlm_getLockCBInList(	nlmtest_fileCBp,
									lockInfop,
									0,
									&nextLockNodep,
									&nlmtest_fileCBp->nfp_lockList);

	if (!lockCBp)
	{
		printf("\tAdd to current list\n");
		nlm_addLockCBToCurrList(nlmtest_fileCBp, nextLockNodep, addLockCBp);
	}
	else
	{
		printf("show lockCBp\n");
		nlm_showLock(lockCBp, "\t");

		printf("show addLockCBp\n");
		nlm_showLock(addLockCBp, "\t");

		printf("\tAdd to pending list\n");
		nlm_addLockCBToPendList(lockCBp, addLockCBp);
	}
}

void
nlm_testTstCurrLock(uint32	searchMask)
{
	nlm_lockInfo_t	alock;
	nfp_lockCB_t	*lockCBp;
	nfp_nodePtr_t   nextLockNodep;


	alock.nlm_svid = 1;
	alock.lockRec.nlm_l_offset = 250;
	alock.lockRec.nlm_l_end = 500;
	alock.lockRec.nlm_l_len = 251;
	alock.lockRec.nlm_exclusive = FALSE;
	alock.lockRec.nlm_state = 1;
	alock.nlm_callerNameLen = 7;
	alock.nlm_callerName = eee_ramAlloc(alock.nlm_callerNameLen + 1);
	strcpy(alock.nlm_callerName, "client3");
	alock.nlm_ohLen = 6;
	alock.nlm_oh = eee_ramAlloc(alock.nlm_ohLen + 1);
	strcpy(alock.nlm_oh, "owner2");

	if (searchMask & NLM_SEARCH_REGION_MATCH)
	{
		alock.lockRec.nlm_l_offset = 200;
		alock.lockRec.nlm_l_end = 230;
		alock.lockRec.nlm_l_len = 31;
	}
	if (searchMask & NLM_SEARCH_EXCLUSIVE)
	{
		alock.lockRec.nlm_exclusive = TRUE;
		alock.lockRec.nlm_l_offset = 110;
		alock.lockRec.nlm_l_end = 120;
		alock.lockRec.nlm_l_len = 11;
	}

	lockCBp = nlm_getLockCBInList(	nlmtest_fileCBp, 
									&alock, searchMask, 
									&nextLockNodep, 
									&nlmtest_fileCBp->nfp_lockList);
	if (lockCBp)
		printf("Lock found\n");
	else
		printf("Lock not found\n");
}

void
nlm_testTstPendLock(uint64 offset, uint64 len)
{
	nlm_lockInfo_t	alock;
	nfp_lockCB_t	*lockCBp;

	alock.nlm_svid = 1;
	alock.lockRec.nlm_l_offset = offset;
	alock.lockRec.nlm_l_end = offset + len - 1;
	alock.lockRec.nlm_l_len = len;
	alock.lockRec.nlm_exclusive = TRUE;
	alock.lockRec.nlm_state = 1;
	alock.nlm_callerNameLen = 7;
	alock.nlm_callerName = eee_ramAlloc(alock.nlm_callerNameLen + 1);
	strcpy(alock.nlm_callerName, "client3");
	alock.nlm_ohLen = 6;
	alock.nlm_oh = eee_ramAlloc(alock.nlm_ohLen + 1);
	strcpy(alock.nlm_oh, "owner2");

	lockCBp = nlm_getLockCBInPendList(nlmtest_fileCBp, &alock);
	if (lockCBp)
		printf("Lock found\n");
	else
		printf("Lock not found\n");
}

void
nlm_testRmLock(uint64 offset, uint64 len)
{
	nlm_lockInfo_t	alock;
	nfp_lockCB_t	*lockCBp;
	nfp_nodePtr_t   nextLockNodep;

	alock.nlm_svid = 1;
	alock.lockRec.nlm_l_offset = offset;
	alock.lockRec.nlm_l_end = offset + len - 1;
	alock.lockRec.nlm_l_len = len;
	alock.lockRec.nlm_exclusive = TRUE;
	alock.lockRec.nlm_state = 1;
	alock.nlm_callerNameLen = 7;
	alock.nlm_callerName = eee_ramAlloc(alock.nlm_callerNameLen + 1);
	strcpy(alock.nlm_callerName, "client3");
	alock.nlm_ohLen = 6;
	alock.nlm_oh = eee_ramAlloc(alock.nlm_ohLen + 1);
	strcpy(alock.nlm_oh, "owner2");

	lockCBp = nlm_getLockCBInList(	nlmtest_fileCBp,
									&alock,
									NLM_SEARCH_OH | NLM_SEARCH_SVID | NLM_SEARCH_REGION_MATCH | NLM_SEARCH_EXCLUSIVE,
									&nextLockNodep,
									&nlmtest_fileCBp->nfp_lockList);

	if (!lockCBp)
	{
		lockCBp = nlm_getLockCBInPendList(nlmtest_fileCBp, &alock);
		if (lockCBp)
		{
			printf("Remove lock from pending list\n");
			nlm_rmLockCBFromList(lockCBp, NLM_PENDING_LIST, TRUE);
		}
		else
			printf("Lock is not found\n");
	}
	else
	{
		printf("Remove lock from current list\n");
		nlm_rmLockCBFromList(lockCBp, NLM_CURRENT_LIST, TRUE);
	}
}

void
nlm_testRmCurrLockList()
{
	nlm_delLockCBList(&nlmtest_fileCBp->nfp_lockList);
}

void
nlm_testRmPendLockList(uint64 offset, uint64 len)
{
	nlm_lockInfo_t	alock;
//	nfp_lockCB_t	*lockCBp;
//	nfp_nodePtr_t   nextLockNodep;

	alock.nlm_svid = 1;
	alock.lockRec.nlm_l_offset = offset;
	alock.lockRec.nlm_l_end = offset + len - 1;
	alock.lockRec.nlm_l_len = len;
	alock.lockRec.nlm_exclusive = TRUE;
	alock.lockRec.nlm_state = 1;
	alock.nlm_callerNameLen = 7;
	alock.nlm_callerName = eee_ramAlloc(alock.nlm_callerNameLen + 1);
	strcpy(alock.nlm_callerName, "client3");
	alock.nlm_ohLen = 6;
	alock.nlm_oh = eee_ramAlloc(alock.nlm_ohLen + 1);
	strcpy(alock.nlm_oh, "owner2");

#ifdef	NOTUSED
	lockCBp = nlm_getLockCBInList(	nlmtest_fileCBp,
									&alock,
									0,
									&nextLockNodep,
									&nlmtest_fileCBp->nfp_lockList);
	if (lockCBp)
	{
		printf("Found lock in current list\n");
		nlm_delLockCBList(&lockCBp->nfp_pendingLockList);
	}
	else
		printf("Lock is not found\n");
#endif
	nlm_delLockCBList(&nlmtest_fileCBp->nfp_lockPendingList);


}

void
nlm_testShowLock()
{
	nlm_showFileLocks(nlmtest_fileCBp);
}


#endif	//NOTUSED

#endif	//NFP_TXRX
