#include <sys/types.h>
#include "opt-api.h"
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

static void
do_test(const char *file_name)
{
	int rv;
	int fd;

	if ((rv = ensure_fs_writable(file_name)) != 0) {
		printf("ensure_fs_writable failed\n");
	}
	fd = open(file_name, O_RDWR| O_CREAT, 0666);
	if (fd < 0) {
		perror("open");
		exit(1);
	}
	close(fd);
	unlink(file_name);
	restore_fs_permissions(file_name);
	fd = open(file_name, O_RDWR|O_CREAT, 0666);
	if (fd >= 0) {
		printf("open succeeeded\n");
		exit(1);
	}
}

int
main(int argc, char **argv)
{
	const char *test_file_1 = "/my-file";
	const char *test_file_2 = "/usr/my_file";

	do_test(test_file_1);
	do_test(test_file_2);

	return 0;
}
