/*
 *------------------------------------------------------------------------------
 *
 * Name:	raid-common.h
 *
 * RCS:		$Id: raid-common.h,v 1.1 2002/04/26 03:39:15 raster Exp $
 *
 * Copyright (C) 2001, 2002, Agile Storage Inc.
 *
 * Description:	RAID config manager common definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 4/16/02
 *
 *------------------------------------------------------------------------------
 */
#ifndef __RAID_COMMON_H__
#define __RAID_COMMON_H__

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/time.h>

#include <nfx-target.h>
#include <nfx-error.h>
#include <nfx-types.h>
#include <nfx-defs.h>
#include <exports/eee-api.h>  
#include <exports/scsi-api.h>
#include <exports/sdm-api.h>
#include <exports/debug.h>
#include <exports/anpssc-api.h>
#include <exports/elog-api.h>

#include "raid-api.h"
#include "raid-sm.h"
#include "raid-device.h"
#include "raid-msg.h"
#include "raid-debug.h"

void panic(char *, ...);
void raid_terminate(void);

#endif /* __RAID_COMMON_H__ */
