/*
 *------------------------------------------------------------------------------
 *
 * Name:	raid-device.h
 *
 * RCS:		$Id: raid-device.h,v 1.1 2002/04/26 03:39:15 raster Exp $
 *
 * Copyright (C) 2001, 2002 Agile Storage Inc.
 *
 * Description:	RAID config manager device discover and management.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 4/16/02
 *
 *------------------------------------------------------------------------------
 */

#ifndef __RAID_DEVICE_H__
#define __RAID_DEVICE_H__

extern raid_dev_t * raid_devs;

raid_dev_t *raid_device_new(sdm_devInfoRspMsg_t *);
raid_dev_t *raid_device_lookup_by_id(scsi_id_t);
raid_dev_t *raid_device_lookup_by_devname(char *);
void        raid_device_destroy(raid_dev_t *);

void        raid_devs_init(void);
void        raid_device_management_init(void);
void        raid_device_management_poll(void);
void        raid_close_all_devices(void);

#endif /* __RAID_DEVICE_H__ */
