/*  
 *=============================================================================
 * File Name   :    sb1250-dm-regs.h
 *
 *  Description:    
 *
 *  Created    :    20 December 2001
 *
 *  Author     :    Frank Salzmann
 *
 *  RCS		   :	$Id: sb1250-dm-regs.h,v 1.1.1.1 2002/02/09 20:48:35 frank Exp $
 *
 *  Copyright(c)  Agile Storage, Inc. 2001
 *=============================================================================
 */
#ifndef SB1250_DM_REGS_H_INCLUDED
#define SB1250_DM_REGS_H_INCLUDED

typedef struct _sb1250dm_regs
{
	uint64 *dm_desc_base;     
	uint64 *dm_desc_count;    
	uint64 *dm_cur_desc_addr;
	uint64 *dm_dbg_desc_base;
} sb1250dm_regs_t;

//---------------------------------------------
// SB1250 DESC BASE ADDRESS REGISTER 
//---------------------------------------------
typedef union _sb1250dm_desc_ba_reg 
{
	uint64 wd;
	struct {
		uint64 base			:40;
		uint64 ring_size	:16;
		uint64 priority		:3;
		uint64 active		:1;
		uint64 interrupt	:1;
		uint64 error_reset	:1;
		uint64 abort		:1;
		uint64 enbl			:1;
	} bits;
} sb1250dm_descBar_t;

#endif /* SB1250_DM_REGS_H_INCLUDED */
