/* AME $Id: amelib.h,v 1.9 2001/02/02 20:31:02 cgd Exp $ */

/*
 * Copyright 2000 SiByte, Inc.
 * THIS IS UNPUBLISHED, PROPRIETARY SOURCE CODE OF SiByte, Inc.
 */

/*
 * Library functions provided Absolutely Minimal Environment.
 */

#ifndef	_AMELIB_H_
#define	_AMELIB_H_

#include "stdarg.h"
#include "ametypes.h"

#ifndef NULL
#define	NULL	0
#endif

#ifndef offsetof
#define offsetof(type, member)	((size_t)(&((type *)0)->member))
#endif

/* XXX these satisfy the string->int et al conversion fns */
#define isupper(c)      ((c) >= 'A' && (c) <= 'Z')
#define islower(c)      ((c) >= 'a' && (c) <= 'z')
#define isspace(c)      ((c) == ' ' || (c) == '\t')	/* XXX there are more */
#define isdigit(c)      ((c) >= '0' && (c) <= '9')
#define isalpha(c)      (isupper(c) || islower(c))

/* XXX these satisfy the string->int et al conversion fns */
#define	ERANGE	1
extern int errno;

#define	EXIT_FAILURE	1
#define	EXIT_SUCCESS	0

void	abort(void)
	    __attribute__((__noreturn__));
void	_exit(int)
	    __attribute__((__noreturn__));
void	exit(int)
	    __attribute__((__noreturn__));
void	panic(const char *, ...)
	    __attribute__((__noreturn__,__format__(__printf__,1,2)));

int	atexit(void (*func)(void));	/* max 32 fns can be registered */

void	*malloc(size_t);
void	free(void *);
void	*calloc(size_t num, size_t size);

int	printf(const char *, ...)
	    __attribute__((__format__(__printf__,1,2)));
int	sprintf(char *, const char *, ...)
	    __attribute__((__format__(__printf__,2,3)));
int	snprintf(char *, size_t, const char *, ...)
	    __attribute__((__format__(__printf__,3,4)));
int	vprintf(const char *, va_list);
int	vsprintf(char *, const char *, va_list);
int	vsnprintf(char *, size_t, const char *, va_list);

extern int printf_disabled;	/* disable operation of printf() et al */
extern int sprintf_disabled;	/* disable operation of sprintf() et al */

int	_getchar(void);		/* returns character or -1 if none ready */
int	getchar(void);		/* returns character (waiting if necessary) */
char 	*gets(char *);
void	putchar(int);		/* output char, translates \n -> \r\n */
int	puts(const char *);

void	*memcpy(void *, const void *, size_t);
void	*memccpy(void *, const void *, int c, size_t);
void	*memchr(const void *, int c, size_t);
void	*memmove(void *, const void *, size_t);
int	memcmp(const void *, const void *, size_t);
void	*memset(void *, int c, size_t);

#define	bcopy(s, d, l)		(void)memmove((d), (s), (l))
#define	bcmp(s1, s2, l)		memcmp((s1), (s2), (l))
#define	bzero(s, l)		(void)memset((s), 0, (l))

char	*strdup(const char *);
char	*strcat(char *, const char *);
char	*strncat(char *, const char *, size_t);
char	*strchr(const char *, int);
char	*strrchr(const char *, int);
size_t	strlen(const char *);
int	strcmp(const char *, const char *);
int	strncmp(const char *, const char *, size_t);
char	*strcpy(char *, const char *);
char	*strncpy(char *, const char *, size_t);
size_t	strspn(const char *, const char *);
char	*strstr(const char *, const char *);
char	*strtok(char *, const char *);

long		atol(const char *);
long long	atoll(const char *);
int		atoi(const char *);
long		strtol(const char *, char **, int);
unsigned long	strtoul(const char *, char **, int);
long long	strtoll(const char *, char **, int);
unsigned long long strtoull(const char *, char **, int);

void	qsort(void *, size_t, size_t, int (*)(const void *, const void *));

/* MIPS-specific bits */
uint32_t mips_get_count(void);

#endif
