/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: bsp-api.h,v 1.7 2002/11/26 22:23:10 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/14/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _BSP_API_H
#define _BSP_API_H

#define BSP_TIMER_PROFILER		1
#define BSP_TIMER_SYSTEM_TIC	3

/*
 * Timer functions
 */
void timer_start_us(uint32 timer_num,
					uint32 us,
					void (*int_func)(uint32, uint32, address_t));
void timer_stop(uint32 timer_num);
void timer_int_clear(uint32 timer_num);
uint64 timer_get_count(uint32 timer_num);

#define TIMER_REF_SYSTEM_TIC_COUNT	0x3FFFFFLL
#define TIMER_REF_SHIFT				22
extern volatile uint64	timer_refSecond;

/*
 * Performance counter event IDs
 */
#define SB1250_PERF_INST_EXE	0
#define SB1250_PERF_ICACHE_MISS	15
#define SB1250_PERF_CYCLES		16
#define SB1250_PERF_ISSUE_TO_L0	40

void	perf_init_count(int32 counter_index, int32 event_id);
void	perf_start_counters();
void	perf_stop_counters();
uint64	perf_read_count(int32 counter_index);
uchar8	* perf_name(int32 event_id);

/*
 * Alternate CPU start/stop interface
 */
int32
altcpu_start(
    int32   cpu_num,
    void    * start_address
);

#endif	/* _BSP_API_H */

