/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: delay.c,v 1.4 2002/03/21 22:59:57 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/30/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <sys/sb1250/sb1250_regs.h>

/*-----------------------------------------------------------------
 * Name:	delay_us
 *
 * Description:	blocking delay loop which uses the internal gerneral purpose
 *				timer.  Counts down every microsecond.
 *
 *				Parameter is in microseconds.
 *
 *				Uses GP timer 0.
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/30/01
 *
 *-----------------------------------------------------------------
 */
void
delay_us(
	uint32	us			/* how many microseconds to pause */
)
{
#ifdef SB1250_SIMULATOR
	uint64	i;
	for (i=0; i<us; i++);
#else
	if (us > 8 * 1000 * 1000) {
		panic("Invalid delay setting, %d microseconds\n", us);
		return;
	}
	volatile sb1250_gptimer_t	* tptr;

	tptr = (volatile sb1250_gptimer_t *)PHYS_TO_K1(A_SCD_TIMER_0);

	tptr->init_cnt = us;
	tptr->config = GPTIMER_CFG_MODE_ONCE | GPTIMER_CFG_ENABLE;

	while (tptr->timer_cnt);
#endif
}

