/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: ecc-test.c,v 1.3 2002/11/07 01:17:17 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/26/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <sys/mips.h>
#include <sys/sb1250/sb1250_regs.h>
#include <sys/sb1250/sb1250_int.h>
#include <sys/sb1250/sb1250_mc.h>
#include <exports/except-api.h>

void ecc_set_test(uint32 mchan, address_t a, int set);
void ecc_set_test_data(uint32 mchan, address_t a, uint64 set);
void ecc_enable(uint32 mchan);
void ecc_disable(uint32 mchan);
void ecc_exception_start(uint32 cpu);
void ecc_exception_stop(uint32 cpu);
void ecc_view(uint32 cpu);

void  memz(void * start_addr, void * end_addr);
extern uint32 singleBitErrCauseException; 

int32
do_ecc(
	int32	ac,
	char8 * av[]
)
{
    if (ac < 2)
        return -1;

    if (strncmp(av[1], "ena", 3) == 0) {
        if( ac == 3) {
            int mctrl =0;
            mctrl = atolx(av[2]);
            if(( mctrl > 1 )||( mctrl < 0)) {
                printf(" Invalid Memory Controller (0/1) got %d\n",mctrl);
                return -1;
            }
            else {
                ecc_enable(mctrl);
            }
        }
        else {
            ecc_enable(0);
            ecc_enable(1);
        }
    }
    else if (strncmp(av[1], "dis", 3) == 0) {
        if( ac == 3) {
            int mctrl =0;
            mctrl = atolx(av[2]);
            if(( mctrl > 1 )||( mctrl < 0)) {
                printf(" Invalid Memory Controller (0/1) got %d\n",mctrl);
                return -1;
            }
            else {
                ecc_disable(mctrl);
            }
        }
        else {
            ecc_disable(0);
            ecc_disable(1);
        }
    }
    else if (strncmp(av[1], "test", 3) == 0) {
        int test = 0xf;
        address_t addr = 0xa0010000;
        if (ac >= 3)
            addr = atolx(av[2]);
        if (ac == 4)
            test = atox(av[3]);
        // current memory config interleaves memory controllers
        // to set up an error on both controllers we need to add
        // 0x10 to the address  (Bit 5)
        ecc_set_test(0, test, addr);
//        ecc_set_test(1, test, (addr + 0x10));
    }
    else if (strncmp(av[1], "data", 3) == 0) {
        uint64 test = 0xAAAAAAAA;
        address_t addr = 0xa0010000;
        if (ac >= 3)
            addr = atolx(av[2]);
        if (ac == 4)
            test = atolx(av[3]);
        ecc_set_test_data(0, test, addr);
//        ecc_set_test_data(1, test, (addr + 0x10));
    }
    else if (strncmp(av[1], "start", 3) == 0) {
        ecc_exception_start(0);
    }
    else if (strncmp(av[1], "stop", 3) == 0) {
        ecc_exception_stop(0);
    }
    else if (strncmp(av[1], "scrub", 3) == 0) {
        address_t  beg = 0x01000000;
        address_t  end = 0x02000000;

        extern void zerom(address_t, address_t);

        if (ac == 4) {
            beg = atolx(av[2]);
            end = atolx(av[3]);
        }
        beg = PHYS_TO_XKSEG_UNCACCEL(beg);
        end = PHYS_TO_XKSEG_UNCACCEL(end);
        printf("scrubbing %p to %p\n", (void *)beg, (void *)end);
        memz((void *)beg, (void *)end);
    }
    else if (strncmp(av[1], "view", 3) == 0) {
        ecc_view(0);
    }
    else if (strncmp(av[1], "sbe", 3) == 0) {
        if (strncmp(av[2], "ena", 3) == 0) {
            singleBitErrCauseException = 1;
            ecc_exception_start(0);
        }    
        else if (strncmp(av[2], "dis", 3) == 0) {
            if( ! singleBitErrCauseException )
                return(0);
            singleBitErrCauseException = 0;
            ecc_exception_start(0);
        }
        else
            printf(" Bad parameter..  ecc sbe [ena|dis] \n");
    }
    return 0;
}
