/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: led.c,v 1.1 2002/09/22 00:43:39 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/9/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <exports/hwMap.h>
#include <sys/led-api.h>
#include <exports/gpp-defs.h>
#include <sys/sb1250/sb1250_regs.h>

static int led_direction_set;
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	John Hahn
 *
 * Date Created:	9/18/02
 *
 *-----------------------------------------------------------------
 */
void
led_set(
	int	led_state
)
{
    volatile uint64 * gpio_pin_read_p;
    volatile uint64 * gpio_pin_clr_p;
    volatile uint64 * gpio_pin_set_p;


    gpio_pin_clr_p = (volatile uint64 *)PHYS_TO_K1(A_GPIO_PIN_CLR);
    gpio_pin_set_p = (volatile uint64 *)PHYS_TO_K1(A_GPIO_PIN_SET);
    gpio_pin_read_p = (volatile uint64 *)PHYS_TO_K1(A_GPIO_READ);

    //printf(">read gpio %x from %p\n", *gpio_pin_read_p, gpio_pin_read_p);

    if (isTXRX()) {
        if (!led_direction_set) {
            volatile uint64 * gpio_pin_dir_p;

            gpio_pin_dir_p = (volatile uint64 *)PHYS_TO_K1(A_GPIO_DIRECTION);
            *gpio_pin_dir_p = (GPP_TXRX_LED_OK_MASK|GPP_TXRX_LED_FLT_MASK);
            led_direction_set = 1;
        }
        switch (led_state) {
        case LED_OK_ON:
            *gpio_pin_clr_p = GPP_TXRX_LED_OK_MASK;
            *gpio_pin_set_p = GPP_TXRX_LED_OK_GREEN;
            break;

        case LED_OK_OFF:
            *gpio_pin_clr_p = GPP_TXRX_LED_OK_MASK;
            *gpio_pin_set_p = GPP_TXRX_LED_OK_OFF;
            break;

        case LED_FAULT_ON:
            *gpio_pin_clr_p = GPP_TXRX_LED_FLT_MASK;
            *gpio_pin_set_p = GPP_TXRX_LED_FLT_RED;
            break;

        case LED_FAULT_OFF:
            *gpio_pin_clr_p = GPP_TXRX_LED_FLT_MASK;
            *gpio_pin_set_p = GPP_TXRX_LED_FLT_OFF;
            break;
        }
    }
    else {
        if (!led_direction_set) {
            volatile uint64 * gpio_pin_dir_p;

            gpio_pin_dir_p = (volatile uint64 *)PHYS_TO_K1(A_GPIO_DIRECTION);
            *gpio_pin_dir_p = (GPP_FP_DIAG_LED_MASK);
            led_direction_set = 1;
        }
        switch (led_state) {
        case LED_DIAG_01:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED1_MASK;
            break;
        case LED_DIAG_02:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED2_MASK;
            break;
        case LED_DIAG_03:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED3_MASK;
            break;
        case LED_DIAG_04:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED4_MASK;
            break;
        case LED_DIAG_05:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED5_MASK;
            break;
        case LED_DIAG_06:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED6_MASK;
            break;
        case LED_DIAG_07:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED7_MASK;
            break;
        case LED_DIAG_08:
            *gpio_pin_clr_p = GPP_FP_DIAG_LED8_MASK;
            break;
        case LED_DIAG_11:
            *gpio_pin_set_p = GPP_FP_DIAG_LED1_MASK;
            break;
        case LED_DIAG_12:
            *gpio_pin_set_p = GPP_FP_DIAG_LED2_MASK;
            break;
        case LED_DIAG_13:
            *gpio_pin_set_p = GPP_FP_DIAG_LED3_MASK;
            break;
        case LED_DIAG_14:
            *gpio_pin_set_p = GPP_FP_DIAG_LED4_MASK;
            break;
        case LED_DIAG_15:
            *gpio_pin_set_p = GPP_FP_DIAG_LED5_MASK;
            break;
        case LED_DIAG_16:
            *gpio_pin_set_p = GPP_FP_DIAG_LED6_MASK;
            break;
        case LED_DIAG_17:
            *gpio_pin_set_p = GPP_FP_DIAG_LED7_MASK;
            break;
        case LED_DIAG_18:
            *gpio_pin_set_p = GPP_FP_DIAG_LED8_MASK;
            break;
        }
    }
    //printf("<read gpio %x from %p\n", *gpio_pin_read_p, gpio_pin_read_p);
}

