/*
 *-----------------------------------------------------------------
 *
 * Name:	sbm-util.c
 *
 * RCS:  $Id: sbm-util.c,v 1.11 2002/11/01 23:30:14 janv Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:	support functions
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/7/02
 *
 *-----------------------------------------------------------------
 */


#include <nfx-incl.h>

#ifndef SBM_REV2
#error Compiled without SBM_REV2
#endif

#include <exports/eee-api.h>
#include <exports/sbm-api.h>
#include <exports/cod-api.h>
#include "sbm.h"


#ifdef NFX_MOD_NFP
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/7/02
 *
 *-----------------------------------------------------------------
 */
nfx_cod_t
sbm_getCODFromDesc(
	eee_descPtr_t	edesc,
	uint32			slot,
	uint32			cpu
)
{
	uint64	cod;

	cod = ((uint64)slot << COD_SLOT_SHIFT) |
			((uint64)cpu << COD_CPU_SHIFT);

	cod |= (uint64)edesc;

	return (nfx_cod_t)cod;
}
#endif

#ifdef NFP_TXRX
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/7/02
 *
 *-----------------------------------------------------------------
 */
eee_descPtr_t
sbm_getDescFromCOD(
	nfx_cod_t	cod
)
{
	long	desc;

	desc = (long)(cod & 0x000000FFFFFFFFFF);

	return ((eee_descPtr_t)desc);

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/7/02
 *
 *-----------------------------------------------------------------
 */

static int sbm_mgmt_update_cnt = 0;

void
sbm_mgmt_update_sac_info_struct(
	void * cb,
	uint32	tref
)
{
#if defined(NFP_TXRX) && defined(NFX_SMP)
	if (!CM_IS_TXRX_NCPU)
		return;
#endif

#ifndef LINUX_TEST
    if (((sbm_mgmt_update_cnt++) & 0x7) == 0)
    {    
        sbm_sac_info->num_buf_small_avail = eee_getAvailableNbrOfBufs(EEE_BUF_SMALL);
        sbm_sac_info->num_buf_large_avail = eee_getAvailableNbrOfBufs(EEE_BUF_LARGE);
        sbm_sac_info->num_buf_ultra_avail = eee_getAvailableNbrOfBufs(EEE_BUF_ULTRA);

        sbm_sac_info->num_buf_LWM_small = eee_getLWMBufs(EEE_BUF_SMALL);
        sbm_sac_info->num_buf_LWM_large = eee_getLWMBufs(EEE_BUF_LARGE);
        sbm_sac_info->num_buf_LWM_ultra = eee_getLWMBufs(EEE_BUF_ULTRA);
    }
    
#endif
}

#endif	/* NFP_TXRX */

#ifdef NFX_MOD_NFP
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/7/02
 *
 *-----------------------------------------------------------------
 */

uint64
sbm_get_sac_size()
{
#ifndef LINUX_TEST
	return(eee_getTotalSizeOfLargeBufsOnTxrx());
#endif
}
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/23/02
 *
 *-----------------------------------------------------------------
 */
uint32
sbm_getNumBufsInPkt(
	eee_descPtr_t	edesc
)
{
	uint32	nb = 0;

	while (edesc) {
		nb += EEE_GET_NUM_BUFS(edesc);
		edesc = edesc->hdr.next;
	}

	return nb;
}

