#ifdef LINUX_TEST
#include <stdio.h>

#undef NULL
#endif /* LINUX_TEST */

#include <nfx-incl.h>
#include <exports/eee-api.h>
#include <exports/cm-api.h>
#include <exports/scsi-api.h>
#include <exports/hal.h>

int32 
test_eee_sendMessage( uchar8 *src,
				     uint32 num_bytes,
				     uint32 dest_port,
					 uint32 source_port )
{
	printf("[test_eee_sendMessage] Enter\n");
#if 0
	scsi_msgHdr_t *hdr;


	
	hdr = (scsi_msgHdr_t *)src;
	switch(hdr->mid) {
		case SCSI_MSG_ID_READ_RSP:
			/* print_readRspMsg(src, filep); */
			break;

		case SCSI_MSG_ID_WRITE_RSP:
			/* print_writeRspMsg(src, filep); */
			break;

		case SCSI_MSG_ID_ADD_DEV:
			test_sendSdmMsg(src, num_bytes);
			/* print_devAddMsg(src, filep); */
			break;

		case SCSI_MSG_ID_OPEN_RSP:
			test_sendSdmMsg(src, num_bytes);
			/* print_openRspMsg(src, filep); */
			break;

		case SCSI_MSG_ID_CLOSE_RSP:
			test_sendSdmMsg(src, num_bytes);
			break;


		case SCSI_MSG_ID_PATH_ERR:
			break;
			
		case SCSI_MSG_ID_REBALANCE:
			break;

		case SCSI_MSG_ID_RELAY_RSP:
			break;

		case SCSI_MSG_ID_ERR_RSP:
			/* print_errRspMsg(src, filep); */
			break;
	}
#endif 
	printf("[test_eee_sendMessage] Leave\n");
	return 0;
}

print_openRspMsg(void *ptr)
{
#if 0
	scsi_openRspMsg_t *msg;
	
	msg = (scsi_openRspMsg_t *)ptr;
	printf("mid       : %08x : %s\n", msg->mid, "OPEN RESPONSE");
	printf("cHandle   : %08x : \n", msg->cHandle);
	print_eCode(msg->eCode);
	printf("\n\n");
#endif
}
print_closeRspMsg(void *ptr)
{
#if 0
	scsi_closeRspMsg_t *msg;
	
	msg = (scsi_closeRspMsg_t *)ptr;
	printf("mid       : %08x : %s\n", msg->mid, "CLOSE RESPONSE");
	printf("cHandle   : %08x : \n", msg->cHandle);
	print_eCode(msg->eCode);
	printf("\n\n");
#endif
}
print_readRspMsg(void *ptr)
{
#if 0
	scsi_readRspMsg_t *msg;
	
	msg = (scsi_readRspMsg_t *)ptr;
	printf("mid       : %08x : %s\n", msg->mid, "READ RESPONSE");
	printf("cHandle   : %08x : \n", msg->cHandle);
	print_eCode(msg->eCode);
	printf("cod       : %llx : \n", msg->codHandle);
	printf("\n\n");
#endif
}

print_writeRspMsg(void *ptr)
{
#if 0
	scsi_writeRspMsg_t *msg;
	
	msg = (scsi_writeRspMsg_t *)ptr;
	printf("mid       : %08x : %s\n", msg->mid, "WRITE RESPONSE");
	printf("cHandle   : %08x : \n", msg->cHandle);
	print_eCode(msg->eCode);
	printf("\n\n");
#endif
}

print_errRspMsg(void *ptr)
{
#if 0
	scsi_errRspMsg_t *msg;
	
	msg = (scsi_errRspMsg_t *)ptr;
	printf("mid       : %08x : %s\n", msg->mid, "ERROR RESPONSE");
	printf("cHandle   : %08x : \n", msg->cHandle);
	print_eCode(msg->eCode);
	printf("\n\n");
#endif
}

print_devAddMsg(void *ptr)
{
#if 0
	scsi_addDevMsg_t *msg;
	
	msg = (scsi_addDevMsg_t *)ptr;
	printf("mid       : %016x : %s\n", msg->mid, "DEVICE ADD");
	printf("cHandle   : %016x : \n", msg->cHandle);
	printf("path      : %016x : \n", msg->path);
	printf("id        : %016llx : \n", msg->id);
	printf("type      : %016x : \n", msg->type);
	printf("blocks    : %016x : \n", msg->lbCnt);
	printf("block size: %016x : \n", msg->lbSize);
	printf("vendor    : %16s : \n", msg->vendor);
	printf("model     : %16s : \n", msg->model);
	printf("\n\n");
#endif
}

print_eCode(uint32 eCode)
{
#if 0
	printf("eCode     : %08x : ", eCode);
	switch(eCode) {
		case SCSI_MSG_ECODE_OK:
			printf("%s\n", "OK");
			break;
		case SCSI_MSG_ECODE_NOSUCH_DEV:
			printf("%s\n", "NOSUCH DEVICE");
			break;
		case SCSI_MSG_ECODE_DEV_CLOSED:
			printf("%s\n", "DEVICE CLOSED");
			break;
		case SCSI_MSG_ECODE_INVALID_MSG:
			printf("%s\n", "INVALID MESSAGE ID");
			break;
		case SCSI_MSG_ECODE_NO_RESOURCE:
			printf("%s\n", "NO RESOURCE");
			break;
		case SCSI_MSG_ECODE_NO_MEDIA:
			printf("%s\n", "MEDIA NOT INSTALLED");
			break;
		case SCSI_MSG_ECODE_READ_ONLY:
			printf("%s\n", "DEVICE READ ONLY");
			break;
		case SCSI_MSG_ECODE_OO_RANGE:
			printf("%s\n", "OUT OF RANGE");
			break;
		default:
			printf("%s\n", "Status Unknown");
	}
#endif
} /* print_statusCode */

void 
test_eee_freePacket( eee_desc_t *edesc )
{
	uint32 i;
	uint32 bufCnt;

	/* printf("[eee_freePacket] Enter\n"); */

	if( !edesc )
		return;
	bufCnt = (edesc->hdr.control & EDESC_BUFCNT_MASK) >> EDESC_BUFCNT_SHIFT;
	/* printf("freePkt: buf cnt: %d\n", bufCnt); */
	for(i=1; i <= bufCnt; i++) {
		/* printf("bufptr: %x\n", edesc->bd[i].buf); */
		if( edesc->bd[i].buf )
			eee_ramDealloc( edesc->bd[i].buf );
	}

	eee_ramDealloc(edesc);

	/* printf("[eee_freePacket] Leave\n"); */
	return;
}

int32 
test_eee_deliverPacket( eee_desc_t *edesc )
{
	printf("[eee_deliverPacket]\n");
	return 0;
}

int32 
scsi_getHalHandle()
{
	printf("[scsi_getHalHandle]\n");
	return 0;
}

uchar8 *
test_eee_allocateBuffer( int i, int j, int z)
{
	uchar8 *buf;	
	buf = (uchar8 *)eee_ramAlloc(2048);
	return buf;
}

eee_desc_t *
test_eee_allocateDesc(int i, int j)
{
	eee_desc_t *edesc;
	edesc = (eee_desc_t *)eee_ramAlloc(sizeof(eee_desc_t));
	memset(edesc, 0, sizeof(eee_desc_t));
	return edesc;
}

int
test_eee_deallocateDesc(eee_desc_t *edesc)
{
	eee_ramDealloc((uchar8 *)edesc);
	return 0;
}

int
test_eee_deallocateBuffer(uchar8 *buf)
{
	eee_ramDealloc(buf);
	return 0;
}

int
test_nullFunc()
{
	return 0;
}
