/*
 * ---------------------------------------------------------------------------
 *  FileName: scsit.h
 *
 *  Description:  Contains definitions and prototypes for using the scsitest application.
 *
 *  Created:    5 August 2002
 *
 *  Author:     Frank Salzmann
 *
 *  Copyright (c)  Agile Storage, Inc. 2001, 2002
 *
 *  CVS Version:  $Id: scsit.h,v 1.3 2002/09/25 20:16:04 frank Exp $
 * ---------------------------------------------------------------------------
 */

#define SCSITEST_MAX_LUNS		64
#define SCSITEST_READ_BLKCNT	16
#define SCSITEST_WRITE_BLKCNT	16
#define SCSITEST_MAX_PKT        256 

//-- scsitest structure
typedef struct _scsi_test {
	//-- Test parameters.
	uint32      control;
#define SCSITEST_CONTROL_AVAIL 0
#define SCSITEST_CONTROL_INUSE 1

	scsi_path_t path;
	uint32      handle;
	uint32      chandle;
	uint32      testType;
#define SCSITEST_TYPE_READ	 0
#define SCSITEST_TYPE_WRITE  1
#define SCSITEST_TYPE_UREAD  2
#define SCSITEST_TYPE_UWRITE 3
	uint32      testMode;
#define SCSITEST_MODE_NORMAL    0		// Go through test run once, from start to end, numBlks
#define SCSITEST_MODE_LOOP	    1		// Go through test forever, looping from start to end to start.
#define SCSITEST_MODE_STOP      2
#define SCSITEST_MODE_LOOP_SCSI 3
	uint32      lbStart;
	uint32      lbEnd;
	uint32      numBlks;
	nfx_cod_t	cod;

	//-- Test counters
	uint32		lbCur;
	uint32      blkCur;
	int64      readIoCnt;
	int64      writeIoCnt;
	int64      tTime_read;
	int64      tTime_write;
	int64      readIo_persec;

	//-- Pkt Timers
	eeeGMT_t start_t;
} scsi_test_t;

// 
// Function Prototypes
// 
void scsitest_rcvMsg( eee_desc_t *edesc );

//
// External Declarations
//
extern uint32 scsitest_appId;
extern uint32 scsitest_addr;
extern uint32 scsitest_sac_addr;
extern uint32 scsitest_errCnt;
extern scsi_test_t scsitest[SCSITEST_MAX_LUNS];
