/*
 * ---------------------------------------------------------------------------
 *  FileName: sdm-agent-api.h
 *
 *  Description:  Contains definitions and prototypes for using the SDM agent.
 *
 *  Created:    21 August 2001
 *
 *  Author:     Frank Salzmann
 *
 *  Copyright (c)  Agile Storage, Inc. 2001
 *
 *  CVS Version:  $Id: sdm-agent-api.h,v 1.2 2002/05/13 16:20:05 frank Exp $
 * ---------------------------------------------------------------------------
 */

#define SDMA_MAX_HANDLES	SDM_OPEN_HANDLE_MAX

//
// SDM Agent Handle Table Entry
//
typedef struct _sdma_handle_entry {
	uint32      state;
#define SDMA_VALID_ENTRY 	0x80000000
	scsi_path_t	path;
	scsi_id_t   id;
} sdma_hEntry_t;



// 
// Function Prototypes
// 
int  sdma_handleToPath(uint32 handle, scsi_path_t *path, uint32 *scsi_port);
void sdma_receiveMsg( eee_desc_t *eDesc );
int sdma_allocDevHandle(scsi_id_t id, scsi_path_t path);
