//------------------------------------------------------------------------------
//  FileName   : sdm-init-disk-mylex.h
//
//  Description: Mylex specific structures and definitions to support SCSI device 
//               initialization.
//
//	Created    : 18 June 2002
//
//  Author     : Radek AsterFrank Salzmann
//
//  RCS        : $Id: sdm-init-disk-mylex.h,v 1.1 2002/06/19 21:57:16 raster Exp $
//
//  Copyright (c)  Agile Storage, Inc. 2002
//------------------------------------------------------------------------------

#ifndef __SDM_INIT_DISK_MYLEX_H__
#define __SDM_INIT_DISK_MYLEX_H__

#define MDACMD_IOCTL					0x22
#define MDACIOCTL_GETLOGDEVINFOVALID	0x03

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETLOGDEVINFOVALID
 * --------------------------------------------------------------------------------------------------------------
 */
typedef struct {
	byte Reserved0[4];
	byte State;
	byte RaidLevel;
	byte StripeSize;
	byte CacheLineSize;
	byte LDControl;
#define FSI_LDCONTROL_INITIALIZED		0x80
#define FSI_LDCONTROL_WRITECACHEENABLED	0x10
	byte OperationsStatus;
#define FSI_OPSTATUS_CCHECKACTIVE		0x01
#define FSI_OPSTATUS_REBUILDACTIVE		0x02
#define FSI_OPSTATUS_MDCONSISTACTIVE	0x04
#define FSI_OPSTATUS_INITACTIVE			0x08
#define FSI_OPSTATUS_MIGRATIONACTIVE	0x10
#define FSI_OPSTATUS_PATROLACTIVE		0x20
#define FSI_OPSTATUS_ACTIVE_MASK		0x3F
	byte R5WriteUpdate;
	byte R5Algor;
	byte LDN[2];					/* Little Endian */
	byte Reserved1[2];
	byte ErrorCounters[16];			/* Unused for now */
	byte Reserved2[2];
	byte BlockSize[2];
	byte OrgDeviceSize[4];
	byte DeviceSize[4];
	byte Reserved3[4];
	char LDName[17];
	byte Reserved4[15];
	byte SCSIInquiry36[36];
	byte Reserved5[12];
	byte Reserved6[16];
	byte ConsistencyCheckBlockNumber[8];
	byte RebuildBlockNumber[8];
	byte MDConsistentBlockNumber[8];
	byte LDInitializationBlockNumber[8];
	byte DataMigrationBlockNumber[8];
	byte Reserved7[16];
	byte StatBackgroundInit[2];
	byte StatLogDeviceInit[2];
	byte StatPhysDevInit[2];
	byte StatConsistencyCheckInit[2];
	byte StatRebuildLong[2];
	byte StatMORE[2];
	byte RDN[2];
	byte Reserved8[42];
} FSI_GetLogDevInfoValid_t;

#endif /* __SDM_INIT_DISK_MYLEX_H__ */


