/*
 *-----------------------------------------------------------------
 *
 * Name:	seep-api.h
 *
 * RCS:  $Id: seep-api.h,v 1.10 2002/12/10 23:08:08 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	exported API for the Chassis Manager
 *
 * Created by:	ericc
 *
 * Date Created:	09/24/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _SEEP_API_H
#define _SEEP_API_H


#define SEEP_PCB 		0
#define SEEP_SW			1
#define SEEP_CHASSIS	2
#define SEEP_PS0		3
#define SEEP_PS1		4

#ifdef SIBYTE_BC
#define SEEP_PCB_BOARD 		SEEP_PCB
#define SEEP_PCB_LOCAL		5
#define NUM_SEEPS		6
#else
#define NUM_SEEPS		5
#endif

void seepWrite(	int32	which_seep,
				uchar8	* seep,
				uint32	offset,
				uint32	len);

void seepRead(	int32	which_seep,
				uchar8	* seep,
				uint32	offset,
				uint32	len);

void seepInit();

#if defined (R9000) || defined (SIBYTE_BC)
void seepInit_BC();
#endif

void seepGetIpAddr(uchar8	* ipaddr);
void seepInitExtMacAddr(uint32	ipaddr);
uchar8 * seepGetMyExtMacAddr(uint32	port);
	/* port :   TXRX = 0,1,2,3    SSC = 1    FC = 0 */
uchar8 * seepGetBSDMacAddr(uint32 port);
void seepGetMiscInfo(uchar8  *info);

#endif	/* _SEEP_API_H */

