/*
 *-----------------------------------------------------------------
 *
 * Name:	st16552.c
 *
 * RCS:  $Id: sb1250_uart.c,v 1.1.1.1 2002/01/10 20:44:52 frank Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	 Serial driver for sb1250
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */

#ifdef SIBYTE

#include <nfx-incl.h>
#include <sys/sb1250/sb1250_uart.h>
#include <exports/serio-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
int32
sb1250_uart(
	uint32	op,
	uint32	chan,
	int32	data
)
{
	uint32	br;
	volatile sb1250_uart_t	* dp;

	if (chan > 1)
		return SERIO_ERR_BAD_PARAM;

	if (chan == 0)
		dp = (volatile sb1250_uart_t *)
								PHYS_TO_K1(A_DUART + DUART_CHANREG_SPACING);
	else
		dp = (volatile sb1250_uart_t *)
								PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*2));

	switch (op) {
		case OP_INIT:
			while (!(dp->status & 0x8));
			dp->cmd = 0x20;
			sbddelay(100);
			dp->cmd = 0x30;
			sbddelay(100);
			dp->cmd = 0;
			sbddelay(100);
			dp->mode = 0x13;	/* 8 bits, no parity */
			dp->mode1 = 0;		/* normal operation, 1 stop bit */
			dp->brg = V_DUART_BAUD_RATE(data);		/* set baud rate */
			dp->cmd = 0x5;		/* TX enable + RX enable */
			break;

		case OP_BAUD:
			dp->cmd = 0;		/* TX disable + RX disable */
			dp->brg = V_DUART_BAUD_RATE(data);		/* set baud rate */
			dp->cmd = 0x5;		/* TX enable + RX enable */
			break;

		case OP_TXRDY:
			return (dp->status & M_DUART_TX_RDY);

		case OP_RXRDY:
			return (dp->status & M_DUART_RX_RDY);

		case OP_TX:
			dp->tx_hold = data;
			break;

		case OP_RX:
			return (dp->rx_hold & 0xFF);
	}		

	return NFX_OK;

}	/* sb1250() */

#endif	/* SIBYTE */

