/*
 *-----------------------------------------------------------------
 *
 * Name:	st16552.c
 *
 * RCS:  $Id: st16552.c,v 1.1.1.1 2002/01/10 20:44:52 frank Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	 Serial driver for 16552
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */

#if defined(EVAL_BOARD) && !defined(SIBYTE)

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <sys/st16552.h>
#include <exports/serio-api.h>

st16552_dev_t	* st16552dev = (st16552_dev_t *)PHYS_TO_K1(HW_ST16552_BASE);

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
int32
st16552(
	uint32	op,
	uint32	chan,
	int32	data
)
{
	volatile st16552_channel_t * dp;
	uint32	br;

	if (chan > 1)
		return SERIO_ERR_BAD_PARAM;

	if (chan == 0)
		dp = (st16552_channel_t *)&(st16552dev->chan_a);
	else
		dp = (st16552_channel_t *)&(st16552dev->chan_b);

	switch (op) {
		case OP_INIT:
		case OP_BAUD:
			br = ST16552_BRTC(data);
			br *= 2;			/* ??????????????????????????? */
			dp->lcr |= LCR_DIV_LATCH_ENABLE;
			dp->tx_reg = br & 0xff;
			dp->ier = (br >> 8) & 0xff;
			dp->lcr &= ~LCR_DIV_LATCH_ENABLE;
			break;

		case OP_TXRDY:
			return (dp->lsr & LSR_TXRDY);

		case OP_RXRDY:
			return (dp->lsr & LSR_RXRDY);

		case OP_TX:
			dp->tx_reg = data;
			break;

		case OP_RX:
			return (dp->rx_reg & 0xFF);
	}		

	return NFX_OK;

}	/* st16552() */

#endif	/* EVAL_BOARD && !SIBYTE */

