/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: atomic-api.c,v 1.3 2002/11/21 21:10:12 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/12/02
 *
 *-----------------------------------------------------------------
 */

#ifdef NFX_SMP

#include <nfx-incl.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/12/02
 *
 *-----------------------------------------------------------------
 */
void
atomic_increment(
	void	* valptr,
	uint32	size,
	uint32	step
)
{
	if (size == 4)
		ATOMIC_INC_INT(valptr, step);
	else if (size == 8)
		ATOMIC_INC_DWORD(valptr, step);
	else
		panic("atomic_increment, size = %d, ra = %p\n", size, get_ra());
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/12/02
 *
 *-----------------------------------------------------------------
 */
void
atomic_decrement(
	void	* valptr,
	uint32	size,
	uint32	step
)
{
	if (size == 4)
		ATOMIC_DEC_INT(valptr, step);
	else if (size == 8)
		ATOMIC_DEC_DWORD(valptr, step);
	else
		panic("atomic_decrement, size = %d, ra = %p\n", size, get_ra());
}

#endif	/* NFX_SMP */

