/*
 *-----------------------------------------------------------------
 *
 * Name:	start.sx
 *
 * RCS:  $Id: start.S,v 1.12 2002/12/09 23:55:14 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

#if defined(EVAL_BOARD) || defined(AGILE_HARDWARE)

#include <sys/mips.h>

#ifdef __long64
#define SR	sd
#else
#define SR	sw
#endif

	.text

	.globl	_start
	.globl	__start
	.globl	_bss_init

	.set	noreorder

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
	.ent	_start

_start:
__start:

#ifdef SSC_MGMT
	/*
	 * For toshiba, the jump block address is passed in a0
	 */
	move	s0,a0

	la		a0,1f
	jr		a0
	nop
1:
#endif	/* SSC_MGMT */

#ifndef NFX_SMP
	la		sp,stack+STKSIZE-24
#endif
	la		gp, _gp

	/*
	 * zero out BSS area
	 */
	jal		_bss_init
	nop

#ifndef SSC_MGMT
	/*
	 * get memorysize from PROM
	 */
	jal		get_memorysize
	nop
	sd		v0,memorysize
	srl		v0,20
	sw		v0,memorysize_MB
#endif

	/*
	 * should set up tlb entries and anything needed for
	 * address conversion functions (virt_to_phys, is_valid_addr, etc)
	 */
	jal		mem_map_init
	nop

#ifdef NFX_SMP
	la		sp,smp_stack+STKSIZE-24
	la		v0,stack_addr
	la		v1,smp_stack
	sd		v1,0(v0)
#else
	la		v0,stack_addr
	la		v1,stack
	SR		v1,0(v0)
#endif


#ifdef SSC_MGMT
	move	a0,s0

	jal		tx3927_init
	nop
#endif

	/*
	 * jump to main()
	 */
	move	a0,zero
	jal		_main
	nop

	/*
	 * return to caller
	 */
#ifdef EVAL_BOARD
	la		a0,0xBFC00520			/* cliexit() */
	lw		a0,0(a0)
	jr		a0
	nop
#endif

	nop

	.end	_start

/*-----------------------------------------------------------------
 * Name:	_bss_init
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
    .ent    _bss_init
_bss_init:
    la      v0,_fbss
    la      v1,end
1:
    sw      zero,0x0(v0)
    sw      zero,0x4(v0)
    sw      zero,0x8(v0)
    sw      zero,0xC(v0)
    addu    v0,16
    blt     v0,v1,1b
	nop

    j       ra
	nop

    .end    _bss_init


#endif	/* EVAL_BOARD || AGILE_HARDWARE */
