/*
 *-----------------------------------------------------------------
 *
 * Name:	sizeram.S
 *
 * RCS:  $Id: sizeram.S,v 1.2 2001/11/06 23:44:31 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/17/01
 *
 *-----------------------------------------------------------------
 */

#ifdef PROM

#include <nfx-target.h>
#include <exports/hwMap.h>
#include <sys/mips.h>
#include <exports/promio-api.h>

	.text

	.globl	sizeram
	.ent	sizeram
sizeram:
	
#ifdef SIBYTE
	li		s4,0x10000000
#else

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	li		t0,0
	li		t1,0x7F
	sw		t1,SCS_0_LOW_DECODE_ADDRESS(a0)
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	
	sw		t1,SCS_1_LOW_DECODE_ADDRESS(a0)
	sw		t0,SCS_1_HIGH_DECODE_ADDRESS(a0)

	sw		t1,SCS_2_LOW_DECODE_ADDRESS(a0)
	sw		t0,SCS_2_HIGH_DECODE_ADDRESS(a0)

	sw		t1,SCS_3_LOW_DECODE_ADDRESS(a0)
	sw		t0,SCS_3_HIGH_DECODE_ADDRESS(a0)
do_dimm1:

#if !defined(USE_128MB_SIMM) && !defined(USE_32MB_SIMM)
	GT_SPD_WRITE(I2C_CONTROL, 0x60)

	GT_SPD_GET_INT(I2C_CONTROL, 0x8)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x8)

	GT_SPD_WRITE(I2C_DATA, 0xAC | 0x1)
	GT_SPD_WRITE(I2C_CONTROL, 0x0)
	GT_SPD_GET_INT(I2C_CONTROL, 0x8)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x40)

	li		k1,0
spd_read1:
	beq		k1,32,spd_read1_done
	GT_SPD_WRITE(I2C_CONTROL, 0x4)
	GT_SPD_GET_INT(I2C_CONTROL, 0x8)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x50)
	GT_SPD_READ(I2C_DATA)

#if RAL_XXX
	move	ARG1,v0
	li		ARG2,2
	JMP_SUB2(promio_prx)
	la		ARG1,nl_msg
	JMP_SUB2(promio_prs)
#endif

	bne		k1,0,1f
	bne		v0,0xFF,1f
	li		k1,0
	b		spd_read1
1:
	beq		k1,5,num_banks
	beq		k1,6,module_data_width
	beq		k1,13,sdram_width
	beq		k1,17,sdram_banks
	beq		k1,31,module_bank_density
	b		spd_cont

num_banks:
	move	t2,v0
	b		spd_cont
module_data_width:
	move	t3,v0
	and		t3,0xC0
	b		spd_cont
sdram_width:
	move	t4,v0
	b		spd_cont
sdram_banks:
	move	t5,v0
	b		spd_cont
module_bank_density:
	move	t6,v0
	b		spd_cont

spd_cont:
	add		k1,1
	b		spd_read1

1:
	la		ARG1,spd_err_msg
	JMP_SUB2(promio_prs)

	move	t2,zero
	move	t3,zero
	move	t4,zero
	move	t5,zero
	move	t6,zero

spd_read1_done:
	GT_SPD_WRITE(I2C_CONTROL, 0)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x58)
1:
	GT_SPD_WRITE(I2C_CONTROL, 0x10)
#else

#ifdef USE_128MB_SIMM
	li		t2,1
	li		t3,64
	li		t4,8
	li		t5,4
	li		t6,32
#endif	/* 128 MB */

#ifdef USE_32MB_SIMM
	li		t2,1
	li		t3,64
	li		t4,16
	li		t5,4
	li		t6,8
#endif	/* 32 MB */

#endif

	/*
	 * Get Total Memory on DIMM1
	 */
	mul		s3,t2,t5
	mul		s3,s3,t6

	/*
	 * Get Memory Organization for DIMM1
	 */
	mul		s4,s3,8
	mul		s4,s4,t4
	div		s4,s4,t2
	div		s4,s4,t3

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	beq		s4,16,dimm1_bank_16mbit
	beq		s4,64,dimm1_bank_64mbit
	beq		s4,128,dimm1_bank_128mbit
dimm1_bank_256mbit:
dimm1_bank_512mbit:
	li		t0,0x000FC000
	b		dimm1_bank_cont
dimm1_bank_64mbit:
dimm1_bank_128mbit:
	li		t0,0x000F8000
	b		dimm1_bank_cont
dimm1_bank_16mbit:
	li		t0,0x000F4000
dimm1_bank_cont:
	sw		t0,SDRAM_BANK0PARAMETERS(a0)

	la		ARG1,dimm1_size_msg
	JMP_SUB2(promio_prs)

	move	ARG1,s3
	li		ARG2,8
	JMP_SUB2(promio_prx)

	la		ARG1,mb_msg
	JMP_SUB2(promio_prs)

	la		ARG1,nl_msg
	JMP_SUB2(promio_prs)


	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	beq		s3,32,dimm1_32
	beq		s3,64,dimm1_64
	beq		s3,128,dimm1_128
	beq		s3,256,dimm1_256
	beq		s3,512,dimm1_512
	beq		s3,1024,dimm1_1024 
dimm1_0:
	b		save_dimm1
	
dimm1_32:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x1FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

dimm1_64:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x3FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

dimm1_128:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x7FFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

dimm1_256:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0xFFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

dimm1_512:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x1FFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

dimm1_1024:
	li		t0,HW_RAM_BASE
	and		t0,0xFFF00000
	srl		t0,20
	sw		t0,SCS_0_LOW_DECODE_ADDRESS(a0)
	li		t0,HW_RAM_BASE
	add		t0,0x3FFFFFFF
	srl		t0,20
	sw		t0,SCS_0_HIGH_DECODE_ADDRESS(a0)
	b		save_dimm1

save_dimm1:
	move	s4,s3


#if 0
do_dimm2:

	move	t2,zero
	move	t3,zero
	move	t4,zero
	move	t5,zero
	move	t6,zero

	GT_SPD_WRITE(I2C_CONTROL, 0x60)

	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x8)

	GT_SPD_WRITE(I2C_DATA, 0xA8 | 0x1)
	GT_SPD_WRITE(I2C_CONTROL, 0x0)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x40)

	li		k1,0
spd_read2:
	beq		k1,32,spd_read2_done
	GT_SPD_WRITE(I2C_CONTROL, 0x4)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x50)
	GT_SPD_READ(I2C_DATA)

	beq		k1,5,num_banks_2
	beq		k1,6,module_data_width_2
	beq		k1,13,sdram_width_2
	beq		k1,31,module_bank_density_2
	b		spd_cont_2

num_banks_2:
	move	t2,v0
	b		spd_cont_2
module_data_width_2:
	move	t3,v0
	b		spd_cont_2
sdram_width_2:
	move	t4,v0
	b		spd_cont_2
module_bank_density_2:
	move	t5,v0
	b		spd_cont_2

spd_cont_2:
	add		k1,1
	b		spd_read2

1:
	la		ARG1,spd_err_msg
	JMP_SUB2(promio_prs)

spd_read2_done:
	GT_SPD_WRITE(I2C_CONTROL, 0)
	GT_SPD_CHECK_STATUS(I2C_STATUS_BAUDE_RATE, 0x58)
1:
	GT_SPD_WRITE(I2C_CONTROL, 0x10)

	mul		s3,t2,t5
	mul		s3,s3,t6

	la		ARG1,dimm2_size_msg
	JMP_SUB2(promio_prs)

	move	ARG1,s3
	li		ARG2,8
	JMP_SUB2(promio_prx)

	la		ARG1,mb_msg
	JMP_SUB2(promio_prs)

	la		ARG1,nl_msg
	JMP_SUB2(promio_prs)

	add		s4,s3

	/*
	 * Get Memory Organization for DIMM2
	 */
	mul		s3,s3,8
	mul		s3,s3,t4
	div		s3,s3,t2
	div		s3,s3,t3

	la		a0,PHYS_TO_K1(HW_GALILEO_BASE)
	beq		s3,16,dimm2_bank_16mbit
	beq		s3,64,dimm2_bank_64mbit
	beq		s3,128,dimm2_bank_128mbit
dimm2_bank_256mbit:
dimm2_bank_512mbit:
	li		t0,0x000FC000
	b		dimm2_bank_cont
dimm2_bank_64mbit:
dimm2_bank_128mbit:
	li		t0,0x000F8000
	b		dimm2_bank_cont
dimm2_bank_16mbit:
	li		t0,0x000F4000
dimm2_bank_cont:
	sw		t0,SDRAM_BANK1PARAMETERS(a0)
#endif

#endif

	j		ra

	.end	sizeram

/*------------------------------------------------------------------*/

spd_err_msg:
	.asciiz	"Error reading SPD\r\n"
nl_msg:
	.asciiz "\r\n"
dimm1_size_msg:
	.asciiz	"DIMM1 size = "
dimm2_size_msg:
	.asciiz	"DIMM2 size = "
mb_msg:
	.asciiz	"MB"

#endif	/* PROM */
