/*
 *-----------------------------------------------------------------
 *
 * Name:	cmdtable.c
 *
 * RCS:  $Id: cmdtable.c,v 1.107 2002/12/05 00:50:42 nitinb Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	test commands
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include "pmon-ui.h"

/*------------------------------------------------------------------
 *
 *	function declarations
 *
 *------------------------------------------------------------------*/
/*
 * General testing functions
 */
int32	do_history();
#ifdef AGILE_HARDWARE
int32	do_reboot();
#endif
int32	do_help();
int32	do_break();
int32	do_ver();

/*
 * EEE Layer testing functions
 */
int32	do_rq();
int32	do_showEEEconfig();
int32	do_showEEEError();
int32	do_allocateDesc();
int32	do_freeDesc();
int32	do_allocateBuf();
int32	do_freeBuf();
int32	do_simple_EEE_test();
int32	do_mgmt_test_stats_print();
int32	do_mgmt_test_start();
int32	do_mgmt_test_end();
int32	do_mgmt_test_stats_clear();
int32	do_data_test_stats_print();
int32	do_data_test_start();
int32	do_data_test_end();
int32	do_data_test_stats_clear();
int32	do_ctrl_test_stats_print();
int32	do_ctrl_test_start();
int32	do_ctrl_test_end();
int32	do_ctrl_test_stats_clear();
int32	do_ipc();
int32	do_ipc_stats();

/*
 * Queue testing functions
 */
int32	do_qstats();
int32	do_qcreate();
int32	do_qdestroy();
int32	do_enqueue();
int32	do_dequeue();
int32	do_qreset();
int32	do_qreadadvance();
int32	do_qread();
int32	do_qdelete();
int32	do_qchange();
int32	do_qinsertbefore();
int32	do_qinsertafter();
int32	do_qinsertorder();
int32	do_qfind();

/*
 * Timer testing functions
 */
int32	do_timercreate();
int32	do_timerstart();
int32	do_timerstop();
int32	do_timerdestroy();
int32	do_timerstats();
int32	do_showtic();
int32	do_showperf();

/*
 * State Machine testing functions
 */
int32	do_esmcreate();
int32	do_esmdestroy();
int32	do_esmstart();
int32	do_esmstop();
int32	do_esmstats();
int32	do_esmclear();

/*
 * Memory Manager testing functions
 */
int32	do_mmstats();
int32	do_malloc();
int32	do_free();
int32	do_mmfreelist();
int32	do_mmalloclist();
int32	do_mmfreestack();
int32	do_mmallocstack();
int32	do_mmallocrange();
int32	do_mmallohist();
int32	do_copytest();
int32   do_showHistogram();
int32	do_mallocOwner();

/* 
 * Event Manager testing functions 
 */
int32   event_mgr_ui();

#ifndef SSC_MGMT
/*
 * Peripherals functions
 */
int32	do_seepenv();
#endif

int32   do_seep();
/*
 * PCI testing functions
 */
#if defined(FCNIM) || defined(NFP_TXRX)
int32	do_pci_read();
int32	do_pci_write();
int32	do_pci_clear();
int32	do_pci_stat();
#endif

#ifdef FCNIM
int32   scsi_uiAdmin();
int32	scsi_testMenu();
int32   dp83820_uiDiag();
int32	gt_mii_uiDiag();
int32   ispfc_fcadmin();
#ifndef LINUX_TEST
int32 	bp_cmd();
int32	bcm5600_uiDiag();
#endif
#endif

#if defined(NFP_TXRX) || defined(FCNIM) || defined(SSC_MGMT)
int32	do_chassis();
#endif

#ifdef EVAL_BOARD
int32	do_led();
int32	do_baud();
#endif

int32	do_send_message();

#ifdef NFX_MOD_NFP
int32	do_sac();
#endif

#ifdef LINUX_TEST
#if defined(NFP_TXRX) || defined(FCNIM)
int32	do_sacify_file();
#endif
#endif

#ifdef NFP_FP
int32   scsitest_uiAdmin();   
int32   scsiio_cmd();
int32   sdma_uiViewHandleTable();
int32   fs_changeDoAssert();
int32   fs_laudbg();
int32   evm_admin();
int32	ndmp_cmd();
#ifndef LINUX_TEST
int32	bp_cmd();
int32   bmc12500Eth_uiDiag();
int32	lsi_gmac_uiDiag();
#endif
#endif

#if defined(NFP_TXRX) || defined(NFP_FP)
int32	poll_cmd();
#endif 

#ifdef NFP_TXRX
int32	nfp_cmd();
int32	nfs_cmd();
int32   luc_cmd();
int32   tpl_cmd();
int32   do_bsd();
int32   nlm_cmd();
int32   nsm_cmd();
int32   lock_cmd();
#ifndef LINUX_TEST
int32	bp_cmd();
int32   bmc12500Eth_uiDiag();
int32	lsi_gmac_uiDiag();
int32   dp83820_uiDiag();
int32	sb1250dm_uiDiag();
#endif
#endif

int32	do_ssc_msg();
int32   do_threadtest();

#ifndef LINUX_TEST
int32	do_mem_modify();
int32	do_mem_dump();
int32	do_mem_test();
int32	do_mem_read();
int32	do_ecc();
int32	do_tlb();
#endif

#ifdef NFX_PROFILING
int32   prof_start();
int32   prof_stop();
int32   prof_dump();
#endif

#ifdef SSC_MGMT
int32	bcm5600_uiDiag();
int32	bcm5632_uiDiag();
int32	gt_mii_uiDiag();
#ifndef LINUX_TEST
int32 	bp_cmd();
#endif
#endif

#if defined(NFP_TXRX) || defined(NFP_FP)
int32	do_dpp();
#endif

int32	do_edebug();
int32   do_esmTimeStats();

#ifdef SIBYTE
int32	do_cerr();
int32	ht_traffic_ui();
int32	do_perf_count();
#endif

#ifdef AGILE_HARDWARE
int32	do_prom_cmd();
#endif

int32	watchdog_cmd();
int32	crashdump_cmd();
int32	debug();
int32	do_cp0_regs();

int32	eee_start_polling_ui();

int32	show_config();

#if defined(NFP_FP)
int32 fs_getHashVolBlock();
int32 fs_getHashVolInum();
int32 fs_getHashVolInumPage();
#endif

#if defined(NFP_FP)
int32 fs_uiLockPrintAllOwned();
#endif

#if defined(USE_THREAD_STACKS) || defined(USE_BSS_THREAD_STACKS)
int32	ts_cmd();
#endif

#ifdef AGILE_HARDWARE
int32 libc_check_crc();
#endif

/*
 * Memory benchmarking test commands.
 */
int32 mb_memBenchBzero(int argc, char **argv);
int32 mb_memBenchWrite32(int argc, char **argv);
int32 mb_memBenchWrite64(int argc, char **argv);
int32 mb_memBenchRead32(int argc, char **argv);
int32 mb_memBenchRead64(int argc, char **argv);
int32 mb_memBenchCopy32(int argc, char **argv);
int32 mb_memBenchCopy64(int argc, char **argv);
#if 0
int32	memcpy_cmd();
#endif

#if !defined(SSC_MGMT) && !defined(PROM) && !defined(FCNIM_TM)
#define NFX_COVERAGE
#endif

#if defined(NFX_COVERAGE)
extern int gcov_dump(int argc, char **argv);
extern int gcov_reset_counts(int argc, char **argv);
#endif

#ifdef NFX_SMP
int32	altcpu_cmd();
int32	spinlock_ui(int32 argc, uchar8 * argv[]);
int32	counttest(int32 argc, uchar8	* argv[]);
#endif
int32	atomic_ui(int32 argc, uchar8 * argv[]);

#ifdef SIBYTE
#ifdef NFP_FP
int32	sbprof_cmd(int32 argc, uchar8 * argv[]);
#endif
#endif

/*------------------------------------------------------------------
 *
 *	option structures
 *
 *------------------------------------------------------------------*/
extern Optdesc  load_opts[];

/*------------------------------------------------------------------
 *
 *	command list
 *
 *------------------------------------------------------------------*/
Cmd CmdTable[] =
{
	{"h",		NULL,		0,	"display commands",		do_help,	1,	2,	0},
    {"hi",		"[cnt]",0,	"display command history",	do_history,	1,	2,	0},
#ifdef AGILE_HARDWARE
    {"reboot",	NULL,		0,	"reset",		do_reboot,	1,	1,	0},
#endif
    {"break",	NULL,		0,	"GDB breakpoint",		do_break,	1,	1,	0},
	{"ver",		NULL,		0,	"display version string",	do_ver,	1,	1,	0},

	{"rq",		NULL,		0,	"show resource queues",	do_rq,		1,	1,	0},

	{"eee",		"[clear]",	0,	"show EEE config",		do_showEEEconfig,	1,	2,	0},
	{"err",		NULL,		0,	"show EEE errors",		do_showEEEError,	1,	1,	0},
	{"da",	"<pool_id>",0,	"allocate descriptor",	do_allocateDesc,	1,	2,	0},
	{"df",	"<desc>",	0,	"free descriptor",		do_freeDesc,		1,	2,	0},
	{"ba",	"<pool_id> <size>",	0,	"allocate buffer",	do_allocateBuf,	1,	3,	0},
	{"bf",	"<buffer>",	0,	"free buffer",			do_freeBuf,			1,	2,	0},
	{"simple",	NULL,	0,	"send EEE packets",		do_simple_EEE_test,	1,	1,	0},
	{"mgmt_stats",	NULL,	0,	"print test stats",	do_mgmt_test_stats_print,	1,	1,	0},
	{"mgmt_clear",	NULL,	0,	"clear test stats",	do_mgmt_test_stats_clear,	1,	1,	0},
	{"mgmt_start",	NULL,	0,	"start EEE test",	do_mgmt_test_start,	1,	2,	0},
	{"mgmt_stop",	NULL,	0,	"end EEE test",	do_mgmt_test_end,	1,	1,	0},
	{"data_stats",	NULL,	0,	"print test stats",	do_data_test_stats_print,	1,	1,	0},
	{"data_clear",	NULL,	0,	"clear test stats",	do_data_test_stats_clear,	1,	1,	0},
	{"data_start",	NULL,	0,	"start EEE test",	do_data_test_start,	1,	2,	0},
	{"data_stop",	NULL,	0,	"end EEE test",	do_data_test_end,	1,	1,	0},
	{"ctrl_stats",	NULL,	0,	"print test stats",	do_ctrl_test_stats_print,	1,	1,	0},
	{"ctrl_clear",	NULL,	0,	"clear test stats",	do_ctrl_test_stats_clear,	1,	1,	0},
	{"ctrl_start",	NULL,	0,	"start EEE test",	do_ctrl_test_start,	1,	2,	0},
	{"ctrl_stop",	NULL,	0,	"end EEE test",	do_ctrl_test_end,	1,	1,	0},
	{"ipc",	"<dest>",	0,	"send IPC message",		do_ipc,		1,	2,	0},
	{"ipc_stats",	NULL,	0,	"print IPC stats",	do_ipc_stats,	1,	1,	0},

	{"qstats",		NULL,	0,	"display Q stats",	do_qstats,		1,	1,	0},
	{"qcreate",		NULL,	0,	"create a new Q",	do_qcreate,		2,	2,	0},
	{"qdestroy",	NULL,	0,	"destroy a Q",		do_qdestroy,	2,	2,	0},
	{"enqueue",		NULL,	0,	"enqueue an entry",	do_enqueue,		4,	4,	0},
	{"dequeue",		NULL,	0,	"dequeue an entry",	do_dequeue,		2,	2,	0},
	{"qreset",		NULL,	0,	"reset Q read ptr",	do_qreset,		2,	2,	0},
	{"qreadadvance",NULL,	0,	"read and advance",	do_qreadadvance,2,	2,	0},
	{"qread",		NULL,	0,	"read Q node",		do_qread,		2,	2,	0},
	{"qdelete",		NULL,	0,	"delete Q node",	do_qdelete,		2,	2,	0},
	{"qchange",		NULL,	0,	"change Q node",	do_qchange,		4,	4,	0},
	{"qinsertbefore",NULL,	0,	"insert Q node",do_qinsertbefore,	4,	4,	0},
	{"qinsertafter",NULL,	0,	"insert Q node",	do_qinsertafter,4,	4,	0},
	{"qinsertorder",NULL,	0,	"insert Q node",	do_qinsertorder,4,	4,	0},
	{"qfind",		NULL,	0,	"find Q node",		do_qfind,		3,	3,	0},

	{"timercreate",	NULL,	0,	"create a timer",	do_timercreate,	1,	1,	0},
	{"timerstart",	"<tmr handle>",	0,	"start a timer",	do_timerstart,	2,	2,	0},
	{"timerstop",	"<tmr handle>",	0,	"stop a timer",		do_timerstop,	2,	2,	0},
	{"timerdestroy","<tmr handle>",	0,	"destroy a timer",	do_timerdestroy,2,	2,	0},
	{"timerstats",	NULL,	0,	"display timer stats",	do_timerstats,	1,	1,	0},
	{"showtic",		NULL,	0,	"show tic count",	do_showtic,		1,	1,	0},
	{"showperf",	NULL,	0,	"show some performance counters [-c[lear]]",	do_showperf,	1,	2,	0},

	{"esmcreate",	NULL,	0,	"create a state machine",	do_esmcreate,	1,	1,	0},
	{"esmdestroy",	"<esm handle>",	0,	"destroy SM instance",	do_esmdestroy,	2,	2,	0},
	{"esmstart",	"<esm handle>",	0,	"start a SM instance",	do_esmstart,	2,	2,	0},
	{"esmstop",		"<esm handle>",	0,	"stop a SM instance",	do_esmstop,	2,	2,	0},
	{"esmstats",	"<esm handle>",	0,	"SM test counters",	do_esmstats,	2,	2,	0},
	{"esmclear",	"<esm handle>",	0,	"clear SM test counters",	do_esmclear,	2,	2,	0},

	{"mmstats",		NULL,	0,	"display memmgr stats",	do_mmstats,	1,	1,	0},
	{"malloc",		"<num_bytes>",	0,	"malloc bytes",	do_malloc,	2,	2,	0},
	{"free",		"<addr>",		0,	"free buffer",	do_free,	2,	2,	0},
	{"freelist",	NULL,	0,	"display free list",	do_mmfreelist,	1,	1,	0},
	{"alloclist",	NULL,	0,	"display alloc list",	do_mmalloclist,	1,	1,	0},
	{"freestack",	NULL,	0,	"display free stack",	do_mmfreestack,	1,	1,	0},
	{"allocstack",	NULL,	0,	"display alloc stack",	do_mmallocstack,	1,	1,	0},
	{"allocrange",	NULL,	0,	"display alloc ranges",	do_mmallocrange,	1,	1,	0},
	{"mallochist",	NULL,	0,	"display alloc histogram [s|m|c|t|help] [nbr]",	do_showHistogram,	1,	3,	0},
	{"mallocowner",	NULL,	0,	"display malloc RA", do_mallocOwner, 1, 1, 0},

	{"copytest",	NULL,	0,	"test copyPktToBuffer", do_copytest, 1, 1, 0},

#if defined(NFP_TXRX) || defined(NFP_FP)
	{"pollcfg",        NULL,   0,	"Poll config ",  		poll_cmd,	1,  5, 0},
#endif

#ifdef NFP_TXRX
	{"luc",         NULL,   0,	"LUC commands ",  		luc_cmd,	1,  5, 0},
	{"tpl",         NULL,   0,  "TPL commands ",        tpl_cmd,	1,  5, 0},
	{"nfp",         NULL,   0,	"NFP commands ",  		nfp_cmd,	1,  4, 0},
	{"nfs",         NULL,   0,	"NFS commands ",  		nfs_cmd,	1,  4, 0},
	{"bsd",		NULL, 0, "bsd commands", do_bsd, 1, 10, 0},
	{"nlm",         NULL,   0,      "NLM commands ",                nlm_cmd,        1,  4, 0},
	{"nsm",         NULL,   0,      "NSM commands ",                nsm_cmd,        1,  4, 0},
	{"lock",        NULL,   0,      "LOCK commands ",               lock_cmd,       1,  4, 0},
#ifndef LINUX_TEST
    {"bp", NULL,   0,  "backplane commands", bp_cmd, 1,  4,  0},
    {"bmc12500",    NULL, 0, "bmc12500 Eth diag", bmc12500Eth_uiDiag, 1, 10, 0},
	{"lsi", NULL, 0, "LSI 8104 menu", lsi_gmac_uiDiag, 1, 1, 0},  
	{"dp83820", NULL,   0,  "run dp83820 test menu",dp83820_uiDiag, 1,  1,  0},
	{"sb1250dm", NULL,   0,  "run sb1250dm test menu",sb1250dm_uiDiag, 1,  1,  0},
#endif
#endif
#ifdef FCNIM
    {"scsiadmin", NULL,   0,  "SCSI admin command", scsi_uiAdmin,  1,  10, 0},
	{"scsitest",NULL,	0,	"run scsi test menu",scsi_testMenu,	1,	1,	0},
	{"dp83820", NULL,   0,  "run dp83820 test menu",dp83820_uiDiag, 1,  1,  0},
	{"gtdiag", NULL,   0,  "run gt64240mii test menu",gt_mii_uiDiag, 1,  1,  0},
    {"fcadmin", NULL,   0,  "FC admin command", ispfc_fcadmin,  1,  11, 0},
#ifndef LINUX_TEST
    {"bp", NULL,   0,  "backplane commands", bp_cmd, 1,  4,  0},
	{"bcm5600", NULL,   0,  "run bcm5600 test menu", bcm5600_uiDiag, 1,  1,  0},
#endif
#endif

#if defined(NFP_TXRX) || defined(FCNIM) || defined(SSC_MGMT)
	{"cm", NULL,	0,	"chassis cm",do_chassis,	1,	1,	0},
#endif

#if defined(FCNIM) || defined(NFP_TXRX)
	{"pciread",	"<bus> <dev> <func> [reg]", 0, "read PCI CFG reg", do_pci_read, 4, 5, 0},
	{"pciwrite",	"<bus> <dev> <func> [reg] <data>", 0, "write PCI CFG reg", do_pci_write, 6, 6, 0},
	{"pciclear",	"<bus> <dev>", 0, "clear pci errors", do_pci_clear, 3, 3, 0},
	{"pcistat",		"<bus> <dev>", 0, "read pci cfg stat reg", do_pci_stat, 3, 3, 0},

#endif

#ifdef EVAL_BOARD
	{"led",	"<0,1,2> <on/off>",	0,	"turn on/off debug LED", do_led, 3, 3, 0},
	{"baud", "<9600/19200/38400>",	0,	"set baud rate",	do_baud,	2,	2,	0},

#endif	/* EVAL_BOARD */
	{"send",	"<slot> <cpu> <num_bytes>", 0, "call eee_sendMessage", do_send_message, 4, 4, 0},

#ifdef LINUX_TEST
#if defined(NFP_TXRX) || defined(FCNIM)
	{"sacify", "<file_name> <byte granularity>", 0, "rcv file in sac blocks", do_sacify_file, 2, 3, 0},
#endif
#endif


#ifdef NFP_FP
	{"scsiio",   NULL,   0, "SCSIIO test and admin control", scsiio_cmd, 0, 7, 0},
	{"sdma_view",NULL,   0, "Show SDMA hndl table", sdma_uiViewHandleTable, 0, 6, 0},
	{"scsit",    NULL,   0, "SCSI test command", scsitest_uiAdmin,  1,  10, 0}, 
    {"fsassert", NULL,   0, "Allow to turn on/off FS asserts", fs_changeDoAssert,  2,  2, 0},
    {"laudbg",   NULL,   0, "laurent debug",   fs_laudbg, 1, 10, 0},
    {"evmadmin", NULL,   0, "EVM admin command", evm_admin,  1,  10, 0},
	{"ndmp",     NULL,   0,	"NDMP commands ",  		ndmp_cmd,	1,  4, 0},
#ifndef LINUX_TEST
    {"bp", NULL,   0,  "backplane commands", bp_cmd, 1,  4,  0},
    {"bmc12500",    NULL, 0, "bmc12500 Eth diag", bmc12500Eth_uiDiag, 1, 10, 0},
	{"lsi", NULL, 0, "LSI 8104 menu", lsi_gmac_uiDiag, 1, 1, 0},  
#endif
#endif

#ifdef NFX_MOD_NFP
	{"sac", "<view|clear|tx|create|merge|free|split>", 0, "test SAC function", do_sac, 2, 6, 0},
#endif	/* NFX_MOD_NFP */

#ifdef SSC_MGMT
	{"bcm5600", NULL,   0,  "run bcm5600 test menu", bcm5600_uiDiag, 1,  1,  0},
	{"bcm5632", NULL,   0,  "run bcm5632 test menu", bcm5632_uiDiag, 1,  1,  0},
	{"gtdiag", NULL,   0,  "run gt64240mii test menu",gt_mii_uiDiag, 1,  1,  0},
#ifndef LINUX_TEST
    {"bp", NULL,   0,  "backplane commands", bp_cmd, 1,  4,  0},
#endif
#endif
	{"ssc_msg", "<app name>", 0, "send msg to SSC app", do_ssc_msg, 2, 2, 0},

#ifndef LINUX_TEST
	{"mm", "[-b|-h|-w|-d] <addr> <data>", 0, "memory modify", do_mem_modify, 3, 4, 0},
	{"dm", "[-b|-h|-w|-d] <addr> [len]", 0, "display memory", do_mem_dump, 2, 4, 0},
	{"tlb", "<index> <va> <pa> <size> <calg>", 0, "display/set TLB entry", do_tlb, 1, 6, 0},
	{"mt", "<addr> <length>", 0, "do memory test", do_mem_test, 3, 3, 0},
	{"mr", "[<addr> <length>]", 0, "check memory scrub", do_mem_read, 1, 3, 0},
#endif
	{"threadtest", NULL, 0, "test esm threads", do_threadtest, 1, 1, 0},
#ifndef SSC_MGMT
	{"ecc", "ena|dis|test|data|start|stop|scrub [<begin> <end>]", 0, "ecc test", do_ecc, 2, 4, 0},
	{"env", "<view|set|reset]", 0, "view/set environment variable", do_seepenv, 2, 4, 0},
#endif
	{"seep", "<view|program|erase> [pcb|chassis]", 0, "view/modify/erase seep",
															do_seep, 2, 3, 0},
#if defined(NFP_TXRX) || defined(NFP_FP)
	{"dpp", "", 0, "show Data Plane Proxy", do_dpp, 1, 1, 0},
#endif

	{"edebug", "", 0, "EEE layer debug", do_edebug, 1, 1, 0},
	{"esmtime", "", 0, "ESM statistics", do_esmTimeStats, 1, 1, 0},
#ifdef NFX_PROFILING
	{"prof_start", "", 0, "Start profiling", prof_start, 1, 1, 0},
	{"prof_stop", "", 0, "Stop profiling", prof_stop, 1, 1, 0},
	{"prof_dump", "[vol:file]", 0, "Dump profiler data", prof_dump, 1, 2, 0},
#endif
#ifdef NFX_COVERAGE
	{"gcov_dump", "", 0, "Dump gcov data", gcov_dump, 1, 2, 0},
	{"gcov_reset", "", 0, "Reset gcov counts", gcov_reset_counts, 1, 1, 0},
#endif
#ifdef SIBYTE
	{"cerr", "", 0, "Read Cache Error counter", do_cerr, 1, 1, 0},
	{"htstats", "[clear]", 0, "HT tx bytes", ht_traffic_ui, 1, 2, 0},
	{"perfcount", "<start|stop|view>", 0, "SB-1 Perf Counters", do_perf_count, 2, 2, 0},
#endif

#ifdef AGILE_HARDWARE
#ifndef SSC_MGMT
	{"prom", "<id | view | autoload | flag >", 0, "prom cmds", do_prom_cmd, 1, 99, 0},
#else
	{"prom", "<id | view | autoload | flag | upgrade >", 0, "prom cmds", do_prom_cmd, 1, 99, 0},
#endif
#endif

	{"wd", "<ena|dis|view> <nsec>", 0, "watchdog commands", watchdog_cmd, 1, 3, 0},
	{"crashdump", "<view|remove|store> [saved|pending]", 0, "crashdump commands", crashdump_cmd, 2, 3, 0},
	{"debug", "[-v] [-V] [9600|19200|38400|57600]", 0, "attach to serial GDB", debug, 1, 99, 0},

	{"cp0", "", 0, "view cp0 regs", do_cp0_regs, 1, 1, 0},

	{"eeepoll", "<on | off>", 0, "start/stop polling loop", eee_start_polling_ui, 2, 2, 0},

#ifdef NFP_FP
	{"fs_vb_hash",	"<0xVolId> <blknum>", 0, "get hashcode for fs object", fs_getHashVolBlock, 3, 3, 0},
	{"fs_vi_hash",	"<0xVolId> <inum>", 0, "get hashcode for fs object", fs_getHashVolInum, 3, 3, 0},
	{"fs_vip_hash",	"<0xVolId> <inum> <page>", 0, "get hashcode for fs object", fs_getHashVolInumPage, 4, 4, 0},
#endif

#ifdef NFP_FP
	{"fs_locks",	"", 0, "show all locks for all fs", fs_uiLockPrintAllOwned, 1, 1, 0},
#endif

#ifdef AGILE_HARDWARE
	{"libc_crc", "", 0, "Check the CRC calculations", libc_check_crc, 1, 1, 0},
#endif
#ifndef FCNIM_TM
	{"event", "<register|post|list|stat> <id>", 0, "event mgr ui", event_mgr_ui, 2, 3, 0},
#endif
	{"config", "", 0, "show module config", show_config, 1, 1, 0},

#if defined(USE_THREAD_STACKS) || defined(USE_BSS_THREAD_STACKS)
	{"ts", "<alloc|free>", 0, "threadstack test", ts_cmd, 2, 3, 0},
#endif

#ifndef SSC_MGMT
	{"mb_bzero", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "bzero benchmark", mb_memBenchBzero, 4, 6, 0},
	{"mb_r32", "<numBytes> <numIter> <memType> [-u] [-c] [l]", 0, "32-bit read benchmark", mb_memBenchRead32, 4, 7, 0},
	{"mb_r64", "<numBytes> <numIter> <memType> [-u] [-c] [l]", 0, "64-bit read benchmark", mb_memBenchRead64, 4, 7, 0},
	{"mb_w32", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "32-bit write benchmark", mb_memBenchWrite32, 4, 6, 0},
	{"mb_w64", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "64-bit write benchmark", mb_memBenchWrite64, 4, 6, 0},
	{"mb_c32", "<numBytes> <numIter> <fromMmemType> <toMemType> [-u] [-c]", 0, "32-bit copy benchmark", mb_memBenchCopy32, 5, 7, 0},
	{"mb_c64", "<numBytes> <numIter> <fromMemType> <toMemType> [-u] [-c]", 0, "64-bit copy benchmark", mb_memBenchCopy64, 5, 7, 0},

#if 0
	{"memcpy", "", 0, "memcpy test", memcpy_cmd, 3, 3, 0},
#endif
#endif

#ifdef NFX_SMP
	{"altcpu", "<start|stop>", 0, "altcpu test", altcpu_cmd, 2, 3, 0},
	{"lock", "<get|release|view>", 0, "spinlock debug UI", spinlock_ui, 2, 3, 0},
	{"counttest", "", 0, "", counttest, 1, 1, 0},
#endif
	{"atomic", "<inc|dec> [step]", 0, "atomic counter UI", atomic_ui, 2, 3, 0},

#ifdef SIBYTE
#ifdef NFP_FP
	{"sbprof", "<start|stop|dump>", 0, "sb1 profiler", sbprof_cmd, 2, 5, 0},
#endif
#endif

    {NULL,		NULL,		0,	NULL,						NULL,	0,	0,	0}
};
