/*
 *-----------------------------------------------------------------
 *
 * Name:	more.c
 *
 * RCS:  $Id: more.c,v 1.3 2002/11/23 19:04:52 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
#include <nfx-incl.h>
#include "pmon-ui.h"
#include <exports/serio-api.h>

#define BEL			007
#define TIKRATE		100000

uint32		moresz = 40;
char8		more_pat[LINESZ] CPU_PRIVATE;
int32		tik_cnt CPU_PRIVATE;
char8		more_tiks[] = "|/-\\";
char8  		 * more_tik CPU_PRIVATE;
char8		* more_msg = "more... ";

int32 getinp ( int32	* cnt, int32	size);

/*-----------------------------------------------------------------
 * Name:	more()
 *
 * Description:	the 'more' paginator
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
int32
more (
	char8	* p,
	int32	* cnt,
	int32	size
)
{
	int32	r;

	if (*cnt == 0) {
		if (size == 0)
			return (1);			/* if cnt=0 and size=0 we're done */
		while ((r = getinp (cnt, size)) == -1);
			if (r) {			/* quit */
				*p = 0;
				return (1);
			}
	}
	if (*cnt == -1) {			/* search in progress */
		if (!strposn (p, more_pat)) {
			dotik (256, 0);
			return (0);			/* not found yet */
		} else {				/* found */
			*cnt = size;
			printf ("\b \n");
		}
	}

	printf ("%s\n", p);
	*p = 0;
	(*cnt)--;

	return (0);

}	/* more() */

/*-----------------------------------------------------------------
 * Name:	getinp()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
int32
getinp (
	int32	* cnt,
	int32	size
)
{
	int32	i, c;

	printf ("%s", more_msg);
	for (;;) {
		c = getchar ();
		if (strchr ("nq/ \n", c))
			break;
		putchar (BEL);
	}
	era_line (more_msg);
	if (c == 'q')
		return (1);
	switch (c) {
		case ' ':
				*cnt = size;
				break;
		case '\n':
				*cnt = 1;
				break;
		case '/':
				/* get pattern */
				putchar ('/');
				for (i = 0;;) {
						c = getchar ();
					if (c == '\n')
						break;
					if (c == '\b') {
						if (i > 0) {
							putchar (c);
							i--;
						} else {
							putchar ('\b');
							return (-1);
						}
					} else {
						putchar (c);
						more_pat[i++] = c;
					}
				}
				more_pat[i] = 0;
				printf ("  ");
				*cnt = -1;		/* enter search mode */
				break;
		case 'n':
				printf ("/%s  ", more_pat);
				*cnt = -1;		/* enter search mode */
				break;
	}

	return (0);

}	/* getinp() */

/*-----------------------------------------------------------------
 * Name:	dotik()
 *
 * Description:	twirly
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
void
dotik (
	int32	rate,
	int32	use_ret
)
{
	tik_cnt -= rate;
	if (tik_cnt > 0)
		return;
	tik_cnt = TIKRATE;
	if (more_tik == 0)
		more_tik = more_tiks;
	if (*more_tik == 0)
		more_tik = more_tiks;
	if (use_ret)
		printf (" %c\r", *more_tik);
	else
		printf ("\b%c", *more_tik);
	more_tik++;

}	/* dotik() */

