/*
 *-----------------------------------------------------------------
 *
 * Name:	pmon-ui.h
 *
 * RCS:  $Id: pmon-ui.h,v 1.1.1.1 2001/07/04 00:44:57 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	definitions for UI from pmon
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _PMON_UI_H
#define _PMON_UI_H

#define LINESZ	200		/* max command line length */
#define MAX_AC	100		/* max number of args to commands */

typedef struct Optdesc {
	char8		*name;
	char8		*desc;
} Optdesc;

typedef struct Cmd {
	char8		*name;
	char8		*opts;
	Optdesc		*optdesc;
	char8		*desc;
	int32		(*func)();
	int32		minac;
	int32		maxac;
	int32		repeat;
} Cmd;

/* external data declarations */
extern int32	histno;			/* current history number */
extern char8	* searching;
extern Cmd		CmdTable[];
extern char8	line[LINESZ + 1];
extern char8	prnbuf[];
extern uint32	moresz;
extern int32	repeating_cmd;


/* function declarations */
char8 *		findbang (char *);
char8 *		gethistn (int);
int32		get_rsa (uint32 *, char8 *);
int32		atob (uint32 *, char8 *, int32);
int32		llatob (uint64 *, char8 *, int32);

/* macros to increment and decrement x, modulus mod */
#define incmod(x,mod)	(((x+1) > mod)?0:x+1)
#define decmod(x,mod)	(((x-1) < 0)?mod:x-1)

#define CNTRL(x)	(x & 0x1f)

int32 argvize(char8 * av[], char8 * s);
char8 *getword(char8 *dst, char8 *p);
int32 more(char8 * p, int32 * cnt, int32 size);
void dotik(int32 rate, int32 use_ret);
void era_line(char8 *s);
int32 prhelp (int32 n, int32 * lnp, int32 siz, int32 namemax, int32 optsmax);

#endif	/* _PMON_UI_H */

