/*
 *-----------------------------------------------------------------
 *
 * Name: cm-helper.c
 *
 * RCS:  $Id: cm-helper.h,v 1.2 2002/03/26 23:17:46 ericc Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:  these are cut-n-pasted from cm-api.c and modified
 *		to fit an anpssc context.
 *
 * Created by:  ericc
 *
 * Date Created:        8/17/01
 *
 *-----------------------------------------------------------------
 */

#define         VIEW_CM_MSG     77
#define         EDIT_CM_MAP     	78
#define		NFX_CARDTYPE_NUM	3
#define	 	CM_NUM_STATES			8

typedef struct {
	int	msg;
	int	slot;
	int	slice;
} bsd_cm_msg_t;

typedef struct {
        int  occ;
        int  type;
        int  state;
        int  cpu_state[16];
} cmCard_t;

cmCard_t	*map_of_chassis;

typedef struct {
        int  status;
        int  status_exp;
        int  control;
        int  control_exp;
        int  power_usage;
        int  message_in;
        int  message_out;
        int  reserved;
} slave_cm_info, * slave_cm_info_ptr;

typedef struct {
        int  master_board_status;
        int  master_board_gpp;
        int  master_module_presence;
        int  reserved;
        slave_cm_info   slot[11];
} master_cm_info, * master_cm_info_ptr;

char  * card_type_strings[NFX_CARDTYPE_NUM] = {
                                                                                                "SSC",
                                                                                                "NFP",
                                                                                                "FCNIM"
};

char  * card_state_strings[CM_NUM_STATES] = {
                                                                                                "NOT PRESENT",
                                                                                                "POWER_REQ",
                                                                                                "BOOT",
                                                                                                "SYS_INIT",
                                                                                                "LOADING",
                                                                                                "RUNTIME",
                                                                                                "REBOOTING",
                                                                                                "CRASHED"
};

void cmMasterDisplay(master_cm_info * mptr);
void cmSlaveDisplay(slave_cm_info * sptr);
char *cmGetCardString(int  slot_num);
char *cmGetStateString(int  state);
int  cmGetCardState( int  slot_num);
int  cmGetCardType(int slot_num);
void cmViewChassis();

void cmSlaveDisplay(slave_cm_info * sptr)
{
        printf("\n status:      %x  control: %x",sptr->status, sptr->control);
        printf("\n power usage: %x  message in: %x  message out: %x",
                        sptr->power_usage, sptr->message_in, sptr->message_out);
}

void cmMasterDisplay(master_cm_info * mptr)
{
	int i;

        printf("\nstatus: %x | gpp: %x | module presence: %x\n",
                mptr->master_board_status, mptr->master_board_gpp,
                mptr->master_module_presence);

        for (i = 0; i < 10; i++)
        {
                printf("\nslot[%d]",i);
                cmSlaveDisplay(&mptr->slot[i]);
        }
        printf("\n");
}

char  * cmGetCardString(
        int  slot_num
)
{
        return card_type_strings[slot_num];

}       /* cmGetCardString() */

char  * cmGetStateString(
        int  state
)
{
        return card_state_strings[state];

}       /* cmGetStateString() */

int
cmGetCardState(
        int  slot_num
)
{
        return map_of_chassis[slot_num].state;

}       /* cmGetCardState() */

int
cmGetCardType(
        int  slot_num
)
{
        return map_of_chassis[slot_num].type;

}       /* cmGetCardType() */

void cmViewChassis()
{
	int i;
		printf("\nSlot     CardType        State\n");
                printf(  "----     --------     ----------\n");
                for (i=0; i< 12; i++) {
                        if (map_of_chassis[i].occ) {
                                printf("%4d%c    %8s     %10s\n", i,
				((!i) ? '*' : ' '),
                                cmGetCardString(cmGetCardType(i)),
                                cmGetStateString(cmGetCardState(i)));
                 
                        }
                }
                printf(  "----     --------     ----------\n\n");

}
