// vi:ts=4
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <stdio.h>

static void prthex (unsigned char *x, int len)
{
	for (;len;len--,x++) {
		printf ("%02x ", *x);
	}
	printf("\n");
}

extern int
main (int argc, char *argv[])
{
	int fd;
	int sz;
	char buf[1024];

	fd = open (argv[1], O_RDONLY, 0);
	if (fd < 0) {
		perror ("Open");
		return 1;
	}

	while (read (fd, &sz, 4) == 4) {
		if (sz == 1024) printf("\n");

		printf ("Reading: %d\n", sz);
		read (fd, buf, sz);

		if ((sz != 24) && (sz != 8)) {
			printf ("strlen %d:%s:\n", strlen(buf), buf);
		}
		else {
			prthex (buf, sz);
		}

	}
	return 0;
}
