// vi:ts=4

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "exports/anpssc-api.h"
#include "exports/event-api.h"
#include "ncm-api.h"

extern int
main(int argc, char *argv[])
{
	nfx_eventMsg_t new;
	
	if (argc != 4) {
		fprintf (stderr, "Usage: %s nodeName prim_ip sec_ip\n", argv[0]);
		exit (1);
	}

	memset (&new, 0, sizeof(new));

	new.msgType = NFX_EVENT_POST;
	new.eventType = NFX_EVENT_NODE;
	new.param.nodeEvent.state = EVENT_STATE_UP;
	strcpy (new.nodeName, argv[1]);
	new.param.nodeEvent.mgmt_ip[0] = inet_addr (argv[2]);
	new.param.nodeEvent.mgmt_ip[1] = inet_addr (argv[3]);

	sendAgileMsg (-1, &new, sizeof (new),
	              "ncm", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE,
	              NULL, NULL, 0);

	return 0;
}
