/* vi:ts=4
*/
#include <stdio.h>
#include <stdlib.h>

#include "exports/anpssc-api.h"
#include "ncm-api.h"

#include "tests.h"

extern int
main (int argc, char *argv[])
{
	long long buf[2048];
	ncmMsg_t *msg = (ncmMsg_t *)buf;
	long long rbuf[2048];
	ncmMsg_t *rsp = (ncmMsg_t *)rbuf;
	unsigned char *prsp;
	int i;
	int totSize;
	int pass;
	int maxpass;

	if (argc != 2) {
		printf ("usage: %s count\n", argv[0]);
		exit (1);
	}
	maxpass = atoi(argv[1]);

	for (pass = 0; pass < maxpass; pass++) {
		memset (msg, 0, sizeof(ncmMsg_t));

		msg->msgType = NCM_SEND;
		strcpy (msg->appName, TAPP);
		strcpy (msg->nodeName, "pcc");
		msg->rqResp = 1;
	
		for (i = 0; i < MSG_SIZE; i++) {
			msg->appMsg[i] = pass << i;
		}

		totSize = sizeof (ncmMsg_t) + (sizeof(long long) * (MSG_SIZE - 1));

		i = sendAgileMsg (-1, msg, totSize, 
	                  "ncm", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE,
	                  NULL,
	                  rsp, sizeof(rbuf));

		printf ("Got %d in response from app %s at %s\n", i, 
		        rsp->appName, rsp->nodeName);
		printf ("%s\n", rsp->msgType == NCM_RESP ? "Proper Response" : "Bad msg");

		prsp = (unsigned char *)rsp->appMsg;
		i = i - sizeof(ncmMsg_t) + sizeof(long long);

		for (;i > 0; i--, prsp++) {
			printf ("%02x", *prsp);
			if (!((i + 7) % 8)) printf (" ");
		}
		printf ("\n\n");
	}
	exit(0);
}
