// vi:ts=4
#include <stdio.h>

#include "exports/anpssc-api.h"
#include "exports/evm-api.h"

extern int
main(int argc, char *argv[])
{
	int sock;
	long long buf[1024];
	int rc;
	int cpu, slot, plane;
	char app[80];
	int sz;
	evm_MsgStat_t *rsp = (evm_MsgStat_t *)buf;
	evm_MsgVolCreate_t *cfg = (evm_MsgVolCreate_t *)buf;

	sock = regAgileApp("evm");
	if (sock < 0) {
		perror ("Unable to register evm");
		exit (1);
	}

	while (1) {
		rc = recvAgileMsg (sock, buf, sizeof(buf), NULL, 
		                   app, &cpu, &slot, &plane);

		printf ("%s: got %d(len %d), from %s:%d:%d\n", argv[0], 
			        *(int *)buf, rc, app, slot, cpu);

		switch (rsp->hdr.msgType) {
			case EVM_VOL_ONLINE:
				rsp->hdr.msgType = EVM_MSG_STAT;
				rsp->stat = NFX_OK;
				sz = sizeof(evm_MsgStat_t);
				printf ("%s online rq\n", argv[0]);
				break;

			case EVM_VOL_GET_ATTRIB:
				cfg->hdr.msgType = EVM_VOL_CONFIG;
				strcpy (cfg->config.name, "volume");
				sz = sizeof(evm_MsgVolCreate_t);
				printf ("%s get attr rq\n", argv[0]);
				break;

			case EVM_VOL_OFFLINE:
				rsp->hdr.msgType = EVM_MSG_STAT;
				rsp->stat = NFX_OK;
				sz = sizeof(evm_MsgStat_t);
				printf ("%s offline rq\n", argv[0]);
				break;

			default:
				printf ("%s unknown msg: %d\n", argv[0], rsp->hdr.msgType);
				continue;
		}
		sendAgileMsg (-1, buf, sz, app, cpu, slot, plane,
		              NULL, NULL, 0);
	}
}
