// vi:ts =4
#include <sys/types.h>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>

#include "exports/anpssc-api.h"
#include "exports/event-api.h"

extern int
main(int argc, char *argv[])
{
	nfx_eventMsg_t failit;

	if (argc != 2) {
		printf ("Usage: %s VolIdToFailInHex\n", argv[0]);
		exit(1);
	}

	memset (&failit, 0, sizeof(failit));

	failit.msgType = NFX_EVENT_POST;
	failit.eventType = NFX_EVENT_VOLUME;
	failit.param.volEvent.event = EVENT_VOL_FSYSABORT;
	failit.param.volEvent.volId.whole_thing = strtoq (argv[1], NULL, 16);
	failit.param.volEvent.state = EVENT_STATE_FAILED;

	sendAgileMsg (-1, &failit, sizeof(failit),
	              "eventd", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE, NULL,
	              NULL, 0);
	exit(0);
}
