// vi:ts=4
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "exports/anpssc-api.h"
#include "exports/ncm-api.h"

/* Send echo to "node slot cpu" and verify return over cluster */

extern int
main(int argc, char *argv[])
{
	long long buf[256];
	long long rbuf[256];
	ncmMsg_t *ping = (ncmMsg_t *)buf;
	ncmMsg_t *pong = (ncmMsg_t *)rbuf;
	struct timeval to = {2, 0};
	int msgsize;
	int rc;


	if (argc != 4) {
		printf ("usage: %s node slot cpu\n", argv[0]);
		exit (1);
	}

	ping->msgType = NCM_SEND_EMB;
	strcpy (ping->appName, "eee_test_simple");
	strcpy (ping->nodeName, argv[1]);
	ping->rqResp = 1;
	ping->slot = atoi(argv[2]);
	ping->cpu = atoi(argv[3]);
	((int *)(ping->appMsg))[0] = SSC_SLOT;
	((int *)(ping->appMsg))[1] = NFX_SSC_UNIX;
	((int *)(ping->appMsg))[2] = 28;
	((int *)(ping->appMsg))[3] = MGMTPLANE;

	msgsize = (char *)(ping->appMsg) - (char *)buf + 4 * sizeof(int);

	rc = sendAgileMsg (-1, ping, msgsize,
	                   "ncm", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE, &to,
	                   pong, sizeof(rbuf));

	if (rc != (msgsize + 12)) {
		printf ("Short return: %d\n", rc);
		exit (1);
	}

	if (pong->msgType != NCM_RESP) {
		printf ("Not a response\n");
		exit (1);
	}

	if ((ping->appMsg[0] != pong->appMsg[0]) ||
	    (ping->appMsg[1] != pong->appMsg[1])) {
		printf ("Ping doesn't match pong\n");
	}
	exit (0);
}
