// vi:ts=4
#include <stdio.h>

#include "exports/anpssc-api.h"
#include "ncm-api.h"

#define APP "spm"

extern int
main(int argc, char *argv[])
{
	int sock;
	long long buf[1024];
	ncmnodeEvent_t *evt = (ncmnodeEvent_t *)buf;
	int rc;
	int cpu, slot, plane;
	char app[80];

	sock = regAgileApp(APP);
	if (sock < 0) {
		perror ("Unable to register spm");
		exit (1);
	}

	while (1) {
		rc = recvAgileMsg (sock, buf, sizeof(buf), NULL, 
		                   app, &cpu, &slot, &plane);

		printf ("%s: got %d(len %d), from %s:%d:%d\n", argv[0], 
			        *(int *)buf, rc, app, slot, cpu);

		if ( *(int *)buf == NCM_NODE_EVENT) {
			printf ("%s: node %s is %s\n", argv[0], evt->nodeName,
			        evt->new ? "new" : "gone");
		}
		else {
			printf ("Unknown message %d\n", *(int *)buf);
		}

	}
}
