#include "nfx-incl.h"
#include "exports/anpssc-api.h"
#include "exports/elog-api.h"
#include <signal.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "unistd.h"

int myappid;
char *myname = "crashsave";
int sock;
const char *save_dir = "/var/crash";

static void
mmm()
{
}


int
main(int argc, char **argv)
{
	myappid = eee_getApplicationId(myname);

	sock = regAgileApp(myname);

	if (sock < 0) {
		E_LOG(class_1, err_s, myappid, 0, 0, 0,
			  ("can not register application: %m\n"));
		exit(1);
	}

	signal(SIGHUP, mmm);

	kill(getppid(), SIGUSR1);

	while (1) {
		uint32 cpu, slot, plane;
		char buf[50*1024];
		char appName[256];
		int rv = recvAgileMsg(sock, buf, sizeof(buf), NULL,
							  appName, &cpu, &slot, &plane);
		uint32 reply = 0;
		if (rv > 0) {
			char file_name[50];
			struct timeval tv;
			FILE *f;
			gettimeofday(&tv, NULL);
			sprintf(file_name, "%s/%d.%d", save_dir, slot, cpu);
			f = fopen(file_name, "a");
			if (f != NULL) {
				if (fprintf(f, "crashdump_begin: %s\n",
							ctime((time_t *)&tv.tv_sec)) > 0
					&& fwrite(buf, 1, rv, f) == rv
					&& fprintf(f, "\ncrashdump_end\n") > 0) {
					reply = 1;
				}
				fclose(f);
			}
			sendAgileMsg(sock, &reply, sizeof(reply),
						 appName, cpu, slot, plane, NULL, NULL, NULL);
		}
		else {
			E_LOG(class_1, err_s, myappid, 0, 0, 0,
				  ("recvAgileMsg failed: %m\n"));
			exit(1);
		}
	}

	return 0;
}
