/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: licman-api.h
 *
 * RCS:  $Id: licman-api.h,v 1.7 2002/08/28 22:10:16 gregs Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: This is how you determine if there is a valid
 *              license for a product.
 *
 * Created by:	Greg Seibert
 *
 * Date Created: 4 Jan 2002
 *
 *-----------------------------------------------------------------
 */
#if !defined (__licman_api_h)
#define __licman_api_h

// This is what you call to see if a prodId is licensed on the local machine

extern int licman_is_valid (int prodId, int sw_rev);

// And this is what you pass it

#define LIC_BASIC			1
#define LIC_NDMP			2
#define LIC_CLUSTERING		3
#define LIC_AGILEMIRROR		4
#define LIC_SECUREACCESS	5
#define LIC_AGILEVISION		6
#define LIC_AGILESNAP		7
#define LIC_NFS				8
#define LIC_CIFS			9

#define LIC_INVALID			10		// Add new ones starting here

// What we'll call them is in licman-names.h so when you add a product,
// add it's name too please.

#define LICDBFILE "/usr/local/agile/conf/license.db"
#endif
