
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "exports/opt-api.h"


char argstr[1024];


static void
usage(void)
{
	fprintf(stderr, "Usage: modify-ro path command [ arguments ]\n");
}

int
main(int argc, char **argv)
{
	int i;
	int len = 0;
	int rv;
	char *path = argv[1];

	if (argc < 3) {
		fprintf(stderr, "Not enough arguments");
		usage();
		exit(1);
	}

	for (i = 2; i < argc && argv[i] != NULL; ++i) {
		len += 1 + strlen(argv[i]);
	}

	if (len > sizeof(argstr)) {
		fprintf(stderr, "Arguments too long\n");
		usage();
		exit(1);
	}

	for (i = 2; i < argc && argv[i] != NULL; ++i) {
		strcat(argstr, argv[i]);
		strcat(argstr, " ");
	}
	
	if ((rv = ensure_fs_writable(path)) == 0) {
		rv = system(argstr);
		restore_fs_permissions(path);
	}
	return rv;
}
