/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: cmd_spool
 *
 * RCS:  $Id: cmd_help.c,v 1.30 2002/12/04 19:13:58 lanc Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Nitin Jain
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
#include <sys/types.h>
#include <pwd.h>
#include <readline/history.h>
#include <grp.h>
#include <unistd.h>

#include "zebra.h"
#include "command.h"
#include "log.h"
#include "vtysh.h"
#include "memory.h"

#include "nfxsh.h"

#define PAGER "/usr/bin/less"
#define HELPHELP "Command help\n"

/*
 * VOL commands
 */

DEFUN(help_vol_create,
      help_vol_create_cmd,
      "help volume create",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_delete,
      help_vol_delete_cmd,
      "help volume delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_delete.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_show,
      help_vol_show_cmd,
      "help volume show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_modify,
      help_vol_modify_cmd,
      "help volume modify",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_modify.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_offline,
      help_vol_offline_cmd,
      "help volume offline",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_offline.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_online,
      help_vol_online_cmd,
      "help volume online",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_online.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vol_takeover,
      help_vol_takeover_cmd,
      "help volume takeover",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vol_takeover.txt", NULL);
    return(CMD_SUCCESS);
}


#if 0
/*
 * File set commands
 */

DEFUN(help_fset_create,
      help_fset_create_cmd,
      "help fileset create",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_off,
      help_fset_quota_off_cmd,
      "help quota off",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_off.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_on,
      help_fset_quota_on_cmd,
      "help quota on",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_on.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_report_fset,
      help_fset_quota_report_fset_cmd,
      "help quota report fileset",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_report_fset.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_report_group,
      help_fset_quota_report_group_cmd,
      "help quota report group",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_report_group.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_report_user,
      help_fset_quota_report_user_cmd,
      "help quota report user",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_report_user.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_set_default,
      help_fset_quota_set_default_cmd,
      "help quota set default",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_set_default.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_set_fset,
      help_fset_quota_set_fset_cmd,
      "help quota set fileset",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_set_fset.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_set_group,
      help_fset_quota_set_group_cmd,
      "help quota set group",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_set_group.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_set_user,
      help_fset_quota_set_user_cmd,
      "help quota set user",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_set_user.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_show_default,
      help_fset_quota_show_default_cmd,
      "help quota show default",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_show_default.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_show_fset,
      help_fset_quota_show_fset_cmd,
      "help quota show fileset",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_show_fset.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_show_group,
      help_fset_quota_show_group_cmd,
      "help quota show group",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_show_group.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_quota_show_user,
      help_fset_quota_show_user_cmd,
      "help quota show user",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_quota_show_user.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_remove,
      help_fset_remove_cmd,
      "help fileset remove",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_remove.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_show_list,
      help_fset_show_list_cmd,
      "help fileset show list",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_show_list.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_show_usage_fset,
      help_fset_show_usage_fset_cmd,
      "help fileset show usage fileset",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_show_usage_fset.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_show_usage_group,
      help_fset_show_usage_group_cmd,
      "help fileset show usage group",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_show_usage_group.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_fset_show_usage_user,
      help_fset_show_usage_user_cmd,
      "help fileset show usage user",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_fset_show_usage_user.txt", NULL);
    return(CMD_SUCCESS);
}
#endif


/*
 * Snap shot commands
 */

DEFUN(help_snapshot_create,
      help_snapshot_create_cmd,
      "help snapshot create",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_delete,
      help_snapshot_delete_cmd,
      "help snapshot delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_delete.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_schedule,
      help_snapshot_schedule_cmd,
      "help snapshot schedule",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_schedule.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_enable,
      help_snapshot_enable_cmd,
      "help snapshot enable",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_enable.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_disable,
      help_snapshot_disable_cmd,
      "help snapshot disable",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_disable.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_show,
      help_snapshot_show_cmd,
      "help snapshot show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_revert,
      help_snapshot_revert_cmd,
      "help snapshot revert",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_revert.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_pin,
      help_snapshot_pin_cmd,
      "help snapshot pin",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_pin.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_unpin,
      help_snapshot_unpin_cmd,
      "help snapshot unpin",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_unpin.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_snapshot_rename,
      help_snapshot_rename_cmd,
      "help snapshot rename",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_snapshot_rename.txt", NULL);
    return(CMD_SUCCESS);
}

/*
 * Lun commands from SPM
 */

DEFUN(help_lun_label,
      help_lun_label_cmd,
      "help lun label",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_lun_label.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_lun_show,
      help_lun_show_cmd,
      "help lun show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_lun_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_lun_unlabel,
      help_lun_unlabel_cmd,
      "help lun unlabel",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_lun_unlabel.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_lun_topology,
      help_lun_topology_cmd,
      "help lun topology",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_lun_topology.txt", NULL);
    return(CMD_SUCCESS);
}

/* 
 * IP help cmd
 */

DEFUN(help_intf_add,
      help_intf_add_cmd,
      "help interface add",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_add.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_intf_del,
      help_intf_del_cmd,
      "help interface delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_del.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_intf_en,
      help_intf_en_cmd,
      "help interface enable",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_en.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_intf_dis,
      help_intf_dis_cmd,
      "help interface disable",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_dis.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_intf_setmtu,
      help_intf_setmtu_cmd,
      "help interface setmtu",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_setmtu.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_intf_autoneg,
      help_intf_autoneg_cmd,
      "help interface autoneg",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_autoneg.txt", NULL);
    return(CMD_SUCCESS);
}



DEFUN(help_intf_show,
      help_intf_show_cmd,
      "help interface show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_intf_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_create,
      help_vif_create_cmd,
      "help vif create",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_destory,
      help_vif_destory_cmd,
      "help vif delete",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_destory.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_addport,
      help_vif_addport_cmd,
      "help vif addport",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_addlink.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_delport,
      help_vif_delport_cmd,
      "help vif delport",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_dellink.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_pref,
      help_vif_pref_cmd,
      "help vif prefer",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_pref.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_vif_show,
      help_vif_show_cmd,
      "help vif show",
      "")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_vif_show.txt", NULL);
    return(CMD_SUCCESS);
}


DEFUN(help_rt_add,
      help_rt_add_cmd,
      "help route add",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_rt_add.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_rt_del,
      help_rt_del_cmd,
      "help route delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_rt_del.txt", NULL);
    return(CMD_SUCCESS);
}


DEFUN(help_rt_show,
      help_rt_show_cmd,
      "help route show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_rt_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_arp_add,
      help_arp_add_cmd,
      "help arp add",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_arp_add.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_arp_del,
      help_arp_del_cmd,
      "help arp delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_arp_del.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_arp_show,
      help_arp_show_cmd,
      "help arp show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_arp_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_system_show,
      help_system_show_cmd,
      "help system show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_system_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_nameservice,
      help_nameservice_cmd,
      "help nameservice",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nameservice.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_nameservice,
      help_name_add_cmd,
      "help nameservice add",
      HELPHELP)

ALIAS(help_nameservice,
      help_name_del_cmd,
      "help nameservice delete",
      HELPHELP)

ALIAS(help_nameservice,
      help_name_sho_cmd,
      "help nameservice show",
      HELPHELP)

DEFUN(help_admin,
      help_admin_cmd,
      "help admin",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/admin.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_admin,
      help_admin_add_cmd,
      "help admin add",
      HELPHELP)

ALIAS(help_admin,
      help_admin_show_cmd,
      "help admin show",
      HELPHELP)

ALIAS(help_admin,
      help_admin_delete_cmd,
      "help admin delete",
      HELPHELP)

ALIAS(help_admin,
      help_admin_modify_cmd,
      "help admin modify",
      HELPHELP)

ALIAS(help_admin,
      help_admin_password_cmd,
      "help admin password",
      HELPHELP)

DEFUN(help_ping,
      help_ping_cmd,
      "help system ping",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/system_ping.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_ping,
      help_ping_alias,
      "help ping",
      HELPHELP)

DEFUN(help_reboot,
      help_reboot_cmd,
      "help system reboot",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/system_reboot.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_halt,
      help_halt_cmd,
      "help system halt",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/system_halt.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_traceroute,
      help_traceroute_cmd,
      "help system traceroute",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/system_traceroute.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_traceroute,
      help_traceroute_alias,
      "help traceroute",
       HELPHELP)

DEFUN(help_time,
      help_time_cmd,
      "help system time",
      HELPHELP)
{
    execute_command (PAGER, 1, 
	        "/usr/local/agile/man/help_system_time.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_license,
      help_license_cmd,
      "help license",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_license.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_license,
      help_license_add_cmd,
      "help license add",
      HELPHELP)

ALIAS(help_license,
      help_license_delete_cmd,
      "help license delete",
      HELPHELP)

ALIAS(help_license,
      help_license_show_cmd,
      "help license show",
      HELPHELP)

DEFUN(help_port_disable,
	  help_port_disable_cmd,
	  "help port disable",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_state.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_port_enable,
	  help_port_enable_cmd,
	  "help port enable",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_state.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_port_reset,
	  help_port_reset_cmd,
	  "help port reset",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_state.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_port_show_detail,
	  help_port_show_detail_cmd,
	  "help port show detail",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_port_show_stats,
	  help_port_show_stats_cmd,
	  "help port show stats",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_port_show_topology,
	  help_port_show_topology_cmd,
	  "help port show topology",
	  HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_port_show.txt", NULL);
    return(CMD_SUCCESS);
}

/*
 * NFS share command
 */
DEFUN(help_nfs_share,
      help_nfs_share_cmd,
      "help nfs share",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nfs_share.txt", NULL);
    return(CMD_SUCCESS);
}

#ifdef	NOTUSED
DEFUN(help_nfs_shareall,
      help_nfs_shareall_cmd,
      "help nfs shareall",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nfs_shareall.txt", NULL);
    return(CMD_SUCCESS);
}


DEFUN(help_nfs_unshare,
      help_nfs_unshare_cmd,
      "help nfs unshare",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nfs_unshare.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_nfs_unshareall,
      help_nfs_unshareall_cmd,
      "help nfs unshareall",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nfs_unshareall.txt", NULL);
    return(CMD_SUCCESS);
}
#endif	//NOTUSED

DEFUN(help_nfs_show,
      help_nfs_show_cmd,
      "help nfs show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_nfs_show.txt", NULL);
    return(CMD_SUCCESS);
}

/*
 * Elog commands
 */
	  
DEFUN(help_elog,
      help_elog_cmd,
      "help elog",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_elog.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_elog,
      help_elog_state_cmd,
      "help elog state",
      HELPHELP)

ALIAS(help_elog,
      help_elog_level_cmd,
      "help elog level",
      HELPHELP)

ALIAS(help_elog,
      help_elog_facility_cmd,
      "help elog facility",
      HELPHELP)

ALIAS(help_elog,
      help_elog_host_cmd,
      "help elog host",
      HELPHELP)

ALIAS(help_elog,
      help_elog_show_cmd,
      "help elog show",
      HELPHELP)

/*
 * Mirror commands
 */

DEFUN(help_am_create,
      help_am_create_cmd,
      "help mirror create",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_am_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_am_delete,
      help_am_delete_cmd,
      "help mirror delete",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_am_delete.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_am_show,
      help_am_show_cmd,
      "help mirror show",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_am_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_am_host,
      help_am_host_cmd,
      "help mirror host",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_am_host.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_am_host,
      help_am_host_add_cmd,
      "help mirror host add",
      HELPHELP)

ALIAS(help_am_host,
      help_am_host_delete_cmd,
      "help mirror host delete",
      HELPHELP)

DEFUN(help_am_misc,
      help_am_enable_cmd,
      "help mirror enable",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_am_misc.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_am_misc,
      help_am_disable_cmd,
      "help mirror disable",
      HELPHELP)

ALIAS(help_am_misc,
      help_am_start_cmd,
      "help mirror start",
      HELPHELP)

ALIAS(help_am_misc,
      help_am_stop_cmd,
      "help mirror stop",
      HELPHELP)

/*
 * NDMP commands
 */

DEFUN(help_ndmp_auth,
      help_ndmp_auth_cmd,
      "help ndmp auth",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_auth.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_delete,
      help_ndmp_delete_cmd,
      "help ndmp delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_delete.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_disable,
      help_ndmp_disable_cmd,
      "help ndmp disable",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_disable.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_enable,
      help_ndmp_enable_cmd,
      "help ndmp enable",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_enable.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_set,
      help_ndmp_set_cmd,
      "help ndmp set",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_set.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_show,
      help_ndmp_show_cmd,
      "help ndmp show",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_show.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_sch_create,
      help_ndmp_sch_create_cmd,
      "help ndmp schedule create",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_sch_create.txt", NULL);
    return(CMD_SUCCESS);
}

DEFUN(help_ndmp_sch_delete,
      help_ndmp_sch_delete_cmd,
      "help ndmp schedule delete",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_ndmp_sch_del.txt", NULL);
    return(CMD_SUCCESS);
}


/*
 * Help command
 */

DEFUN(help,
      help_cmd,
      "help",
      HELPHELP)
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_help.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help,
      help_help,
      "help help",
      HELPHELP
      "Help on the help command\n")

DEFUN(help_cluster,
      help_cluster_cmd,
      "help cluster",
      HELPHELP
      "Gives help on clustering command set\n")
{
    execute_command (PAGER, 1, "/usr/local/agile/man/help_cluster.txt", NULL);
    return(CMD_SUCCESS);
}

/*
 * RAID commands
 */
DEFUN (help_raid_config,
	   help_raid_config_cmd,
	   "help raid config",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_raid_config.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_raid_dev,
	   help_raid_dev_cmd,
	   "help raid dev",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_raid_dev.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_raid_devlist,
	   help_raid_devlist_cmd,
	   "help raid devlist",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_raid_devlist.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_raid_info,
	   help_raid_info_cmd,
	   "help raid info",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_raid_info.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_raid_lun,
	   help_raid_lun_cmd,
	   "help raid lun",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_raid_lun.txt", NULL);
		return(CMD_SUCCESS);
}

/*
 * TAPE commands
 */
DEFUN (help_tape_bsf,
	   help_tape_bsf_cmd,
	   "help tape bsf",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_bsr_bsf.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_bsr,
	   help_tape_bsr_cmd,
	   "help tape bsr",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_bsr_bsf.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_close,
	   help_tape_close_cmd,
	   "help tape close",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_close.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_devlist,
	   help_tape_devlist_cmd,
	   "help tape devlist",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_devlist.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_devstate,
	   help_tape_devstate_cmd,
	   "help tape devstate",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_devstate.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_eod,
	   help_tape_eod_cmd,
	   "help tape eod",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_eod.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_fsf,
	   help_tape_fsf_cmd,
	   "help tape fsf",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_fsr_fsf.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_fsr,
	   help_tape_fsr_cmd,
	   "help tape fsr",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_fsr_fsf.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_load,
	   help_tape_load_cmd,
	   "help tape load",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_load.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_mc_devlist,
	   help_tape_mc_devlist_cmd,
	   "help tape mc devlist",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_mc.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_open,
	   help_tape_open_cmd,
	   "help tape open",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_open.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_rewind,
	   help_tape_rewind_cmd,
	   "help tape rewind",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_rewind.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_unload,
	   help_tape_unload_cmd,
	   "help tape unload",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_unload.txt", NULL);
		return(CMD_SUCCESS);
}

DEFUN (help_tape_wfm,
	   help_tape_wfm_cmd,
	   "help tape wfm",
	   HELPHELP)
{
		execute_command(PAGER, 1, "/usr/local/agile/man/help_tape_wfm.txt", NULL);
		return(CMD_SUCCESS);
}

/*
 * Autosupport commands
 */
	  
DEFUN(help_autosupport,
      help_autosupport_cmd,
      "help autosupport",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_autosupport.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_autosupport,
      help_autosupport_state_cmd,
      "help autosupport state",
      HELPHELP)

ALIAS(help_autosupport,
      help_autosupport_to_cmd,
      "help autosupport email to",
      HELPHELP)

ALIAS(help_autosupport,
      help_autosupport_noteto_cmd,
      "help autosupport email noteto",
      HELPHELP)

ALIAS(help_autosupport,
      help_autosupport_show_config_cmd,
      "help autosupport show config",
      HELPHELP)

/*
 * AV config commands
 */
	  
DEFUN(help_av,
      help_av_cmd,
      "help av",
      HELPHELP)
{
    execute_command (PAGER, 1, 
			"/usr/local/agile/man/help_av.txt", NULL);
    return(CMD_SUCCESS);
}

ALIAS(help_av,
      help_av_ip_cmd,
      "help av host",
      HELPHELP)

ALIAS(help_av,
      help_av_password_cmd,
      "help av password",
      HELPHELP)

ALIAS(help_av,
      help_av_show_config_cmd,
      "help av show config",
      HELPHELP)


/************************************************************************
 * The main help menu tree
 *************************************************************************
 */

void
install_help (priv_t myPriv, enum node_type node)
{
/*
	Organizing this switch statment such that the higher priority commands
	are first allows us to fall through and pick up the lower priority
	ones at no extra cost.
 */
	switch (myPriv) {
		case diagPriv:
            /* VOL commands */
            install_element(node, &help_vol_takeover_cmd);

			/* Nameservice */
			install_element (node, &help_nameservice_cmd);

            /* File set commands */
		case fullPriv:
			/* FibreChannel PORT commands */
			install_element (node, &help_port_disable_cmd);	
			install_element (node, &help_port_enable_cmd);	
			install_element (node, &help_port_reset_cmd);	

            /* VOL commands */
            install_element(node, &help_vol_delete_cmd);
            install_element(node, &help_vol_offline_cmd);
            install_element(node, &help_vol_online_cmd);

			/* ip commands */
			install_element(node, &help_intf_add_cmd);
			install_element(node, &help_intf_del_cmd);
			install_element(node, &help_intf_en_cmd);
            install_element(node, &help_intf_dis_cmd);
			install_element(node, &help_intf_setmtu_cmd);
            install_element(node, &help_intf_autoneg_cmd);
			install_element(node, &help_vif_create_cmd);
			install_element(node, &help_vif_destory_cmd);
			install_element(node, &help_vif_addport_cmd);
			install_element(node, &help_vif_delport_cmd);		
			install_element(node, &help_vif_pref_cmd);

			install_element(node, &help_rt_add_cmd);
			install_element(node, &help_rt_del_cmd);
			install_element(node, &help_arp_add_cmd);
			install_element(node, &help_arp_del_cmd);

			/* license commands */
			install_element(node, &help_license_cmd);
			install_element(node, &help_license_delete_cmd);

			/* admin commands */
			install_element(node, &help_admin_cmd);
			install_element(node, &help_admin_add_cmd);
			install_element(node, &help_admin_delete_cmd);
			install_element(node, &help_admin_modify_cmd);
			install_element(node, &help_admin_show_cmd);

			/* system commands */
			install_element(node, &help_halt_cmd);
			install_element(node, &help_reboot_cmd);

            /* NFS command*/
            //install_element(node, &help_nfs_unshare_cmd);
            //install_element(node, &help_nfs_unshareall_cmd);

            /* NDMP commands */
            install_element(node, &help_ndmp_auth_cmd);
            install_element(node, &help_ndmp_delete_cmd);
            install_element(node, &help_ndmp_disable_cmd);
            install_element(node, &help_ndmp_set_cmd);

			/* Nameservice */
			install_element (node, &help_name_del_cmd);

            /* File set commands */

			/* Elog commands */
			install_element(node, &help_elog_cmd);
			install_element(node, &help_elog_level_cmd);
			install_element(node, &help_elog_facility_cmd);
			install_element(node, &help_elog_state_cmd);
			install_element(node, &help_elog_host_cmd);

			/* Mirror commands */
			install_element(node, &help_am_delete_cmd);
			install_element(node, &help_am_stop_cmd);
			install_element(node, &help_am_start_cmd);

			/* Tape commands */
			install_element(node, &help_tape_bsf_cmd);
			install_element(node, &help_tape_bsr_cmd);
			install_element(node, &help_tape_close_cmd);
			install_element(node, &help_tape_devstate_cmd);
			install_element(node, &help_tape_eod_cmd);
			install_element(node, &help_tape_fsf_cmd);
			install_element(node, &help_tape_fsr_cmd);
			install_element(node, &help_tape_load_cmd);
			install_element(node, &help_tape_open_cmd);
			install_element(node, &help_tape_rewind_cmd);
			install_element(node, &help_tape_unload_cmd);
			install_element(node, &help_tape_wfm_cmd);

		case changePriv:
            /* VOL commands */
            install_element(node, &help_vol_modify_cmd);

#if 0
            /* File set commands */
            install_element(node, &help_fset_quota_off_cmd);
            install_element(node, &help_fset_quota_on_cmd);
#endif

            /* Snap shot commands */
            install_element(node, &help_snapshot_schedule_cmd);
            install_element(node, &help_snapshot_enable_cmd);
            install_element(node, &help_snapshot_disable_cmd);
            install_element(node, &help_snapshot_pin_cmd);
            install_element(node, &help_snapshot_unpin_cmd);
            install_element(node, &help_snapshot_rename_cmd);

            /* LUN commands from SPM */
            install_element(node, &help_lun_label_cmd);
            install_element(node, &help_lun_unlabel_cmd);

			/* Mirror commands */
			install_element(node, &help_am_enable_cmd);
			install_element(node, &help_am_disable_cmd);

			/* Autosupport commands */
			install_element(node, &help_autosupport_state_cmd);
			install_element(node, &help_autosupport_to_cmd);
			install_element(node, &help_autosupport_noteto_cmd);

			/* AV config commands */
			install_element(node, &help_av_password_cmd);
			install_element(node, &help_av_ip_cmd);

		case addPriv:
            /* VOL commands */
            install_element(node, &help_vol_create_cmd);

			/* license commands */
			install_element(node, &help_license_add_cmd);

#if 0
            /* File set commands */
            install_element(node, &help_fset_create_cmd);
            install_element(node, &help_fset_remove_cmd);
            install_element(node, &help_fset_quota_set_default_cmd);
            install_element(node, &help_fset_quota_set_fset_cmd);
            install_element(node, &help_fset_quota_set_group_cmd);
            install_element(node, &help_fset_quota_set_user_cmd);
#endif

            /* Snap shot commands */
            install_element(node, &help_snapshot_create_cmd);
            install_element(node, &help_snapshot_delete_cmd);
            install_element(node, &help_snapshot_revert_cmd);

            /* NFS share */
            install_element(node, &help_nfs_share_cmd);
            //install_element(node, &help_nfs_shareall_cmd);

            /* NDMP commands */
            install_element(node, &help_ndmp_enable_cmd);
            install_element(node, &help_ndmp_sch_create_cmd);
            install_element(node, &help_ndmp_sch_delete_cmd);

			/* Nameservice */
			install_element (node, &help_name_add_cmd);

			/* Mirror commands */
			install_element(node, &help_am_create_cmd);
			install_element(node, &help_am_host_add_cmd);
			install_element(node, &help_am_host_delete_cmd);

		case viewPriv:
			/* admin commands */
			install_element(node, &help_admin_password_cmd);

            /* VOL commands */
            install_element(node, &help_vol_show_cmd);

#if 0
            /* File set commands */
            install_element(node, &help_fset_quota_report_fset_cmd);
            install_element(node, &help_fset_quota_report_group_cmd);
            install_element(node, &help_fset_quota_report_user_cmd);
            install_element(node, &help_fset_quota_show_default_cmd);
            install_element(node, &help_fset_quota_show_fset_cmd);
            install_element(node, &help_fset_quota_show_group_cmd);
            install_element(node, &help_fset_quota_show_user_cmd);
            install_element(node, &help_fset_show_list_cmd);
            install_element(node, &help_fset_show_usage_fset_cmd);
            install_element(node, &help_fset_show_usage_group_cmd);
            install_element(node, &help_fset_show_usage_user_cmd);
#endif

            /* Snap shot commands */
            install_element(node, &help_snapshot_show_cmd);

            /* LUN commands from SPM */
            install_element(node, &help_lun_show_cmd);
            install_element(node, &help_lun_topology_cmd);

			/* ip cmds */
			install_element(node, &help_arp_show_cmd);
			install_element(node, &help_rt_show_cmd);
			install_element(node, &help_intf_show_cmd);
			install_element(node, &help_system_show_cmd);
			install_element(node, &help_vif_show_cmd);

			/* system commands */
			install_element(node, &help_ping_cmd);
			install_element(node, &help_traceroute_cmd);
			install_element(node, &help_ping_alias);
			install_element(node, &help_traceroute_alias);
			install_element(node, &help_time_cmd);

			/* license commands */
			install_element(node, &help_license_show_cmd);

            /* NFS commands */
            install_element(node, &help_nfs_show_cmd);

            /* NDMP commands */
            install_element(node, &help_ndmp_show_cmd);

			/* FibreChannel PORT commands */
			install_element (node, &help_port_show_detail_cmd);	
			install_element (node, &help_port_show_stats_cmd); 
			install_element (node, &help_port_show_topology_cmd); 

			/* Nameservice */
			install_element (node, &help_name_sho_cmd);

			/* Help for the helpless */
			install_element (node, &help_cmd);
			install_element (node, &help_help);

			/* Elog commands */
			install_element(node, &help_elog_show_cmd);

			/* Mirror commands */
			install_element(node, &help_am_show_cmd);
			install_element(node, &help_am_host_cmd);

			/* Cluster stuff */
			install_element (node, &help_cluster_cmd);

			/* RAID commands */
			install_element (node, &help_raid_config_cmd);
			install_element (node, &help_raid_dev_cmd);
			install_element (node, &help_raid_devlist_cmd);
			install_element (node, &help_raid_info_cmd);
			install_element (node, &help_raid_lun_cmd);

			/* Autosupport commands */
			install_element(node, &help_autosupport_show_config_cmd);
			install_element(node, &help_autosupport_cmd);

			/* AV config commands */
			install_element(node, &help_av_show_config_cmd);
			install_element(node, &help_av_cmd);

			/* Tape commands */
			install_element(node, &help_tape_devlist_cmd);
			install_element(node, &help_tape_mc_devlist_cmd);
	}
}
