/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:redo_hosts
 *
 * RCS:  $Id: redo_hosts.c,v 1.2 2002/10/01 23:10:36 gregs Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: When the node name changes, the /etc/hosts file needs to
 *              be updated. Also changing the addresses of the management
 *              Ethernet ports require this to be done too.
 *
 * Created by:	Greg Seibert
 *
 * Date Created: 19 Sep 2002
 *
 *-----------------------------------------------------------------
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "exports/opt-api.h"

static char *mgmt_port_names[] = {"sc1", "sc2", NULL};

int
redo_hosts (char *hosts_file, char *newname)
{
	FILE *hosts;
	FILE *fodder;
	char buff[1024];
	char **intf;

	fodder = fopen ("/etc/hosts.org", "r");
	if (!fodder) {
		return 1;
	}
	hosts = fopen (hosts_file, "w");
	if (!hosts) {
		fclose (fodder);
		return 1;
	}
	while (fgets (buff, sizeof(buff), fodder)) {
		fputs (buff, hosts);
	}
	fclose (fodder);

	for (intf = mgmt_port_names; *intf; intf++) {
		sprintf (buff, "/etc/hostname.%s", *intf);
		fodder = fopen (buff, "r");
		if (fodder) {	// Reading a single line "inet addr netmask"
			if (fgets (buff, sizeof(buff), fodder)) {
				*strchr (&buff[5], ' ') = '\0';	// NULL terminate addr
				fprintf (hosts, "%s %s.%s %s\n", &buff[5], newname, 
						*intf, newname);
			}
			fclose (fodder);
		}
	}
	fclose (hosts);
	return 0;
}

