// vi:ts=4

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <strings.h>
#include <stdlib.h>

#define SERVICES_FILE "/etc/services"
#define AGILE_SERVICES "/usr/local/agile/etc/agile.services"
#define TMP_TEMPLATE "/etc/tmpservXXXXXX"

#define SERVICES_MODE (S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)

extern int
main()
{
	char *tmpname;
	char *savename;
	int tmpfd;
	FILE *services;
	FILE *new_services;
	FILE *agileservices;
	char newentry[256];
	char oldentry[256];

	tmpname = strdup (TMP_TEMPLATE);
	tmpfd = mkstemp (tmpname);
	if (tmpfd < 0) {
		perror ("Error creating services tmp file");
		exit (1);
	}

	if (fchmod(tmpfd, SERVICES_MODE) < 0) {
		perror ("Error chmod services tmp file");
		exit(1);
	}

	new_services = fdopen (tmpfd, "w+");
	if (!new_services) {
		perror ("fdopen on services tmp failed");
		exit (1);
	}

	services = fopen (SERVICES_FILE, "r");
	if (!services) {
		perror ("Error opening services file for reading");
		exit(1);
	}

	agileservices = fopen (AGILE_SERVICES, "r");
	if (!agileservices) {
		perror ("Error opening agileservices file for reading");
		exit(1);
	}
	
	if (!fgets (newentry, sizeof(newentry), agileservices)) {
		perror ("Error getting first line from agile.services");
		exit(1);
	}

	while (fgets (oldentry, sizeof(oldentry), services)) {
		if (!strcmp (oldentry, newentry)) {
			break;
		}

		fputs (oldentry, new_services);
	}
	fputs (newentry, new_services);

	while (fgets (newentry, sizeof(newentry), agileservices)) {
		fputs (newentry, new_services);
	}

	savename = malloc (strlen(".orig") + strlen (SERVICES_FILE) + 1);
	strcpy (savename, SERVICES_FILE);
	strcat (savename, ".orig");

	if (rename (SERVICES_FILE, savename)) {
		perror ("Error saving services file");
		unlink (tmpname);
		exit (1);
	}

	if (rename (tmpname, SERVICES_FILE)) {
		perror ("Error setting new services file. Restoring");
		rename (savename, SERVICES_FILE);
		exit (1);
	}

	exit (0);
}
